/*! 
* This Source Code Form is subject to the terms of the Mozilla Public
* License, v. 2.0. If a copy of the MPL was not distributed with this file,
* You can obtain one at http://mozilla.org/MPL/2.0/.
*
* Copyright(c) 2012 Apogee Imaging Systems, Inc. 
* \class GeeIo 
* \brief io class for alta-g, aka aspen, aka ??, cameras 
* 
*/ 


#ifndef GEEIO_INCLUDE_H__ 
#define GEEIO_INCLUDE_H__ 

#include "CameraIo.h" 
#include <string>

class DLL_EXPORT GeeIo : public CameraIo
{ 
    public: 
        GeeIo(CamModel::InterfaceType type, 
               const std::string & deviceAddr); 

        virtual ~GeeIo(); 

        void Program(const std::string & FilenameFpga,
            const std::string & FilenameFx2, const std::string & FilenameDescriptor,
            const std::string & FilenameWebPage, const std::string & FilenameWebServer,
            const std::string & FilenameWebCfg, bool Print2StdOut=false);

        uint16_t GetId();

        std::string GetMacAddress();

        private:
            std::string m_fileName;
}; 

#endif