/*!
* This Source Code Form is subject to the terms of the Mozilla Public
* License, v. 2.0. If a copy of the MPL was not distributed with this file,
* You can obtain one at http://mozilla.org/MPL/2.0/.
*
* Copyright(c) 2012 Apogee Instruments, Inc.
* \brief This namespace contains the camera meta data
*   created on Wed Apr 18 11:42:08 2012
*
*/


#ifndef CAMMETADATA_INCLUDE_H__
#define CAMMETADATA_INCLUDE_H__

#include <vector>
#include <map>
#include <stdint.h>
#include "CamCfgMatrix.h" 


namespace camMetaData
{
    typedef void (*getMetaPtr)(CamCfg::APN_CAMERA_METADATA & out);
    bool getMetaFxPtr( const uint16_t id, camMetaData::getMetaPtr & out );
    void getIdMetaFxMap( 
       std::map<uint16_t, camMetaData::getMetaPtr> & out );
    void getMeta0(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta1(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta2(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta3(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta4(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta5(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta6(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta7(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta8(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta9(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta10(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta12(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta14(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta16(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta17(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta18(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta19(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta20(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta21(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta22(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta23(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta24(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta26(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta30(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta31(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta32(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta33(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta34(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta35(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta36(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta37(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta38(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta39(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta40(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta41(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta42(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta43(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta44(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta60(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta11(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta15(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta13(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta45(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta46(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta47(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta48(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta49(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta50(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta51(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta52(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta53(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta54(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta55(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta56(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta57(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta59(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta58(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta61(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta62(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta63(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta25(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta27(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta76(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta77(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta64(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta65(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta66(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta67(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta68(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta69(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta70(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta71(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta72(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta73(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta74(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta75(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta78(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta256(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta257(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta258(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta259(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta260(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta261(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta262(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta263(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta264(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta265(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta266(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta267(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta268(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta269(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta270(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta271(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta272(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta273(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta274(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta275(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta276(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta277(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta278(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta279(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta280(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta384(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta386(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta387(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta427(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta511(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta281(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta412(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta403(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta388(CamCfg::APN_CAMERA_METADATA & out);
    void getMeta389(CamCfg::APN_CAMERA_METADATA & out);


} //namespace camMetaData

#endif
