/*!
* This Source Code Form is subject to the terms of the Mozilla Public
* License, v. 2.0. If a copy of the MPL was not distributed with this file,
* You can obtain one at http://mozilla.org/MPL/2.0/.
*
* Copyright(c) 2012 Apogee Instruments, Inc.
* \brief This namespace contains the camera pattern data
*   created on Wed Apr 18 11:42:13 2012
*
*/


#ifndef PATTERNS_INCLUDE_H__
#define PATTERNS_INCLUDE_H__

#include <vector>
#include <map>
#include "CamCfgMatrix.h" 


namespace patterns
{
    typedef void (*getVPatternPtr)(CamCfg::APN_VPATTERN_FILE & out);
    bool GetVPatternFx(const std::string & name, patterns::getVPatternPtr & out );
    void getStrVPatternFxMap( 
       std::map<std::string, patterns::getVPatternPtr> & out );
    typedef void (*getHPatternPtr)(CamCfg::APN_HPATTERN_FILE & out);
    bool GetHPatternFx(const std::string & name, patterns::getHPatternPtr & out );
    void getStrHPatternFxMap( 
       std::map<std::string, patterns::getHPatternPtr> & out );
    void getPatternAV1(CamCfg::APN_VPATTERN_FILE & out);
    void getPatternAV2(CamCfg::APN_VPATTERN_FILE & out);
    void getPatternAV2S(CamCfg::APN_VPATTERN_FILE & out);
    void getPatternAV2V(CamCfg::APN_VPATTERN_FILE & out);
    void getPatternAV2Vb(CamCfg::APN_VPATTERN_FILE & out);
    void getPatternAV4(CamCfg::APN_VPATTERN_FILE & out);
    void getPatternAV4V(CamCfg::APN_VPATTERN_FILE & out);
    void getPatternAV4Vb(CamCfg::APN_VPATTERN_FILE & out);
    void getPatternAV5(CamCfg::APN_VPATTERN_FILE & out);
    void getPatternAV5V(CamCfg::APN_VPATTERN_FILE & out);
    void getPatternAV6(CamCfg::APN_VPATTERN_FILE & out);
    void getPatternAV7(CamCfg::APN_VPATTERN_FILE & out);
    void getPatternFEV1(CamCfg::APN_VPATTERN_FILE & out);
    void getPatternFKV1(CamCfg::APN_VPATTERN_FILE & out);
    void getPatternFKV2(CamCfg::APN_VPATTERN_FILE & out);
    void getPatternFKV3(CamCfg::APN_VPATTERN_FILE & out);
    void getPatternFKV4(CamCfg::APN_VPATTERN_FILE & out);
    void getPatternFKV5(CamCfg::APN_VPATTERN_FILE & out);
    void getPatternFKV6(CamCfg::APN_VPATTERN_FILE & out);
    void getPatternFV1(CamCfg::APN_VPATTERN_FILE & out);
    void getPatternFV1B(CamCfg::APN_VPATTERN_FILE & out);
    void getPatternHV1(CamCfg::APN_VPATTERN_FILE & out);
    void getPatternHV1a(CamCfg::APN_VPATTERN_FILE & out);
    void getPatternKV1(CamCfg::APN_VPATTERN_FILE & out);
    void getPatternKV2(CamCfg::APN_VPATTERN_FILE & out);
    void getPatternKV2B(CamCfg::APN_VPATTERN_FILE & out);
    void getPatternKV3(CamCfg::APN_VPATTERN_FILE & out);
    void getPatternKV3B(CamCfg::APN_VPATTERN_FILE & out);
    void getPatternKV4(CamCfg::APN_VPATTERN_FILE & out);
    void getPatternKV4B(CamCfg::APN_VPATTERN_FILE & out);
    void getPatternKV5(CamCfg::APN_VPATTERN_FILE & out);
    void getPatternKV5ns(CamCfg::APN_VPATTERN_FILE & out);
    void getPatternKV6(CamCfg::APN_VPATTERN_FILE & out);
    void getPatternKV6B(CamCfg::APN_VPATTERN_FILE & out);
    void getPatternKV7(CamCfg::APN_VPATTERN_FILE & out);
    void getPatternKV7B(CamCfg::APN_VPATTERN_FILE & out);
    void getPatternKV8(CamCfg::APN_VPATTERN_FILE & out);
    void getPatternKV8B(CamCfg::APN_VPATTERN_FILE & out);
    void getPatternKV9(CamCfg::APN_VPATTERN_FILE & out);
    void getPatternMV1(CamCfg::APN_VPATTERN_FILE & out);
    void getPatternMV1B(CamCfg::APN_VPATTERN_FILE & out);
    void getPatternMV1i(CamCfg::APN_VPATTERN_FILE & out);
    void getPatternMV1nimo(CamCfg::APN_VPATTERN_FILE & out);
    void getPatternMV1p2high(CamCfg::APN_VPATTERN_FILE & out);
    void getPatternMV2(CamCfg::APN_VPATTERN_FILE & out);
    void getPatternMV230(CamCfg::APN_VPATTERN_FILE & out);
    void getPatternMV2B(CamCfg::APN_VPATTERN_FILE & out);
    void getPatternMV2C(CamCfg::APN_VPATTERN_FILE & out);
    void getPatternMV2CN(CamCfg::APN_VPATTERN_FILE & out);
    void getPatternMV2i(CamCfg::APN_VPATTERN_FILE & out);
    void getPatternMV3(CamCfg::APN_VPATTERN_FILE & out);
    void getPatternMV4(CamCfg::APN_VPATTERN_FILE & out);
    void getPatternMV4B(CamCfg::APN_VPATTERN_FILE & out);
    void getPatternMV7(CamCfg::APN_VPATTERN_FILE & out);
    void getPatternMV7i(CamCfg::APN_VPATTERN_FILE & out);
    void getPatternMV8(CamCfg::APN_VPATTERN_FILE & out);
    void getPatternNoOpV(CamCfg::APN_VPATTERN_FILE & out);
    void getPatternXAV1(CamCfg::APN_VPATTERN_FILE & out);
    void getPatternA12HC(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternA12HR(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternA12HS(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternA16HC(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternA16HR(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternA16HS(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternAR2(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternAR2F(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternAR2Fa(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternAR2S(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternAR2V(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternAR2Vb(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternAR2a(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternAR4(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternAR4F(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternAR4Fb(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternAR4V(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternAR4Vb(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternAR5(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternAR5F(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternAR5V(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternAS2(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternAS2S(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternAS4(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternAS5(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternF16HR1(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternF16HR1B(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternF16HS1(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternF16HS1B(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternFEHR1A(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternFEHR1AQ(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternFEHR1Ah2_3(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternFEHR1B(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternFEHR1BQ(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternFEHS1(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternFEHS1A(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternFEHS1Ah2_3(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternFEHS1B(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternFKHR1(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternFKHR1A(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternFKHR1B(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternFKHR1_3_22MHz(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternFKHR1_6_25MHz(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternFKHR2A(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternFKHR2B(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternFKHR3A(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternFKHR3B(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternFKHR4A(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternFKHR4AQ(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternFKHR4B(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternFKHR4BQ(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternFKHR5A(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternFKHR5B(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternFKHR6A(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternFKHR6B(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternFKHS1(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternFKHS1A(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternFKHS1B(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternFKHS2(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternFKHS3(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternFKHS4(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternFKHS5(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternFKHS6(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternFM12HC(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternFM12HR(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternFM12HS(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternFM16HR3(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternFM16HS1(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternFR2(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternFR2F(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternH12HC(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternH12HCi(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternH12HR(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternH12HRi(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternH12HS(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternH12HSi(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternH16HR(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternH16HRa(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternH16HRi(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternH16HS(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternH16HSa(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternH16HSi(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternK12HC2(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternK12HC2B(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternK12HC3(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternK12HC3i(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternK12HC4(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternK12HC5(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternK12HC5B(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternK12HC6(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternK12HC6B(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternK12HC7(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternK12HC8(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternK12HC9(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternK12HR10B(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternK12HR2(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternK12HR2B(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternK12HR3(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternK12HR3i(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternK12HR4(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternK12HR5(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternK12HR5B(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternK12HR6(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternK12HR6B(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternK12HR7(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternK12HR8(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternK12HR9(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternK12HS10B(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternK12HS2(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternK12HS2B(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternK12HS3(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternK12HS3i(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternK12HS4(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternK12HS5(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternK12HS5B(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternK12HS6(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternK12HS6B(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternK12HS7(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternK12HS8(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternK12HS9(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternK16HC1(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternK16HC2(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternK16HC2B(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternK16HR1(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternK16HR10B(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternK16HR2(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternK16HR2B(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternK16HR3(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternK16HR31(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternK16HR3i(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternK16HR3ns(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternK16HR5(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternK16HR5B(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternK16HR6(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternK16HR6B(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternK16HR7(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternK16HR8(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternK16HR8a(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternK16HR9(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternK16HS1(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternK16HS10B(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternK16HS2(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternK16HS2B(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternK16HS3(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternK16HS3i(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternK16HS5(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternK16HS5B(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternK16HS6(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternK16HS6B(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternK16HS7(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternK16HS8(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternK16HS9(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternM12HC(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternM12HC7(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternM12HC7i(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternM12HCB(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternM12HCC(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternM12HCi(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternM12HR(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternM12HR2(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternM12HR7(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternM12HR7i(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternM12HRB(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternM12HRC(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternM12HRi(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternM12HS(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternM12HS2(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternM12HS7(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternM12HS7i(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternM12HSB(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternM12HSC(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternM12HSi(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternM16HC1(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternM16HR1(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternM16HR2(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternM16HR230(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternM16HR3(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternM16HR3B(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternM16HR3C(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternM16HR3i(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternM16HR4(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternM16HR5(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternM16HR5B(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternM16HR5i(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternM16HR7(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternM16HR7i(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternM16HS1(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternM16HS1B(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternM16HS1C(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternM16HS1i(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternM16HS2(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternM16HS230(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternM16HS7(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternM16HS7i(CamCfg::APN_HPATTERN_FILE & out);
    void getPatternNoOpH(CamCfg::APN_HPATTERN_FILE & out);


} //namespace patterns

#endif
