/* Processed by ecpg (4.7.0) */
/* These include files are added by the preprocessor */
#include <ecpglib.h>
#include <ecpgerrno.h>
#include <sqlca.h>
/* End of automatic include section */

#line 1 "accountset.ec"
/* 
 * Account class.
 * Copyright (C) 2008 Petr Kubanek <petr@kubanek.net>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#include "rts2db/accountset.h"
#include "rts2db/sqlerror.h"

using namespace rts2db;

AccountSet *AccountSet::pInstance = NULL;

AccountSet::AccountSet (): std::map <int, Account * > ()
{
}


AccountSet::~AccountSet ()
{
	for (AccountSet::iterator iter = begin (); iter != end (); iter++)
		delete (*iter).second;

	clear ();
}


void
AccountSet::load ()
{
	/* exec sql begin declare section */
	 
	 
	 
	
#line 45 "accountset.ec"
 int d_account_id ;
 
#line 46 "accountset.ec"
  struct varchar_1  { int len; char arr[ 150 ]; }  d_account_name ;
 
#line 47 "accountset.ec"
 float d_account_share ;
/* exec sql end declare section */
#line 48 "accountset.ec"


	/* declare cur_accounts cursor for select account_id , account_name , account_share from accounts */
#line 55 "accountset.ec"


	{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "declare cur_accounts cursor for select account_id , account_name , account_share from accounts", ECPGt_EOIT, ECPGt_EORT);}
#line 57 "accountset.ec"

	if (sqlca.sqlcode)
		throw SqlError();

	shareSum = 0;

	while (true)
	{
		{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "fetch next from cur_accounts", ECPGt_EOIT, 
	ECPGt_int,&(d_account_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_varchar,&(d_account_name),(long)150,(long)1,sizeof(struct varchar_1), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_float,&(d_account_share),(long)1,(long)1,sizeof(float), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EORT);}
#line 68 "accountset.ec"


		if (sqlca.sqlcode == ECPG_NOT_FOUND)
			break;
		else if (sqlca.sqlcode)
			throw SqlError();
		
		(*this)[d_account_id] = new Account (d_account_id, std::string (d_account_name.arr), d_account_share);

		shareSum += d_account_share;
	}
}


AccountSet *
AccountSet::instance ()
{
	if (pInstance)
		return pInstance;
	pInstance = new AccountSet ();
	pInstance->load ();
	return pInstance;
}
