/* Processed by ecpg (4.7.0) */
/* These include files are added by the preprocessor */
#include <ecpglib.h>
#include <ecpgerrno.h>
#include <sqlca.h>
/* End of automatic include section */

#line 1 "augerset.ec"
/* 
 * Sets of Auger targets.
 * Copyright (C) 2009 Petr Kubanek <petr@kubanek.net>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#include "augerset.h"
#include "rts2db/sqlerror.h"

#include "configuration.h"

using namespace rts2db;

void AugerSet::load (double _from, double _to)
{
	/* exec sql begin declare section */
	   
	   

	 
	 
	 
	 

	                /// FD eye Id
	                /// FD run number
	              /// FD event number
	    /// Event Auger Id after SD/FD merger
	             /// GPS second (SD)
	            /// GPS nano second (SD)
	               /// SD Event Id

	               /// Num. pixels with a pulse after FdPulseFinder

	        /// Zenith angle of SDP normal vector (deg)
	     /// Uncertainty of SDPtheta
	          /// Azimuth angle of SDP normal vector (deg)
	       /// Uncertainty of SDPphi
	         /// Chi^2 of SDP db_it
	             /// Degrees of db_reedom of SDP db_it

	              /// Shower impact parameter Rp (m)
	           /// Uncertainty of Rp (m)
	            /// Angle of shower in the SDP (deg)
	         /// Uncertainty of Chi0 (deg)
	              /// FD time db_it T_0 (ns)
	           /// Uncertainty of T_0 (ns)
	        /// Full Chi^2 of axis db_it
	      /// Chi^2 of axis db_it (FD only)
	            /// Degrees of db_reedom of axis db_it

	         /// Core position in easting coordinate (m)
	        /// Core position in northing coordinate (m)
	        /// Core position altitude (m)
	     /// Uncertainty of northing coordinate (m)
	      /// Uncertainty of easting coordinate (m)
	           /// Shower zenith angle in core coords. (deg)
	        /// Uncertainty of zenith angle (deg)
	             /// Shower azimuth angle in core coords. (deg)
	          /// Uncertainty of azimuth angle (deg)

	         /// Energy deposit at shower max (GeV/(g/cm^2))
	      /// Uncertainty of Nmax (GeV/(g/cm^2))
	            /// Slant depth of shower maximum (g/cm^2)
	         /// Uncertainty of Xmax (g/cm^2)
	              /// X0 Gaisser-Hillas db_it (g/cm^2)
	           /// Uncertainty of X0 (g/cm^2)
	          /// Lambda of Gaisser-Hillas db_it (g/cm^2)
	       /// Uncertainty of Lambda (g/cm^2)
	          /// Chi^2 of Gaisser-Hillas db_it
	              /// Degrees of db_reedom of GH db_it
	     /// Chi^2 of linear db_it to profile

	        /// Calorimetric energy db_rom GH db_it (EeV)
	     /// Uncertainty of Eem (EeV)
	          /// Total energy db_rom GH db_it (EeV)
	       /// Uncertainty of Etot (EeV)

	        /// Minimum viewing angle (deg)
	        /// Maximum viewing angle (deg)
	       /// Mean viewing angle (deg)

	              /// Number of stations in hybrid db_it
	        /// Station used in hybrid-geometry reco
	        /// Shower axis distance to hottest station (m)
	         /// SDP distance to hottest station (m)

	          /// SD/FD time offset after the minimization (ns)
	     /// Distance to shower maximum (m)
	       /// First recorded slant depth of track (g/cm^2)
	       /// Last recorded slant depth of track (g/cm^2)
	         /// First slant depth inside FOV (g/cm^2)
	         /// Last slant depth inside FOV (g/cm^2)
	       /// Observed track length depth (g/cm^2)
	     /// Observed track length angle (deg)
	       /// Observed track length time (100 ns)

	   

	
#line 30 "augerset.ec"
 double d_from = _from ;
 
#line 31 "augerset.ec"
 double d_to = _to ;
 
#line 33 "augerset.ec"
 int d_auger_t3id ;
 
#line 34 "augerset.ec"
 double d_auger_date ;
 
#line 35 "augerset.ec"
 double d_auger_ra ;
 
#line 36 "augerset.ec"
 double d_auger_dec ;
 
#line 38 "augerset.ec"
 int db_Eye ;
 
#line 39 "augerset.ec"
 int db_Run ;
 
#line 40 "augerset.ec"
 int db_Event ;
 
#line 41 "augerset.ec"
  struct varchar_1  { int len; char arr[ 50 ]; }  db_AugerId ;
 
#line 42 "augerset.ec"
 int db_GPSSec ;
 
#line 43 "augerset.ec"
 int db_GPSNSec ;
 
#line 44 "augerset.ec"
 int db_SDId ;
 
#line 46 "augerset.ec"
 int db_NPix ;
 
#line 48 "augerset.ec"
 double db_SDPTheta ;
 
#line 49 "augerset.ec"
 double db_SDPThetaErr ;
 
#line 50 "augerset.ec"
 double db_SDPPhi ;
 
#line 51 "augerset.ec"
 double db_SDPPhiErr ;
 
#line 52 "augerset.ec"
 double db_SDPChi2 ;
 
#line 53 "augerset.ec"
 int db_SDPNdf ;
 
#line 55 "augerset.ec"
 double db_Rp ;
 
#line 56 "augerset.ec"
 double db_RpErr ;
 
#line 57 "augerset.ec"
 double db_Chi0 ;
 
#line 58 "augerset.ec"
 double db_Chi0Err ;
 
#line 59 "augerset.ec"
 double db_T0 ;
 
#line 60 "augerset.ec"
 double db_T0Err ;
 
#line 61 "augerset.ec"
 double db_TimeChi2 ;
 
#line 62 "augerset.ec"
 double db_TimeChi2FD ;
 
#line 63 "augerset.ec"
 int db_TimeNdf ;
 
#line 65 "augerset.ec"
 double db_Easting ;
 
#line 66 "augerset.ec"
 double db_Northing ;
 
#line 67 "augerset.ec"
 double db_Altitude ;
 
#line 68 "augerset.ec"
 double db_NorthingErr ;
 
#line 69 "augerset.ec"
 double db_EastingErr ;
 
#line 70 "augerset.ec"
 double db_Theta ;
 
#line 71 "augerset.ec"
 double db_ThetaErr ;
 
#line 72 "augerset.ec"
 double db_Phi ;
 
#line 73 "augerset.ec"
 double db_PhiErr ;
 
#line 75 "augerset.ec"
 double db_dEdXmax ;
 
#line 76 "augerset.ec"
 double db_dEdXmaxErr ;
 
#line 77 "augerset.ec"
 double db_Xmax ;
 
#line 78 "augerset.ec"
 double db_XmaxErr ;
 
#line 79 "augerset.ec"
 double db_X0 ;
 
#line 80 "augerset.ec"
 double db_X0Err ;
 
#line 81 "augerset.ec"
 double db_Lambda ;
 
#line 82 "augerset.ec"
 double db_LambdaErr ;
 
#line 83 "augerset.ec"
 double db_GHChi2 ;
 
#line 84 "augerset.ec"
 int db_GHNdf ;
 
#line 85 "augerset.ec"
 double db_LineFitChi2 ;
 
#line 87 "augerset.ec"
 double db_EmEnergy ;
 
#line 88 "augerset.ec"
 double db_EmEnergyErr ;
 
#line 89 "augerset.ec"
 double db_Energy ;
 
#line 90 "augerset.ec"
 double db_EnergyErr ;
 
#line 92 "augerset.ec"
 double db_MinAngle ;
 
#line 93 "augerset.ec"
 double db_MaxAngle ;
 
#line 94 "augerset.ec"
 double db_MeanAngle ;
 
#line 96 "augerset.ec"
 int db_NTank ;
 
#line 97 "augerset.ec"
 int db_HottestTank ;
 
#line 98 "augerset.ec"
 double db_AxisDist ;
 
#line 99 "augerset.ec"
 double db_SDPDist ;
 
#line 101 "augerset.ec"
 double db_SDFDdT ;
 
#line 102 "augerset.ec"
 double db_XmaxEyeDist ;
 
#line 103 "augerset.ec"
 double db_XTrackMin ;
 
#line 104 "augerset.ec"
 double db_XTrackMax ;
 
#line 105 "augerset.ec"
 double db_XFOVMin ;
 
#line 106 "augerset.ec"
 double db_XFOVMax ;
 
#line 107 "augerset.ec"
 double db_XTrackObs ;
 
#line 108 "augerset.ec"
 double db_DegTrackObs ;
 
#line 109 "augerset.ec"
 double db_TTrackObs ;
 
#line 111 "augerset.ec"
 int db_cut = 0 ;
/* exec sql end declare section */
#line 113 "augerset.ec"


	ECPGset_var( 0, &( d_to ), __LINE__);\
 ECPGset_var( 1, &( d_from ), __LINE__);\
 /* declare cur_augerset cursor for select auger_t3id , extract ( EPOCH from auger_date ) , NPix , ra , dec , cut , eye , run , event , augerid , GPSSec , GPSNSec , SDId , NPix , SDPTheta , SDPThetaErr , SDPPhi , SDPPhiErr , SDPChi2 , SDPNdf , Rp , RpErr , Chi0 , Chi0Err , T0 , T0Err , TimeChi2 , TimeChi2FD , TimeNdf , Easting , Northing , Altitude , NorthingErr , EastingErr , Theta , ThetaErr , Phi , PhiErr , dEdXmax , dEdXmaxErr , X_max , X_maxErr , X0 , X0Err , Lambda , LambdaErr , GHChi2 , GHNdf , LineFitChi2 , EmEnergy , EmEnergyErr , Energy , EnergyErr , MinAngle , MaxAngle , MeanAngle , NTank , HottestTank , AxisDist , SDPDist , SDFDdT , XmaxEyeDist , XTrackMin , XTrackMax , XFOVMin , XFOVMax , XTrackObs , DegTrackObs , TTrackObs from auger where auger_date between to_timestamp ( $1  ) and to_timestamp ( $2  ) order by auger_date asc */
#line 191 "augerset.ec"

	
	{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "declare cur_augerset cursor for select auger_t3id , extract ( EPOCH from auger_date ) , NPix , ra , dec , cut , eye , run , event , augerid , GPSSec , GPSNSec , SDId , NPix , SDPTheta , SDPThetaErr , SDPPhi , SDPPhiErr , SDPChi2 , SDPNdf , Rp , RpErr , Chi0 , Chi0Err , T0 , T0Err , TimeChi2 , TimeChi2FD , TimeNdf , Easting , Northing , Altitude , NorthingErr , EastingErr , Theta , ThetaErr , Phi , PhiErr , dEdXmax , dEdXmaxErr , X_max , X_maxErr , X0 , X0Err , Lambda , LambdaErr , GHChi2 , GHNdf , LineFitChi2 , EmEnergy , EmEnergyErr , Energy , EnergyErr , MinAngle , MaxAngle , MeanAngle , NTank , HottestTank , AxisDist , SDPDist , SDFDdT , XmaxEyeDist , XTrackMin , XTrackMax , XFOVMin , XFOVMax , XTrackObs , DegTrackObs , TTrackObs from auger where auger_date between to_timestamp ( $1  ) and to_timestamp ( $2  ) order by auger_date asc", 
	ECPGt_double,&(d_from),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_double,&(d_to),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EOIT, ECPGt_EORT);}
#line 193 "augerset.ec"


	while (1)
	{
		{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "fetch next from cur_augerset", ECPGt_EOIT, 
	ECPGt_int,&(d_auger_t3id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_double,&(d_auger_date),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_double,&(d_auger_ra),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_double,&(d_auger_dec),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_int,&(db_cut),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_int,&(db_Eye),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_int,&(db_Run),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_int,&(db_Event),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_varchar,&(db_AugerId),(long)50,(long)1,sizeof(struct varchar_1), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_int,&(db_GPSSec),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_int,&(db_GPSNSec),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_int,&(db_SDId),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_int,&(db_NPix),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_double,&(db_SDPTheta),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_double,&(db_SDPThetaErr),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_double,&(db_SDPPhi),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_double,&(db_SDPPhiErr),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_double,&(db_SDPChi2),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_int,&(db_SDPNdf),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_double,&(db_Rp),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_double,&(db_RpErr),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_double,&(db_Chi0),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_double,&(db_Chi0Err),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_double,&(db_T0),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_double,&(db_T0Err),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_double,&(db_TimeChi2),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_double,&(db_TimeChi2FD),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_int,&(db_TimeNdf),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_double,&(db_Easting),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_double,&(db_Northing),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_double,&(db_Altitude),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_double,&(db_NorthingErr),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_double,&(db_EastingErr),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_double,&(db_Theta),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_double,&(db_ThetaErr),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_double,&(db_Phi),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_double,&(db_PhiErr),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_double,&(db_dEdXmax),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_double,&(db_dEdXmaxErr),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_double,&(db_Xmax),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_double,&(db_XmaxErr),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_double,&(db_X0),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_double,&(db_X0Err),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_double,&(db_Lambda),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_double,&(db_LambdaErr),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_double,&(db_GHChi2),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_int,&(db_GHNdf),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_double,&(db_LineFitChi2),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_double,&(db_EmEnergy),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_double,&(db_EmEnergyErr),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_double,&(db_Energy),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_double,&(db_EnergyErr),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_double,&(db_MinAngle),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_double,&(db_MaxAngle),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_double,&(db_MeanAngle),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_int,&(db_NTank),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_int,&(db_HottestTank),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_double,&(db_AxisDist),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_double,&(db_SDPDist),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_double,&(db_SDFDdT),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_double,&(db_XmaxEyeDist),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_double,&(db_XTrackMin),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_double,&(db_XTrackMax),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_double,&(db_XFOVMin),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_double,&(db_XFOVMax),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_double,&(db_XTrackObs),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_double,&(db_DegTrackObs),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_double,&(db_TTrackObs),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EORT);}
#line 275 "augerset.ec"


		if (sqlca.sqlcode)
			break;

		TargetAuger tarAuger (d_auger_t3id, d_auger_date, d_auger_ra, d_auger_dec, rts2core::Configuration::instance ()->getObserver ());

		tarAuger.cut = db_cut;
		tarAuger.Eye = db_Eye;
		tarAuger.Run = db_Run;
		tarAuger.Event = db_Event;
		tarAuger.AugerId = std::string (db_AugerId.arr);
		tarAuger.GPSSec = db_GPSSec;
		tarAuger.GPSNSec = db_GPSNSec;
		tarAuger.SDId = db_SDId;

		tarAuger.NPix = db_NPix;

		tarAuger.SDPTheta = db_SDPTheta;
		tarAuger.SDPThetaErr = db_SDPThetaErr;
		tarAuger.SDPPhi = db_SDPPhi;
		tarAuger.SDPPhiErr = db_SDPPhiErr;
		tarAuger.SDPChi2 = db_SDPChi2;
		tarAuger.SDPNdf = db_SDPNdf;

		tarAuger.Rp = db_Rp;
		tarAuger.RpErr = db_RpErr;
		tarAuger.Chi0 = db_Chi0;
		tarAuger.Chi0Err = db_Chi0Err;
		tarAuger.T0 = db_T0;
		tarAuger.T0Err = db_T0Err;
		tarAuger.TimeChi2 = db_TimeChi2;
		tarAuger.TimeChi2FD = db_TimeChi2FD;
		tarAuger.TimeNdf = db_TimeNdf;

		tarAuger.Easting = db_Easting;
		tarAuger.Northing = db_Northing;
		tarAuger.Altitude = db_Altitude;
		tarAuger.NorthingErr = db_NorthingErr;
		tarAuger.EastingErr = db_EastingErr;
		tarAuger.Theta = db_Theta;
		tarAuger.ThetaErr = db_ThetaErr;
		tarAuger.Phi = db_Phi;
		tarAuger.PhiErr = db_PhiErr;

		tarAuger.dEdXmax = db_dEdXmax;
		tarAuger.dEdXmaxErr = db_dEdXmaxErr;
		tarAuger.Xmax = db_Xmax;
		tarAuger.XmaxErr = db_XmaxErr;
		tarAuger.X0 = db_X0;
		tarAuger.X0Err = db_X0Err;
		tarAuger.Lambda = db_Lambda;
		tarAuger.LambdaErr = db_LambdaErr;
		tarAuger.GHChi2 = db_GHChi2;
		tarAuger.GHNdf = db_GHNdf;
		tarAuger.LineFitChi2 = db_LineFitChi2;

		tarAuger.EmEnergy = db_EmEnergy;
		tarAuger.EmEnergyErr = db_EmEnergyErr;
		tarAuger.Energy = db_Energy;
		tarAuger.EnergyErr = db_EnergyErr;

		tarAuger.MinAngle = db_MinAngle;
		tarAuger.MaxAngle = db_MaxAngle;
		tarAuger.MeanAngle = db_MeanAngle;

		tarAuger.NTank = db_NTank;
		tarAuger.HottestTank = db_HottestTank;
		tarAuger.AxisDist = db_AxisDist;
		tarAuger.SDPDist = db_SDPDist;

		tarAuger.SDFDdT = db_SDFDdT;
		tarAuger.XmaxEyeDist = db_XmaxEyeDist;
		tarAuger.XTrackMin = db_XTrackMin;
		tarAuger.XTrackMax = db_XTrackMax;
		tarAuger.XFOVMin = db_XFOVMin;
		tarAuger.XFOVMax = db_XFOVMax;
		tarAuger.XTrackObs = db_XTrackObs;
		tarAuger.DegTrackObs = db_DegTrackObs;
		tarAuger.TTrackObs = db_TTrackObs;

		(*this)[d_auger_t3id] = tarAuger;

	}
	if (sqlca.sqlcode != ECPG_NOT_FOUND)
	{
		{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "close cur_augerset", ECPGt_EOIT, ECPGt_EORT);}
#line 361 "augerset.ec"

		{ ECPGtrans(__LINE__, NULL, "rollback");}
#line 362 "augerset.ec"

		throw SqlError ();
	}

	{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "close cur_augerset", ECPGt_EOIT, ECPGt_EORT);}
#line 366 "augerset.ec"

	{ ECPGtrans(__LINE__, NULL, "rollback");}
#line 367 "augerset.ec"

}

void AugerSet::printHTMLTable (std::ostringstream &_os)
{
	double JD = ln_get_julian_from_sys ();\

	for (AugerSet::iterator iter = begin (); iter != end (); iter++)
	{
		iter->second.printHTMLRow (_os, JD);
	}
}

void AugerSetDate::load (int year, int month, int day, int hour, int minutes)
{
	/* exec sql begin declare section */
	 
	 
	 
	
#line 383 "augerset.ec"
 int d_value ;
 
#line 384 "augerset.ec"
 int d_c ;
 
#line 385 "augerset.ec"
 char * stmp_c ;
/* exec sql end declare section */
#line 386 "augerset.ec"


	const char *group_by;
	std::ostringstream _where;

	std::ostringstream _os;
	if (year == -1)
	{
		group_by = "year";
	}
	else
	{
		_where << "EXTRACT (year FROM auger_date) = " << year;
		if (month == -1)
		{
			group_by = "month";
		}
		else
		{
			_where << " AND EXTRACT (month FROM auger_date) = " << month;
			if (day == -1)
			{
				group_by = "day";
			}
			else
			{
				_where << " AND EXTRACT (day FROM auger_date) = " << day;
				if (hour == -1)
				{
				 	group_by = "hour";
				}
				else
				{
					_where << " AND EXTRACT (hour FROM auger_date) = " << hour;
					if (minutes == -1)
					{
					 	group_by = "minute";
					}
					else
					{
						_where << " AND EXTRACT (minutes FROM auger_date) = " << minutes;
						group_by = "second";
					}
				}
			}
		}
	}

	_os << "SELECT EXTRACT (" << group_by << " FROM auger_date) as value, count (*) as c FROM auger ";
	
	if (_where.str ().length () > 0)
		_os << "WHERE " << _where.str ();

	_os << " GROUP BY value;";

	stmp_c = new char[_os.str ().length () + 1];
	memcpy (stmp_c, _os.str().c_str(), _os.str ().length () + 1);
	{ ECPGprepare(__LINE__, NULL, 0, "augerset_stmp", stmp_c);}
#line 443 "augerset.ec"


	delete[] stmp_c;

	/* declare augersetdate_cur cursor for $1 */
#line 447 "augerset.ec"


	{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "declare augersetdate_cur cursor for $1", 
	ECPGt_char_variable,(ECPGprepared_statement(NULL, "augerset_stmp", __LINE__)),(long)1,(long)1,(1)*sizeof(char), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EOIT, ECPGt_EORT);}
#line 449 "augerset.ec"


	while (1)
	{
		{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "fetch next from augersetdate_cur", ECPGt_EOIT, 
	ECPGt_int,&(d_value),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_int,&(d_c),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EORT);}
#line 455 "augerset.ec"

		if (sqlca.sqlcode)
			break;
		(*this)[d_value] = d_c;
	}
	if (sqlca.sqlcode != ECPG_NOT_FOUND)
	{
		{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "close augersetdate_cur", ECPGt_EOIT, ECPGt_EORT);}
#line 462 "augerset.ec"

		{ ECPGtrans(__LINE__, NULL, "rollback");}
#line 463 "augerset.ec"


		throw SqlError ();
	}

	{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "close augersetdate_cur", ECPGt_EOIT, ECPGt_EORT);}
#line 468 "augerset.ec"

	{ ECPGtrans(__LINE__, NULL, "rollback");}
#line 469 "augerset.ec"

}
