/* Processed by ecpg (4.7.0) */
/* These include files are added by the preprocessor */
#include <ecpglib.h>
#include <ecpgerrno.h>
#include <sqlca.h>
/* End of automatic include section */

#line 1 "imageset.ec"
/* 
 * Set of images.
 * Copyright (C) 2005-2010 Petr Kubanek <petr@kubanek.net>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#include "imgdisplay.h"

#include "rts2db/imageset.h"
#include "rts2db/observation.h"

#include <sstream>

#include "rts2fits/imagedb.h"

using namespace rts2db;

ImageSet::ImageSet ()
{
}

ImageSet::~ImageSet (void)
{
	std::vector <rts2image::Image *>::iterator img_iter;
	for (img_iter = begin (); img_iter != end (); img_iter++)
	{
		delete *img_iter;
	}
	clear ();
}

int ImageSet::load (std::string in_where)
{
	/* exec sql begin declare section */
		 

		 
		 
		 
		 
		 
		 
		 
		 
		 
		 
		 
		// cannot use DEVICE_NAME_SIZE, as some versions of ecpg complains about it
		 
		// cannot use DEVICE_NAME_SIZE, as some versions of ecpg complains about it
		 
		 
		 
		 
		 
		 
		 

		 
		 
		 
		 
		 

	
#line 48 "imageset.ec"
 char * stmp_c ;
 
#line 50 "imageset.ec"
 int d_tar_id ;
 
#line 51 "imageset.ec"
 int d_obs_id ;
 
#line 52 "imageset.ec"
 int d_img_id ;
 
#line 53 "imageset.ec"
 char d_obs_subtype ;
 
#line 54 "imageset.ec"
 long d_img_date ;
 
#line 55 "imageset.ec"
 int d_img_usec ;
 
#line 56 "imageset.ec"
 float d_img_exposure ;
 
#line 57 "imageset.ec"
 float d_img_temperature ;
 
#line 58 "imageset.ec"
  struct varchar_1  { int len; char arr[ 3 ]; }  d_img_filter ;
 
#line 59 "imageset.ec"
 float d_img_alt ;
 
#line 60 "imageset.ec"
 float d_img_az ;
 
#line 62 "imageset.ec"
  struct varchar_2  { int len; char arr[ 50 ]; }  d_camera_name ;
 
#line 64 "imageset.ec"
  struct varchar_3  { int len; char arr[ 50 ]; }  d_mount_name ;
 
#line 65 "imageset.ec"
 bool d_delete_flag ;
 
#line 66 "imageset.ec"
 int d_process_bitfield ;
 
#line 67 "imageset.ec"
 double d_img_err_ra ;
 
#line 68 "imageset.ec"
 double d_img_err_dec ;
 
#line 69 "imageset.ec"
 double d_img_err ;
 
#line 70 "imageset.ec"
  struct varchar_4  { int len; char arr[ 101 ]; }  d_img_path ;
 
#line 72 "imageset.ec"
 int d_img_temperature_ind ;
 
#line 73 "imageset.ec"
 int d_img_err_ra_ind ;
 
#line 74 "imageset.ec"
 int d_img_err_dec_ind ;
 
#line 75 "imageset.ec"
 int d_img_err_ind ;
 
#line 76 "imageset.ec"
 int d_img_path_ind ;
/* exec sql end declare section */
#line 78 "imageset.ec"


	std::ostringstream _os;
	
	_os << "SELECT "
		"tar_id,"
		"img_id,"
		"images.obs_id,"
		"obs_subtype,"
		"EXTRACT (EPOCH FROM img_date),"
		"img_usec,"
		"img_exposure,"
		"img_temperature,"
		"img_filter,"
		"img_alt,"
		"img_az,"
		"camera_name,"
		"mount_name,"
		"delete_flag,"
		"process_bitfield,"
		"img_err_ra,"
		"img_err_dec,"
		"img_err,"
		"img_path"
		" FROM "
		"images,"
		"observations"
		" WHERE "
		" images.obs_id = observations.obs_id AND " << in_where <<
		" ORDER BY "
		"img_date ASC;";

	stmp_c = new char[_os.str ().length () + 1];
	strcpy (stmp_c, _os.str ().c_str ());

	{ ECPGprepare(__LINE__, NULL, 0, "cur_images_stmp", stmp_c);}
#line 113 "imageset.ec"


	delete[] stmp_c;

	/* declare cur_images cursor for $1 */
#line 117 "imageset.ec"


	{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "declare cur_images cursor for $1", 
	ECPGt_char_variable,(ECPGprepared_statement(NULL, "cur_images_stmp", __LINE__)),(long)1,(long)1,(1)*sizeof(char), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EOIT, ECPGt_EORT);}
#line 119 "imageset.ec"

	while (1)
	{
		{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "fetch next from cur_images", ECPGt_EOIT, 
	ECPGt_int,&(d_tar_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_int,&(d_img_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_int,&(d_obs_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_char,&(d_obs_subtype),(long)1,(long)1,(1)*sizeof(char), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_long,&(d_img_date),(long)1,(long)1,sizeof(long), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_int,&(d_img_usec),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_float,&(d_img_exposure),(long)1,(long)1,sizeof(float), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_float,&(d_img_temperature),(long)1,(long)1,sizeof(float), 
	ECPGt_int,&(d_img_temperature_ind),(long)1,(long)1,sizeof(int), 
	ECPGt_varchar,&(d_img_filter),(long)3,(long)1,sizeof(struct varchar_1), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_float,&(d_img_alt),(long)1,(long)1,sizeof(float), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_float,&(d_img_az),(long)1,(long)1,sizeof(float), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_varchar,&(d_camera_name),(long)50,(long)1,sizeof(struct varchar_2), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_varchar,&(d_mount_name),(long)50,(long)1,sizeof(struct varchar_3), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_bool,&(d_delete_flag),(long)1,(long)1,sizeof(bool), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_int,&(d_process_bitfield),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_double,&(d_img_err_ra),(long)1,(long)1,sizeof(double), 
	ECPGt_int,&(d_img_err_ra_ind),(long)1,(long)1,sizeof(int), 
	ECPGt_double,&(d_img_err_dec),(long)1,(long)1,sizeof(double), 
	ECPGt_int,&(d_img_err_dec_ind),(long)1,(long)1,sizeof(int), 
	ECPGt_double,&(d_img_err),(long)1,(long)1,sizeof(double), 
	ECPGt_int,&(d_img_err_ind),(long)1,(long)1,sizeof(int), 
	ECPGt_varchar,&(d_img_path),(long)101,(long)1,sizeof(struct varchar_4), 
	ECPGt_int,&(d_img_path_ind),(long)1,(long)1,sizeof(int), ECPGt_EORT);}
#line 141 "imageset.ec"

		if (sqlca.sqlcode)
			break;

		d_img_filter.arr[d_img_filter.len] = '\0';

		if (d_img_temperature_ind < 0)
			d_img_temperature = rts2_nan ("f");
		if (d_img_err_ra_ind < 0)
			d_img_err_ra = rts2_nan ("f");
		if (d_img_err_dec_ind < 0)
			d_img_err_dec = rts2_nan ("f");
		if (d_img_err_ind < 0)
			d_img_err = rts2_nan ("f");

		allStat.img_alt += d_img_alt;
		allStat.img_az  += d_img_az;
		if (!isnan (d_img_err))
		{
			allStat.img_err += d_img_err;
			allStat.img_err_ra  += d_img_err_ra;
			allStat.img_err_dec += d_img_err_dec;
			allStat.astro_count++;
		}
		allStat.count++;
		allStat.exposure += d_img_exposure;

		std::vector <ImageSetStat>::iterator iter = getStat (std::string (d_img_filter.arr));

		(*iter).img_alt += d_img_alt;
		(*iter).img_az  += d_img_az;
		if (!isnan (d_img_err))
		{
			(*iter).img_err += d_img_err;
			(*iter).img_err_ra  += d_img_err_ra;
			(*iter).img_err_dec += d_img_err_dec;
			(*iter).astro_count++;
		}
		(*iter).count++;
		(*iter).exposure += d_img_exposure;

		d_camera_name.arr[d_camera_name.len] = '\0';
		d_mount_name.arr[d_mount_name.len] = '\0';
		if (d_img_path_ind < 0)
			d_img_path.arr[0] = '\0';
		else
			d_img_path.arr[d_img_path.len] = '\0';

		push_back (new rts2image::ImageSkyDb (d_tar_id, d_obs_id, d_img_id, d_obs_subtype,
			d_img_date, d_img_usec, d_img_exposure, d_img_temperature, d_img_filter.arr, d_img_alt, d_img_az,
			d_camera_name.arr, d_mount_name.arr, d_delete_flag, d_process_bitfield, d_img_err_ra,
			d_img_err_dec, d_img_err, d_img_path.arr));

	}
	if (sqlca.sqlcode != ECPG_NOT_FOUND)
	{
		logStream(MESSAGE_ERROR) << "ImageSet::load error in DB: " << sqlca.sqlerrm.sqlerrmc << sendLog;
		{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "close cur_images", ECPGt_EOIT, ECPGt_EORT);}
#line 198 "imageset.ec"

		{ ECPGtrans(__LINE__, NULL, "rollback");}
#line 199 "imageset.ec"

		return -1;
	}
	{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "close cur_images", ECPGt_EOIT, ECPGt_EORT);}
#line 202 "imageset.ec"

	{ ECPGtrans(__LINE__, NULL, "commit");}
#line 203 "imageset.ec"


	stat ();

	return 0;
}

void ImageSet::stat ()
{
	// compute statistics
	allStat.stat ();

	for (std::vector <ImageSetStat>::iterator iter = filterStat.begin (); iter != filterStat.end (); iter++)
	{
		(*iter).stat();
	}
}

void ImageSet::print (std::ostream &_os, int printImages)
{
	if ((printImages & DISPLAY_ALL) || (printImages & DISPLAY_FILENAME))
	{
		std::vector <rts2image::Image *>::iterator img_iter;
		if (empty () && !(printImages & DISPLAY_SHORT))
		{
			_os << "      " << "--- no images ---" << std::endl;
			return;
		}
		for (img_iter = begin (); img_iter != end (); img_iter++)
		{
			rts2image::Image *image = (*img_iter);
			if ((printImages & DISPLAY_ASTR_OK) && !image->haveOKAstrometry ())
				continue;
			if ((printImages & DISPLAY_ASTR_TRASH) && (image->haveOKAstrometry () || !image->isProcessed ()))
				continue;
			if ((printImages & DISPLAY_ASTR_QUE) && image->isProcessed ())
				continue;
			image->print (_os, printImages);
		}
	}
	if (printImages & DISPLAY_SUMMARY)
	{
		_os << *this << std::endl;
	}
}

int ImageSet::getAverageErrors (double &eRa, double &eDec, double &eRad)
{
	double tRa;
	double tDec;
	double tRad;

	eRa = 0;
	eDec = 0;
	eRad = 0;

	int aNum = 0;

	std::vector <rts2image::Image *>::iterator img_iter;
	for (img_iter = begin (); img_iter != end (); img_iter++)
	{
		if (((*img_iter)->getError (tRa, tDec, tRad)) == 0)
		{
			eRa += tRa;
			eDec += tDec;
			eRad += tRad;
			aNum++;
		}
	}
	if (aNum > 0)
	{
		eRa /= aNum;
		eDec /= aNum;
		eRad /= aNum;
	}
	return aNum;
}

std::vector <ImageSetStat>::iterator ImageSet::getStat (std::string in_filter)
{
	std::vector <ImageSetStat>::iterator iter;
	for (iter = filterStat.begin ();
		iter != filterStat.end (); iter++)
	{
		if ((*iter).filter == in_filter)
			return iter;
	}
	filterStat.push_back (ImageSetStat (in_filter));
	return --(filterStat.end());
}


ImageSetTarget::ImageSetTarget (int in_tar_id)
{
	tar_id = in_tar_id;
}

int ImageSetTarget::load ()
{
	std::ostringstream os;
	os << "tar_id = " << tar_id;
	return ImageSet::load (os.str());
}

ImageSetObs::ImageSetObs (Observation *in_observation)
{
	observation = in_observation;
}

int ImageSetObs::load ()
{
	std::ostringstream os;
	os << "observations.obs_id = " << observation->getObsId ();
	return ImageSet::load (os.str());
}

ImageSetPosition::ImageSetPosition (struct ln_equ_posn * in_pos)
{
	pos = *in_pos;
}

int ImageSetPosition::load ()
{
	std::ostringstream os;
	os << "isinwcs (" << pos.ra
		<< ", " << pos.dec
		<< ", astrometry)";
	return ImageSet::load (os.str ());
}

int ImageSetDate::load ()
{
	std::ostringstream _os;
	_os << " observations.obs_slew >= to_timestamp (" << from << ")"
	 	<< " AND observations.obs_slew <= to_timestamp ("
		<< to
		<< ") AND (observations.obs_end is NULL OR observations.obs_end < to_timestamp ("
		<< to
			<< "))";
	return ImageSet::load (_os.str ());
}
