/* Processed by ecpg (4.7.0) */
/* These include files are added by the preprocessor */
#include <ecpglib.h>
#include <ecpgerrno.h>
#include <sqlca.h>
/* End of automatic include section */

#line 1 "labels.ec"
/* 
 * Labels support (for targets,..).
 * Copyright (C) 2010 Petr Kubanek <petr@kubanek.net>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#include "rts2db/labels.h"
#include "rts2db/sqlerror.h"

using namespace rts2db;

std::string LabelsVector::getString (const char *empty, const char *jstr)
{
	if (size () == 0)
	{
		return std::string (empty);
	}
	std::string ret;
	for (LabelsVector::iterator iter = begin (); iter != end (); iter++)
	{
		if (iter != begin ())
			ret += std::string (jstr);
		ret += std::string (iter->ltext);
	}
	return ret;
}
		
int Labels::getLabel (const char *label, int type)
{
	/* exec sql begin declare section */
	 
	 
	   
	
#line 44 "labels.ec"
 int d_label_id ;
 
#line 45 "labels.ec"
  struct varchar_1  { int len; char arr[ 500 ]; }  d_label ;
 
#line 46 "labels.ec"
 int d_type = type ;
/* exec sql end declare section */
#line 47 "labels.ec"

	int l = strlen (label);
	if (l > 500)
		throw SqlError ("label is too long");
	memcpy (d_label.arr, label, l);
	d_label.len = l;

	{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "select label_id from labels where label_text like $1  and label_type = $2 ", 
	ECPGt_varchar,&(d_label),(long)500,(long)1,sizeof(struct varchar_1), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_int,&(d_type),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EOIT, 
	ECPGt_int,&(d_label_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EORT);}
#line 61 "labels.ec"

	if (sqlca.sqlcode)
	{
		if (sqlca.sqlcode == ECPG_NOT_FOUND)
		{
			{ ECPGtrans(__LINE__, NULL, "rollback");}
#line 66 "labels.ec"

			return -1;
		}
		{ ECPGtrans(__LINE__, NULL, "rollback");}
#line 69 "labels.ec"

		throw SqlError ();
	}
	{ ECPGtrans(__LINE__, NULL, "commit");}
#line 72 "labels.ec"

	return d_label_id;
}

int Labels::insertLabel (const char *label, int type)
{
	/* exec sql begin declare section */
	 
	 
	   
	
#line 79 "labels.ec"
 int d_label_id ;
 
#line 80 "labels.ec"
  struct varchar_2  { int len; char arr[ 500 ]; }  d_label ;
 
#line 81 "labels.ec"
 int d_type = type ;
/* exec sql end declare section */
#line 82 "labels.ec"


	int l = strlen (label);
	if (l > 500)
		throw SqlError ("too long label");
	memcpy (d_label.arr, label, l);
	d_label.len = l;

	{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "select nextval ( 'label_id' )", ECPGt_EOIT, 
	ECPGt_int,&(d_label_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EORT);}
#line 90 "labels.ec"


	{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "insert into labels ( label_id , label_type , label_text ) values ( $1  , $2  , $3  )", 
	ECPGt_int,&(d_label_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_int,&(d_type),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_varchar,&(d_label),(long)500,(long)1,sizeof(struct varchar_2), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EOIT, ECPGt_EORT);}
#line 95 "labels.ec"

	
	if (sqlca.sqlcode)
	{
		{ ECPGtrans(__LINE__, NULL, "rollback");}
#line 99 "labels.ec"

		throw SqlError ();
	}
	{ ECPGtrans(__LINE__, NULL, "commit");}
#line 102 "labels.ec"

	return d_label_id;
}

void Labels::addLabel (int tar_id, int label_id)
{
	/* exec sql begin declare section */
	   
	   
	
#line 109 "labels.ec"
 int d_tar_id = tar_id ;
 
#line 110 "labels.ec"
 int d_label_id = label_id ;
/* exec sql end declare section */
#line 111 "labels.ec"


	{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "insert into target_labels ( tar_id , label_id ) values ( $1  , $2  )", 
	ECPGt_int,&(d_tar_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_int,&(d_label_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EOIT, ECPGt_EORT);}
#line 116 "labels.ec"

	if (sqlca.sqlcode)
	{
		{ ECPGtrans(__LINE__, NULL, "rollback");}
#line 119 "labels.ec"

		throw SqlError ();
	}
	{ ECPGtrans(__LINE__, NULL, "commit");}
#line 122 "labels.ec"

}

void Labels::addLabel (int tar_id, const char *label, int type, bool create)
{
	int label_id = getLabel (label, type);
	if (label_id < 0)
	{
		if (!create)
			throw SqlError ("label not found");
		label_id = insertLabel (label, type);
	}
	addLabel (tar_id, label_id);
}

LabelsVector Labels::getTargetLabels (int tar_id)
{
	/* exec sql begin declare section */
	   
	 
	 
	 
	
#line 140 "labels.ec"
 int d_tar_id = tar_id ;
 
#line 141 "labels.ec"
 int d_lid ;
 
#line 142 "labels.ec"
 int d_type ;
 
#line 143 "labels.ec"
  struct varchar_3  { int len; char arr[ 501 ]; }  label ;
/* exec sql end declare section */
#line 144 "labels.ec"

	LabelsVector ret;

	ECPGset_var( 0, &( d_tar_id ), __LINE__);\
 /* declare label_target_cur cursor for select labels . label_id , label_type , label_text from labels , target_labels where target_labels . tar_id = $1  and target_labels . label_id = labels . label_id */
#line 154 "labels.ec"

	{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "declare label_target_cur cursor for select labels . label_id , label_type , label_text from labels , target_labels where target_labels . tar_id = $1  and target_labels . label_id = labels . label_id", 
	ECPGt_int,&(d_tar_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EOIT, ECPGt_EORT);}
#line 155 "labels.ec"

	while (true)
	{
		{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "fetch next from label_target_cur", ECPGt_EOIT, 
	ECPGt_int,&(d_lid),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_int,&(d_type),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_varchar,&(label),(long)501,(long)1,sizeof(struct varchar_3), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EORT);}
#line 158 "labels.ec"

		if (sqlca.sqlcode)
			break; 
		label.arr[label.len] = '\0';
		ret.push_back (Label (d_lid, d_type, label.arr));
	}
	if (sqlca.sqlcode != ECPG_NOT_FOUND)
	{
		{ ECPGtrans(__LINE__, NULL, "rollback");}
#line 166 "labels.ec"

		throw SqlError ();
	}
	{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "close label_target_cur", ECPGt_EOIT, ECPGt_EORT);}
#line 169 "labels.ec"

	{ ECPGtrans(__LINE__, NULL, "commit");}
#line 170 "labels.ec"

	return ret;
}

LabelsVector Labels::getTargetLabels (int tar_id, int type)
{
	/* exec sql begin declare section */
	   
	   
	 
	 
	
#line 177 "labels.ec"
 int d_tar_id = tar_id ;
 
#line 178 "labels.ec"
 int d_type = type ;
 
#line 179 "labels.ec"
 int lid ;
 
#line 180 "labels.ec"
  struct varchar_4  { int len; char arr[ 501 ]; }  label ;
/* exec sql end declare section */
#line 181 "labels.ec"


	LabelsVector ret;

	ECPGset_var( 1, &( d_type ), __LINE__);\
 ECPGset_var( 2, &( d_tar_id ), __LINE__);\
 /* declare label_cur cursor for select labels . label_id , label_text from labels , target_labels where labels . label_id = target_labels . label_id and target_labels . tar_id = $1  and labels . label_type = $2  */
#line 191 "labels.ec"

	{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "declare label_cur cursor for select labels . label_id , label_text from labels , target_labels where labels . label_id = target_labels . label_id and target_labels . tar_id = $1  and labels . label_type = $2 ", 
	ECPGt_int,&(d_tar_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_int,&(d_type),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EOIT, ECPGt_EORT);}
#line 192 "labels.ec"

	while (true)
	{
		{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "fetch next from label_cur", ECPGt_EOIT, 
	ECPGt_int,&(lid),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_varchar,&(label),(long)501,(long)1,sizeof(struct varchar_4), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EORT);}
#line 195 "labels.ec"

		if (sqlca.sqlcode)
			break;
		label.arr[label.len] = '\0';
		ret.push_back (Label (lid, d_type, label.arr));
	}
	if (sqlca.sqlcode != ECPG_NOT_FOUND)
	{
		{ ECPGtrans(__LINE__, NULL, "rollback");}
#line 203 "labels.ec"

		throw SqlError ();
	}
	{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "close label_cur", ECPGt_EOIT, ECPGt_EORT);}
#line 206 "labels.ec"

	{ ECPGtrans(__LINE__, NULL, "commit");}
#line 207 "labels.ec"

	return ret;
}

void Labels::deleteTargetLabels (int tar_id, int type)
{
	/* exec sql begin declare section */
	   
	   
	
#line 214 "labels.ec"
 int d_tar_id = tar_id ;
 
#line 215 "labels.ec"
 int d_type = type ;
/* exec sql end declare section */
#line 216 "labels.ec"


	{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "delete from target_labels where tar_id = $1  and ( select label_type from labels where labels . label_id = target_labels . label_id ) = $2 ", 
	ECPGt_int,&(d_tar_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_int,&(d_type),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EOIT, ECPGt_EORT);}
#line 219 "labels.ec"

	{ ECPGtrans(__LINE__, NULL, "commit");}
#line 220 "labels.ec"

	if (sqlca.sqlcode)
		throw SqlError ();
}

const char *getLabelName (int type)
{
	switch (type)
	{
		case LABEL_PI:
			return "PI";
		case LABEL_PROGRAM:
			return "PROGRAM";
	}
	return "unknown label type";
}
