/* Processed by ecpg (4.7.0) */
/* These include files are added by the preprocessor */
#include <ecpglib.h>
#include <ecpgerrno.h>
#include <sqlca.h>
/* End of automatic include section */

#line 1 "messagedb.ec"
/*
 * Class for database messages manipulation.
 * Copyright (C) 2007-2010 Petr Kubanek <petr@kubanek.net>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */


#include "rts2db/messagedb.h"
#include "rts2db/sqlerror.h"
#include "block.h"

#include <iostream>


#line 1 "/usr/include/sqlca.h"
#ifndef POSTGRES_SQLCA_H
#define POSTGRES_SQLCA_H

#ifndef PGDLLIMPORT
#if  defined(WIN32) || defined(__CYGWIN__)
#define PGDLLIMPORT __declspec (dllimport)
#else
#define PGDLLIMPORT
#endif   /* __CYGWIN__ */
#endif   /* PGDLLIMPORT */

#define SQLERRMC_LEN	150

#ifdef __cplusplus
extern		"C"
{
#endif

struct sqlca_t
{
	char		sqlcaid[8];
	long		sqlabc;
	long		sqlcode;
	struct
	{
		int			sqlerrml;
		char		sqlerrmc[SQLERRMC_LEN];
	}			sqlerrm;
	char		sqlerrp[8];
	long		sqlerrd[6];
	/* Element 0: empty						*/
	/* 1: OID of processed tuple if applicable			*/
	/* 2: number of rows processed				*/
	/* after an INSERT, UPDATE or				*/
	/* DELETE statement					*/
	/* 3: empty						*/
	/* 4: empty						*/
	/* 5: empty						*/
	char		sqlwarn[8];
	/* Element 0: set to 'W' if at least one other is 'W'	*/
	/* 1: if 'W' at least one character string		*/
	/* value was truncated when it was			*/
	/* stored into a host variable.				*/

	/*
	 * 2: if 'W' a (hopefully) non-fatal notice occurred
	 */	/* 3: empty */
	/* 4: empty						*/
	/* 5: empty						*/
	/* 6: empty						*/
	/* 7: empty						*/

	char		sqlstate[5];
};

struct sqlca_t *ECPGget_sqlca(void);

#ifndef POSTGRES_ECPG_INTERNAL
#define sqlca (*ECPGget_sqlca())
#endif

#ifdef __cplusplus
}
#endif

#endif

#line 27 "messagedb.ec"


using namespace rts2db;

MessageDB::MessageDB (const struct timeval &in_messageTime, std::string in_messageOName, messageType_t in_messageType, std::string in_messageString): rts2core::Message (in_messageTime, in_messageOName, in_messageType, in_messageString)
{
}

MessageDB::MessageDB (double in_messageTime, const char *in_messageOName, messageType_t in_messageType, const char *in_messageString): rts2core::Message (in_messageTime, in_messageOName, in_messageType, in_messageString)
{
}

MessageDB::~MessageDB (void)
{
}

void MessageDB::insertDB ()
{
	/* exec sql begin declare section */
	        
	 
	   
	 
	
#line 46 "messagedb.ec"
 double d_message_time = messageTime . tv_sec + ( double ) messageTime . tv_usec / USEC_SEC ;
 
#line 47 "messagedb.ec"
  struct varchar_1  { int len; char arr[ 8 ]; }  d_message_oname ;
 
#line 48 "messagedb.ec"
 int d_message_type = messageType ;
 
#line 49 "messagedb.ec"
  struct varchar_2  { int len; char arr[ 200 ]; }  d_message_string ;
/* exec sql end declare section */
#line 50 "messagedb.ec"


	strncpy (d_message_oname.arr, messageOName.c_str(), 8);
	d_message_oname.len = strlen (d_message_oname.arr);
	if (d_message_oname.len > 8)
		d_message_oname.len = 8;

	strncpy (d_message_string.arr, messageString.c_str(), 200);
	d_message_string.len = strlen (d_message_string.arr);
	if (d_message_string.len > 200)
		d_message_string.len = 200;

	{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "insert into message ( message_time , message_oname , message_type , message_string ) values ( to_timestamp ( $1  ) , $2  , $3  , $4  )", 
	ECPGt_double,&(d_message_time),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_varchar,&(d_message_oname),(long)8,(long)1,sizeof(struct varchar_1), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_int,&(d_message_type),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_varchar,&(d_message_string),(long)200,(long)1,sizeof(struct varchar_2), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EOIT, ECPGt_EORT);}
#line 75 "messagedb.ec"

	if (sqlca.sqlcode)
	{
		std::cerr << "Error writing to DB: " << sqlca.sqlerrm.sqlerrmc << " " << sqlca.sqlcode << std::endl;
		{ ECPGtrans(__LINE__, NULL, "rollback");}
#line 79 "messagedb.ec"

		return;
	}
	{ ECPGtrans(__LINE__, NULL, "commit");}
#line 82 "messagedb.ec"

}

void MessageSet::load (double from, double to, int type_mask)
{
	/* exec sql begin declare section */
	   
	   
	   

	 
	 
	 
	 
	
#line 88 "messagedb.ec"
 double d_from = from ;
 
#line 89 "messagedb.ec"
 double d_to = to ;
 
#line 90 "messagedb.ec"
 int d_type_mask = type_mask ;
 
#line 92 "messagedb.ec"
 double d_message_time ;
 
#line 93 "messagedb.ec"
  struct varchar_3  { int len; char arr[ 9 ]; }  d_message_oname ;
 
#line 94 "messagedb.ec"
 int d_message_type ;
 
#line 95 "messagedb.ec"
  struct varchar_4  { int len; char arr[ 200 ]; }  d_message_string ;
/* exec sql end declare section */
#line 96 "messagedb.ec"


	ECPGset_var( 0, &( d_type_mask ), __LINE__);\
 ECPGset_var( 1, &( d_to ), __LINE__);\
 ECPGset_var( 2, &( d_from ), __LINE__);\
 /* declare cur_message cursor for select extract ( EPOCH from message_time ) , message_oname , message_type , message_string from message where message_time between to_timestamp ( $1  ) and to_timestamp ( $2  ) and ( message_type & $3  ) <> 0 order by message_time asc */
#line 110 "messagedb.ec"

	
	{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "declare cur_message cursor for select extract ( EPOCH from message_time ) , message_oname , message_type , message_string from message where message_time between to_timestamp ( $1  ) and to_timestamp ( $2  ) and ( message_type & $3  ) <> 0 order by message_time asc", 
	ECPGt_double,&(d_from),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_double,&(d_to),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_int,&(d_type_mask),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EOIT, ECPGt_EORT);}
#line 112 "messagedb.ec"

	while (true)
	{
		{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "fetch next from cur_message", ECPGt_EOIT, 
	ECPGt_double,&(d_message_time),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_varchar,&(d_message_oname),(long)9,(long)1,sizeof(struct varchar_3), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_int,&(d_message_type),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_varchar,&(d_message_string),(long)200,(long)1,sizeof(struct varchar_4), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EORT);}
#line 119 "messagedb.ec"

		if (sqlca.sqlcode)
			break;
		d_message_oname.arr[d_message_oname.len] = '\0';
		push_back (MessageDB (d_message_time, d_message_oname.arr, d_message_type, d_message_string.arr));
	}
	if (sqlca.sqlcode != ECPG_NOT_FOUND)
	{
		{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "close cur_message", ECPGt_EOIT, ECPGt_EORT);}
#line 127 "messagedb.ec"

		{ ECPGtrans(__LINE__, NULL, "rollback");}
#line 128 "messagedb.ec"

		throw SqlError ();
	}
	{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "close cur_message", ECPGt_EOIT, ECPGt_EORT);}
#line 131 "messagedb.ec"

	{ ECPGtrans(__LINE__, NULL, "commit");}
#line 132 "messagedb.ec"

}

double MessageSet::getNextCtime ()
{
	if (timeLogIter != end ())
		return timeLogIter->getMessageTime ();
	return rts2_nan ("f");
}

void MessageSet::printUntil (double time, std::ostream &os)
{
	while (timeLogIter != end () && timeLogIter->getMessageTime () <= time)
	{
		os << (*timeLogIter) << std::endl;
		timeLogIter++;
	}
}
