/* Processed by ecpg (4.7.0) */
/* These include files are added by the preprocessor */
#include <ecpglib.h>
#include <ecpgerrno.h>
#include <sqlca.h>
/* End of automatic include section */

#line 1 "plan.ec"
/* 
 * Plan target class.
 * Copyright (C) 2003-2007 Petr Kubanek <petr@kubanek.net>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#include "configuration.h"
#include "libnova_cpp.h"

#include "rts2db/plan.h"
#include "rts2db/sqlerror.h"

#include <ostream>
#include <sstream>
#include <iomanip>

using namespace rts2db;

Plan::Plan ()
{
	plan_id = -1;
	tar_id = -1;
	prop_id = -1;
	target = NULL;
	obs_id = -1;
	observation = NULL;
	plan_status = 0;
	plan_start = plan_end = rts2_nan ("f");
}

Plan::Plan (int in_plan_id)
{
	plan_id = in_plan_id;
	tar_id = -1;
	prop_id = -1;
	target = NULL;
	obs_id = -1;
	observation = NULL;
	plan_status = 0;
	plan_start = plan_end = rts2_nan ("f");
}

Plan::Plan (const Plan &cp)
{
	plan_id = cp.plan_id;
	prop_id = cp.prop_id;
	tar_id = cp.tar_id;
	obs_id = cp.obs_id;
	plan_start = cp.plan_start;
	plan_end = cp.plan_end;
	plan_status = cp.plan_status;
	target = cp.target;

	target = NULL;
	observation = NULL;
}

Plan::~Plan (void)
{
	delete target;
}

int Plan::load ()
{
	/* exec sql begin declare section */
		   
		 
		 
		 
		 
		 
		 
		 
		 
		 
	
#line 79 "plan.ec"
 int db_plan_id = plan_id ;
 
#line 80 "plan.ec"
 int db_prop_id ;
 
#line 81 "plan.ec"
 int db_prop_id_ind ;
 
#line 82 "plan.ec"
 int db_tar_id ;
 
#line 83 "plan.ec"
 int db_obs_id ;
 
#line 84 "plan.ec"
 int db_obs_id_ind ;
 
#line 85 "plan.ec"
 double db_plan_start ;
 
#line 86 "plan.ec"
 double db_plan_end ;
 
#line 87 "plan.ec"
 int db_plan_end_ind ;
 
#line 88 "plan.ec"
 int db_plan_status ;
/* exec sql end declare section */
#line 89 "plan.ec"


	{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "select prop_id , tar_id , obs_id , extract ( EPOCH from plan_start ) , extract ( EPOCH from plan_end ) , plan_status from plan where plan_id = $1 ", 
	ECPGt_int,&(db_plan_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EOIT, 
	ECPGt_int,&(db_prop_id),(long)1,(long)1,sizeof(int), 
	ECPGt_int,&(db_prop_id_ind),(long)1,(long)1,sizeof(int), 
	ECPGt_int,&(db_tar_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_int,&(db_obs_id),(long)1,(long)1,sizeof(int), 
	ECPGt_int,&(db_obs_id_ind),(long)1,(long)1,sizeof(int), 
	ECPGt_double,&(db_plan_start),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_double,&(db_plan_end),(long)1,(long)1,sizeof(double), 
	ECPGt_int,&(db_plan_end_ind),(long)1,(long)1,sizeof(int), 
	ECPGt_int,&(db_plan_status),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EORT);}
#line 108 "plan.ec"

	if (sqlca.sqlcode)
	{
		{ ECPGtrans(__LINE__, NULL, "rollback");}
#line 111 "plan.ec"

		return -1;
	}
	if (db_prop_id_ind)
		prop_id = -1;
	else
		prop_id = db_prop_id;
	tar_id = db_tar_id;
	if (db_obs_id_ind)
		db_obs_id = -1;
	else
		obs_id = db_obs_id;
	plan_start = (long) db_plan_start;
	if (db_plan_end_ind)
		plan_end = rts2_nan ("f");
	else
		plan_end = db_plan_end;
	plan_status = db_plan_status;
	{ ECPGtrans(__LINE__, NULL, "commit");}
#line 129 "plan.ec"

	return 0;
}

int Plan::save ()
{
	/* exec sql begin declare section */
		   
		   
		   
		 
		   
		 
		   
		   
		        
		   
	
#line 136 "plan.ec"
 int db_plan_id = plan_id ;
 
#line 137 "plan.ec"
 int db_tar_id = tar_id ;
 
#line 138 "plan.ec"
 int db_prop_id = prop_id ;
 
#line 139 "plan.ec"
 int db_prop_id_ind ;
 
#line 140 "plan.ec"
 int db_obs_id = obs_id ;
 
#line 141 "plan.ec"
 int db_obs_id_ind ;
 
#line 142 "plan.ec"
 double db_plan_start = plan_start ;
 
#line 143 "plan.ec"
 double db_plan_end = plan_end ;
 
#line 144 "plan.ec"
 int db_plan_end_ind = ( isnan ( plan_end ) ? - 1 : 0 ) ;
 
#line 145 "plan.ec"
 int db_plan_status = plan_status ;
/* exec sql end declare section */
#line 146 "plan.ec"


	// don't save entries with same target id as master plan
	if (db_tar_id == TARGET_PLAN)
		return -1;

	if (db_plan_id == -1)
	{
		{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "select nextval ( 'plan_id' )", ECPGt_EOIT, 
	ECPGt_int,&(db_plan_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EORT);}
#line 158 "plan.ec"

		if (sqlca.sqlcode)
		{
			logStream(MESSAGE_ERROR) << "Error getting nextval" << sqlca.sqlcode << sqlca.sqlerrm.sqlerrmc << sendLog;
			return -1;
		}
		plan_id = db_plan_id;
	}

	if (db_prop_id == -1)
	{
		db_prop_id = 0;
		db_prop_id_ind = -1;
	}
	else
	{
		db_prop_id_ind = 0;
	}

	if (db_obs_id == -1)
	{
		db_obs_id = 0;
		db_obs_id_ind = -1;
	}
	else
	{
		db_obs_id_ind = 0;
	}

	{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "insert into plan ( plan_id , tar_id , prop_id , obs_id , plan_start , plan_end , plan_status ) values ( $1  , $2  , $3  , $4  , to_timestamp ( $5  ) , to_timestamp ( $6  ) , $7  )", 
	ECPGt_int,&(db_plan_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_int,&(db_tar_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_int,&(db_prop_id),(long)1,(long)1,sizeof(int), 
	ECPGt_int,&(db_prop_id_ind),(long)1,(long)1,sizeof(int), 
	ECPGt_int,&(db_obs_id),(long)1,(long)1,sizeof(int), 
	ECPGt_int,&(db_obs_id_ind),(long)1,(long)1,sizeof(int), 
	ECPGt_double,&(db_plan_start),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_double,&(db_plan_end),(long)1,(long)1,sizeof(double), 
	ECPGt_int,&(db_plan_end_ind),(long)1,(long)1,sizeof(int), 
	ECPGt_int,&(db_plan_status),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EOIT, ECPGt_EORT);}
#line 204 "plan.ec"

	if (sqlca.sqlcode)
	{
		logStream(MESSAGE_ERROR) << "Error inserting plan " << sqlca.sqlcode << sqlca.sqlerrm.sqlerrmc
			<< " prop_id:" << db_prop_id << " ind:" << db_prop_id_ind << sendLog;
		// try update
		{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "update plan set tar_id = $1  , prop_id = $2  , obs_id = $3  , plan_start = to_timestamp ( $4  ) , plan_end = to_timestamp ( $5  ) , plan_status = $6  where plan_id = $7 ", 
	ECPGt_int,&(db_tar_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_int,&(db_prop_id),(long)1,(long)1,sizeof(int), 
	ECPGt_int,&(db_prop_id_ind),(long)1,(long)1,sizeof(int), 
	ECPGt_int,&(db_obs_id),(long)1,(long)1,sizeof(int), 
	ECPGt_int,&(db_obs_id_ind),(long)1,(long)1,sizeof(int), 
	ECPGt_double,&(db_plan_start),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_double,&(db_plan_end),(long)1,(long)1,sizeof(double), 
	ECPGt_int,&(db_plan_end_ind),(long)1,(long)1,sizeof(int), 
	ECPGt_int,&(db_plan_status),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_int,&(db_plan_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EOIT, ECPGt_EORT);}
#line 220 "plan.ec"

		if (sqlca.sqlcode)
		{
			logStream(MESSAGE_ERROR) << "Error updating plan " << sqlca.sqlcode << sqlca.sqlerrm.sqlerrmc << sendLog;
			{ ECPGtrans(__LINE__, NULL, "rollback");}
#line 224 "plan.ec"

			return -1;
		}
	}
	{ ECPGtrans(__LINE__, NULL, "commit");}
#line 228 "plan.ec"

	return 0;
}

int Plan::del ()
{
	/* exec sql begin declare section */
		   
	
#line 235 "plan.ec"
 int db_plan_id = plan_id ;
/* exec sql end declare section */
#line 236 "plan.ec"


	if (db_plan_id == -1)
		return 0;

	{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "delete from plan where plan_id = $1 ", 
	ECPGt_int,&(db_plan_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EOIT, ECPGt_EORT);}
#line 244 "plan.ec"

	if (sqlca.sqlcode)
	{
		{ ECPGtrans(__LINE__, NULL, "rollback");}
#line 247 "plan.ec"

		return -1;
	}
	{ ECPGtrans(__LINE__, NULL, "commit");}
#line 250 "plan.ec"

	return 0;
}

moveType Plan::startSlew (struct ln_equ_posn *position, bool update_position)
{
	moveType ret;
	ret = getTarget ()->startSlew (position, update_position);
	if (obs_id > 0)
		return ret;

	setObsId (getTarget()->getObsId ());

	return ret;
}

Target * Plan::getTarget ()
{
	if (target)
		return target;
	target = createTarget (tar_id, rts2core::Configuration::instance ()->getObserver ());
	return target;
}

Observation * Plan::getObservation ()
{
	int ret;
	if (observation)
		return observation;
	if (obs_id <= 0)
		return NULL;
	observation = new Observation (obs_id);
	ret = observation->load ();
	if (ret)
	{
		delete observation;
		observation = NULL;
	}
	return observation;
}

void Plan::setObsId (int in_obs_id)
{
	/* exec sql begin declare section */
	   
	   
	
#line 294 "plan.ec"
 int db_plan_id = plan_id ;
 
#line 295 "plan.ec"
 int db_obs_id = in_obs_id ;
/* exec sql end declare section */
#line 296 "plan.ec"

	{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "update plan set obs_id = $1  , plan_status = plan_status | 1 where plan_id = $2 ", 
	ECPGt_int,&(db_obs_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_int,&(db_plan_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EOIT, ECPGt_EORT);}
#line 303 "plan.ec"


	if (sqlca.sqlcode)
	{
		logStream (MESSAGE_ERROR) << "Plan::startSlew " << sqlca.sqlerrm.sqlerrmc << " (" << sqlca.sqlcode << ")" << sendLog;
		{ ECPGtrans(__LINE__, NULL, "rollback");}
#line 308 "plan.ec"

	}
	else
	{
		{ ECPGtrans(__LINE__, NULL, "commit");}
#line 312 "plan.ec"

		obs_id = db_obs_id;
	}
}

void Plan::print (std::ostream & _os)
{
	struct ln_hrz_posn hrz;
	const char *tar_name;
	int good;
	double JD;
	int ret;
	time_t t = plan_start;
	JD = ln_get_julian_from_timet (&t);
	ret = load ();
	if (ret)
	{
		tar_name = "(not loaded!)";
		good = 0;
	}
	else
	{
		tar_name = getTarget()->getTargetName();
		good = getTarget()->isGood (JD);
	}
	getTarget ()->getAltAz (&hrz, JD);
	LibnovaHrz lHrz (&hrz);
	_os << "  " << std::setw (8) << plan_id << SEP
		<< std::setw (8) << prop_id << SEP
		<< std::left << std::setw (20) << tar_name << SEP
		<< std::right << std::setw (8) << tar_id << SEP
		<< std::setw (8) << obs_id << SEP
		<< std::setw (9) << Timestamp (plan_start) << SEP
		<< std::setw (9) << Timestamp (plan_end) << SEP
		<< std::setw (8) << plan_status << SEP
		<< lHrz << SEP
		<< std::setw(1) << (good ? 'G' : 'B')
		<< std::endl;
}

void Plan::printInfoVal (Rts2InfoValStream & _os)
{
	if (_os.getStream ())
		*(_os.getStream ()) << this;
}

void Plan::read (std::istream & _is)
{
	_is >> tar_id;
	if (_is.fail ())
		throw rts2core::Error ("cannot parse target ID");
	LibnovaDate date;
	_is >> date;
	if (_is.fail ())
		throw rts2core::Error ("cannot parse start date");
	plan_start = date.getDateDouble ();
	try
	{
		_is >> date;
		plan_end = date.getDateDouble ();
	}
	catch (rts2core::Error &er)
	{
		plan_end = rts2_nan ("f");
	}
	Target *tar = getTarget ();
	if (tar == NULL)
	{
		std::ostringstream os;
		os << "cannot load target with ID " << getTargetId ();
		throw rts2core::Error (os.str ());
	}
}
