/* Processed by ecpg (4.7.0) */
/* These include files are added by the preprocessor */
#include <ecpglib.h>
#include <ecpgerrno.h>
#include <sqlca.h>
/* End of automatic include section */

#line 1 "planset.ec"
/* 
 * Plan set class.
 * Copyright (C) 2003-2007 Petr Kubanek <petr@kubanek.net>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#include "rts2db/planset.h"
#include "configuration.h"
#include "libnova_cpp.h"

#include <sstream>

using namespace rts2db;

void PlanSet::load ()
{
	/* exec sql begin declare section */
	 

	 
	
#line 31 "planset.ec"
 char * stmp_c ;
 
#line 33 "planset.ec"
 int db_plan_id ;
/* exec sql end declare section */
#line 34 "planset.ec"


	std::list <int> plan_ids;
	std::ostringstream os;
	int ret;

	os << "SELECT "
		"plan_id"
	" FROM "
		"plan";
	if (where.length ())
	{
		os << " WHERE " << where;
	}
	os << " ORDER BY plan_start ASC;";

	stmp_c = new char[strlen (os.str().c_str ()) + 1];
	strcpy (stmp_c, os.str().c_str ());

	{ ECPGprepare(__LINE__, NULL, 0, "plan_stmp", stmp_c);}
#line 53 "planset.ec"


	/* declare plan_cur cursor for $1 */
#line 55 "planset.ec"


	{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "declare plan_cur cursor for $1", 
	ECPGt_char_variable,(ECPGprepared_statement(NULL, "plan_stmp", __LINE__)),(long)1,(long)1,(1)*sizeof(char), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EOIT, ECPGt_EORT);}
#line 57 "planset.ec"

	while (1)
	{
		{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "fetch next from plan_cur", ECPGt_EOIT, 
	ECPGt_int,&(db_plan_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EORT);}
#line 62 "planset.ec"

		if (sqlca.sqlcode)
			break;
		plan_ids.push_back (db_plan_id);
	}
	if (sqlca.sqlcode != ECPG_NOT_FOUND)
	{
		logStream (MESSAGE_ERROR) << "Plan::load cannot load plan set" << sendLog;
		{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "close plan_cur", ECPGt_EOIT, ECPGt_EORT);}
#line 70 "planset.ec"

		{ ECPGtrans(__LINE__, NULL, "rollback");}
#line 71 "planset.ec"

		delete[] stmp_c;
		return;
	}
	delete[] stmp_c;
	{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "close plan_cur", ECPGt_EOIT, ECPGt_EORT);}
#line 76 "planset.ec"

	{ ECPGtrans(__LINE__, NULL, "rollback");}
#line 77 "planset.ec"


	for (std::list<int>::iterator iter = plan_ids.begin (); iter != plan_ids.end (); iter++)
	{
		Plan plan (*iter);
		ret = plan.load ();
		if (ret)
		{
			logStream (MESSAGE_ERROR) << "Plan cannot load plan with plan_id " << *iter << sendLog;
			continue;
		}
		push_back (plan);
	}
}


PlanSet::PlanSet ():where ("")
{
}

PlanSet::PlanSet (int prop_id)
{
	std::ostringstream os;

	os << " prop_id = " << prop_id;
	where = os.str ();
}

PlanSet::PlanSet (double t_from, double t_to)
{
	planFromTo (t_from, t_to);  
}

PlanSet::~PlanSet (void)
{
}

void PlanSet::planFromTo (double t_from, double t_to)
{
	std::ostringstream os;

	os.setf (std::ios_base::fixed, std::ios_base::floatfield);

	os << " EXTRACT (EPOCH FROM plan_start) >= " << t_from;
	if (!isnan (t_to))
		os << " AND EXTRACT (EPOCH FROM plan_start) <= " << t_to;
	where = os.str ();
}

PlanSetTarget::PlanSetTarget (int tar_id)
{
	std::ostringstream os;

	os << " tar_id = " << tar_id;
	where = os.str ();
}

PlanSetNight::PlanSetNight (double JD)
{
	Rts2Night night (JD, rts2core::Configuration::instance ()->getObserver ());
	from = *(night.getFrom ());
	to = *(night.getTo ());
	planFromTo (from, to);
}
