/* Processed by ecpg (4.7.0) */
/* These include files are added by the preprocessor */
#include <ecpglib.h>
#include <ecpgerrno.h>
#include <sqlca.h>
/* End of automatic include section */

#line 1 "records.ec"
/* 
 * Utility classes for record values.
 * Copyright (C) 2009 Petr Kubanek <petr@kubanek.net>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#include "rts2db/records.h"
#include "rts2db/recvals.h"
#include "rts2db/sqlerror.h"

using namespace rts2db;

int RecordsSet::getValueType ()
{
	/* exec sql begin declare section */
	   
	 
	
#line 29 "records.ec"
 int d_recval_id = recval_id ;
 
#line 30 "records.ec"
 int d_value_type ;
/* exec sql end declare section */
#line 31 "records.ec"


	if (value_type != -1)
		return value_type;

	{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "select value_type from recvals where recval_id = $1 ", 
	ECPGt_int,&(d_recval_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EOIT, 
	ECPGt_int,&(d_value_type),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EORT);}
#line 36 "records.ec"

	if (sqlca.sqlcode)
		throw SqlError ();
	value_type = d_value_type;
	return value_type;	
}

void RecordsSet::loadState (double t_from, double t_to)
{
	/* exec sql begin declare section */
	   
	 
	 
	   
	   
	
#line 46 "records.ec"
 int d_recval_id = recval_id ;
 
#line 47 "records.ec"
 double d_rectime ;
 
#line 48 "records.ec"
 double d_value ;
 
#line 49 "records.ec"
 double d_t_from = t_from ;
 
#line 50 "records.ec"
 double d_t_to = t_to ;
/* exec sql end declare section */
#line 51 "records.ec"


	ECPGset_var( 0, &( d_t_to ), __LINE__);\
 ECPGset_var( 1, &( d_t_from ), __LINE__);\
 ECPGset_var( 2, &( d_recval_id ), __LINE__);\
 /* declare records_state_cur cursor for select extract ( EPOCH from rectime ) , value from records_state where recval_id = $1  and rectime between to_timestamp ( $2  ) and to_timestamp ( $3  ) order by rectime */
#line 63 "records.ec"


	{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "declare records_state_cur cursor for select extract ( EPOCH from rectime ) , value from records_state where recval_id = $1  and rectime between to_timestamp ( $2  ) and to_timestamp ( $3  ) order by rectime", 
	ECPGt_int,&(d_recval_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_double,&(d_t_from),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_double,&(d_t_to),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EOIT, ECPGt_EORT);}
#line 65 "records.ec"


	while (true)
	{
		{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "fetch next from records_state_cur", ECPGt_EOIT, 
	ECPGt_double,&(d_rectime),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_double,&(d_value),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EORT);}
#line 71 "records.ec"

		if (sqlca.sqlcode)
			break;
		push_back (Record (d_rectime, d_value));
	}

	if (sqlca.sqlcode != ECPG_NOT_FOUND)
	{
		throw SqlError();
	}
	{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "close records_state_cur", ECPGt_EOIT, ECPGt_EORT);}
#line 81 "records.ec"

	{ ECPGtrans(__LINE__, NULL, "rollback");}
#line 82 "records.ec"

}

void RecordsSet::loadDouble (double t_from, double t_to)
{
	/* exec sql begin declare section */
	   
	 
	 
	   
	   
	
#line 88 "records.ec"
 int d_recval_id = recval_id ;
 
#line 89 "records.ec"
 double d_rectime ;
 
#line 90 "records.ec"
 double d_value ;
 
#line 91 "records.ec"
 double d_t_from = t_from ;
 
#line 92 "records.ec"
 double d_t_to = t_to ;
/* exec sql end declare section */
#line 93 "records.ec"


	ECPGset_var( 3, &( d_t_to ), __LINE__);\
 ECPGset_var( 4, &( d_t_from ), __LINE__);\
 ECPGset_var( 5, &( d_recval_id ), __LINE__);\
 /* declare records_double_cur cursor for select extract ( EPOCH from rectime ) , value from records_double where recval_id = $1  and rectime between to_timestamp ( $2  ) and to_timestamp ( $3  ) order by rectime */
#line 105 "records.ec"


	{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "declare records_double_cur cursor for select extract ( EPOCH from rectime ) , value from records_double where recval_id = $1  and rectime between to_timestamp ( $2  ) and to_timestamp ( $3  ) order by rectime", 
	ECPGt_int,&(d_recval_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_double,&(d_t_from),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_double,&(d_t_to),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EOIT, ECPGt_EORT);}
#line 107 "records.ec"


	min = INFINITY;
	max = -INFINITY;

	while (true)
	{
		{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "fetch next from records_double_cur", ECPGt_EOIT, 
	ECPGt_double,&(d_rectime),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_double,&(d_value),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EORT);}
#line 116 "records.ec"

		if (sqlca.sqlcode)
			break;
		if (d_value < min)
			min = d_value;
		if (d_value > max)
		  	max = d_value;
		push_back (Record (d_rectime, d_value));
	}

	if (sqlca.sqlcode != ECPG_NOT_FOUND)
	{
		throw SqlError();
	}
	{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "close records_double_cur", ECPGt_EOIT, ECPGt_EORT);}
#line 130 "records.ec"

	{ ECPGtrans(__LINE__, NULL, "rollback");}
#line 131 "records.ec"

}

void RecordsSet::loadBoolean (double t_from, double t_to)
{
	/* exec sql begin declare section */
	   
	 
	 
	   
	   
	
#line 137 "records.ec"
 int d_recval_id = recval_id ;
 
#line 138 "records.ec"
 double d_rectime ;
 
#line 139 "records.ec"
 bool d_value ;
 
#line 140 "records.ec"
 double d_t_from = t_from ;
 
#line 141 "records.ec"
 double d_t_to = t_to ;
/* exec sql end declare section */
#line 142 "records.ec"


	ECPGset_var( 6, &( d_t_to ), __LINE__);\
 ECPGset_var( 7, &( d_t_from ), __LINE__);\
 ECPGset_var( 8, &( d_recval_id ), __LINE__);\
 /* declare records_boolean_cur cursor for select extract ( EPOCH from rectime ) , value from records_boolean where recval_id = $1  and rectime between to_timestamp ( $2  ) and to_timestamp ( $3  ) order by rectime */
#line 154 "records.ec"


	{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "declare records_boolean_cur cursor for select extract ( EPOCH from rectime ) , value from records_boolean where recval_id = $1  and rectime between to_timestamp ( $2  ) and to_timestamp ( $3  ) order by rectime", 
	ECPGt_int,&(d_recval_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_double,&(d_t_from),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_double,&(d_t_to),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EOIT, ECPGt_EORT);}
#line 156 "records.ec"


	min = 1;
	max = 0;

	while (true)
	{
		{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "fetch next from records_boolean_cur", ECPGt_EOIT, 
	ECPGt_double,&(d_rectime),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_bool,&(d_value),(long)1,(long)1,sizeof(bool), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EORT);}
#line 165 "records.ec"

		if (sqlca.sqlcode)
			break;
		if (d_value < min)
			min = d_value;
		if (d_value > max)
		  	max = d_value;
		push_back (Record (d_rectime, d_value));
	}

	if (sqlca.sqlcode != ECPG_NOT_FOUND)
	{
		throw SqlError();
	}
	{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "close records_boolean_cur", ECPGt_EOIT, ECPGt_EORT);}
#line 179 "records.ec"

	{ ECPGtrans(__LINE__, NULL, "rollback");}
#line 180 "records.ec"

}

void RecordsSet::load (double t_from, double t_to)
{
	switch (getValueBaseType ())
	{
		case RECVAL_STATE:
			loadState (t_from, t_to);
			break;
		case RTS2_VALUE_DOUBLE:
			loadDouble (t_from, t_to);
			break;
		case RTS2_VALUE_BOOL:
			loadBoolean (t_from, t_to);
			break;
		default:
			throw rts2core::Error ("unknown value type");
	}
}

