/* Processed by ecpg (4.7.0) */
/* These include files are added by the preprocessor */
#include <ecpglib.h>
#include <ecpgerrno.h>
#include <sqlca.h>
/* End of automatic include section */

#line 1 "recvals.ec"
/* 
 * Utility classes for record values manipulations.
 * Copyright (C) 2009 Petr Kubanek <petr@kubanek.net>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#include "utilsfunc.h"

#include "rts2db/recvals.h"
#include "rts2db/sqlerror.h"

using namespace rts2db;

void RecvalsSet::load ()
{
	/* exec sql begin declare section */
	 
	 
	 
	 
	 
	 
	 
	 
	
#line 30 "recvals.ec"
 int d_recval_id ;
 
#line 31 "recvals.ec"
  struct varchar_1  { int len; char arr[ 26 ]; }  d_device_name ;
 
#line 32 "recvals.ec"
  struct varchar_2  { int len; char arr[ 26 ]; }  d_value_name ;
 
#line 33 "recvals.ec"
 int d_value_type ;
 
#line 34 "recvals.ec"
 double d_from ;
 
#line 35 "recvals.ec"
 double d_to ;
 
#line 36 "recvals.ec"
 int d_from_null ;
 
#line 37 "recvals.ec"
 int d_to_null ;
/* exec sql end declare section */
#line 38 "recvals.ec"


	/* declare recval_state_cur cursor for select recval_id , device_name , value_name , extract ( EPOCH from time_from ) , extract ( EPOCH from time_to ) from recvals_state_statistics */
#line 48 "recvals.ec"


	{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "declare recval_state_cur cursor for select recval_id , device_name , value_name , extract ( EPOCH from time_from ) , extract ( EPOCH from time_to ) from recvals_state_statistics", ECPGt_EOIT, ECPGt_EORT);}
#line 50 "recvals.ec"


	while (true)
	{
		{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "fetch next from recval_state_cur", ECPGt_EOIT, 
	ECPGt_int,&(d_recval_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_varchar,&(d_device_name),(long)26,(long)1,sizeof(struct varchar_1), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_varchar,&(d_value_name),(long)26,(long)1,sizeof(struct varchar_2), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_double,&(d_from),(long)1,(long)1,sizeof(double), 
	ECPGt_int,&(d_from_null),(long)1,(long)1,sizeof(int), 
	ECPGt_double,&(d_to),(long)1,(long)1,sizeof(double), 
	ECPGt_int,&(d_to_null),(long)1,(long)1,sizeof(int), ECPGt_EORT);}
#line 59 "recvals.ec"

		if (sqlca.sqlcode)
			break;
		d_device_name.arr[d_device_name.len] = '\0';
		d_value_name.arr[d_value_name.len] = '\0';
		if (d_from_null)
			d_from = rts2_nan ("f");
		if (d_to_null)
			d_to = rts2_nan ("f");
		insert (std::pair <int, Recval> (d_recval_id, Recval (d_recval_id, d_device_name.arr, d_value_name.arr, RECVAL_STATE, d_from, d_to)));
	}

	if (sqlca.sqlcode != ECPG_NOT_FOUND)
	{
		throw SqlError();
	}
	{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "close recval_state_cur", ECPGt_EOIT, ECPGt_EORT);}
#line 75 "recvals.ec"



	/* declare recval_double_cur cursor for select recval_id , device_name , value_name , value_type , extract ( EPOCH from time_from ) , extract ( EPOCH from time_to ) from recvals_double_statistics */
#line 87 "recvals.ec"


	{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "declare recval_double_cur cursor for select recval_id , device_name , value_name , value_type , extract ( EPOCH from time_from ) , extract ( EPOCH from time_to ) from recvals_double_statistics", ECPGt_EOIT, ECPGt_EORT);}
#line 89 "recvals.ec"


	while (true)
	{
		{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "fetch next from recval_double_cur", ECPGt_EOIT, 
	ECPGt_int,&(d_recval_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_varchar,&(d_device_name),(long)26,(long)1,sizeof(struct varchar_1), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_varchar,&(d_value_name),(long)26,(long)1,sizeof(struct varchar_2), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_int,&(d_value_type),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_double,&(d_from),(long)1,(long)1,sizeof(double), 
	ECPGt_int,&(d_from_null),(long)1,(long)1,sizeof(int), 
	ECPGt_double,&(d_to),(long)1,(long)1,sizeof(double), 
	ECPGt_int,&(d_to_null),(long)1,(long)1,sizeof(int), ECPGt_EORT);}
#line 99 "recvals.ec"

		if (sqlca.sqlcode)
			break;
		d_device_name.arr[d_device_name.len] = '\0';
		d_value_name.arr[d_value_name.len] = '\0';
		if (d_from_null)
			d_from = rts2_nan ("f");
		if (d_to_null)
			d_to = rts2_nan ("f");
		insert (std::pair <int, Recval> (d_recval_id, Recval (d_recval_id, d_device_name.arr, d_value_name.arr, d_value_type, d_from, d_to)));
	}

	if (sqlca.sqlcode != ECPG_NOT_FOUND)
	{
		throw SqlError();
	}
	{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "close recval_double_cur", ECPGt_EOIT, ECPGt_EORT);}
#line 115 "recvals.ec"


	/* declare recval_boolean_cur cursor for select recval_id , device_name , value_name , value_type , extract ( EPOCH from time_from ) , extract ( EPOCH from time_to ) from recvals_boolean_statistics */
#line 126 "recvals.ec"


	{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "declare recval_boolean_cur cursor for select recval_id , device_name , value_name , value_type , extract ( EPOCH from time_from ) , extract ( EPOCH from time_to ) from recvals_boolean_statistics", ECPGt_EOIT, ECPGt_EORT);}
#line 128 "recvals.ec"


	while (true)
	{
		{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "fetch next from recval_boolean_cur", ECPGt_EOIT, 
	ECPGt_int,&(d_recval_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_varchar,&(d_device_name),(long)26,(long)1,sizeof(struct varchar_1), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_varchar,&(d_value_name),(long)26,(long)1,sizeof(struct varchar_2), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_int,&(d_value_type),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_double,&(d_from),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_double,&(d_to),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EORT);}
#line 138 "recvals.ec"

		if (sqlca.sqlcode)
			break;
		d_device_name.arr[d_device_name.len] = '\0';
		d_value_name.arr[d_value_name.len] = '\0';
		insert (std::pair <int, Recval> (d_recval_id, Recval (d_recval_id, d_device_name.arr, d_value_name.arr, d_value_type, d_from, d_to)));
	}

	if (sqlca.sqlcode != ECPG_NOT_FOUND)
	{
		throw SqlError();
	}
	{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "close recval_boolean_cur", ECPGt_EOIT, ECPGt_EORT);}
#line 150 "recvals.ec"

	{ ECPGtrans(__LINE__, NULL, "rollback");}
#line 151 "recvals.ec"

}

Recval * RecvalsSet::searchByName (const char *_device_name, const char *_value_name)
{
	std::string _dn (_device_name);
	std::string _vn (_value_name);
	for (std::map <int, Recval>::iterator iter = begin (); iter != end (); iter++)
	{
		if (iter->second.getDevice () == _dn && iter->second.getValueName () == _vn)
			return &(iter->second);
	}
	return NULL;
}
