/* Processed by ecpg (4.7.0) */
/* These include files are added by the preprocessor */
#include <ecpglib.h>
#include <ecpgerrno.h>
#include <sqlca.h>
/* End of automatic include section */

#line 1 "sqlcolumn.ec"
#include "rts2db/sqlcolumn.h"
#include "rts2db/target.h"


#line 1 "/usr/include/sql3types.h"
#ifndef _ECPG_SQL3TYPES_H
#define _ECPG_SQL3TYPES_H

/* SQL3 dynamic type codes */

/* chapter 13.1 table 2: Codes used for SQL data types in Dynamic SQL */

enum
{
	SQL3_CHARACTER = 1,
	SQL3_NUMERIC,
	SQL3_DECIMAL,
	SQL3_INTEGER,
	SQL3_SMALLINT,
	SQL3_FLOAT,
	SQL3_REAL,
	SQL3_DOUBLE_PRECISION,
	SQL3_DATE_TIME_TIMESTAMP,
	SQL3_INTERVAL,				/* 10 */
	SQL3_CHARACTER_VARYING = 12,
	SQL3_ENUMERATED,
	SQL3_BIT,
	SQL3_BIT_VARYING,
	SQL3_BOOLEAN,
	SQL3_abstract
	/* the rest is xLOB stuff */
};

/* chapter 13.1 table 3: Codes associated with datetime data types in Dynamic SQL */

enum
{
	SQL3_DDT_DATE = 1,
	SQL3_DDT_TIME,
	SQL3_DDT_TIMESTAMP,
	SQL3_DDT_TIME_WITH_TIME_ZONE,
	SQL3_DDT_TIMESTAMP_WITH_TIME_ZONE,

	SQL3_DDT_ILLEGAL			/* not a datetime data type (not part of
								 * standard) */
};

#endif   /* !_ECPG_SQL3TYPES_H */

#line 4 "sqlcolumn.ec"


using namespace rts2db;

SqlColumn::SqlColumn (const char *in_sql, const char *in_name, int in_order)
{
	if (in_sql)
	{
		sql = new char[strlen (in_sql) + 1];
		strcpy (sql, in_sql);
	}
	else
	{
		sql = NULL;
	}

	if (in_name)
	{
		name = new char[strlen (in_name) + 1];
		strcpy (name, in_name);
	}
	else
	{
		name = NULL;
	}
	order = in_order;
}

SqlColumn::~SqlColumn (void)
{
	delete sql;
	delete name;
}

void SqlColumn::processValue (void *val, int sqlType, int isNull)
{
	return;
}

void SqlColumn::printStatistics (std::ostream &os)
{
}


bool operator < (SqlColumn lhs, SqlColumn rhs)
{
	return lhs.getOrderBy () < rhs.getOrderBy ();
}

/**
 * Defines some extra statistic for ObsState column.
 */
SqlColumnObsState::SqlColumnObsState (const char *in_sql, const char *in_name, int in_order):SqlColumn (in_sql, in_name, in_order)
{
	interupted = 0;
	acq_failed = 0;
	ok = 0;
}

void SqlColumnObsState::processValue (void *val, int sqlType, int isNull)
{
	int trueVal;
	if (sqlType != SQL3_INTEGER)
		return;
	trueVal = *((int *) val);
	if (trueVal & OBS_BIT_INTERUPED)
		interupted++;
	else if (trueVal & OBS_BIT_ACQUSITION_FAI)
		acq_failed++;
	else
		ok++;
}

void SqlColumnObsState::printStatistics (std::ostream &os)
{
	os << std::endl;
	os << getName() << " statistics - good: " << ok << " interupted: " << interupted << " acqusition failed: " << acq_failed << std::endl;
	os << std::endl;
}
