/* Processed by ecpg (4.7.0) */
/* These include files are added by the preprocessor */
#include <ecpglib.h>
#include <ecpgerrno.h>
#include <sqlca.h>
/* End of automatic include section */

#line 1 "sub_targets.ec"
/* 
 * Various targets classes.
 * Copyright (C) 2003-2007 Petr Kubanek <petr@kubanek.net>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#include <libnova/libnova.h>
#include "configuration.h"
#include "timestamp.h"
#include "infoval.h"
#include "utilsfunc.h"

#include "rts2db/plan.h"
#include "rts2db/target.h"
#include "rts2db/sqlerror.h"

#include <iomanip>
#include <sstream>


#line 1 "/usr/include/sqlca.h"
#ifndef POSTGRES_SQLCA_H
#define POSTGRES_SQLCA_H

#ifndef PGDLLIMPORT
#if  defined(WIN32) || defined(__CYGWIN__)
#define PGDLLIMPORT __declspec (dllimport)
#else
#define PGDLLIMPORT
#endif   /* __CYGWIN__ */
#endif   /* PGDLLIMPORT */

#define SQLERRMC_LEN	150

#ifdef __cplusplus
extern		"C"
{
#endif

struct sqlca_t
{
	char		sqlcaid[8];
	long		sqlabc;
	long		sqlcode;
	struct
	{
		int			sqlerrml;
		char		sqlerrmc[SQLERRMC_LEN];
	}			sqlerrm;
	char		sqlerrp[8];
	long		sqlerrd[6];
	/* Element 0: empty						*/
	/* 1: OID of processed tuple if applicable			*/
	/* 2: number of rows processed				*/
	/* after an INSERT, UPDATE or				*/
	/* DELETE statement					*/
	/* 3: empty						*/
	/* 4: empty						*/
	/* 5: empty						*/
	char		sqlwarn[8];
	/* Element 0: set to 'W' if at least one other is 'W'	*/
	/* 1: if 'W' at least one character string		*/
	/* value was truncated when it was			*/
	/* stored into a host variable.				*/

	/*
	 * 2: if 'W' a (hopefully) non-fatal notice occurred
	 */	/* 3: empty */
	/* 4: empty						*/
	/* 5: empty						*/
	/* 6: empty						*/
	/* 7: empty						*/

	char		sqlstate[5];
};

struct sqlca_t *ECPGget_sqlca(void);

#ifndef POSTGRES_ECPG_INTERNAL
#define sqlca (*ECPGget_sqlca())
#endif

#ifdef __cplusplus
}
#endif

#endif

#line 33 "sub_targets.ec"


using namespace rts2db;

// ConstTarget
ConstTarget::ConstTarget () : Target ()
{
	position.ra = position.dec = 0;
	proper_motion.ra = proper_motion.dec = NAN;
}

ConstTarget::ConstTarget (int in_tar_id, struct ln_lnlat_posn *in_obs):Target (in_tar_id, in_obs)
{
	position.ra = position.dec = 0;
	proper_motion.ra = proper_motion.dec = NAN;
}

ConstTarget::ConstTarget (int in_tar_id, struct ln_lnlat_posn *in_obs, struct ln_equ_posn *pos):Target (in_tar_id, in_obs)
{
	position.ra = pos->ra;
	position.dec = pos->dec;
	proper_motion.ra = proper_motion.dec = NAN;
}

void ConstTarget::load ()
{
	/* exec sql begin declare section */
	 
	 
	 
	 
	 
	 
	 
	 
	    
	
#line 60 "sub_targets.ec"
 double d_ra ;
 
#line 61 "sub_targets.ec"
 double d_dec ;
 
#line 62 "sub_targets.ec"
 double d_pm_ra ;
 
#line 63 "sub_targets.ec"
 double d_pm_dec ;
 
#line 64 "sub_targets.ec"
 int d_ra_ind ;
 
#line 65 "sub_targets.ec"
 int d_dec_ind ;
 
#line 66 "sub_targets.ec"
 int d_pm_ra_ind ;
 
#line 67 "sub_targets.ec"
 int d_pm_dec_ind ;
 
#line 68 "sub_targets.ec"
 int db_tar_id = getObsTargetID () ;
/* exec sql end declare section */
#line 69 "sub_targets.ec"


	{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "select tar_ra , tar_dec , tar_pm_ra , tar_pm_dec from targets where tar_id = $1 ", 
	ECPGt_int,&(db_tar_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EOIT, 
	ECPGt_double,&(d_ra),(long)1,(long)1,sizeof(double), 
	ECPGt_int,&(d_ra_ind),(long)1,(long)1,sizeof(int), 
	ECPGt_double,&(d_dec),(long)1,(long)1,sizeof(double), 
	ECPGt_int,&(d_dec_ind),(long)1,(long)1,sizeof(int), 
	ECPGt_double,&(d_pm_ra),(long)1,(long)1,sizeof(double), 
	ECPGt_int,&(d_pm_ra_ind),(long)1,(long)1,sizeof(int), 
	ECPGt_double,&(d_pm_dec),(long)1,(long)1,sizeof(double), 
	ECPGt_int,&(d_pm_dec_ind),(long)1,(long)1,sizeof(int), ECPGt_EORT);}
#line 85 "sub_targets.ec"

	if (sqlca.sqlcode)
	{
	  	std::ostringstream err;
		err << "cannot load constant target with ID " << db_tar_id;
		throw SqlError (err.str ().c_str ());
	}

	if (d_ra_ind)
		d_ra = NAN;
	if (d_dec_ind)
	  	d_dec = NAN;
	if (d_pm_ra_ind)
	  	d_pm_ra = NAN;
	if (d_pm_dec_ind)
		d_pm_dec = NAN;

	position.ra = d_ra;
	position.dec = d_dec;

	proper_motion.ra = d_pm_ra;
	proper_motion.dec = d_pm_dec;

	Target::load ();
}

int ConstTarget::saveWithID (bool overwrite, int tar_id)
{
	/* exec sql begin declare section */
	 
	 
	 
	 
	 
	
#line 114 "sub_targets.ec"
 double d_tar_ra ;
 
#line 115 "sub_targets.ec"
 double d_tar_dec ;
 
#line 116 "sub_targets.ec"
 double d_tar_pm_ra ;
 
#line 117 "sub_targets.ec"
 double d_tar_pm_dec ;
 
#line 118 "sub_targets.ec"
 int d_tar_id ;
/* exec sql end declare section */
#line 119 "sub_targets.ec"


	int ret;

	ret = Target::saveWithID (overwrite, tar_id);
	if (ret)
		return ret;

	d_tar_ra = position.ra;
	d_tar_dec = position.dec;

	d_tar_pm_ra = proper_motion.ra;
	d_tar_pm_dec = proper_motion.dec;

	d_tar_id = tar_id;

	{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "update targets set tar_ra = $1  , tar_dec = $2  , tar_pm_ra = $3  , tar_pm_dec = $4  where tar_id = $5 ", 
	ECPGt_double,&(d_tar_ra),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_double,&(d_tar_dec),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_double,&(d_tar_pm_ra),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_double,&(d_tar_pm_dec),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_int,&(d_tar_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EOIT, ECPGt_EORT);}
#line 144 "sub_targets.ec"


	if (sqlca.sqlcode)
	{
		logMsgDb ("ConstTarget::saveWithID", MESSAGE_ERROR);
		{ ECPGtrans(__LINE__, NULL, "rollback");}
#line 149 "sub_targets.ec"

		return -1;
	}
	{ ECPGtrans(__LINE__, NULL, "commit");}
#line 152 "sub_targets.ec"

	return 0;
}

void ConstTarget::getPosition (struct ln_equ_posn *pos, double JD)
{
	*pos = position;
	if (!isnan (proper_motion.ra) && !isnan (proper_motion.dec))
		ln_get_equ_pm (pos, &proper_motion, JD, pos);
}

void ConstTarget::getProperMotion (struct ln_equ_posn *pm)
{
	pm->ra = proper_motion.ra;
	pm->dec = proper_motion.dec;
}

int ConstTarget::getRST (struct ln_rst_time *rst, double JD, double horizon)
{
	struct ln_equ_posn pos;

	getPosition (&pos, JD);
	return ln_get_object_next_rst_horizon (JD, observer, &pos, horizon, rst);
}

int ConstTarget::selectedAsGood ()
{
	/* exec sql begin declare section */
		   
		 
		 
	
#line 180 "sub_targets.ec"
 int d_tar_id = target_id ;
 
#line 181 "sub_targets.ec"
 double d_tar_ra ;
 
#line 182 "sub_targets.ec"
 double d_tar_dec ;
/* exec sql end declare section */
#line 183 "sub_targets.ec"

	// check if we are still enabled..
	{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "select tar_ra , tar_dec from targets where tar_id = $1 ", 
	ECPGt_int,&(d_tar_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EOIT, 
	ECPGt_double,&(d_tar_ra),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_double,&(d_tar_dec),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EORT);}
#line 195 "sub_targets.ec"

	if (sqlca.sqlcode)
	{
		logStream (MESSAGE_ERROR) << "error while loading target positions for target with it ID " << d_tar_id << " observation target ID " << getObsTargetID () << sendLog;
		logMsgDb ("ConstTarget::selectedAsGood", MESSAGE_ERROR);
		return -1;
	}
	position.ra = d_tar_ra;
	position.dec = d_tar_dec;
	return Target::selectedAsGood ();
}

int ConstTarget::compareWithTarget (Target * in_target, double in_sep_limit)
{
	struct ln_equ_posn other_position;
	in_target->getPosition (&other_position);
	return (getDistance (&other_position) < in_sep_limit);
}

void ConstTarget::printExtra (Rts2InfoValStream &_os, double JD)
{
	Target::printExtra (_os, JD);
	_os
		<< InfoVal <LibnovaDegArcMin> ("PROPER MOTION RA", LibnovaDegArcMin (proper_motion.ra)) 
		<< InfoVal <LibnovaDegArcMin> ("PROPER MOTION DEC", LibnovaDegArcMin (proper_motion.dec));
}

DarkTarget::DarkTarget (int in_tar_id, struct ln_lnlat_posn *in_obs): Target (in_tar_id, in_obs)
{
	currPos.ra = rts2_nan ("f");
	currPos.dec = rts2_nan ("f");
}

DarkTarget::~DarkTarget ()
{
}

bool DarkTarget::getScript (const char *deviceName, std::string &buf)
{
 	try
	{
		getDBScript (deviceName, buf);
		return false;
	}
	catch (rts2core::Error &er)
	{
	}
	// otherwise, take bias frames
	buf = std::string ("D 0");
	return false;
}

void DarkTarget::getPosition (struct ln_equ_posn *pos, double JD)
{
	*pos = currPos;
}

moveType DarkTarget::startSlew (struct ln_equ_posn *position, bool update_position)
{
	currPos.ra = position->ra;
	currPos.dec = position->dec;
	// when telescope isn't initialized to point when we get ra | dec - put some defaults
	if (isnan (currPos.ra))
		currPos.ra = -999;
	if (isnan (currPos.dec))
		currPos.dec = -999;
	Target::startSlew (position, update_position);
	return OBS_DONT_MOVE;
}

FlatTarget::FlatTarget (int in_tar_id, struct ln_lnlat_posn *in_obs): ConstTarget (in_tar_id, in_obs)
{
	setTargetName ("flat target");
}

void FlatTarget::getAntiSolarPos (struct ln_equ_posn *pos, double JD)
{
	struct ln_equ_posn eq_sun;
	struct ln_hrz_posn hrz;
	ln_get_solar_equ_coords (JD, &eq_sun);
	ln_get_hrz_from_equ (&eq_sun, observer, JD, &hrz);
	hrz.alt = 60;
	hrz.az = ln_range_degrees (hrz.az + 180);
	ln_get_equ_from_hrz (&hrz, observer, JD, pos);
}

bool FlatTarget::getScript (const char *deviceName, std::string &buf)
{
	try
	{
		ConstTarget::getDBScript (deviceName, buf);
		return false;
	}
	catch (rts2core::Error &er)
	{
	}
	// default string
	buf = std::string ("E 1");
	return false;
}

// we will try to find target, that is among empty fields, and is at oposite location from sun
// that target will then become our target_id, so entries in observation log
// will refer to that id, not to generic flat target_id
void FlatTarget::load ()
{
	/* exec sql begin declare section */
		 
		 
		 
		   
	
#line 302 "sub_targets.ec"
 double d_tar_ra ;
 
#line 303 "sub_targets.ec"
 double d_tar_dec ;
 
#line 304 "sub_targets.ec"
 int d_tar_id ;
 
#line 305 "sub_targets.ec"
 int db_target_flat = TARGET_FLAT ;
/* exec sql end declare section */
#line 306 "sub_targets.ec"


	if (getTargetID () != TARGET_FLAT)
	{
		ConstTarget::load ();
		return;
	}

	double minAntiDist = 1000;
	double curDist;
	struct ln_equ_posn d_tar;
	struct ln_equ_posn antiSolarPosition;
	struct ln_hrz_posn hrz;
	double JD;

	JD = ln_get_julian_from_sys ();

	getAntiSolarPos (&antiSolarPosition, JD);

	ECPGset_var( 0, &( db_target_flat ), __LINE__);\
 /* declare flat_targets cursor for select tar_ra , tar_dec , tar_id from targets where type_id = 'f' and ( tar_bonus_time is null or tar_bonus > 0 ) and tar_enabled = true and tar_id <> $1  */
#line 336 "sub_targets.ec"

	{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "declare flat_targets cursor for select tar_ra , tar_dec , tar_id from targets where type_id = 'f' and ( tar_bonus_time is null or tar_bonus > 0 ) and tar_enabled = true and tar_id <> $1 ", 
	ECPGt_int,&(db_target_flat),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EOIT, ECPGt_EORT);}
#line 337 "sub_targets.ec"

	while (1)
	{
		{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "fetch next from flat_targets", ECPGt_EOIT, 
	ECPGt_double,&(d_tar_ra),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_double,&(d_tar_dec),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_int,&(d_tar_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EORT);}
#line 343 "sub_targets.ec"

		if (sqlca.sqlcode)
			break;
		d_tar.ra = d_tar_ra;
		d_tar.dec = d_tar_dec;
		// we should be at least 10 deg above horizon to be considered..
		ln_get_hrz_from_equ (&d_tar, observer, JD, &hrz);
		if (hrz.alt < rts2core::Configuration::instance ()->getMinFlatHeigh ())
			continue;
		// and of course we should be above horizon..
		if (!isAboveHorizon (&hrz))
			continue;
		// test if we found the best target..
		curDist = ln_get_angular_separation (&d_tar, &antiSolarPosition);
		if (curDist < minAntiDist)
		{
			// check if it is too far from moon..
			obs_target_id = d_tar_id;
			minAntiDist = curDist;
		}
	}
	if ((sqlca.sqlcode && sqlca.sqlcode != ECPG_NOT_FOUND)
		|| obs_target_id <= 0)
	{
		logMsgDb ("FlatTarget::load", MESSAGE_DEBUG);
		{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "close flat_targets", ECPGt_EOIT, ECPGt_EORT);}
#line 368 "sub_targets.ec"

		//in that case, we will simply use generic flat target..
		return;
	}
	{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "close flat_targets", ECPGt_EOIT, ECPGt_EORT);}
#line 372 "sub_targets.ec"

	ConstTarget::load ();
}

void FlatTarget::getPosition (struct ln_equ_posn *pos, double JD)
{
	// we were loaded, or we aren't generic flat target
	if (obs_target_id > 0 || getTargetID () != TARGET_FLAT)
		return ConstTarget::getPosition (pos, JD);
	// generic flat target observations
	getAntiSolarPos (pos, JD);
}

int FlatTarget::considerForObserving (double JD)
{
	// get new position..when new is available..
	load ();
	// still return considerForObserving..is there is nothing, then get -1 so selector will delete us
	return ConstTarget::considerForObserving (JD);
}

void FlatTarget::printExtra (Rts2InfoValStream & _os, double JD)
{
	ConstTarget::printExtra (_os, JD);
	struct ln_equ_posn antisol;
	getAntiSolarPos (&antisol, JD);
	struct ln_equ_posn pos;
	getPosition (&pos, JD);
	_os
		<< InfoVal<LibnovaDeg180> ("ANTISOL_DIST", ln_get_angular_separation (&pos, &antisol))
		<< std::endl;
}

CalibrationTarget::CalibrationTarget (int in_tar_id, struct ln_lnlat_posn *in_obs):ConstTarget (in_tar_id, in_obs)
{
	airmassPosition.ra = airmassPosition.dec = 0;
	time (&lastImage);
	needUpdate = 1;
}

// the idea is to cover uniformly whole sky.
// in airmass_cal_images table we have recorded previous observations
// for frames with astrometry which contains targeted airmass
void CalibrationTarget::load ()
{
	/* exec sql begin declare section */
	 
	 
	 

	 
	 
	 
	 
	// cannot use TARGET_NAME_LEN, as it does not work with some ecpg veriosn
	 
	
#line 418 "sub_targets.ec"
 double d_airmass_start ;
 
#line 419 "sub_targets.ec"
 double d_airmass_end ;
 
#line 420 "sub_targets.ec"
 long d_airmass_last_image ;
 
#line 422 "sub_targets.ec"
 double db_tar_ra ;
 
#line 423 "sub_targets.ec"
 double db_tar_dec ;
 
#line 424 "sub_targets.ec"
 int db_tar_id ;
 
#line 425 "sub_targets.ec"
 char db_type_id ;
 
#line 427 "sub_targets.ec"
  struct varchar_1  { int len; char arr[ 150 ]; }  db_tar_name ;
/* exec sql end declare section */
#line 428 "sub_targets.ec"


	double JD = ln_get_julian_from_sys ();

	time_t now;
	time_t valid;

	PosCalibration *fallback_obs_calib = NULL;
	time_t fallback_last_image = 0;
	double fallback_last_time = 0;

	std::list <PosCalibration *> cal_list;
	std::list <PosCalibration *> bad_list;
	std::list <PosCalibration *>::iterator cal_iter, cal_iter2;
	if (getTargetID () != TARGET_CALIBRATION)
	{
		ConstTarget::load ();
		return;
	}

	// create airmass & target_id pool (I dislike idea of creating
	// target object, as that will cost me a lot of resources
	/* declare pos_calibration cursor for select tar_ra , tar_dec , tar_id , type_id , tar_name from targets where tar_enabled = true and ( tar_bonus_time is null or tar_bonus > 0 ) and ( ( tar_next_observable is null ) or ( tar_next_observable < now ( ) ) ) and tar_id <> 6 and ( type_id = 'c' or type_id = 'M' ) order by tar_priority + tar_bonus desc */
#line 469 "sub_targets.ec"

	{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "declare pos_calibration cursor for select tar_ra , tar_dec , tar_id , type_id , tar_name from targets where tar_enabled = true and ( tar_bonus_time is null or tar_bonus > 0 ) and ( ( tar_next_observable is null ) or ( tar_next_observable < now ( ) ) ) and tar_id <> 6 and ( type_id = 'c' or type_id = 'M' ) order by tar_priority + tar_bonus desc", ECPGt_EOIT, ECPGt_EORT);}
#line 470 "sub_targets.ec"

	while (1)
	{
		{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "fetch next from pos_calibration", ECPGt_EOIT, 
	ECPGt_double,&(db_tar_ra),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_double,&(db_tar_dec),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_int,&(db_tar_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_char,&(db_type_id),(long)1,(long)1,(1)*sizeof(char), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_varchar,&(db_tar_name),(long)150,(long)1,sizeof(struct varchar_1), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EORT);}
#line 479 "sub_targets.ec"

		if (sqlca.sqlcode)
			break;
		struct ln_equ_posn pos;
		pos.ra = db_tar_ra;
		pos.dec = db_tar_dec;
		struct ln_hrz_posn hrz;
		ln_get_hrz_from_equ (&pos, observer, JD, &hrz);
		if (rts2core::Configuration::instance ()->getObjectChecker ()->is_good (&hrz))
		{
			PosCalibration *newCal = new PosCalibration (db_tar_id, db_tar_ra, db_tar_dec, db_type_id,
				db_tar_name.arr, observer, JD);
			cal_list.push_back (newCal);
		}
	}
	if (sqlca.sqlcode != ECPG_NOT_FOUND)
	{
		// free cal_list..
		for (cal_iter = cal_list.begin (); cal_iter != cal_list.end ();)
		{
			cal_iter2 = cal_iter;
			cal_iter++;
			delete *cal_iter2;
		}
		cal_list.clear ();
		{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "close pos_calibration", ECPGt_EOIT, ECPGt_EORT);}
#line 504 "sub_targets.ec"

		{ ECPGtrans(__LINE__, NULL, "rollback");}
#line 505 "sub_targets.ec"

		throw SqlError ("cannot find any possible callibration target");
	}
	if (cal_list.size () == 0)
	{
		logStream (MESSAGE_ERROR) << "there aren't any calibration targets; either create them or delete target with ID 6" << sendLog;
		{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "close pos_calibration", ECPGt_EOIT, ECPGt_EORT);}
#line 511 "sub_targets.ec"

		{ ECPGtrans(__LINE__, NULL, "rollback");}
#line 512 "sub_targets.ec"

		return;
	}
	{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "close pos_calibration", ECPGt_EOIT, ECPGt_EORT);}
#line 515 "sub_targets.ec"

	{ ECPGtrans(__LINE__, NULL, "commit");}
#line 516 "sub_targets.ec"


	// center airmass is 1.5 - when we don't have any images in airmass_cal_images,
	// order us by distance from such center distance
	/* declare cur_airmass_cal_images cursor for select air_airmass_start , air_airmass_end , extract ( EPOCH from air_last_image ) from airmass_cal_images order by air_last_image asc , abs ( 1.5 - ( air_airmass_start + air_airmass_end ) / 2 ) asc */
#line 529 "sub_targets.ec"

	{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "declare cur_airmass_cal_images cursor for select air_airmass_start , air_airmass_end , extract ( EPOCH from air_last_image ) from airmass_cal_images order by air_last_image asc , abs ( 1.5 - ( air_airmass_start + air_airmass_end ) / 2 ) asc", ECPGt_EOIT, ECPGt_EORT);}
#line 530 "sub_targets.ec"

	obs_target_id = -1;
	time (&now);
	valid = now - rts2core::Configuration::instance()->getCalibrationValidTime();
	while (1)
	{
		{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "fetch next from cur_airmass_cal_images", ECPGt_EOIT, 
	ECPGt_double,&(d_airmass_start),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_double,&(d_airmass_end),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_long,&(d_airmass_last_image),(long)1,(long)1,sizeof(long), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EORT);}
#line 540 "sub_targets.ec"

		if (sqlca.sqlcode)
			break;
		// find any target which lies within requested airmass range
		for (cal_iter = cal_list.begin (); cal_iter != cal_list.end (); cal_iter++)
		{
			PosCalibration *calib = *cal_iter;
			if (calib->getCurrAirmass () >= d_airmass_start
				&& calib->getCurrAirmass () < d_airmass_end)
			{
				if (calib->getLunarDistance (JD) < rts2core::Configuration::instance()->getCalibrationLunarDist())
				{
					bad_list.push_back (calib);
				}
				// if that target was already observerd..
				else if (calib->getNumObs (&valid, &now) > 0)
				{
					// if we do not have any target, pick that on
					double calib_last_time = calib->getLastObsTime ();
					if (fallback_obs_calib == NULL ||
						calib_last_time > fallback_last_time)
					{
						fallback_obs_calib = calib;
						fallback_last_image = (time_t) d_airmass_last_image;
						fallback_last_time = calib_last_time;
					}
				}
				else
				{
					// switch current target coordinates..
					obs_target_id = calib->getTargetID ();
					calib->getPosition (&airmassPosition, JD);
					lastImage = (time_t) d_airmass_last_image;
					break;
				}
			}
		}
		if (obs_target_id != -1)
			break;
		std::ostringstream _os;
		_os << "CalibrationTarget::load cannot find any target for airmass between "
			<< d_airmass_start << " and " << d_airmass_end ;
		logMsgDb (_os.str ().c_str (), MESSAGE_DEBUG);
	}
	// change priority for bad targets..
	for (cal_iter = bad_list.begin (); cal_iter != bad_list.end (); cal_iter++)
	{
		(*cal_iter)->setNextObservable (JD + 1.0/24.0);
	}
	bad_list.clear ();
	// no target found..try fallback
	if (obs_target_id == -1 && fallback_obs_calib != NULL)
	{
		obs_target_id = fallback_obs_calib->getTargetID ();
		fallback_obs_calib->getPosition (&airmassPosition, JD);
		lastImage = fallback_last_image;
	}
	// free cal_list..
	for (cal_iter = cal_list.begin (); cal_iter != cal_list.end ();)
	{
		cal_iter2 = cal_iter;
		cal_iter++;
		delete *cal_iter2;
	}
	cal_list.clear ();

	// SQL test..
	if (sqlca.sqlcode)
	{
		logMsgDb ("CalibrationTarget::load cannot find any airmass_cal_images entry",
			(sqlca.sqlcode == ECPG_NOT_FOUND) ? MESSAGE_DEBUG : MESSAGE_ERROR);
		// don't return, as we can have fallback target, which loaded
		// properly
	}
	{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "close cur_airmass_cal_images", ECPGt_EOIT, ECPGt_EORT);}
#line 614 "sub_targets.ec"

	{ ECPGtrans(__LINE__, NULL, "commit");}
#line 615 "sub_targets.ec"

	if (obs_target_id != -1)
	{
		needUpdate = 0;
		ConstTarget::load ();
		return;
	}
	throw SqlError ("cannot locate any calibration target");
}

int CalibrationTarget::beforeMove ()
{
	// as calibration target can change between time we select it, let's reload us
	if (getTargetID () == TARGET_CALIBRATION && needUpdate)
		load ();
	return ConstTarget::beforeMove ();
}

int CalibrationTarget::endObservation (int in_next_id)
{
	needUpdate = 1;
	return ConstTarget::endObservation (in_next_id);
}

void CalibrationTarget::getPosition (struct ln_equ_posn *pos, double JD)
{
	if (obs_target_id <= 0)
	{
		ConstTarget::getPosition (pos, JD);
		return;
	}
	*pos = airmassPosition;
}

int CalibrationTarget::considerForObserving (double JD)
{
	// load (possibly new target) before considering us..
	load ();
	return ConstTarget::considerForObserving (JD);
}

float CalibrationTarget::getBonus (double JD)
{
	time_t now;
	time_t t_diff;

	int validTime = rts2core::Configuration::instance()->getCalibrationValidTime();
	int maxDelay = rts2core::Configuration::instance()->getCalibrationMaxDelay();
	float minBonus = rts2core::Configuration::instance()->getCalibrationMinBonus();
	float maxBonus = rts2core::Configuration::instance()->getCalibrationMaxBonus();
	if (obs_target_id <= 0)
		return -1;
	ln_get_timet_from_julian (JD, &now);
	t_diff = now - lastImage;
	// smaller then valid_time is not interesting..
	if (t_diff < validTime)
		return minBonus;
	// greater then MaxDelay is interesting
	else if (t_diff > maxDelay)
		return maxBonus;
	// otherwise linear increase
	return minBonus + ((maxBonus - minBonus) * t_diff / (maxDelay - validTime));
}

ModelTarget::ModelTarget (int in_tar_id, struct ln_lnlat_posn *in_obs):ConstTarget (in_tar_id, in_obs)
{
	modelStepType = 2;
	rts2core::Configuration::instance ()->getInteger ("observatory", "model_step_type", modelStepType);
}

void ModelTarget::load ()
{
	/* exec sql begin declare section */
	    
	 
	 
	 
	 
	 
	 
	 
	 
	
#line 688 "sub_targets.ec"
 int d_tar_id = getTargetID () ;
 
#line 689 "sub_targets.ec"
 float d_alt_start ;
 
#line 690 "sub_targets.ec"
 float d_alt_stop ;
 
#line 691 "sub_targets.ec"
 float d_alt_step ;
 
#line 692 "sub_targets.ec"
 float d_az_start ;
 
#line 693 "sub_targets.ec"
 float d_az_stop ;
 
#line 694 "sub_targets.ec"
 float d_az_step ;
 
#line 695 "sub_targets.ec"
 float d_noise ;
 
#line 696 "sub_targets.ec"
 int d_step ;
/* exec sql end declare section */
#line 697 "sub_targets.ec"


	{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "select alt_start , alt_stop , alt_step , az_start , az_stop , az_step , noise , step from target_model where tar_id = $1 ", 
	ECPGt_int,&(d_tar_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EOIT, 
	ECPGt_float,&(d_alt_start),(long)1,(long)1,sizeof(float), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_float,&(d_alt_stop),(long)1,(long)1,sizeof(float), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_float,&(d_alt_step),(long)1,(long)1,sizeof(float), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_float,&(d_az_start),(long)1,(long)1,sizeof(float), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_float,&(d_az_stop),(long)1,(long)1,sizeof(float), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_float,&(d_az_step),(long)1,(long)1,sizeof(float), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_float,&(d_noise),(long)1,(long)1,sizeof(float), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_int,&(d_step),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EORT);}
#line 721 "sub_targets.ec"

	if (sqlca.sqlcode)
	{
	  	std::ostringstream err;
		err << "cannot load model target for ID " << d_tar_id;
		throw SqlError (err.str ().c_str ());
	}
	if (d_alt_start < d_alt_stop)
	{
		alt_start = d_alt_start;
		alt_stop = d_alt_stop;
	}
	else
	{
		alt_start = d_alt_stop;
		alt_stop = d_alt_start;
	}
	alt_step = d_alt_step;
	if (d_az_start < d_az_stop)
	{
		az_start = d_az_start;
		az_stop = d_az_stop;
	}
	else
	{
		az_start = d_az_stop;
		az_stop = d_az_start;
	}
	az_step = d_az_step;
	noise = d_noise;
	step = d_step;

	alt_size = (int) (fabs (alt_stop - alt_start) / alt_step);
	alt_size++;

	srandom (time (NULL));
	calPosition ();
	ConstTarget::load ();
}

ModelTarget::~ModelTarget (void)
{
}

int ModelTarget::writeStep ()
{
	/* exec sql begin declare section */
		    
		   
	
#line 768 "sub_targets.ec"
 int d_tar_id = getTargetID () ;
 
#line 769 "sub_targets.ec"
 int d_step = step ;
/* exec sql end declare section */
#line 770 "sub_targets.ec"

	{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "update target_model set step = $1  where tar_id = $2 ", 
	ECPGt_int,&(d_step),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_int,&(d_tar_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EOIT, ECPGt_EORT);}
#line 777 "sub_targets.ec"

	if (sqlca.sqlcode)
	{
		logMsgDb ("ModelTarget::writeStep", MESSAGE_ERROR);
		{ ECPGtrans(__LINE__, NULL, "rollback");}
#line 781 "sub_targets.ec"

		return -1;
	}
	{ ECPGtrans(__LINE__, NULL, "commit");}
#line 784 "sub_targets.ec"

	return 0;
}

int ModelTarget::getNextPosition ()
{
	switch (modelStepType)
	{
		case -2:
			// completly random model
			step = -2;
			break;
		case -1:
			// linear model
			step++;
			break;
		case 0:
			// random model
			step += (int) (((double) random () * ((fabs (360.0 / az_step) + 1) * fabs((alt_stop - alt_start) / alt_step) + 1)) / RAND_MAX);
			break;
		default:
			step += modelStepType * ((int) fabs ((alt_stop - alt_start) / alt_step) + 1) + 1;
	}
	return calPosition ();
}

int ModelTarget::calPosition ()
{
	double m_alt;
	switch (modelStepType)
	{
		case -2:
			hrz_poz.az = (az_stop - az_start) * random_num ();
			hrz_poz.alt = 0;
			m_alt = rts2core::Configuration::instance ()->getObjectChecker ()->getHorizonHeight (&hrz_poz, 0);
			if (m_alt < alt_start)
				m_alt = alt_start;
			if (m_alt < getMinObsAlt ())
				m_alt = getMinObsAlt ();
 			hrz_poz.alt = m_alt + (alt_stop - m_alt) * asin (random_num ()) / (M_PI / 2.0);
			if (!isAboveHorizon (&hrz_poz))
				hrz_poz.alt = rts2core::Configuration::instance ()->getObjectChecker ()->getHorizonHeight (&hrz_poz, 0) + 2;
			ra_noise = 0;
			dec_noise = 0;
			break;
		default:
			hrz_poz.az = az_start + az_step * (step / alt_size);
			hrz_poz.alt = alt_start + alt_step * (step % alt_size);
			ra_noise = 2 * noise * random_num ();
			ra_noise -= noise;
			dec_noise = 2 * noise * random_num ();
			dec_noise -= noise;
			if (!isAboveHorizon (&hrz_poz))
				hrz_poz.alt = rts2core::Configuration::instance ()->getObjectChecker ()->getHorizonHeight (&hrz_poz, 0) + 2 * noise;
	}
	// null ra + dec .. for recurent call do getPosition (JD..)
	equ_poz.ra = -1000;
	equ_poz.dec = -1000;
	return 0;
}

int ModelTarget::beforeMove ()
{
	endObservation (-1);		 // we will not observe same model target twice
	nullAcquired ();
	return getNextPosition ();
}

moveType ModelTarget::afterSlewProcessed ()
{
	/* exec sql begin declare section */
		 
		   
	
#line 855 "sub_targets.ec"
 int d_obs_id ;
 
#line 856 "sub_targets.ec"
 int d_step = step ;
/* exec sql end declare section */
#line 857 "sub_targets.ec"


	d_obs_id = getObsId ();

	{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "insert into model_observation ( obs_id , step ) values ( $1  , $2  )", 
	ECPGt_int,&(d_obs_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_int,&(d_step),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EOIT, ECPGt_EORT);}
#line 870 "sub_targets.ec"

	if (sqlca.sqlcode)
	{
		logMsgDb ("ModelTarget::endObservation", MESSAGE_ERROR);
		{ ECPGtrans(__LINE__, NULL, "rollback");}
#line 874 "sub_targets.ec"

	}
	else
	{
		{ ECPGtrans(__LINE__, NULL, "commit");}
#line 878 "sub_targets.ec"

	}
	//  return OBS_MOVE_UNMODELLED;
	return OBS_MOVE;
}

int ModelTarget::endObservation (int in_next_id)
{
	if (getObsId () > 0)
		writeStep ();
	return ConstTarget::endObservation (in_next_id);
}

void ModelTarget::getPosition (struct ln_equ_posn *pos, double JD)
{
	if (equ_poz.ra < -10)
	{
		ln_get_equ_from_hrz (&hrz_poz, observer, JD, &equ_poz);
		// put to right range
		equ_poz.ra += ra_noise;
		equ_poz.ra = ln_range_degrees (equ_poz.ra);
		equ_poz.dec += dec_noise;
		if (equ_poz.dec > 90)
			equ_poz.dec = 90;
		else if (equ_poz.dec < -90)
			equ_poz.dec = -90;
	}
	*pos = equ_poz;
}

// pick up some opportunity target; don't pick it too often
OportunityTarget::OportunityTarget (int in_tar_id, struct ln_lnlat_posn *in_obs):ConstTarget (in_tar_id, in_obs)
{
}

float OportunityTarget::getBonus (double JD)
{
	double retBonus = 0;
	struct ln_hrz_posn hrz;
	double lunarDist;
	double ha;
	double lastObs;
	time_t now;
	time_t start_t;
	getAltAz (&hrz, JD);
	lunarDist = getLunarDistance (JD);
	ha = getHourAngle ();
	// time target was last observed
	lastObs = getLastObsTime ();
	ln_get_timet_from_julian (JD, &now);
	start_t = now - 86400;
	// do not observe if already observed between 1h and 3h from now
	if (lastObs > 3600 && lastObs < (3 * 3600))
		retBonus -= log (lastObs / 3600) * 50;
	// do not observe if observed during last 24 h 
	else if (lastObs < 86400)
		retBonus -= log (3) * 50;
	// do not observe if too close to moon
	if (lunarDist < 60.0)
		retBonus -= log (61 - lunarDist) * 10;
	// bonus for south
	if (ha < 165)
		retBonus += log ((180 - ha) / 15.0);
	if (ha > 195)
		retBonus += log ((ha - 180) / 15.0);
	// bonus for altitute
	retBonus += hrz.alt * 2;
	// try to follow some period, based on how well we do in the past
	retBonus -= sin (getNumObs (&start_t, &now) * M_PI_4) * 5;
	// getBonus returns target priority + target bonus (from database)
	return ConstTarget::getBonus (JD) + retBonus;
}

// will pickup the Moon
LunarTarget::LunarTarget (int in_tar_id, struct ln_lnlat_posn *in_obs):Target (in_tar_id, in_obs)
{
}

void LunarTarget::getPosition (struct ln_equ_posn *pos, double JD)
{
	ln_get_lunar_equ_coords (JD, pos);
}

int LunarTarget::getRST (struct ln_rst_time *rst, double JD, double horizon)
{
	return ln_get_body_rst_horizon (JD, observer, ln_get_lunar_equ_coords, horizon, rst);
}

TargetSwiftFOV::TargetSwiftFOV (int in_tar_id, struct ln_lnlat_posn *in_obs):Target (in_tar_id, in_obs)
{
	swiftOnBonus = 0;
	target_id = TARGET_SWIFT_FOV;
	swiftId = -1;
	oldSwiftId = -1;
	swiftName = NULL;
	target_name = new char[200];

	swiftLastTar = -1;
	swiftLastTarName = NULL;
}

TargetSwiftFOV::~TargetSwiftFOV (void)
{
	delete[] swiftName;
	delete[] swiftLastTarName;
}

void TargetSwiftFOV::load ()
{
	struct ln_hrz_posn testHrz;
	struct ln_equ_posn testEqu;
	double JD = ln_get_julian_from_sys ();

	/* exec sql begin declare section */
	   
	 
	 
	 
	 
	 
	 
	 
	
#line 992 "sub_targets.ec"
 int d_swift_id = - 1 ;
 
#line 993 "sub_targets.ec"
 double d_swift_ra ;
 
#line 994 "sub_targets.ec"
 double d_swift_dec ;
 
#line 995 "sub_targets.ec"
 double d_swift_roll ;
 
#line 996 "sub_targets.ec"
 int d_swift_roll_null ;
 
#line 997 "sub_targets.ec"
 int d_swift_time ;
 
#line 998 "sub_targets.ec"
 float d_swift_obstime ;
 
#line 999 "sub_targets.ec"
  struct varchar_2  { int len; char arr[ 70 ]; }  d_swift_name ;
/* exec sql end declare section */
#line 1000 "sub_targets.ec"


	swiftId = -1;

	Target::load();

	delete[] swiftLastTarName;
	swiftLastTarName = NULL;

	/* declare find_swift_poiniting cursor for select swift_id , swift_ra , swift_dec , swift_roll , extract ( EPOCH from swift_time ) , swift_obstime , swift_name from swift where swift_time is not null and swift_obstime is not null order by swift_id desc */
#line 1024 "sub_targets.ec"

	{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "declare find_swift_poiniting cursor for select swift_id , swift_ra , swift_dec , swift_roll , extract ( EPOCH from swift_time ) , swift_obstime , swift_name from swift where swift_time is not null and swift_obstime is not null order by swift_id desc", ECPGt_EOIT, ECPGt_EORT);}
#line 1025 "sub_targets.ec"

	while (1)
	{
		{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "fetch next from find_swift_poiniting", ECPGt_EOIT, 
	ECPGt_int,&(d_swift_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_double,&(d_swift_ra),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_double,&(d_swift_dec),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_double,&(d_swift_roll),(long)1,(long)1,sizeof(double), 
	ECPGt_int,&(d_swift_roll_null),(long)1,(long)1,sizeof(int), 
	ECPGt_int,&(d_swift_time),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_float,&(d_swift_obstime),(long)1,(long)1,sizeof(float), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_varchar,&(d_swift_name),(long)70,(long)1,sizeof(struct varchar_2), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EORT);}
#line 1035 "sub_targets.ec"

		if (sqlca.sqlcode)
			break;
		// fill last values
		if (swiftLastTarName == NULL)
		{
			swiftLastTar = d_swift_id;
			swiftLastTarName = new char[d_swift_name.len + 1];
			strcpy (swiftLastTarName, d_swift_name.arr);
			swiftLastTarTimeStart = d_swift_time;
			swiftLastTarTimeEnd = d_swift_time + (int) d_swift_obstime;
			swiftLastTarPos.ra = d_swift_ra;
			swiftLastTarPos.dec = d_swift_dec;
		}
		// check for our altitude..
		testEqu.ra = d_swift_ra;
		testEqu.dec = d_swift_dec;
		ln_get_hrz_from_equ (&testEqu, observer, JD, &testHrz);
		if (testHrz.alt > rts2core::Configuration::instance ()->getSwiftMinHorizon ())
		{
			if (testHrz.alt < rts2core::Configuration::instance ()->getSwiftSoftHorizon ())
			{
				testHrz.alt = rts2core::Configuration::instance ()->getSwiftSoftHorizon ();
				// get equ coordinates we will observe..
				ln_get_equ_from_hrz (&testHrz, observer, JD, &testEqu);
			}
			swiftFovCenter.ra = testEqu.ra;
			swiftFovCenter.dec = testEqu.dec;
			if (oldSwiftId == -1)
				oldSwiftId = d_swift_id;
			swiftId = d_swift_id;
			swiftTimeStart = d_swift_time;
			swiftTimeEnd = d_swift_time + (int) d_swift_obstime;
			break;
		}
	}
	{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "close find_swift_poiniting", ECPGt_EOIT, ECPGt_EORT);}
#line 1071 "sub_targets.ec"

	if (swiftId < 0)
	{
		setTargetName ("Cannot find any Swift FOV");
		swiftFovCenter.ra = rts2_nan ("f");
		swiftFovCenter.dec = rts2_nan ("f");
		swiftTimeStart = 0;
		swiftTimeEnd = 0;
		swiftRoll = rts2_nan ("f");
		return;
	}
	if (d_swift_roll_null)
		swiftRoll = rts2_nan ("f");
	else
		swiftRoll = d_swift_roll;
	delete[] swiftName;

	swiftName = new char[d_swift_name.len + 1];
	strncpy (swiftName, d_swift_name.arr, d_swift_name.len);
	swiftName[d_swift_name.len] = '\0';

	std::ostringstream name;
	name << "SwiftFOV #" << swiftId
		<< " ( " << Timestamp(swiftTimeStart)
		<< " - " << Timestamp(swiftTimeEnd) << " )";
	setTargetName (name.str().c_str());
}

void TargetSwiftFOV::getPosition (struct ln_equ_posn *pos, double JD)
{
	*pos = swiftFovCenter;
}

int TargetSwiftFOV::getRST (struct ln_rst_time *rst, double JD, double horizon)
{
	struct ln_equ_posn pos;

	getPosition (&pos, JD);
	return ln_get_object_next_rst_horizon (JD, observer, &pos, horizon, rst);
}

moveType TargetSwiftFOV::afterSlewProcessed ()
{
	/* exec sql begin declare section */
		 
		   
	
#line 1115 "sub_targets.ec"
 int d_obs_id ;
 
#line 1116 "sub_targets.ec"
 int d_swift_id = swiftId ;
/* exec sql end declare section */
#line 1117 "sub_targets.ec"


	d_obs_id = getObsId ();
	{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "insert into swift_observation ( swift_id , obs_id ) values ( $1  , $2  )", 
	ECPGt_int,&(d_swift_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_int,&(d_obs_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EOIT, ECPGt_EORT);}
#line 1129 "sub_targets.ec"

	if (sqlca.sqlcode)
	{
		logMsgDb ("TargetSwiftFOV::startSlew SQL error", MESSAGE_ERROR);
		{ ECPGtrans(__LINE__, NULL, "rollback");}
#line 1133 "sub_targets.ec"

		return OBS_MOVE_FAILED;
	}
	{ ECPGtrans(__LINE__, NULL, "commit");}
#line 1136 "sub_targets.ec"

	return OBS_MOVE;
}

int TargetSwiftFOV::considerForObserving (double JD)
{
	// find pointing
	int ret;
	struct ln_equ_posn curr_position;
	double lst = ln_get_mean_sidereal_time (JD) + observer->lng / 15.0;

	load ();

	if (swiftId < 0)
	{
		// no pointing..expect that after 3 minutes, it will be better,
		// as we can get new pointing from GCN
		setNextObservable (JD + 1/1440.0/20.0);
		return -1;
	}

	getPosition (&curr_position, JD);

	ret = isGood (lst, JD, &curr_position);

	if (!ret)
	{
		time_t nextObs;
		time (&nextObs);
								 // we found pointing that already
		if (nextObs > swiftTimeEnd)
			// happens..hope that after 2
			// minutes, we will get better
			// results
		{
			nextObs += 2 * 60;
		}
		else
		{
			nextObs = swiftTimeEnd;
		}
		setNextObservable (&nextObs);
		return -1;
	}

	return selectedAsGood ();
}

int TargetSwiftFOV::beforeMove ()
{
	// are we still the best swiftId on planet?
	load ();
	if (oldSwiftId != swiftId)
		endObservation (-1);	 // startSlew will be called after move suceeded and will write new observation..
	return 0;
}

float TargetSwiftFOV::getBonus (double JD)
{
	/* exec sql begin declare section */
		   
		 
	
#line 1196 "sub_targets.ec"
 int d_tar_id = target_id ;
 
#line 1197 "sub_targets.ec"
 double d_bonus ;
/* exec sql end declare section */
#line 1198 "sub_targets.ec"


	{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "select tar_priority from targets where tar_id = $1 ", 
	ECPGt_int,&(d_tar_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EOIT, 
	ECPGt_double,&(d_bonus),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EORT);}
#line 1208 "sub_targets.ec"


	swiftOnBonus = d_bonus;

	time_t now;
	ln_get_timet_from_julian (JD, &now);
	if (now > swiftTimeStart - 120 && now < swiftTimeEnd + 120)
		return swiftOnBonus;
	if (now > swiftTimeStart - 300 && now < swiftTimeEnd + 300)
		return swiftOnBonus / 2.0;
	return getTargetPriority ();
}

int TargetSwiftFOV::isContinues ()
{
	double ret;
	load ();
	if (oldSwiftId != swiftId)
		return 0;
	ret = Target::getBonus ();
	// FOV become uinteresting..
	if (ret == 1)
		return 0;
	return 1;
}

void TargetSwiftFOV::printExtra (Rts2InfoValStream &_os, double JD)
{
	Target::printExtra (_os, JD);
	double now = timetFromJD (JD);
	_os
		<< InfoVal<const char *> ("NAME", swiftName)
		<< InfoVal<int> ("SwiftFOW ID", swiftId)
		<< InfoVal<Timestamp> ("FROM", Timestamp (swiftTimeStart))
		<< InfoVal<TimeDiff> ("FROM DIFF", TimeDiff (now, swiftTimeStart))
		<< InfoVal<Timestamp> ("TO", Timestamp (swiftTimeEnd))
		<< InfoVal<TimeDiff> ("TO DIFF", TimeDiff (now, swiftTimeEnd))
		<< InfoVal<double> ("ROLL", swiftRoll)
		<< std::endl;

	if (swiftLastTarName != NULL)
	{
		struct ln_hrz_posn lastHrz;
		ln_get_hrz_from_equ (&swiftLastTarPos, observer, JD, &lastHrz);
		_os
			<< InfoVal<const char *> ("LAST NAME", swiftLastTarName)
			<< InfoVal<int> ("LAST ID", swiftLastTar)
			<< InfoVal<Timestamp> ("LAST START", Timestamp (swiftLastTarTimeStart))
			<< InfoVal<TimeDiff> ("LAST START DIFF", TimeDiff (now, swiftLastTarTimeStart))
			<< InfoVal<Timestamp> ("LAST END", Timestamp (swiftLastTarTimeEnd))
			<< InfoVal<TimeDiff> ("LAST END DIFF", TimeDiff (now, swiftLastTarTimeEnd))
			<< InfoVal<LibnovaRaJ2000> ("LAST RA", LibnovaRaJ2000 (swiftLastTarPos.ra))
			<< InfoVal<LibnovaDecJ2000> ("LAST DEC", LibnovaDecJ2000 (swiftLastTarPos.dec))
			<< InfoVal<LibnovaDeg90> ("LAST ALT", LibnovaDeg90 (lastHrz.alt))
			<< InfoVal<LibnovaDeg360> ("LAST AZ", LibnovaDeg360 (lastHrz.az))
			<< std::endl;
	}
}

TargetIntegralFOV::TargetIntegralFOV (int in_tar_id, struct ln_lnlat_posn *in_obs):Target (in_tar_id, in_obs)
{
	target_id = TARGET_INTEGRAL_FOV;
	integralId = -1;
	oldIntegralId = -1;
	integralOnBonus = 0;
}

TargetIntegralFOV::~TargetIntegralFOV (void)
{
}

void TargetIntegralFOV::load ()
{
	struct ln_hrz_posn testHrz;
	struct ln_equ_posn testEqu;
	double JD = ln_get_julian_from_sys ();

	/* exec sql begin declare section */
	   
	 
	 
	 
	
#line 1286 "sub_targets.ec"
 int d_integral_id = - 1 ;
 
#line 1287 "sub_targets.ec"
 double d_integral_ra ;
 
#line 1288 "sub_targets.ec"
 double d_integral_dec ;
 
#line 1289 "sub_targets.ec"
 long d_integral_time ;
/* exec sql end declare section */
#line 1290 "sub_targets.ec"


	integralId = -1;

	Target::load();

	/* declare find_integral_poiniting cursor for select integral_id , integral_ra , integral_dec , extract ( EPOCH from integral_time ) from integral where integral_time is not null order by integral_id desc */
#line 1307 "sub_targets.ec"

	{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "declare find_integral_poiniting cursor for select integral_id , integral_ra , integral_dec , extract ( EPOCH from integral_time ) from integral where integral_time is not null order by integral_id desc", ECPGt_EOIT, ECPGt_EORT);}
#line 1308 "sub_targets.ec"

	while (1)
	{
		{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "fetch next from find_integral_poiniting", ECPGt_EOIT, 
	ECPGt_int,&(d_integral_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_double,&(d_integral_ra),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_double,&(d_integral_dec),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_long,&(d_integral_time),(long)1,(long)1,sizeof(long), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EORT);}
#line 1315 "sub_targets.ec"

		if (sqlca.sqlcode)
			break;
		// check for our altitude..
		testEqu.ra = d_integral_ra;
		testEqu.dec = d_integral_dec;
		ln_get_hrz_from_equ (&testEqu, observer, JD, &testHrz);
		if (testHrz.alt > 0)
		{
			if (testHrz.alt < 30)
			{
				testHrz.alt = 30;
				// get equ coordinates we will observe..
				ln_get_equ_from_hrz (&testHrz, observer, JD, &testEqu);
			}
			integralFovCenter.ra = testEqu.ra;
			integralFovCenter.dec = testEqu.dec;
			if (oldIntegralId == -1)
				oldIntegralId = d_integral_id;
			integralId = d_integral_id;
			integralTimeStart = d_integral_time;
			break;
		}
	}
	{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "close find_integral_poiniting", ECPGt_EOIT, ECPGt_EORT);}
#line 1339 "sub_targets.ec"

	if (integralId < 0)
	{
		setTargetName ("Cannot find any INTEGRAL FOV");
		integralFovCenter.ra = rts2_nan ("f");
		integralFovCenter.dec = rts2_nan ("f");
		integralTimeStart = 0;
		return;
	}

	std::ostringstream name;
	name << "IntegralFOV #" << integralId
		<< " ( " << Timestamp(integralTimeStart) << " )";
	setTargetName (name.str().c_str());
}

void TargetIntegralFOV::getPosition (struct ln_equ_posn *pos, double JD)
{
	*pos = integralFovCenter;
}

int TargetIntegralFOV::getRST (struct ln_rst_time *rst, double JD, double horizon)
{
	struct ln_equ_posn pos;

	getPosition (&pos, JD);
	return ln_get_object_next_rst_horizon (JD, observer, &pos, horizon, rst);
}

moveType TargetIntegralFOV::afterSlewProcessed ()
{
	/* exec sql begin declare section */
		 
		   
	
#line 1371 "sub_targets.ec"
 int d_obs_id ;
 
#line 1372 "sub_targets.ec"
 int d_integral_id = integralId ;
/* exec sql end declare section */
#line 1373 "sub_targets.ec"


	d_obs_id = getObsId ();
	{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "insert into integral_observation ( integral_id , obs_id ) values ( $1  , $2  )", 
	ECPGt_int,&(d_integral_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_int,&(d_obs_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EOIT, ECPGt_EORT);}
#line 1385 "sub_targets.ec"

	if (sqlca.sqlcode)
	{
		logMsgDb ("TargetIntegralFOV::startSlew SQL error", MESSAGE_ERROR);
		{ ECPGtrans(__LINE__, NULL, "rollback");}
#line 1389 "sub_targets.ec"

		return OBS_MOVE_FAILED;
	}
	{ ECPGtrans(__LINE__, NULL, "commit");}
#line 1392 "sub_targets.ec"

	return OBS_MOVE;
}

int TargetIntegralFOV::considerForObserving (double JD)
{
	// find pointing
	int ret;
	struct ln_equ_posn curr_position;
	double lst = ln_get_mean_sidereal_time (JD) + observer->lng / 15.0;

	load ();

	if (integralId < 0)
	{
		// no pointing..expect that after 3 minutes, it will be better,
		// as we can get new pointing from GCN
		setNextObservable (JD + 1/1440.0/20.0);
		return -1;
	}

	getPosition (&curr_position, JD);

	ret = isGood (lst, JD, &curr_position);

	if (!ret)
	{
		time_t nextObs;
		time (&nextObs);
		nextObs += 120;
		setNextObservable (&nextObs);
		return -1;
	}

	return selectedAsGood ();
}

int TargetIntegralFOV::beforeMove ()
{
	// are we still the best swiftId on planet?
	load ();
	if (oldIntegralId != integralId)
		endObservation (-1);	 // startSlew will be called after move suceeded and will write new observation..
	return 0;
}

float TargetIntegralFOV::getBonus (double JD)
{
	/* exec sql begin declare section */
		   
		 
	
#line 1441 "sub_targets.ec"
 int d_tar_id = target_id ;
 
#line 1442 "sub_targets.ec"
 double d_bonus ;
/* exec sql end declare section */
#line 1443 "sub_targets.ec"


	{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "select tar_priority from targets where tar_id = $1 ", 
	ECPGt_int,&(d_tar_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EOIT, 
	ECPGt_double,&(d_bonus),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EORT);}
#line 1453 "sub_targets.ec"


	integralOnBonus = d_bonus;

	time_t now;
	ln_get_timet_from_julian (JD, &now);
	if (now > integralTimeStart - 120)
		return integralOnBonus;
	if (now > integralTimeStart - 300)
		return integralOnBonus / 2.0;
	return 1;
}

int TargetIntegralFOV::isContinues ()
{
	double ret;
	load ();
	if (oldIntegralId != integralId)
		return 0;
	ret = Target::getBonus ();
	// FOV become uinteresting..
	if (ret == 1)
		return 0;
	return 1;
}

void TargetIntegralFOV::printExtra (Rts2InfoValStream &_os, double JD)
{
	Target::printExtra (_os, JD);
	_os
		<< InfoVal<Timestamp> ("FROM", Timestamp (integralTimeStart))
		<< std::endl;
}

TargetGps::TargetGps (int in_tar_id, struct ln_lnlat_posn *in_obs): ConstTarget (in_tar_id, in_obs)
{
}

float TargetGps::getBonus (double JD)
{
	// get our altitude..
	struct ln_hrz_posn hrz;
	struct ln_equ_posn curr;
	int numobs;
	int numobs2;
	time_t now;
	time_t start_t;
	time_t start_t2;
	double gal_ctr;
	getAltAz (&hrz, JD);
	getPosition (&curr, JD);
	// get number of observations in last 24 hours..
	ln_get_timet_from_julian (JD, &now);
	start_t = now - 86400;
	start_t2 = now - 86400 * 2;
	numobs = getNumObs (&start_t, &now);
	numobs2 = getNumObs (&start_t2, &start_t);
	gal_ctr = getGalCenterDist (JD);
	if ((90 - observer->lat + curr.dec) == 0)
		return ConstTarget::getBonus (JD) - 200;
	return ConstTarget::getBonus (JD) + 20 * (hrz.alt / (90 - observer->lat + curr.dec)) + gal_ctr / 9 - numobs * 10 - numobs2 * 5;
}

TargetSkySurvey::TargetSkySurvey (int in_tar_id, struct ln_lnlat_posn *in_obs): ConstTarget (in_tar_id, in_obs)
{
}

float TargetSkySurvey::getBonus (double JD)
{
	time_t now;
	time_t start_t;
	int numobs;
	ln_get_timet_from_julian (JD, &now);
	now -= 300;
	start_t = now - 86400;
	numobs = getNumObs (&start_t, &now);
	return ConstTarget::getBonus (JD) - numobs * 10;
}

TargetTerestial::TargetTerestial (int in_tar_id, struct ln_lnlat_posn *in_obs):ConstTarget (in_tar_id, in_obs)
{
}

int TargetTerestial::considerForObserving (double JD)
{
	// we can obsere it any time..
	return selectedAsGood ();
}

float TargetTerestial::getBonus (double JD)
{
	time_t now;
	time_t start_t;
	struct tm *now_t;
	int numobs;
	int minofday;
	ln_get_timet_from_julian (JD, &now);
	now_t = gmtime (&now);

	minofday = now_t->tm_hour * 60 + now_t->tm_min;
	// HAM times (all UTC) (min of day)
	// 1:30 - 3:30          90 - 210
	// 4:00 - 6:00         240 - 360
	// 6:30 - 8:30         390 - 510
	// not correct times..
	if (minofday < 100
		|| (minofday > 200 && minofday < 250)
		|| (minofday > 350 && minofday < 400)
		|| minofday > 500)
		return 1;

	// we can observe..

	start_t = now - 3600;
	numobs = getNumObs (&start_t, &now);

	if (numobs == 0)
		return 600;
	if (numobs == 1)
		return 1;
	return 1;
}

moveType TargetTerestial::afterSlewProcessed ()
{
	return OBS_MOVE_FIXED;
}

TargetPlan::TargetPlan (int in_tar_id, struct ln_lnlat_posn *in_obs) : Target (in_tar_id, in_obs)
{
	selectedPlan = NULL;
	nextPlan = NULL;
	rts2core::Configuration::instance ()->getFloat ("selector", "last_search", hourLastSearch, 16.0);
	rts2core::Configuration::instance ()->getFloat ("selector", "consider_plan", hourConsiderPlans, 1.0);
	nextTargetRefresh = 0;
}

TargetPlan::~TargetPlan (void)
{
	delete selectedPlan;
	delete nextPlan;
}


// refresh next time..
void TargetPlan::refreshNext ()
{
	/* exec sql begin declare section */
		 
		 
		 
	
#line 1601 "sub_targets.ec"
 int db_next_plan_id ;
 
#line 1602 "sub_targets.ec"
 long db_next_plan_start ;
 
#line 1603 "sub_targets.ec"
 long db_next ;
/* exec sql end declare section */
#line 1604 "sub_targets.ec"


	time_t now;
	int ret;

	time (&now);
	if (now < nextTargetRefresh)
		return;

	// next refresh after 60 seconds
	nextTargetRefresh = now + 60;

	if (nextPlan)
	{
		// we need to select new plan..don't bother with db select
		if (nextPlan->getPlanStart () < now)
			return;
	}
	// consider targets 1/2 hours old..
	db_next = now - 1800;

	{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "select plan_id , extract ( EPOCH from plan_start ) from plan where plan_start = ( select min ( plan_start ) from plan where plan_start >= to_timestamp ( $1  ) and obs_id is null )", 
	ECPGt_long,&(db_next),(long)1,(long)1,sizeof(long), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EOIT, 
	ECPGt_int,&(db_next_plan_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_long,&(db_next_plan_start),(long)1,(long)1,sizeof(long), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EORT);}
#line 1635 "sub_targets.ec"

	if (sqlca.sqlcode)
	{
		logMsgDb ("TargetPlan::refreshNext cannot load next target",
			(sqlca.sqlcode == ECPG_NOT_FOUND) ? MESSAGE_DEBUG : MESSAGE_ERROR);
		{ ECPGtrans(__LINE__, NULL, "rollback");}
#line 1640 "sub_targets.ec"

		// we can be last plan entry - so change us, so selectedTarget will be changed
		return;
	}
	{ ECPGtrans(__LINE__, NULL, "rollback");}
#line 1644 "sub_targets.ec"

	// we loaded same plan as already prepared
	if (nextPlan && nextPlan->getPlanId() == db_next_plan_id && nextPlan->getPlanStart() == db_next_plan_start)
		return;
	delete nextPlan;
	nextPlan = new Plan (db_next_plan_id);
	ret = nextPlan->load ();
	if (ret)
	{
		delete nextPlan;
		nextPlan = NULL;
		return;
	}
	// we will need change
	return;
}

void TargetPlan::load ()
{
	load (ln_get_julian_from_sys ());
}

void TargetPlan::load (double JD)
{
	/* exec sql begin declare section */
	 
	 
	 
	 

	 
	
#line 1669 "sub_targets.ec"
 int db_cur_plan_id ;
 
#line 1670 "sub_targets.ec"
 double db_cur_plan_start ;
 
#line 1671 "sub_targets.ec"
 int db_obs_id ;
 
#line 1672 "sub_targets.ec"
 int db_obs_id_ind ;
 
#line 1674 "sub_targets.ec"
 long last ;
/* exec sql end declare section */
#line 1675 "sub_targets.ec"


	int db_plan_id = -1;
	int db_next_plan_id = -1;

	time_t now;
	time_t considerPlans;

	ln_get_timet_from_julian (JD, &now);

	// always load plan target!
	Target::loadTarget (getTargetID ());

	// get plan entries from last 12 hours..
	last = (time_t) (now - (hourLastSearch * 3600));

	considerPlans = (time_t) (now - (hourConsiderPlans * 3600.0));

	// check for next plan entry after 1 minute..
	nextTargetRefresh = now + 60;

	ECPGset_var( 1, &( last ), __LINE__);\
 /* declare cur_plan cursor for select plan_id , obs_id , extract ( EPOCH from plan_start ) from plan where extract ( EPOCH from plan_start ) >= $1  and tar_id <> 7 order by plan_start asc */
#line 1707 "sub_targets.ec"


	{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "declare cur_plan cursor for select plan_id , obs_id , extract ( EPOCH from plan_start ) from plan where extract ( EPOCH from plan_start ) >= $1  and tar_id <> 7 order by plan_start asc", 
	ECPGt_long,&(last),(long)1,(long)1,sizeof(long), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EOIT, ECPGt_EORT);}
#line 1709 "sub_targets.ec"

	while (1)
	{
		{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "fetch next from cur_plan", ECPGt_EOIT, 
	ECPGt_int,&(db_cur_plan_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_int,&(db_obs_id),(long)1,(long)1,sizeof(int), 
	ECPGt_int,&(db_obs_id_ind),(long)1,(long)1,sizeof(int), 
	ECPGt_double,&(db_cur_plan_start),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EORT);}
#line 1715 "sub_targets.ec"

		if (sqlca.sqlcode)
			break;
		if (db_cur_plan_start > now)
		{
			if (db_plan_id == -1)
			{
				// that's the last plan ID
				db_plan_id = db_next_plan_id;
			}
			db_next_plan_id = db_cur_plan_id;
			break;
		}
		if (db_obs_id_ind < 0 && db_cur_plan_start > considerPlans)
		{
			// we found current plan - one that wasn't observed and is close enought to current time
			if (db_plan_id == -1)
			{
				db_plan_id = db_cur_plan_id;
			}
			else
			{
				db_next_plan_id = db_cur_plan_id;
				break;
			}
		}
		// keep for futher reference
		db_next_plan_id = db_cur_plan_id;
	}
	if (sqlca.sqlcode)
	{
		if (sqlca.sqlcode != ECPG_NOT_FOUND
			|| db_next_plan_id == -1)
		{
			if (sqlca.sqlcode != ECPG_NOT_FOUND)
				logMsgDb ("TargetPlan::load cannot find any plan", MESSAGE_ERROR);
			{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "close cur_plan", ECPGt_EOIT, ECPGt_EORT);}
#line 1751 "sub_targets.ec"

			return;
		}
		// we don't find next, but we have current
		if (db_plan_id == -1)
		{
			db_plan_id = db_next_plan_id;
		}
		db_next_plan_id = -1;
	}
	{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "close cur_plan", ECPGt_EOIT, ECPGt_EORT);}
#line 1761 "sub_targets.ec"


	if (db_plan_id != -1)
	{
		delete selectedPlan;
		selectedPlan = new Plan (db_plan_id);
		selectedPlan->load ();
		if (selectedPlan->getTarget ()->getTargetType () == TYPE_PLAN)
		{
			delete selectedPlan;
			selectedPlan = NULL;
			throw SqlError ("target scheduled from plan is also planning target, that is not allowed");
		}
		setTargetName (selectedPlan->getTarget()->getTargetName ());
	}
	else
	{
		setTargetName ("No scheduled target");
	}
	if (db_next_plan_id != -1)
	{
		delete nextPlan;
		nextPlan = new Plan (db_next_plan_id);
		nextPlan->load ();
	}
}

bool TargetPlan::getScript (const char *camera_name, std::string &script)
{
	if (selectedPlan)
		return selectedPlan->getTarget()->getScript (camera_name, script);
	return Target::getScript (camera_name, script);
}

void TargetPlan::getPosition (struct ln_equ_posn *pos, double JD)
{
	if (selectedPlan)
	{
		selectedPlan->getTarget()->getPosition (pos, JD);
	}
	else
	{
		// pretend to observe in zenith..
		pos->ra = ln_get_mean_sidereal_time (JD) * 15.0 + observer->lng;
		pos->dec = observer->lat;
	}
}

int TargetPlan::getRST (struct ln_rst_time *rst, double JD, double horizon)
{
	if (selectedPlan)
		return selectedPlan->getTarget()->getRST (rst, JD, horizon);
	// otherwise we have circumpolar target
	return 1;
}

int TargetPlan::getObsTargetID ()
{
	if (selectedPlan)
		return selectedPlan->getTarget()->getObsTargetID ();
	return Target::getObsTargetID ();
}

int TargetPlan::considerForObserving (double JD)
{
	load (JD);
	return Target::considerForObserving (JD);
}

float TargetPlan::getBonus (double JD)
{
	// we have something to observe
	if (selectedPlan)
		return Target::getBonus (JD);
	return 0;
}

int TargetPlan::isContinues ()
{
	time_t now;
	refreshNext ();
	time (&now);
	if ((nextPlan && nextPlan->getPlanStart () < now)
		|| !(nextPlan))
		return 2;
	if (selectedPlan)
		return selectedPlan->getTarget()->isContinues ();
	return 0;
}

int TargetPlan::beforeMove ()
{
	if (selectedPlan)
		selectedPlan->getTarget ()->beforeMove ();
	return Target::beforeMove ();
}

moveType TargetPlan::startSlew (struct ln_equ_posn *pos, bool update_position)
{
	moveType ret;
	if (selectedPlan)
	{
		ret = selectedPlan->startSlew (pos, update_position);
		setObsId (selectedPlan->getTarget()->getObsId ());
		return ret;
	}
	return Target::startSlew (pos, update_position);
}

void TargetPlan::printExtra (Rts2InfoValStream & _os, double JD)
{
	Target::printExtra (_os, JD);
	if (selectedPlan)
	{
		_os
			<< "SELECTED PLAN" << std::endl
			<< selectedPlan << std::endl
			<< *(selectedPlan->getTarget ()) << std::endl
			<< "*************************************************" << std::endl << std::endl;
	}
	else
	{
		_os << "NO PLAN SELECTED" << std::endl;
	}
	if (nextPlan && nextPlan->getTarget()->getTargetType() != TYPE_PLAN)
	{
		_os << "NEXT PLAN" << std::endl
			<< nextPlan << std::endl
			<< *(nextPlan->getTarget ()) << std::endl
			<< "*************************************************" << std::endl << std::endl;
	}
	else
	{
		_os << "NO NEXT PLAN SELECTED" << std::endl << std::endl;
	}
}
