/* Processed by ecpg (4.7.0) */
/* These include files are added by the preprocessor */
#include <ecpglib.h>
#include <ecpgerrno.h>
#include <sqlca.h>
/* End of automatic include section */

#line 1 "taruser.ec"
/* 
 * User access.
 * Copyright (C) 2005-2008 Petr Kubanek <petr@kubanek.net>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#include <algorithm>

#include "rts2db/taruser.h"
#include "block.h"

using namespace rts2db;

UserEvent::UserEvent (const UserEvent &in_user)
{
	usr_email = in_user.usr_email;
	event_mask = in_user.event_mask;
}

UserEvent::UserEvent (const char *in_usr_email, int in_event_mask)
{
	usr_email = std::string (in_usr_email);
	event_mask = in_event_mask;
}

UserEvent::~UserEvent (void)
{
}

/**********************************************************************
 *  TarUser class
 **********************************************************************/

TarUser::TarUser (int in_target, char in_type_id)
{
	tar_id = in_target;
	type_id = in_type_id;
}

TarUser::~TarUser (void)
{
}

int TarUser::load ()
{
	/* exec sql begin declare section */
	   
	   

	 
	// cannot use USER_EMAIL_LEN, as it does not work with some ecpg versions
	 
	 
	
#line 60 "taruser.ec"
 int db_tar_id = tar_id ;
 
#line 61 "taruser.ec"
 char db_type_id = type_id ;
 
#line 63 "taruser.ec"
 int db_usr_id ;
 
#line 65 "taruser.ec"
  struct varchar_1  { int len; char arr[ 200 ]; }  db_usr_email ;
 
#line 66 "taruser.ec"
 int db_event_mask ;
/* exec sql end declare section */
#line 67 "taruser.ec"


	// get TarUsers from targets_users

	ECPGset_var( 0, &( db_tar_id ), __LINE__);\
 /* declare cur_targets_users cursor for select users . usr_id , usr_email , event_mask from users , targets_users where tar_id = $1  and targets_users . usr_id = users . usr_id */
#line 81 "taruser.ec"


	{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "declare cur_targets_users cursor for select users . usr_id , usr_email , event_mask from users , targets_users where tar_id = $1  and targets_users . usr_id = users . usr_id", 
	ECPGt_int,&(db_tar_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EOIT, ECPGt_EORT);}
#line 83 "taruser.ec"

	while (1)
	{
		{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "fetch next from cur_targets_users", ECPGt_EOIT, 
	ECPGt_int,&(db_usr_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_varchar,&(db_usr_email),(long)200,(long)1,sizeof(struct varchar_1), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_int,&(db_event_mask),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EORT);}
#line 89 "taruser.ec"

		if (sqlca.sqlcode)
			break;
		users.push_back (UserEvent (db_usr_email.arr, db_event_mask));
	}
	if (sqlca.sqlcode && sqlca.sqlcode != ECPG_NOT_FOUND)
	{
		logStream (MESSAGE_ERROR) << "TarUsers::load cannot get users " << sqlca.sqlerrm.sqlerrmc << sendLog;
		{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "close cur_targets_users", ECPGt_EOIT, ECPGt_EORT);}
#line 97 "taruser.ec"

		{ ECPGtrans(__LINE__, NULL, "rollback");}
#line 98 "taruser.ec"

		return -1;
	}
	{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "close cur_targets_users", ECPGt_EOIT, ECPGt_EORT);}
#line 101 "taruser.ec"

	{ ECPGtrans(__LINE__, NULL, "commit");}
#line 102 "taruser.ec"


	// get TarUsers from type_users

	ECPGset_var( 1, &( db_type_id ), __LINE__);\
 /* declare cur_type_users cursor for select users . usr_id , usr_email , event_mask from users , type_users where type_id = $1  and type_users . usr_id = users . usr_id */
#line 116 "taruser.ec"


	{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "declare cur_type_users cursor for select users . usr_id , usr_email , event_mask from users , type_users where type_id = $1  and type_users . usr_id = users . usr_id", 
	ECPGt_char,&(db_type_id),(long)1,(long)1,(1)*sizeof(char), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EOIT, ECPGt_EORT);}
#line 118 "taruser.ec"

	while (1)
	{
		{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "fetch next from cur_type_users", ECPGt_EOIT, 
	ECPGt_int,&(db_usr_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_varchar,&(db_usr_email),(long)200,(long)1,sizeof(struct varchar_1), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_int,&(db_event_mask),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EORT);}
#line 124 "taruser.ec"

		if (sqlca.sqlcode)
			break;
		UserEvent newUser = UserEvent (db_usr_email.arr, db_event_mask);
		if (std::find (users.begin (), users.end (), newUser) != users.end ())
		{
			logStream (MESSAGE_ERROR) << "TarUsers::load user already exists (tar_id " << tar_id << ")" << sendLog;
		}
		else
		{
			users.push_back (UserEvent (newUser));
		}
	}
	if (sqlca.sqlcode && sqlca.sqlcode != ECPG_NOT_FOUND)
	{
		logStream (MESSAGE_ERROR) << "TarUsers::load cannot get users '" << sqlca.sqlerrm.sqlerrmc << "'" << sendLog;
		{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "close cur_type_users", ECPGt_EOIT, ECPGt_EORT);}
#line 140 "taruser.ec"

		{ ECPGtrans(__LINE__, NULL, "rollback");}
#line 141 "taruser.ec"

		return -1;
	}
	{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "close cur_type_users", ECPGt_EOIT, ECPGt_EORT);}
#line 144 "taruser.ec"

	{ ECPGtrans(__LINE__, NULL, "commit");}
#line 145 "taruser.ec"

	return 0;
}

std::string TarUser::getUsers (int in_event_mask, int &count)
{
	std::vector <UserEvent>::iterator user_iter;
	int ret;
	std::string email_list = "";
	if (users.empty ())
	{
		ret = load ();
		if (ret)
			return std::string ("");
	}
	count = 0;
	for (user_iter = users.begin (); user_iter != users.end (); user_iter++)
	{
		if ((*user_iter).haveMask (in_event_mask))
		{
			if (count != 0)
				email_list += ", ";
			email_list += (*user_iter).getUserEmail ();
			count++;
		}
	}
	return email_list;
}
