/* Processed by ecpg (4.7.0) */
/* These include files are added by the preprocessor */
#include <ecpglib.h>
#include <ecpgerrno.h>
#include <sqlca.h>
/* End of automatic include section */

#line 1 "user.ec"
/* 
 * User management.
 * Copyright (C) 2008 Petr Kubanek <petr@kubanek.net>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#include "rts2db/user.h"
#include "app.h"

#include <unistd.h>
#include <crypt.h>

using namespace rts2db;

TypeUser::TypeUser (char in_type, int in_eventMask)
{
	type = in_type;
	eventMask = in_eventMask;
}

TypeUser::~TypeUser (void)
{

}

int TypeUser::updateFlags (int id, int newFlags)
{
	/* exec sql begin declare section */
	   
	   
	   
	
#line 42 "user.ec"
 int db_id = id ;
 
#line 43 "user.ec"
 char db_type = type ;
 
#line 44 "user.ec"
 int db_eventMask = newFlags ;
/* exec sql end declare section */
#line 45 "user.ec"


	{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "update type_users set event_mask = $1  where usr_id = $2  and type_id = $3 ", 
	ECPGt_int,&(db_eventMask),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_int,&(db_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_char,&(db_type),(long)1,(long)1,(1)*sizeof(char), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EOIT, ECPGt_EORT);}
#line 52 "user.ec"

	
	if (sqlca.sqlcode)
	{
		logStream (MESSAGE_ERROR) << "error while updating flags for user " << id
			<< " and type " << type 
			<< " :" << sqlca.sqlerrm.sqlerrmc << sendLog;
		{ ECPGtrans(__LINE__, NULL, "rollback");}
#line 59 "user.ec"

		return -1;
	}

	eventMask = newFlags;

	{ ECPGtrans(__LINE__, NULL, "commit");}
#line 65 "user.ec"

	return 0;
}

int TypeUserSet::load (int usr_id)
{
	/* exec sql begin declare section */
	   
	 
	 
	
#line 72 "user.ec"
 int db_usr_id = usr_id ;
 
#line 73 "user.ec"
 char db_type ;
 
#line 74 "user.ec"
 int db_eventMask ;
/* exec sql end declare section */
#line 75 "user.ec"


	{ ECPGtrans(__LINE__, NULL, "begin transaction");}
#line 77 "user.ec"


	ECPGset_var( 0, &( db_usr_id ), __LINE__);\
 /* declare typeuser_cur cursor for select type_id , event_mask from type_users where usr_id = $1  */
#line 86 "user.ec"


	{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "declare typeuser_cur cursor for select type_id , event_mask from type_users where usr_id = $1 ", 
	ECPGt_int,&(db_usr_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EOIT, ECPGt_EORT);}
#line 88 "user.ec"


	while (1)
	{
		{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "fetch next from typeuser_cur", ECPGt_EOIT, 
	ECPGt_char,&(db_type),(long)1,(long)1,(1)*sizeof(char), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_int,&(db_eventMask),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EORT);}
#line 94 "user.ec"

		if (sqlca.sqlcode)
			break;
		push_back (TypeUser (db_type, db_eventMask));
	}
	if (sqlca.sqlcode != ECPG_NOT_FOUND)
	{
		logStream (MESSAGE_ERROR) << "TypeUserSet::load cannot load user set " << sqlca.sqlerrm.sqlerrmc << sendLog;
		{ ECPGtrans(__LINE__, NULL, "rollback");}
#line 102 "user.ec"

		return -1;
	}
	{ ECPGtrans(__LINE__, NULL, "rollback");}
#line 105 "user.ec"

	return 0;
}

TypeUserSet::TypeUserSet (int usr_id)
{
	load (usr_id);
}

TypeUserSet::~TypeUserSet (void)
{

}

TypeUser * TypeUserSet::getFlags (char type)
{
	for (TypeUserSet::iterator iter = begin (); iter != end (); iter++)
	{
		if ((*iter).isType (type))
			return &(*iter);
	}
	return NULL;
}

int TypeUserSet::addNewTypeFlags (int id, char type, int flags)
{
	/* exec sql begin declare section */
           
	   
	   
	
#line 132 "user.ec"
 char db_type_id = type ;
 
#line 133 "user.ec"
 int db_usr_id = id ;
 
#line 134 "user.ec"
 int db_event_mask = flags ;
/* exec sql end declare section */
#line 135 "user.ec"

	
	{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "insert into type_users ( type_id , usr_id , event_mask ) values ( $1  , $2  , $3  )", 
	ECPGt_char,&(db_type_id),(long)1,(long)1,(1)*sizeof(char), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_int,&(db_usr_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_int,&(db_event_mask),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EOIT, ECPGt_EORT);}
#line 147 "user.ec"


	if (sqlca.sqlcode)
	{
		logStream (MESSAGE_ERROR) << "cannot insert event trigger record " << sqlca.sqlerrm.sqlerrmc << sendLog;
		{ ECPGtrans(__LINE__, NULL, "rollback");}
#line 152 "user.ec"

		return -1;
	}

	push_back (TypeUser (type, flags));

	{ ECPGtrans(__LINE__, NULL, "commit");}
#line 158 "user.ec"

	return 0;
}

int TypeUserSet::removeType (int id, char type)
{
	/* exec sql begin declare section */
	   
	   
	
#line 165 "user.ec"
 int db_id = id ;
 
#line 166 "user.ec"
 char db_type = type ;
/* exec sql end declare section */
#line 167 "user.ec"


	{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "delete from type_users where type_id = $1  and usr_id = $2 ", 
	ECPGt_char,&(db_type),(long)1,(long)1,(1)*sizeof(char), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_int,&(db_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EOIT, ECPGt_EORT);}
#line 172 "user.ec"

	
	if (sqlca.sqlcode)
	{
		logStream (MESSAGE_ERROR) << "error while removing user " << id 
			<< " and type " << type << "." << sendLog;
		{ ECPGtrans(__LINE__, NULL, "rollback");}
#line 178 "user.ec"

		return -1;
	}

	{ ECPGtrans(__LINE__, NULL, "commit");}
#line 182 "user.ec"

	return 0;
}

User::User ()
{
 	id = -1;
	types = NULL;
}

User::User (int in_id, std::string in_login, std::string in_email)
{
	id = in_id;
	login = in_login;
	email = in_email;

	types = NULL;
}

User::~User (void)
{
	delete types;
}

int User::load (const char * in_login)
{
	/* exec sql begin declare section */
	 
	 
	 
	
#line 209 "user.ec"
 int db_id ;
 
#line 210 "user.ec"
  struct varchar_1  { int len; char arr[ 25 ]; }  db_login ;
 
#line 211 "user.ec"
  struct varchar_2  { int len; char arr[ 200 ]; }  db_email ;
/* exec sql end declare section */
#line 212 "user.ec"


	if (strlen (in_login) > 25)
	{
		logStream (MESSAGE_ERROR) << "login string '" << in_login << "' too long." << sendLog;
		return -1;
	}

	strcpy (db_login.arr, in_login);
	db_login.len = strlen (in_login);

	{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "select usr_id , usr_email from users where usr_login = $1 ", 
	ECPGt_varchar,&(db_login),(long)25,(long)1,sizeof(struct varchar_1), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EOIT, 
	ECPGt_int,&(db_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_varchar,&(db_email),(long)200,(long)1,sizeof(struct varchar_2), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EORT);}
#line 232 "user.ec"


	if (sqlca.sqlcode)
	{
		logStream (MESSAGE_ERROR) << "cannot find user with login " << in_login << "." << sendLog;
		id = -1;
		return -1;
	}
	id = db_id;
	login = std::string (in_login);
	email = std::string (db_email.arr);

	return loadTypes ();
}

int User::loadTypes ()
{
	delete types;
	types = new TypeUserSet (id);
	return 0;
}

int User::setPassword (std::string newPass)
{
	/* exec sql begin declare section */
	 
	 
	
#line 257 "user.ec"
  struct varchar_3  { int len; char arr[ 25 ]; }  db_login ;
 
#line 258 "user.ec"
  struct varchar_4  { int len; char arr[ 100 ]; }  db_passwd ;
/* exec sql end declare section */
#line 259 "user.ec"


	strncpy (db_login.arr, login.c_str (), 25);
	db_login.len = login.length ();

	if (newPass.length () > 100)
	{
		logStream (MESSAGE_ERROR) << "too long password" << sendLog;
		return -1;
	}

#ifdef HAVE_CRYPT
	char salt[100];
	strcpy (salt, "$6$");
	random_salt (salt + 3, 8);
	strcpy (salt + 11, "$");
	strncpy (db_passwd.arr, crypt (newPass.c_str (), salt), 100);
	db_passwd.len = strlen (db_passwd.arr);
#else
	strncpy (db_passwd.arr, newPass.c_str (), 100);
	db_passwd.len = newPass.length ();
#endif

	{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "update users set usr_passwd = $1  where usr_login = $2 ", 
	ECPGt_varchar,&(db_passwd),(long)100,(long)1,sizeof(struct varchar_4), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_varchar,&(db_login),(long)25,(long)1,sizeof(struct varchar_3), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EOIT, ECPGt_EORT);}
#line 287 "user.ec"


	if (sqlca.sqlcode)
	{
		logStream (MESSAGE_ERROR) << "error updating password " << sqlca.sqlerrm.sqlerrmc << sendLog;
		{ ECPGtrans(__LINE__, NULL, "rollback");}
#line 292 "user.ec"

		return -1;
	}

	{ ECPGtrans(__LINE__, NULL, "commit");}
#line 296 "user.ec"


	return 0;
}

int User::setEmail (std::string newEmail)
{
	/* exec sql begin declare section */
	 
	 
	
#line 304 "user.ec"
  struct varchar_5  { int len; char arr[ 25 ]; }  db_login ;
 
#line 305 "user.ec"
  struct varchar_6  { int len; char arr[ 200 ]; }  db_email ;
/* exec sql end declare section */
#line 306 "user.ec"


	strncpy (db_login.arr, login.c_str (), 25);
	db_login.len = login.length ();

	if (newEmail.length () > 200)
	{
		logStream (MESSAGE_ERROR) << "too long email" << sendLog;
		return -1;
	}

	strncpy (db_email.arr, newEmail.c_str (), 200);
	db_email.len = newEmail.length ();

	{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "update users set usr_email = $1  where usr_login = $2 ", 
	ECPGt_varchar,&(db_email),(long)200,(long)1,sizeof(struct varchar_6), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_varchar,&(db_login),(long)25,(long)1,sizeof(struct varchar_5), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EOIT, ECPGt_EORT);}
#line 325 "user.ec"


	if (sqlca.sqlcode)
	{
		logStream (MESSAGE_ERROR) << "error updating email " << sqlca.sqlerrm.sqlerrmc << sendLog;
		{ ECPGtrans(__LINE__, NULL, "rollback");}
#line 330 "user.ec"

		return -1;
	}

	{ ECPGtrans(__LINE__, NULL, "commit");}
#line 334 "user.ec"


	return 0;
}

bool verifyUser (std::string username, std::string pass, bool &executePermission)
{
	/* exec sql begin declare section */
	 
	 
	 
	 
	
#line 342 "user.ec"
  struct varchar_7  { int len; char arr[ 25 ]; }  db_username ;
 
#line 343 "user.ec"
  struct varchar_8  { int len; char arr[ 100 ]; }  d_passwd ;
 
#line 344 "user.ec"
 int d_pass_ind ;
 
#line 345 "user.ec"
 bool d_executePermission ;
/* exec sql end declare section */
#line 346 "user.ec"


	db_username.len = username.length ();
	db_username.len = db_username.len > 25 ? 25 : db_username.len;
	strncpy (db_username.arr, username.c_str (), db_username.len);

	{ ECPGtrans(__LINE__, NULL, "begin transaction");}
#line 352 "user.ec"


	ECPGset_var( 1, &( db_username ), __LINE__);\
 /* declare verify_cur cursor for select usr_passwd , usr_execute_permission from users where usr_login = $1  */
#line 361 "user.ec"


	{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "declare verify_cur cursor for select usr_passwd , usr_execute_permission from users where usr_login = $1 ", 
	ECPGt_varchar,&(db_username),(long)25,(long)1,sizeof(struct varchar_7), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EOIT, ECPGt_EORT);}
#line 363 "user.ec"


	{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "fetch next from verify_cur", ECPGt_EOIT, 
	ECPGt_varchar,&(d_passwd),(long)100,(long)1,sizeof(struct varchar_8), 
	ECPGt_int,&(d_pass_ind),(long)1,(long)1,sizeof(int), 
	ECPGt_bool,&(d_executePermission),(long)1,(long)1,sizeof(bool), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EORT);}
#line 365 "user.ec"


	if (sqlca.sqlcode == 0)
	{
		executePermission = d_executePermission;
		// empty password - all passwords are allowed
		if (d_pass_ind > 0)
			return true;
		d_passwd.arr[d_passwd.len] = '\0';
		{ ECPGtrans(__LINE__, NULL, "rollback");}
#line 374 "user.ec"

#ifdef HAVE_CRYPT
		return strcmp (crypt (pass.c_str (), d_passwd.arr), d_passwd.arr) == 0;
#else
		return pass == std::string (d_passwd.arr);
#endif
	}
	executePermission = false;
	{ ECPGtrans(__LINE__, NULL, "rollback");}
#line 382 "user.ec"

	return false;
}
