/* Processed by ecpg (4.7.0) */
/* These include files are added by the preprocessor */
#include <ecpglib.h>
#include <ecpgerrno.h>
#include <sqlca.h>
/* End of automatic include section */

#line 1 "userset.ec"
/* 
 * User set.
 * Copyright (C) 2008 Petr Kubanek <petr@kubanek.net>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#include "app.h"
#include "rts2db/sqlerror.h"
#include "rts2db/userset.h"

#include <crypt.h>

using namespace rts2db;

int UserSet::load ()
{
	/* exec sql begin declare section */
	 
	 
	 
	
#line 31 "userset.ec"
 int db_id ;
 
#line 32 "userset.ec"
  struct varchar_1  { int len; char arr[ 25 ]; }  db_login ;
 
#line 33 "userset.ec"
  struct varchar_2  { int len; char arr[ 200 ]; }  db_email ;
/* exec sql end declare section */
#line 34 "userset.ec"


	{ ECPGtrans(__LINE__, NULL, "begin transaction");}
#line 36 "userset.ec"


	/* declare user_cur cursor for select usr_id , usr_login , usr_email from users order by usr_login asc */
#line 46 "userset.ec"


	{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "declare user_cur cursor for select usr_id , usr_login , usr_email from users order by usr_login asc", ECPGt_EOIT, ECPGt_EORT);}
#line 48 "userset.ec"


	while (1)
	{
		{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "fetch next from user_cur", ECPGt_EOIT, 
	ECPGt_int,&(db_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_varchar,&(db_login),(long)25,(long)1,sizeof(struct varchar_1), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_varchar,&(db_email),(long)200,(long)1,sizeof(struct varchar_2), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EORT);}
#line 55 "userset.ec"

		if (sqlca.sqlcode)
			break;
		push_back (User (db_id, std::string (db_login.arr), std::string (db_email.arr)));
	}
	if (sqlca.sqlcode != ECPG_NOT_FOUND)
	{
		logStream (MESSAGE_ERROR) << "UserSet::load cannot load user set " << sqlca.sqlerrm.sqlerrmc << sendLog;
		{ ECPGtrans(__LINE__, NULL, "rollback");}
#line 63 "userset.ec"

		return -1;
	}

	{ ECPGtrans(__LINE__, NULL, "commit");}
#line 67 "userset.ec"


	// load types
	for (UserSet::iterator iter = begin (); iter != end (); iter++)
	{
		int ret = (*iter).loadTypes ();
		if (ret)
			return ret;
	}

	return 0;
}

UserSet::UserSet ()
{
	load ();
}

UserSet::~UserSet (void)
{
}

int createUser (std::string login, std::string password, std::string email)
{
	/* exec sql begin declare section */
	 
	 
	 
	
#line 92 "userset.ec"
  struct varchar_3  { int len; char arr[ 25 ]; }  db_login ;
 
#line 93 "userset.ec"
  struct varchar_4  { int len; char arr[ 101 ]; }  db_password ;
 
#line 94 "userset.ec"
  struct varchar_5  { int len; char arr[ 200 ]; }  db_email ;
/* exec sql end declare section */
#line 95 "userset.ec"


	if (login.length () > 25)
	{
		logStream (MESSAGE_ERROR) << "login is too long" << sendLog;
		return -1;
	}

#ifdef HAVE_CRYPT
	char salt[101];
	strcpy (salt, "$6$");
	random_salt (salt + 3, 8);
	strcpy (salt + 11, "$");
	strncpy (db_password.arr, crypt (password.c_str (), salt), 100);
	db_password.len = strlen (db_password.arr);
#else
	if (password.length () > 100)
	{
		logStream (MESSAGE_ERROR) << "password is too long" << sendLog;
		return -1;
	}

	strncpy (db_password.arr, password.c_str (), 100);
	db_password.len = password.length ();
#endif

	if (email.length () > 25)
	{
		logStream (MESSAGE_ERROR) << "email is too long" << sendLog;
		return -1;
	}

	strncpy (db_login.arr, login.c_str (), 25);
	db_login.len = login.length ();

	strncpy (db_email.arr, email.c_str (), 200);
	db_email.len = email.length ();

	{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "insert into users ( usr_id , usr_login , usr_passwd , usr_email ) values ( nextval ( 'user_id' ) , $1  , $2  , $3  )", 
	ECPGt_varchar,&(db_login),(long)25,(long)1,sizeof(struct varchar_3), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_varchar,&(db_password),(long)101,(long)1,sizeof(struct varchar_4), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_varchar,&(db_email),(long)200,(long)1,sizeof(struct varchar_5), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EOIT, ECPGt_EORT);}
#line 145 "userset.ec"


	if (sqlca.sqlcode)
	{
		logStream (MESSAGE_ERROR) << "cannot insert new user " << sqlca.sqlerrm.sqlerrmc << sendLog;
		{ ECPGtrans(__LINE__, NULL, "rollback");}
#line 150 "userset.ec"

		return -1;
	}

	{ ECPGtrans(__LINE__, NULL, "commit");}
#line 154 "userset.ec"

	return 0;
}

int removeUser (std::string login)
{
	/* exec sql begin declare section */
	 
	
#line 161 "userset.ec"
  struct varchar_6  { int len; char arr[ 25 ]; }  db_login ;
/* exec sql end declare section */
#line 162 "userset.ec"


	if (login.length () > 25)
	{
		logStream (MESSAGE_ERROR) << "login is too long" << sendLog;
		return -1;
	}

	strncpy (db_login.arr, login.c_str (), 25);
	db_login.len = login.length ();

	{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "delete from users where usr_login = $1 ", 
	ECPGt_varchar,&(db_login),(long)25,(long)1,sizeof(struct varchar_6), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EOIT, ECPGt_EORT);}
#line 173 "userset.ec"


	if (sqlca.sqlcode)
	{
		throw rts2db::SqlError ("cannot delete user");
	}
	{ ECPGtrans(__LINE__, NULL, "commit");}
#line 179 "userset.ec"

	return 0;
}
