/* Processed by ecpg (4.7.0) */
/* These include files are added by the preprocessor */
#include <ecpglib.h>
#include <ecpgerrno.h>
#include <sqlca.h>
/* End of automatic include section */

#line 1 "imagedb.ec"
/* 
 * Database image access classes.
 * Copyright (C) 2003-2007 Petr Kubanek <petr@kubanek.net>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#include "imgdisplay.h"
#include "timestamp.h"
#include "libnova_cpp.h"

#include "rts2fits/imagedb.h"

#include <iomanip>
#include <libnova/airmass.h>
#include <sstream>


#line 1 "/usr/include/sqlca.h"
#ifndef POSTGRES_SQLCA_H
#define POSTGRES_SQLCA_H

#ifndef PGDLLIMPORT
#if  defined(WIN32) || defined(__CYGWIN__)
#define PGDLLIMPORT __declspec (dllimport)
#else
#define PGDLLIMPORT
#endif   /* __CYGWIN__ */
#endif   /* PGDLLIMPORT */

#define SQLERRMC_LEN	150

#ifdef __cplusplus
extern		"C"
{
#endif

struct sqlca_t
{
	char		sqlcaid[8];
	long		sqlabc;
	long		sqlcode;
	struct
	{
		int			sqlerrml;
		char		sqlerrmc[SQLERRMC_LEN];
	}			sqlerrm;
	char		sqlerrp[8];
	long		sqlerrd[6];
	/* Element 0: empty						*/
	/* 1: OID of processed tuple if applicable			*/
	/* 2: number of rows processed				*/
	/* after an INSERT, UPDATE or				*/
	/* DELETE statement					*/
	/* 3: empty						*/
	/* 4: empty						*/
	/* 5: empty						*/
	char		sqlwarn[8];
	/* Element 0: set to 'W' if at least one other is 'W'	*/
	/* 1: if 'W' at least one character string		*/
	/* value was truncated when it was			*/
	/* stored into a host variable.				*/

	/*
	 * 2: if 'W' a (hopefully) non-fatal notice occurred
	 */	/* 3: empty */
	/* 4: empty						*/
	/* 5: empty						*/
	/* 6: empty						*/
	/* 7: empty						*/

	char		sqlstate[5];
};

struct sqlca_t *ECPGget_sqlca(void);

#ifndef POSTGRES_ECPG_INTERNAL
#define sqlca (*ECPGget_sqlca())
#endif

#ifdef __cplusplus
}
#endif

#endif

#line 30 "imagedb.ec"


using namespace rts2image;

void ImageDb::initDbImage ()
{
}

void ImageDb::reportSqlError (const char *msg)
{
	logStream (MESSAGE_ERROR) << "SQL error #" << sqlca.sqlcode << " text " << sqlca.sqlerrm.sqlerrmc << " (in " <<
		msg << ")" << sendLog;
}

void ImageDb::getValueInd (const char *name, double &value, int &ind, char *comment)
{
	try
	{
		getValue (name, value, true, comment);
                ind = 0;
	}
	catch (rts2core::Error &er)
	{
		value = 100;
		ind = -1;
	}
}

void ImageDb::getValueInd (const char *name, float &value, int &ind, char *comment)
{
	try
	{
		getValue (name, value, true, comment);
                ind = 0;
	}
	catch (rts2core::Error &er)
	{
		value = 100;
		ind = -1;
	}
}

ImageDb::ImageDb (): Image ()
{
	initDbImage ();
}

ImageDb::ImageDb (Image * in_image): Image (in_image)
{
}

ImageDb::ImageDb (Rts2Target *currTarget, rts2core::DevClientCamera * camera, const struct timeval *expStart, const char *expand_path, bool overwrite) : Image (currTarget, camera, expStart, expand_path, overwrite)
{
	initDbImage ();
}

ImageDb::ImageDb (int in_obs_id, int in_img_id) : Image ()
{
	initDbImage ();
	// fill in filter
	// fill in exposureStart
	// fill in average (for darks..)
	// fill in target_id
	// fill in epochId
	// fill in camera_name
	// fill in mount_name
	// fill in obsId
	// fill in imgId
	// fill in ra_err
	// fill in dec_err
	// fill in pos_astr (from astrometry)
	// fill in imageType
	// fill in imageName
}

ImageDb::ImageDb (long in_img_date, int in_img_usec, float in_img_exposure):Image (in_img_date, in_img_usec, in_img_exposure)
{
}

int ImageDb::getOKCount ()
{
	/* exec sql begin declare section */
		    
		   
	
#line 112 "imagedb.ec"
 int db_obs_id = getObsId () ;
 
#line 113 "imagedb.ec"
 int db_count = 0 ;
/* exec sql end declare section */
#line 114 "imagedb.ec"


	{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "select count ( * ) from images where obs_id = $1  and ( ( process_bitfield & 2 ) = 2 )", 
	ECPGt_int,&(db_obs_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EOIT, 
	ECPGt_int,&(db_count),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EORT);}
#line 125 "imagedb.ec"

	{ ECPGtrans(__LINE__, NULL, "rollback");}
#line 126 "imagedb.ec"


	return db_count;
}

int ImageDb::saveImage ()
{
	updateDB ();
	return Image::saveImage ();
}

int ImageDb::renameImage (const char *new_filename)
{
	/* exec sql begin declare section */
	 
	    
	    
	
#line 140 "imagedb.ec"
  struct varchar_1  { int len; char arr[ 100 ]; }  d_img_path ;
 
#line 141 "imagedb.ec"
 int d_img_id = getImgId () ;
 
#line 142 "imagedb.ec"
 int d_obs_id = getObsId () ;
/* exec sql end declare section */
#line 143 "imagedb.ec"


	int ret = Image::renameImage (new_filename);
	if (ret)
		return ret;

	// flats and darks are not kept in database
	if (getImageType () == IMGTYPE_FLAT || getImageType () == IMGTYPE_DARK)
		return 0;

	strncpy (d_img_path.arr, getAbsoluteFileName (), 100);
	d_img_path.len = strlen (getAbsoluteFileName ()) > 100 ? 100: strlen (getAbsoluteFileName ());

	{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "update images set img_path = $1  where img_id = $2  and obs_id = $3 ", 
	ECPGt_varchar,&(d_img_path),(long)100,(long)1,sizeof(struct varchar_1), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_int,&(d_img_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_int,&(d_obs_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EOIT, ECPGt_EORT);}
#line 161 "imagedb.ec"

	if (sqlca.sqlcode != 0)
	{
		reportSqlError ("renameImage");
		{ ECPGtrans(__LINE__, NULL, "rollback");}
#line 165 "imagedb.ec"

		return -1;
	}
	{ ECPGtrans(__LINE__, NULL, "commit");}
#line 168 "imagedb.ec"

	return 0;
}

std::ostream & operator << (std::ostream &_os, ImageDb &img_db)
{
	img_db.print (_os);
	return _os;
}

/*********************************************************************
 *
 * ImageSkyDb class
 *
 ********************************************************************/
int ImageSkyDb::updateDB ()
{
	/* exec sql begin declare section */
	 
	    
	    
	   
	    
	    
	   
	 
	   
	   
	   
	   
	   
	 
	 
	 
	 
	 
	 
	 
	 
	 
	
#line 186 "imagedb.ec"
  struct varchar_2  { int len; char arr[ 100 ]; }  d_img_path ;
 
#line 187 "imagedb.ec"
 int d_img_id = getImgId () ;
 
#line 188 "imagedb.ec"
 int d_obs_id = getObsId () ;
 
#line 189 "imagedb.ec"
 char d_obs_subtype = 'S' ;
 
#line 190 "imagedb.ec"
 int d_img_date = getExposureSec () ;
 
#line 191 "imagedb.ec"
 int d_img_usec = getExposureUsec () ;
 
#line 192 "imagedb.ec"
 float d_img_temperature = - 500 ;
 
#line 193 "imagedb.ec"
 int d_img_temperature_ind ;
 
#line 194 "imagedb.ec"
 float d_img_exposure = - 1 ;
 
#line 195 "imagedb.ec"
 float d_img_alt = - 100 ;
 
#line 196 "imagedb.ec"
 float d_img_az = - 100 ;
 
#line 197 "imagedb.ec"
 int d_med_id = 0 ;
 
#line 198 "imagedb.ec"
 int d_proccess_bitfield = processBitfiedl ;
 
#line 199 "imagedb.ec"
 float d_img_fwhm ;
 
#line 200 "imagedb.ec"
 int d_img_fwhm_ind ;
 
#line 201 "imagedb.ec"
 float d_img_limmag ;
 
#line 202 "imagedb.ec"
 int d_img_limmag_ind ;
 
#line 203 "imagedb.ec"
 float d_img_qmagmax ;
 
#line 204 "imagedb.ec"
 int d_img_qmagmax_ind ;
 
#line 205 "imagedb.ec"
  struct varchar_3  { int len; char arr[ 8 ]; }  d_mount_name ;
 
#line 206 "imagedb.ec"
  struct varchar_4  { int len; char arr[ 8 ]; }  d_camera_name ;
 
#line 207 "imagedb.ec"
  struct varchar_5  { int len; char arr[ 3 ]; }  d_img_filter ;
/* exec sql end declare section */
#line 208 "imagedb.ec"


	strncpy (d_img_path.arr, getAbsoluteFileName (), 100);
	d_img_path.len = strlen (getAbsoluteFileName ()) > 100 ? 100: strlen (getAbsoluteFileName ());

	strncpy (d_mount_name.arr, getMountName (), 8);
	d_mount_name.len = strlen (getMountName ());

	strncpy (d_camera_name.arr, getCameraName (), 8);
	d_camera_name.len = strlen (getCameraName ());

	d_img_filter.len = strlen (getFilter()) > 3 ? 3 : strlen (getFilter());
	strncpy (d_img_filter.arr, getFilter(), d_img_filter.len);

	d_img_exposure = getExposureLength ();
	getValue ("TEL_ALT", d_img_alt);
	getValue ("TEL_AZ", d_img_az);

	getValueInd ("CCD_TEMP", d_img_temperature, d_img_temperature_ind);
	getValueInd ("FWHM", d_img_fwhm, d_img_fwhm_ind);
	getValueInd ("QMAGMAX", d_img_qmagmax, d_img_qmagmax_ind);
	getValueInd ("LIMMAG", d_img_limmag, d_img_limmag_ind);

	{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "insert into images ( img_path , img_id , obs_id , obs_subtype , mount_name , camera_name , img_temperature , img_exposure , img_filter , img_alt , img_az , img_date , img_usec , med_id , process_bitfield , img_fwhm , img_limmag , img_qmagmax ) values ( $1  , $2  , $3  , $4  , $5  , $6  , $7  , $8  , $9  , $10  , $11  , to_timestamp ( $12  ) , $13  , $14  , $15  , $16  , $17  , $18  )", 
	ECPGt_varchar,&(d_img_path),(long)100,(long)1,sizeof(struct varchar_2), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_int,&(d_img_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_int,&(d_obs_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_char,&(d_obs_subtype),(long)1,(long)1,(1)*sizeof(char), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_varchar,&(d_mount_name),(long)8,(long)1,sizeof(struct varchar_3), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_varchar,&(d_camera_name),(long)8,(long)1,sizeof(struct varchar_4), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_float,&(d_img_temperature),(long)1,(long)1,sizeof(float), 
	ECPGt_int,&(d_img_temperature_ind),(long)1,(long)1,sizeof(int), 
	ECPGt_float,&(d_img_exposure),(long)1,(long)1,sizeof(float), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_varchar,&(d_img_filter),(long)3,(long)1,sizeof(struct varchar_5), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_float,&(d_img_alt),(long)1,(long)1,sizeof(float), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_float,&(d_img_az),(long)1,(long)1,sizeof(float), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_int,&(d_img_date),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_int,&(d_img_usec),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_int,&(d_med_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_int,&(d_proccess_bitfield),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_float,&(d_img_fwhm),(long)1,(long)1,sizeof(float), 
	ECPGt_int,&(d_img_fwhm_ind),(long)1,(long)1,sizeof(int), 
	ECPGt_float,&(d_img_limmag),(long)1,(long)1,sizeof(float), 
	ECPGt_int,&(d_img_limmag_ind),(long)1,(long)1,sizeof(int), 
	ECPGt_float,&(d_img_qmagmax),(long)1,(long)1,sizeof(float), 
	ECPGt_int,&(d_img_qmagmax_ind),(long)1,(long)1,sizeof(int), ECPGt_EOIT, ECPGt_EORT);}
#line 274 "imagedb.ec"

	// data found..do just update
	if (sqlca.sqlcode != 0)
	{
		int orig_err = sqlca.sqlcode;
		{ ECPGtrans(__LINE__, NULL, "rollback");}
#line 279 "imagedb.ec"

		{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "update images set img_path = $1  , img_date = to_timestamp ( $2  ) , img_usec = $3  , med_id = $4  , process_bitfield = $5  , img_fwhm = $6  , img_limmag = $7  , img_qmagmax = $8  , img_filter = $9  where img_id = $10  and obs_id = $11 ", 
	ECPGt_varchar,&(d_img_path),(long)100,(long)1,sizeof(struct varchar_2), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_int,&(d_img_date),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_int,&(d_img_usec),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_int,&(d_med_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_int,&(d_proccess_bitfield),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_float,&(d_img_fwhm),(long)1,(long)1,sizeof(float), 
	ECPGt_int,&(d_img_fwhm_ind),(long)1,(long)1,sizeof(int), 
	ECPGt_float,&(d_img_limmag),(long)1,(long)1,sizeof(float), 
	ECPGt_int,&(d_img_limmag_ind),(long)1,(long)1,sizeof(int), 
	ECPGt_float,&(d_img_qmagmax),(long)1,(long)1,sizeof(float), 
	ECPGt_int,&(d_img_qmagmax_ind),(long)1,(long)1,sizeof(int), 
	ECPGt_varchar,&(d_img_filter),(long)3,(long)1,sizeof(struct varchar_5), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_int,&(d_img_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_int,&(d_obs_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EOIT, ECPGt_EORT);}
#line 294 "imagedb.ec"

		// still error.. return -1
		if (sqlca.sqlcode != 0)
		{
			std::ostringstream os;
			os << "image OBJECT update original error " << orig_err << " img_id " << d_img_id << " obs_id " << d_obs_id;
			reportSqlError (os.str ().c_str ());
			{ ECPGtrans(__LINE__, NULL, "rollback");}
#line 301 "imagedb.ec"

			return -1;
		}
	}
	{ ECPGtrans(__LINE__, NULL, "commit");}
#line 305 "imagedb.ec"

	return updateAstrometry ();
}

int ImageSkyDb::updateAstrometry ()
{
	/* exec sql begin declare section */
	    
	    

	 
	 
	 

	 
	
#line 312 "imagedb.ec"
 int d_obs_id = getObsId () ;
 
#line 313 "imagedb.ec"
 int d_img_id = getImgId () ;
 
#line 315 "imagedb.ec"
 double d_img_err_ra ;
 
#line 316 "imagedb.ec"
 double d_img_err_dec ;
 
#line 317 "imagedb.ec"
 double d_img_err ;
 
#line 319 "imagedb.ec"
  struct varchar_6  { int len; char arr[ 2000 ]; }  s_astrometry ;
/* exec sql end declare section */
#line 320 "imagedb.ec"


	long a_naxis[2];
	char *ctype[2];
	double crpix[2];
	double crval[2];
	double cdelt[2];
	double crota[2];
	double equinox;

	ctype[0] = (char *) malloc (50);
	ctype[1] = (char *) malloc (50);

	ctype[0][0] = ctype[1][0] = '\0';

	try
	{
		getValues ("NAXIS", a_naxis, 2);
		getValues ("CTYPE", ctype, 2);
		getValues ("CRPIX", crpix, 2);
		getValues ("CRVAL", crval, 2);
		getValues ("CDELT", cdelt, 2);
		getValues ("CROTA", crota, 2);
		getValue ("EQUINOX", equinox);
	}
	catch (rts2core::Error &er)
	{
		return -1;
	}

	logStream (MESSAGE_DEBUG) << "update astrometry " << getAbsoluteFileName () << ": " << ctype[0] << " " << ctype[1] << sendLog;

	d_img_err_ra = ra_err;
	d_img_err_dec = dec_err;
	if (isnan (img_err))
		d_img_err = getAstrometryErr ();
	else	
		d_img_err = img_err;

	snprintf (s_astrometry.arr, 2000,
		"NAXIS1 %ld NAXIS2 %ld CTYPE1 %s CTYPE2 %s CRPIX1 %f CRPIX2 %f "
		"CRVAL1 %f CRVAL2 %f CDELT1 %f CDELT2 %f CROTA %f EQUINOX %f",
		a_naxis[0], a_naxis[1], ctype[0], ctype[1], crpix[0], crpix[1],
		crval[0], crval[1], cdelt[0], cdelt[1], crota[0], equinox);
	s_astrometry.len = strlen (s_astrometry.arr);

	{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "update images set astrometry = $1  , img_err_ra = $2  , img_err_dec = $3  , img_err = $4  , process_bitfield = process_bitfield | 1 | 2 where obs_id = $5  and img_id = $6 ", 
	ECPGt_varchar,&(s_astrometry),(long)2000,(long)1,sizeof(struct varchar_6), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_double,&(d_img_err_ra),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_double,&(d_img_err_dec),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_double,&(d_img_err),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_int,&(d_obs_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_int,&(d_img_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EOIT, ECPGt_EORT);}
#line 376 "imagedb.ec"

	{ ECPGtrans(__LINE__, NULL, "commit");}
#line 377 "imagedb.ec"

	if (sqlca.sqlcode != 0)
	{
		reportSqlError ("astrometry update");
		return -1;
	}
	processBitfiedl |= ASTROMETRY_PROC | ASTROMETRY_OK;
	return 0;
}

void ImageSkyDb::initDbImage ()
{
	processBitfiedl = 0;
	getValue ("PROC", processBitfiedl);
}

int ImageSkyDb::isCalibrationImage ()
{
	return (getTargetType () == TYPE_CALIBRATION
		|| getTargetType () == TYPE_PHOTOMETRIC);
}

void ImageSkyDb::updateCalibrationDb ()
{
	/* exec sql begin declare section */
		 
		 
		    
		    
	
#line 402 "imagedb.ec"
 int db_air_last_image ;
 
#line 403 "imagedb.ec"
 float db_airmass ;
 
#line 404 "imagedb.ec"
 int db_obs_id = getObsId () ;
 
#line 405 "imagedb.ec"
 int db_img_id = getImgId () ;
/* exec sql end declare section */
#line 406 "imagedb.ec"


	double img_alt;

	// we have calibration image processed..update airmass_cal_images table
	if (isCalibrationImage ())
	{
		try
		{
			getValue ("TEL_ALT", img_alt);
			db_airmass = ln_get_airmass (img_alt, 750.0);
			db_air_last_image = getExposureSec ();
			// delete - unset our old references (if any exists..)
			{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "update airmass_cal_images set air_last_image = to_timestamp ( 0 ) , obs_id = null , img_id = null where obs_id = $1  and img_id = $2 ", 
	ECPGt_int,&(db_obs_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_int,&(db_img_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EOIT, ECPGt_EORT);}
#line 428 "imagedb.ec"


			if (sqlca.sqlcode && sqlca.sqlcode != ECPG_NOT_FOUND)
			{
				reportSqlError ("Image::updateCalibrationDb unseting airmass_cal_images");
				{ ECPGtrans(__LINE__, NULL, "rollback");}
#line 433 "imagedb.ec"

			}
			else
			{
				{ ECPGtrans(__LINE__, NULL, "commit");}
#line 437 "imagedb.ec"

			}
			// if not processed, or processed and not failed..
			if (!(processBitfiedl & ASTROMETRY_PROC)
				|| (processBitfiedl & ASTROMETRY_OK))
			{
				{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "update airmass_cal_images set air_last_image = to_timestamp ( $1  ) , obs_id = $2  , img_id = $3  where air_airmass_start <= $4  and $5  < air_airmass_end and air_last_image <= to_timestamp ( $6  )", 
	ECPGt_int,&(db_air_last_image),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_int,&(db_obs_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_int,&(db_img_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_float,&(db_airmass),(long)1,(long)1,sizeof(float), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_float,&(db_airmass),(long)1,(long)1,sizeof(float), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_int,&(db_air_last_image),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EOIT, ECPGt_EORT);}
#line 453 "imagedb.ec"


				if (sqlca.sqlcode)
				{
					reportSqlError ("Image::toArchive updating airmass_cal_images");
					{ ECPGtrans(__LINE__, NULL, "rollback");}
#line 458 "imagedb.ec"

				}
				else
				{
					{ ECPGtrans(__LINE__, NULL, "commit");}
#line 462 "imagedb.ec"

				}
			}
		}
		catch (rts2core::Error &er)
		{
			logStream (MESSAGE_ERROR) << "cannot update calibration table: " << er << sendLog;
		}
	}
}

ImageSkyDb::ImageSkyDb (Rts2Target *currTarget, rts2core::DevClientCamera * camera, const struct timeval *expStart):ImageDb (currTarget, camera, expStart)
{
	initDbImage ();
}

ImageSkyDb::ImageSkyDb (Image * in_image): ImageDb (in_image)
{
	initDbImage ();
}

ImageSkyDb::ImageSkyDb (int in_obs_id, int in_img_id) : ImageDb (in_obs_id, in_img_id)
{
	initDbImage ();
}

ImageSkyDb::ImageSkyDb (int in_tar_id, int in_obs_id, int in_img_id, char in_obs_subtype, long in_img_date, int in_img_usec, float in_img_exposure, float in_img_temperature, const char *in_img_filter, float in_img_alt, float in_img_az, const char *in_camera_name, const char *in_mount_name, bool in_delete_flag, int in_process_bitfield, double in_img_err_ra, double in_img_err_dec, double in_img_err, const char *_img_path) : ImageDb (in_img_date, in_img_usec, in_img_exposure)
{
	setTargetHeaders (in_tar_id, in_obs_id, in_img_id, in_obs_subtype);
	setCameraName (in_camera_name);
	setMountName (in_mount_name);
	focName = NULL;
	// construct image name..

	ra_err = in_img_err_ra;
	dec_err = in_img_err_dec;
	img_err = in_img_err;

	// TODO fill that..
	pos_astr.ra = rts2_nan ("f");
	pos_astr.dec = rts2_nan ("f");
	processBitfiedl = in_process_bitfield;

	setFilter (in_img_filter);
	setFileName (_img_path);
}

ImageSkyDb::~ImageSkyDb ()
{
}

int ImageSkyDb::toArchive ()
{
	int ret;

	processBitfiedl |= ASTROMETRY_OK | ASTROMETRY_PROC;

	ret = Image::toArchive ();
	if (ret)
	{
		processBitfiedl |= IMG_ERR;
		return ret;
	}

	return 0;
}

int ImageSkyDb::toTrash ()
{
	int ret;

	processBitfiedl &= (~ASTROMETRY_OK);
	processBitfiedl |= ASTROMETRY_PROC;

	ret = Image::toTrash ();
	if (ret)
		return ret;

	return 0;
}

// write changes of image to DB..
int ImageSkyDb::saveImage ()
{
	updateCalibrationDb ();
	if (shouldSaveImage ())
		setValue ("PROC", processBitfiedl, "procesing status; info in DB");
	return ImageDb::saveImage ();
}

int ImageSkyDb::deleteFormDB ()
{
	/* exec sql begin declare section */
	    
	    
	
#line 555 "imagedb.ec"
 int d_img_id = getImgId () ;
 
#line 556 "imagedb.ec"
 int d_obs_id = getObsId () ;
/* exec sql end declare section */
#line 557 "imagedb.ec"


	if (getImageType () == IMGTYPE_OBJECT)
	{
		{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "delete from images where img_id = $1  and obs_id = $2 ", 
	ECPGt_int,&(d_img_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_int,&(d_obs_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EOIT, ECPGt_EORT);}
#line 566 "imagedb.ec"

	}
	if (sqlca.sqlcode)
	{
		reportSqlError ("ImageSkyDb::deleteImage");
		{ ECPGtrans(__LINE__, NULL, "rollback");}
#line 571 "imagedb.ec"

		return -1;
	}
	{ ECPGtrans(__LINE__, NULL, "commit");}
#line 574 "imagedb.ec"

	return 0;
}

int ImageSkyDb::deleteImage ()
{
	deleteFromDB ();
	return Image::deleteImage ();
}

std::string ImageSkyDb::getFileNameString ()
{
	std::ostringstream out;
	printFileName (out);
	return out.str();
}
