/* Processed by ecpg (4.7.0) */
/* These include files are added by the preprocessor */
#include <ecpglib.h>
#include <ecpgerrno.h>
#include <sqlca.h>
/* End of automatic include section */

#line 1 "rts2devcliphot.ec"
/**
 * Executor client for photometer.
 * Copyright (C) 2005-2007 Petr Kubanek <petr@kubanek.net>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#include "rts2devcliphot.h"


#line 1 "/usr/include/sqlca.h"
#ifndef POSTGRES_SQLCA_H
#define POSTGRES_SQLCA_H

#ifndef PGDLLIMPORT
#if  defined(WIN32) || defined(__CYGWIN__)
#define PGDLLIMPORT __declspec (dllimport)
#else
#define PGDLLIMPORT
#endif   /* __CYGWIN__ */
#endif   /* PGDLLIMPORT */

#define SQLERRMC_LEN	150

#ifdef __cplusplus
extern		"C"
{
#endif

struct sqlca_t
{
	char		sqlcaid[8];
	long		sqlabc;
	long		sqlcode;
	struct
	{
		int			sqlerrml;
		char		sqlerrmc[SQLERRMC_LEN];
	}			sqlerrm;
	char		sqlerrp[8];
	long		sqlerrd[6];
	/* Element 0: empty						*/
	/* 1: OID of processed tuple if applicable			*/
	/* 2: number of rows processed				*/
	/* after an INSERT, UPDATE or				*/
	/* DELETE statement					*/
	/* 3: empty						*/
	/* 4: empty						*/
	/* 5: empty						*/
	char		sqlwarn[8];
	/* Element 0: set to 'W' if at least one other is 'W'	*/
	/* 1: if 'W' at least one character string		*/
	/* value was truncated when it was			*/
	/* stored into a host variable.				*/

	/*
	 * 2: if 'W' a (hopefully) non-fatal notice occurred
	 */	/* 3: empty */
	/* 4: empty						*/
	/* 5: empty						*/
	/* 6: empty						*/
	/* 7: empty						*/

	char		sqlstate[5];
};

struct sqlca_t *ECPGget_sqlca(void);

#ifndef POSTGRES_ECPG_INTERNAL
#define sqlca (*ECPGget_sqlca())
#endif

#ifdef __cplusplus
}
#endif

#endif

#line 22 "rts2devcliphot.ec"


using namespace rts2script;

DevClientPhotExec::DevClientPhotExec (rts2core::Connection * in_connection):DevClientPhot (in_connection),DevScript (in_connection)
{
	minFlux = 20;
}


DevClientPhotExec::~DevClientPhotExec ()
{
	deleteScript ();
}

void DevClientPhotExec::integrationStart ()
{
	if (currentTarget)
		currentTarget->startObservation ();
	DevClientPhot::integrationStart ();
}

void DevClientPhotExec::integrationEnd ()
{
	nextCommand ();
	DevClientPhot::integrationEnd ();
}

void DevClientPhotExec::integrationFailed (int status)
{
	nextCommand ();
	DevClientPhot::integrationFailed (status);
}

void DevClientPhotExec::addCount (int count, float exp, bool is_ov)
{
	/* exec sql begin declare section */
	 
	 
	 
	 
	 
	 
	 
	 
	 
	
#line 59 "rts2devcliphot.ec"
 int d_obs_id ;
 
#line 60 "rts2devcliphot.ec"
 int d_count_value ;
 
#line 61 "rts2devcliphot.ec"
 double d_count_date ;
 
#line 62 "rts2devcliphot.ec"
 int d_count_usec ;
 
#line 63 "rts2devcliphot.ec"
 float d_count_exposure ;
 
#line 64 "rts2devcliphot.ec"
 char d_count_filter ;
 
#line 65 "rts2devcliphot.ec"
 double d_count_ra ;
 
#line 66 "rts2devcliphot.ec"
 double d_count_dec ;
 
#line 67 "rts2devcliphot.ec"
  struct varchar_1  { int len; char arr[ 8 ]; }  d_counter_name ;
/* exec sql end declare section */
#line 68 "rts2devcliphot.ec"

	if ((connection->getState () & PHOT_MASK_INTEGRATE) != PHOT_INTEGRATE)
	{
		return;
	}

	if (!currentTarget)
		return;

	struct ln_equ_posn actRaDec;
	struct timeval now;

	if (is_ov)
	{
		logStream (MESSAGE_DEBUG) << "DevClientPhotExec::addCount is_ov" << sendLog;
		return;
	}

	gettimeofday (&now, NULL);

	actRaDec.ra = -1000;
	actRaDec.dec = -1000;

	getMaster ()->postEvent (new rts2core::Event (EVENT_GET_RADEC, (void *) &actRaDec));

	d_obs_id = currentTarget->getObsId ();
	d_count_date = now.tv_sec + now.tv_usec / USEC_SEC;
	d_count_usec = now.tv_usec;
	d_count_value = count;
	d_count_exposure = exp;
	d_count_filter = getConnection ()->getValueInteger ("filter") + '0';
	d_count_ra = actRaDec.ra;
	d_count_dec = actRaDec.dec;

	strncpy (d_counter_name.arr, connection->getName (), 8);
	d_counter_name.len = strlen (connection->getName ());
	if (d_counter_name.len > 8)
		d_counter_name.len = 8;

	{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "insert into counts ( obs_id , count_date , count_usec , count_value , count_exposure , count_filter , count_ra , count_dec , counter_name ) values ( $1  , to_timestamp ( $2  ) , $3  , $4  , $5  , $6  , $7  , $8  , $9  )", 
	ECPGt_int,&(d_obs_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_double,&(d_count_date),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_int,&(d_count_usec),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_int,&(d_count_value),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_float,&(d_count_exposure),(long)1,(long)1,sizeof(float), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_char,&(d_count_filter),(long)1,(long)1,(1)*sizeof(char), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_double,&(d_count_ra),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_double,&(d_count_dec),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_varchar,&(d_counter_name),(long)8,(long)1,sizeof(struct varchar_1), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EOIT, ECPGt_EORT);}
#line 131 "rts2devcliphot.ec"


	if (sqlca.sqlcode != 0)
	{
		logStream (MESSAGE_ERROR) << "DevClientPhotExec::addCount db error " << sqlca.sqlerrm.sqlerrmc << sendLog;
		{ ECPGtrans(__LINE__, NULL, "rollback");}
#line 136 "rts2devcliphot.ec"

	}
	else
	{
		{ ECPGtrans(__LINE__, NULL, "commit");}
#line 140 "rts2devcliphot.ec"

	}
}

int DevClientPhotExec::getNextCommand ()
{
	return getScript()->nextCommand (*this, &nextComd, cmd_device);
}

void DevClientPhotExec::postEvent (rts2core::Event * event)
{
	DevScript::postEvent (new rts2core::Event (event));
	DevClientPhot::postEvent (event);
}

void DevClientPhotExec::nextCommand (rts2core::Command *triggerCommand)
{
	if (scriptKillCommand && triggerCommand == scriptKillCommand)
	{
		if (currentTarget == NULL && killTarget != NULL)
			DevScript::postEvent (new rts2core::Event (scriptKillcallScriptEnds ? EVENT_SET_TARGET : EVENT_SET_TARGET_NOT_CLEAR, killTarget));
		killTarget = NULL;
		scriptKillCommand = NULL;
		scriptKillcallScriptEnds = false;
	}
	int ret = haveNextCommand (this);
	if (!ret)
		return;

	if (currentTarget && !currentTarget->wasMoved ())
		return;

	connection->queCommand (nextComd);
	nextComd = NULL;               // after command execute, it will be deleted
}

void DevClientPhotExec::filterMoveEnd ()
{
	if ((connection->getState () & PHOT_MASK_INTEGRATE) != PHOT_INTEGRATE)
		nextCommand ();
}

void DevClientPhotExec::filterMoveFailed (int status)
{
	deleteScript ();
}
