/* Processed by ecpg (4.7.0) */
/* These include files are added by the preprocessor */
#include <ecpglib.h>
#include <ecpgerrno.h>
#include <sqlca.h>
/* End of automatic include section */

#line 1 "valueeventsdb.ec"
/* 
 * Value changes triggering infrastructure. 
 * Copyright (C) 2009 Petr Kubanek <petr@kubanek.net>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#include "xmlrpcd.h"

#include "rts2db/recvals.h"
#include "rts2db/sqlerror.h"


#line 1 "/usr/include/postgresql/sqlca.h"
#ifndef POSTGRES_SQLCA_H
#define POSTGRES_SQLCA_H

#ifndef PGDLLIMPORT
#if  defined(WIN32) || defined(__CYGWIN__)
#define PGDLLIMPORT __declspec (dllimport)
#else
#define PGDLLIMPORT
#endif   /* __CYGWIN__ */
#endif   /* PGDLLIMPORT */

#define SQLERRMC_LEN	150

#ifdef __cplusplus
extern		"C"
{
#endif

struct sqlca_t
{
	char		sqlcaid[8];
	long		sqlabc;
	long		sqlcode;
	struct
	{
		int			sqlerrml;
		char		sqlerrmc[SQLERRMC_LEN];
	}			sqlerrm;
	char		sqlerrp[8];
	long		sqlerrd[6];
	/* Element 0: empty						*/
	/* 1: OID of processed tuple if applicable			*/
	/* 2: number of rows processed				*/
	/* after an INSERT, UPDATE or				*/
	/* DELETE statement					*/
	/* 3: empty						*/
	/* 4: empty						*/
	/* 5: empty						*/
	char		sqlwarn[8];
	/* Element 0: set to 'W' if at least one other is 'W'	*/
	/* 1: if 'W' at least one character string		*/
	/* value was truncated when it was			*/
	/* stored into a host variable.				*/

	/*
	 * 2: if 'W' a (hopefully) non-fatal notice occurred
	 */	/* 3: empty */
	/* 4: empty						*/
	/* 5: empty						*/
	/* 6: empty						*/
	/* 7: empty						*/

	char		sqlstate[5];
};

struct sqlca_t *ECPGget_sqlca(void);

#ifndef POSTGRES_ECPG_INTERNAL
#define sqlca (*ECPGget_sqlca())
#endif

#ifdef __cplusplus
}
#endif

#endif

#line 25 "valueeventsdb.ec"


using namespace rts2xmlrpc;

int ValueChangeRecord::getRecvalId (const char *suffix, int recval_type)
{
	/* exec sql begin declare section */
	 
	 
	 
	   
	
#line 32 "valueeventsdb.ec"
 int db_recval_id ;
 
#line 33 "valueeventsdb.ec"
  struct varchar_1  { int len; char arr[ 25 ]; }  db_device_name ;
 
#line 34 "valueeventsdb.ec"
  struct varchar_2  { int len; char arr[ 26 ]; }  db_value_name ;
 
#line 35 "valueeventsdb.ec"
 int db_recval_type = recval_type ;
/* exec sql end declare section */
#line 36 "valueeventsdb.ec"


	std::map <const char *, int>::iterator iter = dbValueIds.find (suffix);

	if (iter != dbValueIds.end ())
		return iter->second;

	db_device_name.len = deviceName.length ();
	if (db_device_name.len > 25)
		db_device_name.len = 25;
	strncpy (db_device_name.arr, deviceName.c_str (), db_device_name.len);

	db_value_name.len = valueName.length ();
	if (db_value_name.len > 25)
		db_value_name.len = 25;
	strncpy (db_value_name.arr, valueName.c_str (), db_value_name.len);
	db_value_name.arr[db_value_name.len] = '\0';
	if (suffix != NULL)
	{
		strncat (db_value_name.arr, suffix, 25 - db_value_name.len);
		db_value_name.len += strlen (suffix);
		if (db_value_name.len > 25)
			db_value_name.len = 25;
	}
	{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "select recval_id from recvals where device_name = $1  and value_name = $2 ", 
	ECPGt_varchar,&(db_device_name),(long)25,(long)1,sizeof(struct varchar_1), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_varchar,&(db_value_name),(long)26,(long)1,sizeof(struct varchar_2), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EOIT, 
	ECPGt_int,&(db_recval_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EORT);}
#line 61 "valueeventsdb.ec"

	if (sqlca.sqlcode)
	{
		if (sqlca.sqlcode == ECPG_NOT_FOUND)
		{
			// insert new record
			{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "select nextval ( 'recval_ids' )", ECPGt_EOIT, 
	ECPGt_int,&(db_recval_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EORT);}
#line 67 "valueeventsdb.ec"

			{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "insert into recvals values ( $1  , $2  , $3  , $4  )", 
	ECPGt_int,&(db_recval_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_varchar,&(db_device_name),(long)25,(long)1,sizeof(struct varchar_1), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_varchar,&(db_value_name),(long)26,(long)1,sizeof(struct varchar_2), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_int,&(db_recval_type),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EOIT, ECPGt_EORT);}
#line 68 "valueeventsdb.ec"

			if (sqlca.sqlcode)
				throw rts2db::SqlError ();
		}
		else
		{
			throw rts2db::SqlError ();
		}
	}

	dbValueIds[suffix] = db_recval_id;

	return db_recval_id;
}

void ValueChangeRecord::recordValueInteger (int recval_id, int val, double validTime)
{
	/* exec sql begin declare section */
	   
	    
	   
	
#line 86 "valueeventsdb.ec"
 int db_recval_id = recval_id ;
 
#line 87 "valueeventsdb.ec"
 int db_value = val ;
 
#line 88 "valueeventsdb.ec"
 double db_rectime = validTime ;
/* exec sql end declare section */
#line 89 "valueeventsdb.ec"


	{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "insert into records_integer values ( $1  , to_timestamp ( $2  ) , $3  )", 
	ECPGt_int,&(db_recval_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_double,&(db_rectime),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_int,&(db_value),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EOIT, ECPGt_EORT);}
#line 97 "valueeventsdb.ec"


	if (sqlca.sqlcode)
		throw rts2db::SqlError ();
}

void ValueChangeRecord::recordValueDouble (int recval_id, double val, double validTime)
{
	/* exec sql begin declare section */
	   
	    
	   
	
#line 106 "valueeventsdb.ec"
 int db_recval_id = recval_id ;
 
#line 107 "valueeventsdb.ec"
 double db_value = val ;
 
#line 108 "valueeventsdb.ec"
 double db_rectime = validTime ;
/* exec sql end declare section */
#line 109 "valueeventsdb.ec"


	{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "insert into records_double values ( $1  , to_timestamp ( $2  ) , $3  )", 
	ECPGt_int,&(db_recval_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_double,&(db_rectime),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_double,&(db_value),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EOIT, ECPGt_EORT);}
#line 117 "valueeventsdb.ec"


	if (sqlca.sqlcode)
		throw rts2db::SqlError ();
}

void ValueChangeRecord::recordValueBoolean (int recval_id, bool val, double validTime)
{
	/* exec sql begin declare section */
	   
	   
	   
	
#line 126 "valueeventsdb.ec"
 int db_recval_id = recval_id ;
 
#line 127 "valueeventsdb.ec"
 bool db_value = val ;
 
#line 128 "valueeventsdb.ec"
 double db_rectime = validTime ;
/* exec sql end declare section */
#line 129 "valueeventsdb.ec"


	{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "insert into records_boolean values ( $1  , to_timestamp ( $2  ) , $3  )", 
	ECPGt_int,&(db_recval_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_double,&(db_rectime),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_bool,&(db_value),(long)1,(long)1,sizeof(bool), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EOIT, ECPGt_EORT);}
#line 137 "valueeventsdb.ec"


	if (sqlca.sqlcode)
		throw rts2db::SqlError ();
}

void ValueChangeRecord::run (rts2core::Value *val, double validTime)
{

	std::ostringstream _os;

	switch (val->getValueBaseType ())
	{
		case RTS2_VALUE_INTEGER:
			recordValueInteger (getRecvalId (NULL, RTS2_VALUE_INTEGER | val->getValueDisplayType ()), val->getValueInteger (), validTime);
			break;
		case RTS2_VALUE_DOUBLE:
		case RTS2_VALUE_FLOAT:
			recordValueDouble (getRecvalId (NULL, RTS2_VALUE_DOUBLE | val->getValueDisplayType ()), val->getValueDouble (), validTime);
			break;
		case RTS2_VALUE_RADEC:
			recordValueDouble (getRecvalId ("RA", RTS2_VALUE_DOUBLE | RTS2_DT_RA), ((rts2core::ValueRaDec *) val)->getRa (), validTime);
			recordValueDouble (getRecvalId ("DEC", RTS2_VALUE_DOUBLE | RTS2_DT_DEC), ((rts2core::ValueRaDec *) val)->getDec (), validTime);
			break;
		case RTS2_VALUE_ALTAZ:
			recordValueDouble (getRecvalId ("ALT", RTS2_VALUE_DOUBLE | RTS2_DT_DEGREES), ((rts2core::ValueAltAz *) val)->getAlt (), validTime);
			recordValueDouble (getRecvalId ("AZ", RTS2_VALUE_DOUBLE | RTS2_DT_DEGREES), ((rts2core::ValueAltAz *) val)->getAz (), validTime);
			break;
		case RTS2_VALUE_BOOL:
			recordValueBoolean (getRecvalId (NULL, RTS2_VALUE_BOOL), ((rts2core::ValueBool *) val)->getValueBool (), validTime);
			break;
		default:
			_os << "Cannot record value " << valueName.c_str ();
			throw rts2core::Error (_os.str ());
	}
	{ ECPGtrans(__LINE__, NULL, "commit");}
#line 172 "valueeventsdb.ec"

	if (sqlca.sqlcode)
		throw rts2db::SqlError ();
}
