/*!
* This Source Code Form is subject to the terms of the Mozilla Public
* License, v. 2.0. If a copy of the MPL was not distributed with this file,
* You can obtain one at http://mozilla.org/MPL/2.0/.
*
* Copyright(c) 2012 Apogee Instruments, Inc.
* \brief This namespace contains the camera meta data
*   created on Wed Apr 18 11:42:08 2012
*
*/
#include "camMetaData.h"

bool camMetaData::getMetaFxPtr( const uint16_t id, camMetaData::getMetaPtr & out )
{
    std::map<uint16_t, camMetaData::getMetaPtr> fxMap;
    camMetaData::getIdMetaFxMap( fxMap );
    std::map<uint16_t, camMetaData::getMetaPtr>::iterator iter = fxMap.find(id);
    if( iter != fxMap.end() )
    {
         out = (*iter).second;
         return true;
     }
     return false;
}

void camMetaData::getIdMetaFxMap(std::map<uint16_t, camMetaData::getMetaPtr> & out )
{
    out.clear();

    out[0] = camMetaData::getMeta0;
    out[1] = camMetaData::getMeta1;
    out[2] = camMetaData::getMeta2;
    out[3] = camMetaData::getMeta3;
    out[4] = camMetaData::getMeta4;
    out[5] = camMetaData::getMeta5;
    out[6] = camMetaData::getMeta6;
    out[7] = camMetaData::getMeta7;
    out[8] = camMetaData::getMeta8;
    out[9] = camMetaData::getMeta9;
    out[10] = camMetaData::getMeta10;
    out[12] = camMetaData::getMeta12;
    out[14] = camMetaData::getMeta14;
    out[16] = camMetaData::getMeta16;
    out[17] = camMetaData::getMeta17;
    out[18] = camMetaData::getMeta18;
    out[19] = camMetaData::getMeta19;
    out[20] = camMetaData::getMeta20;
    out[21] = camMetaData::getMeta21;
    out[22] = camMetaData::getMeta22;
    out[23] = camMetaData::getMeta23;
    out[24] = camMetaData::getMeta24;
    out[26] = camMetaData::getMeta26;
    out[30] = camMetaData::getMeta30;
    out[31] = camMetaData::getMeta31;
    out[32] = camMetaData::getMeta32;
    out[33] = camMetaData::getMeta33;
    out[34] = camMetaData::getMeta34;
    out[35] = camMetaData::getMeta35;
    out[36] = camMetaData::getMeta36;
    out[37] = camMetaData::getMeta37;
    out[38] = camMetaData::getMeta38;
    out[39] = camMetaData::getMeta39;
    out[40] = camMetaData::getMeta40;
    out[41] = camMetaData::getMeta41;
    out[42] = camMetaData::getMeta42;
    out[43] = camMetaData::getMeta43;
    out[44] = camMetaData::getMeta44;
    out[60] = camMetaData::getMeta60;
    out[11] = camMetaData::getMeta11;
    out[15] = camMetaData::getMeta15;
    out[13] = camMetaData::getMeta13;
    out[45] = camMetaData::getMeta45;
    out[46] = camMetaData::getMeta46;
    out[47] = camMetaData::getMeta47;
    out[48] = camMetaData::getMeta48;
    out[49] = camMetaData::getMeta49;
    out[50] = camMetaData::getMeta50;
    out[51] = camMetaData::getMeta51;
    out[52] = camMetaData::getMeta52;
    out[53] = camMetaData::getMeta53;
    out[54] = camMetaData::getMeta54;
    out[55] = camMetaData::getMeta55;
    out[56] = camMetaData::getMeta56;
    out[57] = camMetaData::getMeta57;
    out[59] = camMetaData::getMeta59;
    out[58] = camMetaData::getMeta58;
    out[61] = camMetaData::getMeta61;
    out[62] = camMetaData::getMeta62;
    out[63] = camMetaData::getMeta63;
    out[25] = camMetaData::getMeta25;
    out[27] = camMetaData::getMeta27;
    out[76] = camMetaData::getMeta76;
    out[77] = camMetaData::getMeta77;
    out[64] = camMetaData::getMeta64;
    out[65] = camMetaData::getMeta65;
    out[66] = camMetaData::getMeta66;
    out[67] = camMetaData::getMeta67;
    out[68] = camMetaData::getMeta68;
    out[69] = camMetaData::getMeta69;
    out[70] = camMetaData::getMeta70;
    out[71] = camMetaData::getMeta71;
    out[72] = camMetaData::getMeta72;
    out[73] = camMetaData::getMeta73;
    out[74] = camMetaData::getMeta74;
    out[75] = camMetaData::getMeta75;
    out[78] = camMetaData::getMeta78;
    out[256] = camMetaData::getMeta256;
    out[257] = camMetaData::getMeta257;
    out[258] = camMetaData::getMeta258;
    out[259] = camMetaData::getMeta259;
    out[260] = camMetaData::getMeta260;
    out[261] = camMetaData::getMeta261;
    out[262] = camMetaData::getMeta262;
    out[263] = camMetaData::getMeta263;
    out[264] = camMetaData::getMeta264;
    out[265] = camMetaData::getMeta265;
    out[266] = camMetaData::getMeta266;
    out[267] = camMetaData::getMeta267;
    out[268] = camMetaData::getMeta268;
    out[269] = camMetaData::getMeta269;
    out[270] = camMetaData::getMeta270;
    out[271] = camMetaData::getMeta271;
    out[272] = camMetaData::getMeta272;
    out[273] = camMetaData::getMeta273;
    out[274] = camMetaData::getMeta274;
    out[275] = camMetaData::getMeta275;
    out[276] = camMetaData::getMeta276;
    out[277] = camMetaData::getMeta277;
    out[278] = camMetaData::getMeta278;
    out[279] = camMetaData::getMeta279;
    out[280] = camMetaData::getMeta280;
    out[384] = camMetaData::getMeta384;
    out[386] = camMetaData::getMeta386;
    out[387] = camMetaData::getMeta387;
    out[427] = camMetaData::getMeta427;
    out[511] = camMetaData::getMeta511;
    out[281] = camMetaData::getMeta281;
    out[412] = camMetaData::getMeta412;
    out[403] = camMetaData::getMeta403;
    out[388] = camMetaData::getMeta388;
    out[389] = camMetaData::getMeta389;
}


void camMetaData::getMeta0(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "KAF0401E";
    out.CameraId = 0;
    out.CameraLine = "Alta";
    out.CameraModel = "1";
    out.InterlineCCD = 0;
    out.SupportsSerialA = 1;
    out.SupportsSerialB = 1;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 796;
    out.ImagingColumns = 768;
    out.ClampColumns = 14;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 14;
    out.TotalRows = 520;
    out.ImagingRows = 512;
    out.UnderscanRows = 4;
    out.OverscanRows = 4;
    out.VFlushBinning = 1;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 100;
    out.PixelSizeX = 9;
    out.PixelSizeY = 9;
    out.Color = 0;
    out.ReportedGainSixteenBit = 1.5;
    out.MinSuggestedExpTime = 10;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -20;
    out.TempRampRateOne = 700;
    out.TempRampRateTwo = 4000;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Alta_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Alta_Twelve;
    out.PrimaryADLatency = 1;
    out.AlternativeADLatency = 12;
    out.IRPreflashTime = 160;
    out.AdCfg = 8;
    out.DefaultGainLeft = 0;
    out.DefaultOffsetLeft = 100;
    out.DefaultGainRight = 0;
    out.DefaultOffsetRight = 0;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 0;
    out.VideoSubSample = 1;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "KV1";
    out.ClampPatternNormal = "K16HC1";
    out.SkipPatternNormal = "K16HS1";
    out.RoiPatternNormal = "K16HR1";
    out.ClampPatternFast = "K12HC4";
    out.SkipPatternFast = "K12HS4";
    out.RoiPatternFast = "K12HR4";
    out.VerticalPatternVideo= "NoOpV";
    out.ClampPatternVideo = "NoOpH";
    out.SkipPatternVideo = "NoOpH";
    out.RoiPatternVideo = "NoOpH";
}


void camMetaData::getMeta1(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "KAF1602E";
    out.CameraId = 1;
    out.CameraLine = "Alta";
    out.CameraModel = "2";
    out.InterlineCCD = 0;
    out.SupportsSerialA = 1;
    out.SupportsSerialB = 1;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 1564;
    out.ImagingColumns = 1536;
    out.ClampColumns = 14;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 14;
    out.TotalRows = 1032;
    out.ImagingRows = 1024;
    out.UnderscanRows = 4;
    out.OverscanRows = 4;
    out.VFlushBinning = 1;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 100;
    out.PixelSizeX = 9;
    out.PixelSizeY = 9;
    out.Color = 0;
    out.ReportedGainSixteenBit = 1.5;
    out.MinSuggestedExpTime = 10;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -20;
    out.TempRampRateOne = 700;
    out.TempRampRateTwo = 4000;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Alta_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Alta_Twelve;
    out.PrimaryADLatency = 1;
    out.AlternativeADLatency = 12;
    out.IRPreflashTime = 160;
    out.AdCfg = 8;
    out.DefaultGainLeft = 0;
    out.DefaultOffsetLeft = 100;
    out.DefaultGainRight = 0;
    out.DefaultOffsetRight = 0;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 0;
    out.VideoSubSample = 1;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "KV1";
    out.ClampPatternNormal = "K16HC1";
    out.SkipPatternNormal = "K16HS1";
    out.RoiPatternNormal = "K16HR1";
    out.ClampPatternFast = "K12HC4";
    out.SkipPatternFast = "K12HS4";
    out.RoiPatternFast = "K12HR4";
    out.VerticalPatternVideo= "NoOpV";
    out.ClampPatternVideo = "NoOpH";
    out.SkipPatternVideo = "NoOpH";
    out.RoiPatternVideo = "NoOpH";
}


void camMetaData::getMeta2(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "KAF0261E";
    out.CameraId = 2;
    out.CameraLine = "Alta";
    out.CameraModel = "260";
    out.InterlineCCD = 0;
    out.SupportsSerialA = 1;
    out.SupportsSerialB = 1;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 530;
    out.ImagingColumns = 512;
    out.ClampColumns = 8;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 10;
    out.TotalRows = 520;
    out.ImagingRows = 512;
    out.UnderscanRows = 4;
    out.OverscanRows = 4;
    out.VFlushBinning = 1;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 200;
    out.PixelSizeX = 20;
    out.PixelSizeY = 20;
    out.Color = 0;
    out.ReportedGainSixteenBit = 3;
    out.MinSuggestedExpTime = 10;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -20;
    out.TempRampRateOne = 700;
    out.TempRampRateTwo = 4000;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Alta_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Alta_Twelve;
    out.PrimaryADLatency = 1;
    out.AlternativeADLatency = 12;
    out.IRPreflashTime = 160;
    out.AdCfg = 8;
    out.DefaultGainLeft = 0;
    out.DefaultOffsetLeft = 250;
    out.DefaultGainRight = 0;
    out.DefaultOffsetRight = 0;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 0;
    out.VideoSubSample = 1;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "KV1";
    out.ClampPatternNormal = "K16HC1";
    out.SkipPatternNormal = "K16HS1";
    out.RoiPatternNormal = "K16HR1";
    out.ClampPatternFast = "K12HC4";
    out.SkipPatternFast = "K12HS4";
    out.RoiPatternFast = "K12HR4";
    out.VerticalPatternVideo= "NoOpV";
    out.ClampPatternVideo = "NoOpH";
    out.SkipPatternVideo = "NoOpH";
    out.RoiPatternVideo = "NoOpH";
}


void camMetaData::getMeta3(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "KAF1301E";
    out.CameraId = 3;
    out.CameraLine = "Alta";
    out.CameraModel = "13";
    out.InterlineCCD = 0;
    out.SupportsSerialA = 1;
    out.SupportsSerialB = 1;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 1305;
    out.ImagingColumns = 1280;
    out.ClampColumns = 4;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 21;
    out.TotalRows = 1028;
    out.ImagingRows = 1024;
    out.UnderscanRows = 2;
    out.OverscanRows = 2;
    out.VFlushBinning = 1;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 300;
    out.PixelSizeX = 16;
    out.PixelSizeY = 16;
    out.Color = 0;
    out.ReportedGainSixteenBit = 3;
    out.MinSuggestedExpTime = 20;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -20;
    out.TempRampRateOne = 700;
    out.TempRampRateTwo = 4000;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Alta_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Alta_Twelve;
    out.PrimaryADLatency = 1;
    out.AlternativeADLatency = 12;
    out.IRPreflashTime = 160;
    out.AdCfg = 8;
    out.DefaultGainLeft = 0;
    out.DefaultOffsetLeft = 200;
    out.DefaultGainRight = 0;
    out.DefaultOffsetRight = 0;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 0;
    out.VideoSubSample = 1;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "KV1";
    out.ClampPatternNormal = "K16HC1";
    out.SkipPatternNormal = "K16HS1";
    out.RoiPatternNormal = "K16HR1";
    out.ClampPatternFast = "K12HC4";
    out.SkipPatternFast = "K12HS4";
    out.RoiPatternFast = "K12HR4";
    out.VerticalPatternVideo= "NoOpV";
    out.ClampPatternVideo = "NoOpH";
    out.SkipPatternVideo = "NoOpH";
    out.RoiPatternVideo = "NoOpH";
}


void camMetaData::getMeta4(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "KAF09000";
    out.CameraId = 4;
    out.CameraLine = "Alta";
    out.CameraModel = "9000";
    out.InterlineCCD = 0;
    out.SupportsSerialA = 1;
    out.SupportsSerialB = 1;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 3103;
    out.ImagingColumns = 3056;
    out.ClampColumns = 35;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 12;
    out.TotalRows = 3086;
    out.ImagingRows = 3056;
    out.UnderscanRows = 20;
    out.OverscanRows = 10;
    out.VFlushBinning = 1;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 300;
    out.PixelSizeX = 12;
    out.PixelSizeY = 12;
    out.Color = 0;
    out.ReportedGainSixteenBit = 1.5;
    out.MinSuggestedExpTime = 30;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -20;
    out.TempRampRateOne = 1500;
    out.TempRampRateTwo = 4000;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Alta_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Alta_Twelve;
    out.PrimaryADLatency = 1;
    out.AlternativeADLatency = 12;
    out.IRPreflashTime = 160;
    out.AdCfg = 8;
    out.DefaultGainLeft = 0;
    out.DefaultOffsetLeft = 150;
    out.DefaultGainRight = 0;
    out.DefaultOffsetRight = 0;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 0;
    out.VideoSubSample = 1;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "KV7";
    out.ClampPatternNormal = "K16HS7";
    out.SkipPatternNormal = "K16HS7";
    out.RoiPatternNormal = "K16HR7";
    out.ClampPatternFast = "K12HC7";
    out.SkipPatternFast = "K12HS7";
    out.RoiPatternFast = "K12HR7";
    out.VerticalPatternVideo= "NoOpV";
    out.ClampPatternVideo = "NoOpH";
    out.SkipPatternVideo = "NoOpH";
    out.RoiPatternVideo = "NoOpH";
}


void camMetaData::getMeta5(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "KAF1001E";
    out.CameraId = 5;
    out.CameraLine = "Alta";
    out.CameraModel = "6";
    out.InterlineCCD = 0;
    out.SupportsSerialA = 1;
    out.SupportsSerialB = 1;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 1044;
    out.ImagingColumns = 1024;
    out.ClampColumns = 8;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 12;
    out.TotalRows = 1032;
    out.ImagingRows = 1024;
    out.UnderscanRows = 4;
    out.OverscanRows = 4;
    out.VFlushBinning = 1;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 300;
    out.PixelSizeX = 24;
    out.PixelSizeY = 24;
    out.Color = 0;
    out.ReportedGainSixteenBit = 3;
    out.MinSuggestedExpTime = 20;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -20;
    out.TempRampRateOne = 700;
    out.TempRampRateTwo = 4000;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Alta_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Alta_Twelve;
    out.PrimaryADLatency = 1;
    out.AlternativeADLatency = 12;
    out.IRPreflashTime = 160;
    out.AdCfg = 8;
    out.DefaultGainLeft = 0;
    out.DefaultOffsetLeft = 250;
    out.DefaultGainRight = 0;
    out.DefaultOffsetRight = 0;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 0;
    out.VideoSubSample = 1;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "KV1";
    out.ClampPatternNormal = "K16HC1";
    out.SkipPatternNormal = "K16HS1";
    out.RoiPatternNormal = "K16HR1";
    out.ClampPatternFast = "K12HC4";
    out.SkipPatternFast = "K12HS4";
    out.RoiPatternFast = "K12HR4";
    out.VerticalPatternVideo= "NoOpV";
    out.ClampPatternVideo = "NoOpH";
    out.SkipPatternVideo = "NoOpH";
    out.RoiPatternVideo = "NoOpH";
}


void camMetaData::getMeta6(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "KAF3200E";
    out.CameraId = 6;
    out.CameraLine = "Alta";
    out.CameraModel = "32";
    out.InterlineCCD = 0;
    out.SupportsSerialA = 1;
    out.SupportsSerialB = 1;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 2267;
    out.ImagingColumns = 2184;
    out.ClampColumns = 46;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 37;
    out.TotalRows = 1510;
    out.ImagingRows = 1472;
    out.UnderscanRows = 34;
    out.OverscanRows = 4;
    out.VFlushBinning = 1;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 100;
    out.PixelSizeX = 6.8;
    out.PixelSizeY = 6.8;
    out.Color = 0;
    out.ReportedGainSixteenBit = 1;
    out.MinSuggestedExpTime = 10;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -20;
    out.TempRampRateOne = 700;
    out.TempRampRateTwo = 4000;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Alta_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Alta_Twelve;
    out.PrimaryADLatency = 1;
    out.AlternativeADLatency = 12;
    out.IRPreflashTime = 160;
    out.AdCfg = 8;
    out.DefaultGainLeft = 100;
    out.DefaultOffsetLeft = 100;
    out.DefaultGainRight = 0;
    out.DefaultOffsetRight = 0;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 0;
    out.VideoSubSample = 1;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "KV2";
    out.ClampPatternNormal = "K16HC2";
    out.SkipPatternNormal = "K16HS2";
    out.RoiPatternNormal = "K16HR2";
    out.ClampPatternFast = "K12HC2";
    out.SkipPatternFast = "K12HS2";
    out.RoiPatternFast = "K12HR2";
    out.VerticalPatternVideo= "NoOpV";
    out.ClampPatternVideo = "NoOpH";
    out.SkipPatternVideo = "NoOpH";
    out.RoiPatternVideo = "NoOpH";
}


void camMetaData::getMeta7(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "KAF3200EB";
    out.CameraId = 7;
    out.CameraLine = "Alta";
    out.CameraModel = "32";
    out.InterlineCCD = 0;
    out.SupportsSerialA = 1;
    out.SupportsSerialB = 1;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 2267;
    out.ImagingColumns = 2184;
    out.ClampColumns = 46;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 37;
    out.TotalRows = 1510;
    out.ImagingRows = 1472;
    out.UnderscanRows = 34;
    out.OverscanRows = 4;
    out.VFlushBinning = 1;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 100;
    out.PixelSizeX = 6.8;
    out.PixelSizeY = 6.8;
    out.Color = 0;
    out.ReportedGainSixteenBit = 1;
    out.MinSuggestedExpTime = 10;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -20;
    out.TempRampRateOne = 700;
    out.TempRampRateTwo = 4000;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Alta_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Alta_Twelve;
    out.PrimaryADLatency = 1;
    out.AlternativeADLatency = 12;
    out.IRPreflashTime = 160;
    out.AdCfg = 8;
    out.DefaultGainLeft = 100;
    out.DefaultOffsetLeft = 100;
    out.DefaultGainRight = 0;
    out.DefaultOffsetRight = 0;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 0;
    out.VideoSubSample = 1;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "KV2B";
    out.ClampPatternNormal = "K16HC2B";
    out.SkipPatternNormal = "K16HS2B";
    out.RoiPatternNormal = "K16HR2B";
    out.ClampPatternFast = "K12HC2B";
    out.SkipPatternFast = "K12HS2B";
    out.RoiPatternFast = "K12HR2B";
    out.VerticalPatternVideo= "NoOpV";
    out.ClampPatternVideo = "NoOpH";
    out.SkipPatternVideo = "NoOpH";
    out.RoiPatternVideo = "NoOpH";
}


void camMetaData::getMeta8(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "KAF6303E";
    out.CameraId = 8;
    out.CameraLine = "Alta";
    out.CameraModel = "9";
    out.InterlineCCD = 0;
    out.SupportsSerialA = 1;
    out.SupportsSerialB = 1;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 3100;
    out.ImagingColumns = 3073;
    out.ClampColumns = 15;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 12;
    out.TotalRows = 2056;
    out.ImagingRows = 2048;
    out.UnderscanRows = 4;
    out.OverscanRows = 4;
    out.VFlushBinning = 1;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 300;
    out.PixelSizeX = 9;
    out.PixelSizeY = 9;
    out.Color = 0;
    out.ReportedGainSixteenBit = 1.5;
    out.MinSuggestedExpTime = 20;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -20;
    out.TempRampRateOne = 700;
    out.TempRampRateTwo = 4000;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Alta_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Alta_Twelve;
    out.PrimaryADLatency = 1;
    out.AlternativeADLatency = 12;
    out.IRPreflashTime = 160;
    out.AdCfg = 8;
    out.DefaultGainLeft = 0;
    out.DefaultOffsetLeft = 100;
    out.DefaultGainRight = 0;
    out.DefaultOffsetRight = 0;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 0;
    out.VideoSubSample = 1;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "KV1";
    out.ClampPatternNormal = "K16HC1";
    out.SkipPatternNormal = "K16HS1";
    out.RoiPatternNormal = "K16HR1";
    out.ClampPatternFast = "K12HC4";
    out.SkipPatternFast = "K12HS4";
    out.RoiPatternFast = "K12HR4";
    out.VerticalPatternVideo= "NoOpV";
    out.ClampPatternVideo = "NoOpH";
    out.SkipPatternVideo = "NoOpH";
    out.RoiPatternVideo = "NoOpH";
}


void camMetaData::getMeta9(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "KAF16801E";
    out.CameraId = 9;
    out.CameraLine = "Alta";
    out.CameraModel = "16";
    out.InterlineCCD = 0;
    out.SupportsSerialA = 1;
    out.SupportsSerialB = 1;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 4152;
    out.ImagingColumns = 4096;
    out.ClampColumns = 36;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 20;
    out.TotalRows = 4129;
    out.ImagingRows = 4096;
    out.UnderscanRows = 21;
    out.OverscanRows = 11;
    out.VFlushBinning = 1;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 300;
    out.PixelSizeX = 9;
    out.PixelSizeY = 9;
    out.Color = 0;
    out.ReportedGainSixteenBit = 1.5;
    out.MinSuggestedExpTime = 30;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -20;
    out.TempRampRateOne = 1500;
    out.TempRampRateTwo = 4000;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Alta_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Alta_Twelve;
    out.PrimaryADLatency = 1;
    out.AlternativeADLatency = 12;
    out.IRPreflashTime = 160;
    out.AdCfg = 8;
    out.DefaultGainLeft = 100;
    out.DefaultOffsetLeft = 255;
    out.DefaultGainRight = 0;
    out.DefaultOffsetRight = 0;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 0;
    out.VideoSubSample = 1;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "KV4";
    out.ClampPatternNormal = "K16HC2";
    out.SkipPatternNormal = "K16HS2";
    out.RoiPatternNormal = "K16HR2";
    out.ClampPatternFast = "K12HC2";
    out.SkipPatternFast = "K12HS2";
    out.RoiPatternFast = "K12HR2";
    out.VerticalPatternVideo= "NoOpV";
    out.ClampPatternVideo = "NoOpH";
    out.SkipPatternVideo = "NoOpH";
    out.RoiPatternVideo = "NoOpH";
}


void camMetaData::getMeta10(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "CCD4710";
    out.CameraId = 10;
    out.CameraLine = "Alta";
    out.CameraModel = "47";
    out.InterlineCCD = 0;
    out.SupportsSerialA = 1;
    out.SupportsSerialB = 1;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 1072;
    out.ImagingColumns = 1024;
    out.ClampColumns = 24;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 24;
    out.TotalRows = 1027;
    out.ImagingRows = 1024;
    out.UnderscanRows = 3;
    out.OverscanRows = 0;
    out.VFlushBinning = 1;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 300;
    out.PixelSizeX = 13;
    out.PixelSizeY = 13;
    out.Color = 0;
    out.ReportedGainSixteenBit = 2;
    out.MinSuggestedExpTime = 20;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -20;
    out.TempRampRateOne = 700;
    out.TempRampRateTwo = 4000;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Alta_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Alta_Twelve;
    out.PrimaryADLatency = 1;
    out.AlternativeADLatency = 12;
    out.IRPreflashTime = 160;
    out.AdCfg = 8;
    out.DefaultGainLeft = 400;
    out.DefaultOffsetLeft = 200;
    out.DefaultGainRight = 0;
    out.DefaultOffsetRight = 0;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 0;
    out.VideoSubSample = 1;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "MV1";
    out.ClampPatternNormal = "M16HS1";
    out.SkipPatternNormal = "M16HS1";
    out.RoiPatternNormal = "M16HR3";
    out.ClampPatternFast = "M12HC";
    out.SkipPatternFast = "M12HS";
    out.RoiPatternFast = "M12HR";
    out.VerticalPatternVideo= "NoOpV";
    out.ClampPatternVideo = "NoOpH";
    out.SkipPatternVideo = "NoOpH";
    out.RoiPatternVideo = "NoOpH";
}


void camMetaData::getMeta12(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "CCD4710alt";
    out.CameraId = 12;
    out.CameraLine = "Alta";
    out.CameraModel = "47";
    out.InterlineCCD = 0;
    out.SupportsSerialA = 1;
    out.SupportsSerialB = 1;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 1072;
    out.ImagingColumns = 1024;
    out.ClampColumns = 24;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 24;
    out.TotalRows = 1027;
    out.ImagingRows = 1024;
    out.UnderscanRows = 3;
    out.OverscanRows = 0;
    out.VFlushBinning = 1;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 1;
    out.ShutterCloseDelay = 300;
    out.PixelSizeX = 13;
    out.PixelSizeY = 13;
    out.Color = 0;
    out.ReportedGainSixteenBit = 2;
    out.MinSuggestedExpTime = 20;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -20;
    out.TempRampRateOne = 700;
    out.TempRampRateTwo = 4000;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Alta_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Alta_Twelve;
    out.PrimaryADLatency = 1;
    out.AlternativeADLatency = 12;
    out.IRPreflashTime = 160;
    out.AdCfg = 8;
    out.DefaultGainLeft = 400;
    out.DefaultOffsetLeft = 200;
    out.DefaultGainRight = 0;
    out.DefaultOffsetRight = 0;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 0;
    out.VideoSubSample = 1;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "MV1";
    out.ClampPatternNormal = "M16HS1";
    out.SkipPatternNormal = "M16HS1";
    out.RoiPatternNormal = "M16HR3";
    out.ClampPatternFast = "M12HC";
    out.SkipPatternFast = "M12HS";
    out.RoiPatternFast = "M12HR";
    out.VerticalPatternVideo= "NoOpV";
    out.ClampPatternVideo = "NoOpH";
    out.SkipPatternVideo = "NoOpH";
    out.RoiPatternVideo = "NoOpH";
}


void camMetaData::getMeta14(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "TH7899";
    out.CameraId = 14;
    out.CameraLine = "Alta";
    out.CameraModel = "10";
    out.InterlineCCD = 0;
    out.SupportsSerialA = 1;
    out.SupportsSerialB = 1;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 2110;
    out.ImagingColumns = 2048;
    out.ClampColumns = 25;
    out.PreRoiSkipColumns = 5;
    out.PostRoiSkipColumns = 5;
    out.OverscanColumns = 27;
    out.TotalRows = 2054;
    out.ImagingRows = 2048;
    out.UnderscanRows = 3;
    out.OverscanRows = 3;
    out.VFlushBinning = 4;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 450;
    out.PixelSizeX = 14;
    out.PixelSizeY = 14;
    out.Color = 0;
    out.ReportedGainSixteenBit = 2;
    out.MinSuggestedExpTime = 20;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -20;
    out.TempRampRateOne = 700;
    out.TempRampRateTwo = 4000;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Alta_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Alta_Twelve;
    out.PrimaryADLatency = 1;
    out.AlternativeADLatency = 12;
    out.IRPreflashTime = 160;
    out.AdCfg = 8;
    out.DefaultGainLeft = 100;
    out.DefaultOffsetLeft = 255;
    out.DefaultGainRight = 0;
    out.DefaultOffsetRight = 0;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 0;
    out.VideoSubSample = 1;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "XAV1";
    out.ClampPatternNormal = "A16HS";
    out.SkipPatternNormal = "A16HS";
    out.RoiPatternNormal = "A16HR";
    out.ClampPatternFast = "A12HC";
    out.SkipPatternFast = "A12HS";
    out.RoiPatternFast = "A12HR";
    out.VerticalPatternVideo= "NoOpV";
    out.ClampPatternVideo = "NoOpH";
    out.SkipPatternVideo = "NoOpH";
    out.RoiPatternVideo = "NoOpH";
}


void camMetaData::getMeta16(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "CCD4240";
    out.CameraId = 16;
    out.CameraLine = "Alta";
    out.CameraModel = "42";
    out.InterlineCCD = 0;
    out.SupportsSerialA = 1;
    out.SupportsSerialB = 1;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 2148;
    out.ImagingColumns = 2048;
    out.ClampColumns = 50;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 50;
    out.TotalRows = 2052;
    out.ImagingRows = 2048;
    out.UnderscanRows = 2;
    out.OverscanRows = 2;
    out.VFlushBinning = 1;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 450;
    out.PixelSizeX = 13.5;
    out.PixelSizeY = 13.5;
    out.Color = 0;
    out.ReportedGainSixteenBit = 2;
    out.MinSuggestedExpTime = 20;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -20;
    out.TempRampRateOne = 400;
    out.TempRampRateTwo = 4000;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Alta_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Alta_Twelve;
    out.PrimaryADLatency = 1;
    out.AlternativeADLatency = 12;
    out.IRPreflashTime = 160;
    out.AdCfg = 8;
    out.DefaultGainLeft = 400;
    out.DefaultOffsetLeft = 200;
    out.DefaultGainRight = 0;
    out.DefaultOffsetRight = 0;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 0;
    out.VideoSubSample = 1;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "MV2";
    out.ClampPatternNormal = "M16HS1";
    out.SkipPatternNormal = "M16HS1";
    out.RoiPatternNormal = "M16HR3";
    out.ClampPatternFast = "M12HC";
    out.SkipPatternFast = "M12HS";
    out.RoiPatternFast = "M12HR";
    out.VerticalPatternVideo= "NoOpV";
    out.ClampPatternVideo = "NoOpH";
    out.SkipPatternVideo = "NoOpH";
    out.RoiPatternVideo = "NoOpH";
}


void camMetaData::getMeta17(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "CCD3011B";
    out.CameraId = 17;
    out.CameraLine = "Alta";
    out.CameraModel = "30";
    out.InterlineCCD = 0;
    out.SupportsSerialA = 1;
    out.SupportsSerialB = 1;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 1040;
    out.ImagingColumns = 1024;
    out.ClampColumns = 8;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 8;
    out.TotalRows = 256;
    out.ImagingRows = 256;
    out.UnderscanRows = 0;
    out.OverscanRows = 0;
    out.VFlushBinning = 1;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 300;
    out.PixelSizeX = 26;
    out.PixelSizeY = 26;
    out.Color = 0;
    out.ReportedGainSixteenBit = 2;
    out.MinSuggestedExpTime = 20;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -20;
    out.TempRampRateOne = 700;
    out.TempRampRateTwo = 4000;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Alta_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Alta_Twelve;
    out.PrimaryADLatency = 1;
    out.AlternativeADLatency = 12;
    out.IRPreflashTime = 160;
    out.AdCfg = 8;
    out.DefaultGainLeft = 400;
    out.DefaultOffsetLeft = 200;
    out.DefaultGainRight = 0;
    out.DefaultOffsetRight = 0;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 0;
    out.VideoSubSample = 1;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "MV2B";
    out.ClampPatternNormal = "M16HS1B";
    out.SkipPatternNormal = "M16HS1B";
    out.RoiPatternNormal = "M16HR5B";
    out.ClampPatternFast = "M12HCB";
    out.SkipPatternFast = "M12HSB";
    out.RoiPatternFast = "M12HRB";
    out.VerticalPatternVideo= "NoOpV";
    out.ClampPatternVideo = "NoOpH";
    out.SkipPatternVideo = "NoOpH";
    out.RoiPatternVideo = "NoOpH";
}


void camMetaData::getMeta18(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "CCD5710";
    out.CameraId = 18;
    out.CameraLine = "Alta";
    out.CameraModel = "57";
    out.InterlineCCD = 0;
    out.SupportsSerialA = 1;
    out.SupportsSerialB = 1;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 536;
    out.ImagingColumns = 512;
    out.ClampColumns = 24;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 12;
    out.TotalRows = 1056;
    out.ImagingRows = 512;
    out.UnderscanRows = 540;
    out.OverscanRows = 4;
    out.VFlushBinning = 1;
    out.EnableSingleRowOffset = 1;
    out.RowOffsetBinning = 540;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 0;
    out.PixelSizeX = 13;
    out.PixelSizeY = 13;
    out.Color = 0;
    out.ReportedGainSixteenBit = 2;
    out.MinSuggestedExpTime = 1;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -20;
    out.TempRampRateOne = 700;
    out.TempRampRateTwo = 4000;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Alta_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Alta_Twelve;
    out.PrimaryADLatency = 1;
    out.AlternativeADLatency = 12;
    out.IRPreflashTime = 160;
    out.AdCfg = 8;
    out.DefaultGainLeft = 400;
    out.DefaultOffsetLeft = 250;
    out.DefaultGainRight = 0;
    out.DefaultOffsetRight = 0;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 0;
    out.VideoSubSample = 1;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "MV4";
    out.ClampPatternNormal = "M16HS1";
    out.SkipPatternNormal = "M16HS1";
    out.RoiPatternNormal = "M16HR3";
    out.ClampPatternFast = "M12HC";
    out.SkipPatternFast = "M12HS";
    out.RoiPatternFast = "M12HR";
    out.VerticalPatternVideo= "NoOpV";
    out.ClampPatternVideo = "NoOpH";
    out.SkipPatternVideo = "NoOpH";
    out.RoiPatternVideo = "NoOpH";
}


void camMetaData::getMeta19(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "CCD5520B";
    out.CameraId = 19;
    out.CameraLine = "Alta";
    out.CameraModel = "55";
    out.InterlineCCD = 0;
    out.SupportsSerialA = 1;
    out.SupportsSerialB = 1;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 804;
    out.ImagingColumns = 770;
    out.ClampColumns = 17;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 17;
    out.TotalRows = 1152;
    out.ImagingRows = 1152;
    out.UnderscanRows = 0;
    out.OverscanRows = 0;
    out.VFlushBinning = 1;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 300;
    out.PixelSizeX = 22.5;
    out.PixelSizeY = 22.5;
    out.Color = 0;
    out.ReportedGainSixteenBit = 2;
    out.MinSuggestedExpTime = 20;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -20;
    out.TempRampRateOne = 700;
    out.TempRampRateTwo = 4000;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Alta_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Alta_Twelve;
    out.PrimaryADLatency = 1;
    out.AlternativeADLatency = 12;
    out.IRPreflashTime = 160;
    out.AdCfg = 8;
    out.DefaultGainLeft = 400;
    out.DefaultOffsetLeft = 200;
    out.DefaultGainRight = 0;
    out.DefaultOffsetRight = 0;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 0;
    out.VideoSubSample = 1;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "MV2B";
    out.ClampPatternNormal = "M16HS1B";
    out.SkipPatternNormal = "M16HS1B";
    out.RoiPatternNormal = "M16HR3B";
    out.ClampPatternFast = "M12HCB";
    out.SkipPatternFast = "M12HSB";
    out.RoiPatternFast = "M12HRB";
    out.VerticalPatternVideo= "NoOpV";
    out.ClampPatternVideo = "NoOpH";
    out.SkipPatternVideo = "NoOpH";
    out.RoiPatternVideo = "NoOpH";
}


void camMetaData::getMeta20(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "CCD3011";
    out.CameraId = 20;
    out.CameraLine = "Alta";
    out.CameraModel = "30";
    out.InterlineCCD = 0;
    out.SupportsSerialA = 1;
    out.SupportsSerialB = 1;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 1040;
    out.ImagingColumns = 1024;
    out.ClampColumns = 8;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 8;
    out.TotalRows = 256;
    out.ImagingRows = 256;
    out.UnderscanRows = 0;
    out.OverscanRows = 0;
    out.VFlushBinning = 1;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 300;
    out.PixelSizeX = 26;
    out.PixelSizeY = 26;
    out.Color = 0;
    out.ReportedGainSixteenBit = 2;
    out.MinSuggestedExpTime = 30;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -20;
    out.TempRampRateOne = 700;
    out.TempRampRateTwo = 4000;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Alta_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Alta_Twelve;
    out.PrimaryADLatency = 1;
    out.AlternativeADLatency = 12;
    out.IRPreflashTime = 160;
    out.AdCfg = 8;
    out.DefaultGainLeft = 400;
    out.DefaultOffsetLeft = 200;
    out.DefaultGainRight = 0;
    out.DefaultOffsetRight = 0;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 0;
    out.VideoSubSample = 1;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "MV2";
    out.ClampPatternNormal = "M16HS1";
    out.SkipPatternNormal = "M16HS1";
    out.RoiPatternNormal = "M16HR5";
    out.ClampPatternFast = "M12HC";
    out.SkipPatternFast = "M12HS";
    out.RoiPatternFast = "M12HR";
    out.VerticalPatternVideo= "NoOpV";
    out.ClampPatternVideo = "NoOpH";
    out.SkipPatternVideo = "NoOpH";
    out.RoiPatternVideo = "NoOpH";
}


void camMetaData::getMeta21(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "CCD4720B";
    out.CameraId = 21;
    out.CameraLine = "Alta";
    out.CameraModel = "4720";
    out.InterlineCCD = 0;
    out.SupportsSerialA = 1;
    out.SupportsSerialB = 1;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 1072;
    out.ImagingColumns = 1024;
    out.ClampColumns = 24;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 24;
    out.TotalRows = 2058;
    out.ImagingRows = 1024;
    out.UnderscanRows = 1033;
    out.OverscanRows = 1;
    out.VFlushBinning = 1;
    out.EnableSingleRowOffset = 1;
    out.RowOffsetBinning = 1033;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 0;
    out.PixelSizeX = 13;
    out.PixelSizeY = 13;
    out.Color = 0;
    out.ReportedGainSixteenBit = 2;
    out.MinSuggestedExpTime = 1;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -20;
    out.TempRampRateOne = 700;
    out.TempRampRateTwo = 4000;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Alta_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Alta_Twelve;
    out.PrimaryADLatency = 1;
    out.AlternativeADLatency = 12;
    out.IRPreflashTime = 160;
    out.AdCfg = 8;
    out.DefaultGainLeft = 400;
    out.DefaultOffsetLeft = 200;
    out.DefaultGainRight = 0;
    out.DefaultOffsetRight = 0;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 0;
    out.VideoSubSample = 1;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "MV4B";
    out.ClampPatternNormal = "M16HS1B";
    out.SkipPatternNormal = "M16HS1B";
    out.RoiPatternNormal = "M16HR3B";
    out.ClampPatternFast = "M12HCB";
    out.SkipPatternFast = "M12HSB";
    out.RoiPatternFast = "M12HRB";
    out.VerticalPatternVideo= "NoOpV";
    out.ClampPatternVideo = "NoOpH";
    out.SkipPatternVideo = "NoOpH";
    out.RoiPatternVideo = "NoOpH";
}


void camMetaData::getMeta22(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "CCD5520";
    out.CameraId = 22;
    out.CameraLine = "Alta";
    out.CameraModel = "55";
    out.InterlineCCD = 0;
    out.SupportsSerialA = 1;
    out.SupportsSerialB = 1;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 804;
    out.ImagingColumns = 770;
    out.ClampColumns = 17;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 17;
    out.TotalRows = 1152;
    out.ImagingRows = 1152;
    out.UnderscanRows = 0;
    out.OverscanRows = 0;
    out.VFlushBinning = 1;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 300;
    out.PixelSizeX = 22.5;
    out.PixelSizeY = 22.5;
    out.Color = 0;
    out.ReportedGainSixteenBit = 2;
    out.MinSuggestedExpTime = 20;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -20;
    out.TempRampRateOne = 700;
    out.TempRampRateTwo = 4000;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Alta_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Alta_Twelve;
    out.PrimaryADLatency = 1;
    out.AlternativeADLatency = 12;
    out.IRPreflashTime = 160;
    out.AdCfg = 8;
    out.DefaultGainLeft = 400;
    out.DefaultOffsetLeft = 200;
    out.DefaultGainRight = 0;
    out.DefaultOffsetRight = 0;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 0;
    out.VideoSubSample = 1;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "MV2";
    out.ClampPatternNormal = "M16HS1";
    out.SkipPatternNormal = "M16HS1";
    out.RoiPatternNormal = "M16HR3";
    out.ClampPatternFast = "M12HC";
    out.SkipPatternFast = "M12HS";
    out.RoiPatternFast = "M12HR";
    out.VerticalPatternVideo= "NoOpV";
    out.ClampPatternVideo = "NoOpH";
    out.SkipPatternVideo = "NoOpH";
    out.RoiPatternVideo = "NoOpH";
}


void camMetaData::getMeta23(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "CCD7700B";
    out.CameraId = 23;
    out.CameraLine = "Alta";
    out.CameraModel = "77";
    out.InterlineCCD = 0;
    out.SupportsSerialA = 1;
    out.SupportsSerialB = 1;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 527;
    out.ImagingColumns = 512;
    out.ClampColumns = 15;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 0;
    out.TotalRows = 512;
    out.ImagingRows = 512;
    out.UnderscanRows = 0;
    out.OverscanRows = 0;
    out.VFlushBinning = 1;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 300;
    out.PixelSizeX = 24;
    out.PixelSizeY = 24;
    out.Color = 0;
    out.ReportedGainSixteenBit = 2;
    out.MinSuggestedExpTime = 20;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -20;
    out.TempRampRateOne = 700;
    out.TempRampRateTwo = 4000;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Alta_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Alta_Twelve;
    out.PrimaryADLatency = 1;
    out.AlternativeADLatency = 12;
    out.IRPreflashTime = 160;
    out.AdCfg = 8;
    out.DefaultGainLeft = 400;
    out.DefaultOffsetLeft = 200;
    out.DefaultGainRight = 0;
    out.DefaultOffsetRight = 0;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 0;
    out.VideoSubSample = 1;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "MV1B";
    out.ClampPatternNormal = "M16HS1B";
    out.SkipPatternNormal = "M16HS1B";
    out.RoiPatternNormal = "M16HR3B";
    out.ClampPatternFast = "M12HCB";
    out.SkipPatternFast = "M12HSB";
    out.RoiPatternFast = "M12HRB";
    out.VerticalPatternVideo= "NoOpV";
    out.ClampPatternVideo = "NoOpH";
    out.SkipPatternVideo = "NoOpH";
    out.RoiPatternVideo = "NoOpH";
}


void camMetaData::getMeta24(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "CCD4720";
    out.CameraId = 24;
    out.CameraLine = "Alta";
    out.CameraModel = "4720";
    out.InterlineCCD = 0;
    out.SupportsSerialA = 1;
    out.SupportsSerialB = 1;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 1072;
    out.ImagingColumns = 1024;
    out.ClampColumns = 24;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 24;
    out.TotalRows = 2058;
    out.ImagingRows = 1024;
    out.UnderscanRows = 1033;
    out.OverscanRows = 1;
    out.VFlushBinning = 1;
    out.EnableSingleRowOffset = 1;
    out.RowOffsetBinning = 1033;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 0;
    out.PixelSizeX = 13;
    out.PixelSizeY = 13;
    out.Color = 0;
    out.ReportedGainSixteenBit = 2;
    out.MinSuggestedExpTime = 1;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -20;
    out.TempRampRateOne = 700;
    out.TempRampRateTwo = 4000;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Alta_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Alta_Twelve;
    out.PrimaryADLatency = 1;
    out.AlternativeADLatency = 12;
    out.IRPreflashTime = 160;
    out.AdCfg = 8;
    out.DefaultGainLeft = 400;
    out.DefaultOffsetLeft = 200;
    out.DefaultGainRight = 0;
    out.DefaultOffsetRight = 0;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 0;
    out.VideoSubSample = 1;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "MV4";
    out.ClampPatternNormal = "M16HS1";
    out.SkipPatternNormal = "M16HS1";
    out.RoiPatternNormal = "M16HR3";
    out.ClampPatternFast = "M12HC";
    out.SkipPatternFast = "M12HS";
    out.RoiPatternFast = "M12HR";
    out.VerticalPatternVideo= "NoOpV";
    out.ClampPatternVideo = "NoOpH";
    out.SkipPatternVideo = "NoOpH";
    out.RoiPatternVideo = "NoOpH";
}


void camMetaData::getMeta26(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "CCD7700";
    out.CameraId = 26;
    out.CameraLine = "Alta";
    out.CameraModel = "77";
    out.InterlineCCD = 0;
    out.SupportsSerialA = 1;
    out.SupportsSerialB = 1;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 527;
    out.ImagingColumns = 512;
    out.ClampColumns = 15;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 0;
    out.TotalRows = 512;
    out.ImagingRows = 512;
    out.UnderscanRows = 0;
    out.OverscanRows = 0;
    out.VFlushBinning = 1;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 300;
    out.PixelSizeX = 24;
    out.PixelSizeY = 24;
    out.Color = 0;
    out.ReportedGainSixteenBit = 2;
    out.MinSuggestedExpTime = 20;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -20;
    out.TempRampRateOne = 700;
    out.TempRampRateTwo = 4000;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Alta_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Alta_Twelve;
    out.PrimaryADLatency = 1;
    out.AlternativeADLatency = 12;
    out.IRPreflashTime = 160;
    out.AdCfg = 8;
    out.DefaultGainLeft = 400;
    out.DefaultOffsetLeft = 200;
    out.DefaultGainRight = 0;
    out.DefaultOffsetRight = 0;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 0;
    out.VideoSubSample = 1;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "MV7";
    out.ClampPatternNormal = "M16HS7";
    out.SkipPatternNormal = "M16HS7";
    out.RoiPatternNormal = "M16HR7";
    out.ClampPatternFast = "M12HC7";
    out.SkipPatternFast = "M12HS7";
    out.RoiPatternFast = "M12HR7";
    out.VerticalPatternVideo= "NoOpV";
    out.ClampPatternVideo = "NoOpH";
    out.SkipPatternVideo = "NoOpH";
    out.RoiPatternVideo = "NoOpH";
}


void camMetaData::getMeta30(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "KAF1001Ens";
    out.CameraId = 30;
    out.CameraLine = "Alta";
    out.CameraModel = "6";
    out.InterlineCCD = 0;
    out.SupportsSerialA = 1;
    out.SupportsSerialB = 1;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 1044;
    out.ImagingColumns = 1024;
    out.ClampColumns = 8;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 12;
    out.TotalRows = 1032;
    out.ImagingRows = 1024;
    out.UnderscanRows = 4;
    out.OverscanRows = 4;
    out.VFlushBinning = 8;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 0;
    out.PixelSizeX = 24;
    out.PixelSizeY = 24;
    out.Color = 0;
    out.ReportedGainSixteenBit = 3;
    out.MinSuggestedExpTime = 20;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -20;
    out.TempRampRateOne = 700;
    out.TempRampRateTwo = 4000;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Alta_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Alta_Twelve;
    out.PrimaryADLatency = 1;
    out.AlternativeADLatency = 12;
    out.IRPreflashTime = 160;
    out.AdCfg = 8;
    out.DefaultGainLeft = 0;
    out.DefaultOffsetLeft = 250;
    out.DefaultGainRight = 0;
    out.DefaultOffsetRight = 0;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 0;
    out.VideoSubSample = 1;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "KV1";
    out.ClampPatternNormal = "K16HC1";
    out.SkipPatternNormal = "K16HS1";
    out.RoiPatternNormal = "K16HR1";
    out.ClampPatternFast = "K12HC4";
    out.SkipPatternFast = "K12HS4";
    out.RoiPatternFast = "K12HR4";
    out.VerticalPatternVideo= "NoOpV";
    out.ClampPatternVideo = "NoOpH";
    out.SkipPatternVideo = "NoOpH";
    out.RoiPatternVideo = "NoOpH";
}


void camMetaData::getMeta31(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "KAF10011105";
    out.CameraId = 31;
    out.CameraLine = "Alta";
    out.CameraModel = "6";
    out.InterlineCCD = 0;
    out.SupportsSerialA = 1;
    out.SupportsSerialB = 1;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 1044;
    out.ImagingColumns = 1024;
    out.ClampColumns = 8;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 12;
    out.TotalRows = 1032;
    out.ImagingRows = 1024;
    out.UnderscanRows = 4;
    out.OverscanRows = 4;
    out.VFlushBinning = 8;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 100;
    out.PixelSizeX = 24;
    out.PixelSizeY = 24;
    out.Color = 0;
    out.ReportedGainSixteenBit = 3;
    out.MinSuggestedExpTime = 20;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -20;
    out.TempRampRateOne = 700;
    out.TempRampRateTwo = 4000;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Alta_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Alta_Twelve;
    out.PrimaryADLatency = 1;
    out.AlternativeADLatency = 12;
    out.IRPreflashTime = 160;
    out.AdCfg = 8;
    out.DefaultGainLeft = 0;
    out.DefaultOffsetLeft = 250;
    out.DefaultGainRight = 0;
    out.DefaultOffsetRight = 0;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 0;
    out.VideoSubSample = 1;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "KV5";
    out.ClampPatternNormal = "K16HS3";
    out.SkipPatternNormal = "K16HS3";
    out.RoiPatternNormal = "K16HR3";
    out.ClampPatternFast = "K12HC3";
    out.SkipPatternFast = "K12HS3";
    out.RoiPatternFast = "K12HR3";
    out.VerticalPatternVideo= "NoOpV";
    out.ClampPatternVideo = "NoOpH";
    out.SkipPatternVideo = "NoOpH";
    out.RoiPatternVideo = "NoOpH";
}


void camMetaData::getMeta32(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "KAF0401EB";
    out.CameraId = 32;
    out.CameraLine = "Alta";
    out.CameraModel = "1";
    out.InterlineCCD = 0;
    out.SupportsSerialA = 1;
    out.SupportsSerialB = 1;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 796;
    out.ImagingColumns = 768;
    out.ClampColumns = 14;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 14;
    out.TotalRows = 520;
    out.ImagingRows = 512;
    out.UnderscanRows = 4;
    out.OverscanRows = 4;
    out.VFlushBinning = 1;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 100;
    out.PixelSizeX = 9;
    out.PixelSizeY = 9;
    out.Color = 0;
    out.ReportedGainSixteenBit = 1.5;
    out.MinSuggestedExpTime = 10;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -20;
    out.TempRampRateOne = 700;
    out.TempRampRateTwo = 4000;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Alta_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Alta_Twelve;
    out.PrimaryADLatency = 1;
    out.AlternativeADLatency = 12;
    out.IRPreflashTime = 160;
    out.AdCfg = 8;
    out.DefaultGainLeft = 0;
    out.DefaultOffsetLeft = 100;
    out.DefaultGainRight = 0;
    out.DefaultOffsetRight = 0;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 0;
    out.VideoSubSample = 1;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "KV5";
    out.ClampPatternNormal = "K16HS3";
    out.SkipPatternNormal = "K16HS3";
    out.RoiPatternNormal = "K16HR3";
    out.ClampPatternFast = "K12HC3";
    out.SkipPatternFast = "K12HS3";
    out.RoiPatternFast = "K12HR3";
    out.VerticalPatternVideo= "NoOpV";
    out.ClampPatternVideo = "NoOpH";
    out.SkipPatternVideo = "NoOpH";
    out.RoiPatternVideo = "NoOpH";
}


void camMetaData::getMeta33(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "KAF1602EB";
    out.CameraId = 33;
    out.CameraLine = "Alta";
    out.CameraModel = "2";
    out.InterlineCCD = 0;
    out.SupportsSerialA = 1;
    out.SupportsSerialB = 1;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 1564;
    out.ImagingColumns = 1536;
    out.ClampColumns = 14;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 14;
    out.TotalRows = 1032;
    out.ImagingRows = 1024;
    out.UnderscanRows = 4;
    out.OverscanRows = 4;
    out.VFlushBinning = 1;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 100;
    out.PixelSizeX = 9;
    out.PixelSizeY = 9;
    out.Color = 0;
    out.ReportedGainSixteenBit = 1.5;
    out.MinSuggestedExpTime = 10;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -20;
    out.TempRampRateOne = 700;
    out.TempRampRateTwo = 4000;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Alta_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Alta_Twelve;
    out.PrimaryADLatency = 1;
    out.AlternativeADLatency = 12;
    out.IRPreflashTime = 160;
    out.AdCfg = 8;
    out.DefaultGainLeft = 0;
    out.DefaultOffsetLeft = 100;
    out.DefaultGainRight = 0;
    out.DefaultOffsetRight = 0;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 0;
    out.VideoSubSample = 1;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "KV5";
    out.ClampPatternNormal = "K16HS3";
    out.SkipPatternNormal = "K16HS3";
    out.RoiPatternNormal = "K16HR3";
    out.ClampPatternFast = "K12HC3";
    out.SkipPatternFast = "K12HS3";
    out.RoiPatternFast = "K12HR3";
    out.VerticalPatternVideo= "NoOpV";
    out.ClampPatternVideo = "NoOpH";
    out.SkipPatternVideo = "NoOpH";
    out.RoiPatternVideo = "NoOpH";
}


void camMetaData::getMeta34(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "KAF0261EB";
    out.CameraId = 34;
    out.CameraLine = "Alta";
    out.CameraModel = "260";
    out.InterlineCCD = 0;
    out.SupportsSerialA = 1;
    out.SupportsSerialB = 1;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 530;
    out.ImagingColumns = 512;
    out.ClampColumns = 8;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 10;
    out.TotalRows = 520;
    out.ImagingRows = 512;
    out.UnderscanRows = 4;
    out.OverscanRows = 4;
    out.VFlushBinning = 1;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 200;
    out.PixelSizeX = 20;
    out.PixelSizeY = 20;
    out.Color = 0;
    out.ReportedGainSixteenBit = 3;
    out.MinSuggestedExpTime = 10;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -20;
    out.TempRampRateOne = 400;
    out.TempRampRateTwo = 3500;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Alta_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Alta_Twelve;
    out.PrimaryADLatency = 1;
    out.AlternativeADLatency = 12;
    out.IRPreflashTime = 160;
    out.AdCfg = 8;
    out.DefaultGainLeft = 0;
    out.DefaultOffsetLeft = 250;
    out.DefaultGainRight = 0;
    out.DefaultOffsetRight = 0;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 0;
    out.VideoSubSample = 1;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "KV5";
    out.ClampPatternNormal = "K16HS3";
    out.SkipPatternNormal = "K16HS3";
    out.RoiPatternNormal = "K16HR3";
    out.ClampPatternFast = "K12HC3";
    out.SkipPatternFast = "K12HS3";
    out.RoiPatternFast = "K12HR3";
    out.VerticalPatternVideo= "NoOpV";
    out.ClampPatternVideo = "NoOpH";
    out.SkipPatternVideo = "NoOpH";
    out.RoiPatternVideo = "NoOpH";
}


void camMetaData::getMeta35(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "KAF1301EB";
    out.CameraId = 35;
    out.CameraLine = "Alta";
    out.CameraModel = "13";
    out.InterlineCCD = 0;
    out.SupportsSerialA = 1;
    out.SupportsSerialB = 1;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 1305;
    out.ImagingColumns = 1280;
    out.ClampColumns = 4;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 21;
    out.TotalRows = 1028;
    out.ImagingRows = 1024;
    out.UnderscanRows = 2;
    out.OverscanRows = 2;
    out.VFlushBinning = 1;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 300;
    out.PixelSizeX = 16;
    out.PixelSizeY = 16;
    out.Color = 0;
    out.ReportedGainSixteenBit = 3;
    out.MinSuggestedExpTime = 20;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -20;
    out.TempRampRateOne = 700;
    out.TempRampRateTwo = 4000;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Alta_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Alta_Twelve;
    out.PrimaryADLatency = 1;
    out.AlternativeADLatency = 12;
    out.IRPreflashTime = 160;
    out.AdCfg = 8;
    out.DefaultGainLeft = 0;
    out.DefaultOffsetLeft = 200;
    out.DefaultGainRight = 0;
    out.DefaultOffsetRight = 0;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 0;
    out.VideoSubSample = 1;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "KV5";
    out.ClampPatternNormal = "K16HS3";
    out.SkipPatternNormal = "K16HS3";
    out.RoiPatternNormal = "K16HR3";
    out.ClampPatternFast = "K12HC3";
    out.SkipPatternFast = "K12HS3";
    out.RoiPatternFast = "K12HR3";
    out.VerticalPatternVideo= "NoOpV";
    out.ClampPatternVideo = "NoOpH";
    out.SkipPatternVideo = "NoOpH";
    out.RoiPatternVideo = "NoOpH";
}


void camMetaData::getMeta36(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "KAF1001EB";
    out.CameraId = 36;
    out.CameraLine = "Alta";
    out.CameraModel = "6";
    out.InterlineCCD = 0;
    out.SupportsSerialA = 1;
    out.SupportsSerialB = 1;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 1044;
    out.ImagingColumns = 1024;
    out.ClampColumns = 8;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 12;
    out.TotalRows = 1032;
    out.ImagingRows = 1024;
    out.UnderscanRows = 4;
    out.OverscanRows = 4;
    out.VFlushBinning = 1;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 300;
    out.PixelSizeX = 24;
    out.PixelSizeY = 24;
    out.Color = 0;
    out.ReportedGainSixteenBit = 3;
    out.MinSuggestedExpTime = 20;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -20;
    out.TempRampRateOne = 700;
    out.TempRampRateTwo = 4000;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Alta_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Alta_Twelve;
    out.PrimaryADLatency = 1;
    out.AlternativeADLatency = 12;
    out.IRPreflashTime = 160;
    out.AdCfg = 8;
    out.DefaultGainLeft = 0;
    out.DefaultOffsetLeft = 250;
    out.DefaultGainRight = 0;
    out.DefaultOffsetRight = 0;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 0;
    out.VideoSubSample = 1;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "KV5";
    out.ClampPatternNormal = "K16HS3";
    out.SkipPatternNormal = "K16HS3";
    out.RoiPatternNormal = "K16HR3";
    out.ClampPatternFast = "K12HC3";
    out.SkipPatternFast = "K12HS3";
    out.RoiPatternFast = "K12HR3";
    out.VerticalPatternVideo= "NoOpV";
    out.ClampPatternVideo = "NoOpH";
    out.SkipPatternVideo = "NoOpH";
    out.RoiPatternVideo = "NoOpH";
}


void camMetaData::getMeta37(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "KAF6303EB";
    out.CameraId = 37;
    out.CameraLine = "Alta";
    out.CameraModel = "9";
    out.InterlineCCD = 0;
    out.SupportsSerialA = 1;
    out.SupportsSerialB = 1;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 3100;
    out.ImagingColumns = 3073;
    out.ClampColumns = 15;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 12;
    out.TotalRows = 2056;
    out.ImagingRows = 2048;
    out.UnderscanRows = 4;
    out.OverscanRows = 4;
    out.VFlushBinning = 1;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 300;
    out.PixelSizeX = 9;
    out.PixelSizeY = 9;
    out.Color = 0;
    out.ReportedGainSixteenBit = 1.5;
    out.MinSuggestedExpTime = 20;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -20;
    out.TempRampRateOne = 700;
    out.TempRampRateTwo = 4000;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Alta_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Alta_Twelve;
    out.PrimaryADLatency = 1;
    out.AlternativeADLatency = 12;
    out.IRPreflashTime = 160;
    out.AdCfg = 8;
    out.DefaultGainLeft = 0;
    out.DefaultOffsetLeft = 100;
    out.DefaultGainRight = 0;
    out.DefaultOffsetRight = 0;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 0;
    out.VideoSubSample = 1;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "KV5";
    out.ClampPatternNormal = "K16HS3";
    out.SkipPatternNormal = "K16HS3";
    out.RoiPatternNormal = "K16HR3";
    out.ClampPatternFast = "K12HC3";
    out.SkipPatternFast = "K12HS3";
    out.RoiPatternFast = "K12HR3";
    out.VerticalPatternVideo= "NoOpV";
    out.ClampPatternVideo = "NoOpH";
    out.SkipPatternVideo = "NoOpH";
    out.RoiPatternVideo = "NoOpH";
}


void camMetaData::getMeta38(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "KAF16803";
    out.CameraId = 38;
    out.CameraLine = "Alta";
    out.CameraModel = "16M";
    out.InterlineCCD = 0;
    out.SupportsSerialA = 1;
    out.SupportsSerialB = 1;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 4152;
    out.ImagingColumns = 4096;
    out.ClampColumns = 36;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 20;
    out.TotalRows = 4129;
    out.ImagingRows = 4096;
    out.UnderscanRows = 21;
    out.OverscanRows = 11;
    out.VFlushBinning = 1;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 300;
    out.PixelSizeX = 9;
    out.PixelSizeY = 9;
    out.Color = 0;
    out.ReportedGainSixteenBit = 1.5;
    out.MinSuggestedExpTime = 30;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -20;
    out.TempRampRateOne = 1500;
    out.TempRampRateTwo = 4000;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Alta_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Alta_Twelve;
    out.PrimaryADLatency = 1;
    out.AlternativeADLatency = 12;
    out.IRPreflashTime = 160;
    out.AdCfg = 8;
    out.DefaultGainLeft = 100;
    out.DefaultOffsetLeft = 255;
    out.DefaultGainRight = 0;
    out.DefaultOffsetRight = 0;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 0;
    out.VideoSubSample = 1;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "KV7";
    out.ClampPatternNormal = "K16HS7";
    out.SkipPatternNormal = "K16HS7";
    out.RoiPatternNormal = "K16HR7";
    out.ClampPatternFast = "K12HC7";
    out.SkipPatternFast = "K12HS7";
    out.RoiPatternFast = "K12HR7";
    out.VerticalPatternVideo= "NoOpV";
    out.ClampPatternVideo = "NoOpH";
    out.SkipPatternVideo = "NoOpH";
    out.RoiPatternVideo = "NoOpH";
}


void camMetaData::getMeta39(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "KAF09000X";
    out.CameraId = 39;
    out.CameraLine = "Alta";
    out.CameraModel = "9000X";
    out.InterlineCCD = 0;
    out.SupportsSerialA = 1;
    out.SupportsSerialB = 1;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 3103;
    out.ImagingColumns = 3056;
    out.ClampColumns = 35;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 12;
    out.TotalRows = 3086;
    out.ImagingRows = 3056;
    out.UnderscanRows = 20;
    out.OverscanRows = 10;
    out.VFlushBinning = 1;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 300;
    out.PixelSizeX = 12;
    out.PixelSizeY = 12;
    out.Color = 0;
    out.ReportedGainSixteenBit = 1.5;
    out.MinSuggestedExpTime = 30;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -20;
    out.TempRampRateOne = 1500;
    out.TempRampRateTwo = 4000;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Alta_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Alta_Twelve;
    out.PrimaryADLatency = 1;
    out.AlternativeADLatency = 12;
    out.IRPreflashTime = 160;
    out.AdCfg = 8;
    out.DefaultGainLeft = 0;
    out.DefaultOffsetLeft = 150;
    out.DefaultGainRight = 0;
    out.DefaultOffsetRight = 0;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 0;
    out.VideoSubSample = 1;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "KV7";
    out.ClampPatternNormal = "K16HS8";
    out.SkipPatternNormal = "K16HS8";
    out.RoiPatternNormal = "K16HR8";
    out.ClampPatternFast = "K12HC7";
    out.SkipPatternFast = "K12HS7";
    out.RoiPatternFast = "K12HR7";
    out.VerticalPatternVideo= "NoOpV";
    out.ClampPatternVideo = "NoOpH";
    out.SkipPatternVideo = "NoOpH";
    out.RoiPatternVideo = "NoOpH";
}


void camMetaData::getMeta40(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "S101401107";
    out.CameraId = 40;
    out.CameraLine = "Alta";
    out.CameraModel = "1107";
    out.InterlineCCD = 0;
    out.SupportsSerialA = 1;
    out.SupportsSerialB = 1;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 2068;
    out.ImagingColumns = 2048;
    out.ClampColumns = 10;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 10;
    out.TotalRows = 128;
    out.ImagingRows = 122;
    out.UnderscanRows = 4;
    out.OverscanRows = 2;
    out.VFlushBinning = 4;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 50;
    out.PixelSizeX = 12;
    out.PixelSizeY = 12;
    out.Color = 0;
    out.ReportedGainSixteenBit = 1;
    out.MinSuggestedExpTime = 30;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -20;
    out.TempRampRateOne = 700;
    out.TempRampRateTwo = 4000;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Alta_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Alta_Twelve;
    out.PrimaryADLatency = 1;
    out.AlternativeADLatency = 12;
    out.IRPreflashTime = 160;
    out.AdCfg = 8;
    out.DefaultGainLeft = 100;
    out.DefaultOffsetLeft = 100;
    out.DefaultGainRight = 0;
    out.DefaultOffsetRight = 0;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 0;
    out.VideoSubSample = 1;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "HV1";
    out.ClampPatternNormal = "H16HS";
    out.SkipPatternNormal = "H16HS";
    out.RoiPatternNormal = "H16HR";
    out.ClampPatternFast = "H12HC";
    out.SkipPatternFast = "H12HS";
    out.RoiPatternFast = "H12HR";
    out.VerticalPatternVideo= "NoOpV";
    out.ClampPatternVideo = "NoOpH";
    out.SkipPatternVideo = "NoOpH";
    out.RoiPatternVideo = "NoOpH";
}


void camMetaData::getMeta41(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "S101401109";
    out.CameraId = 41;
    out.CameraLine = "Alta";
    out.CameraModel = "1109";
    out.InterlineCCD = 0;
    out.SupportsSerialA = 1;
    out.SupportsSerialB = 1;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 2068;
    out.ImagingColumns = 2048;
    out.ClampColumns = 10;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 10;
    out.TotalRows = 512;
    out.ImagingRows = 506;
    out.UnderscanRows = 4;
    out.OverscanRows = 2;
    out.VFlushBinning = 4;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 50;
    out.PixelSizeX = 12;
    out.PixelSizeY = 12;
    out.Color = 0;
    out.ReportedGainSixteenBit = 1;
    out.MinSuggestedExpTime = 30;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -20;
    out.TempRampRateOne = 700;
    out.TempRampRateTwo = 4000;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Alta_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Alta_Twelve;
    out.PrimaryADLatency = 1;
    out.AlternativeADLatency = 12;
    out.IRPreflashTime = 160;
    out.AdCfg = 8;
    out.DefaultGainLeft = 100;
    out.DefaultOffsetLeft = 100;
    out.DefaultGainRight = 0;
    out.DefaultOffsetRight = 0;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 0;
    out.VideoSubSample = 1;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "HV1";
    out.ClampPatternNormal = "H16HS";
    out.SkipPatternNormal = "H16HS";
    out.RoiPatternNormal = "H16HR";
    out.ClampPatternFast = "H12HC";
    out.SkipPatternFast = "H12HS";
    out.RoiPatternFast = "H12HR";
    out.VerticalPatternVideo= "NoOpV";
    out.ClampPatternVideo = "NoOpH";
    out.SkipPatternVideo = "NoOpH";
    out.RoiPatternVideo = "NoOpH";
}


void camMetaData::getMeta42(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "F3041";
    out.CameraId = 42;
    out.CameraLine = "Alta";
    out.CameraModel = "3041";
    out.InterlineCCD = 0;
    out.SupportsSerialA = 1;
    out.SupportsSerialB = 1;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 2080;
    out.ImagingColumns = 2048;
    out.ClampColumns = 16;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 16;
    out.TotalRows = 2112;
    out.ImagingRows = 2048;
    out.UnderscanRows = 32;
    out.OverscanRows = 32;
    out.VFlushBinning = 4;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 50;
    out.PixelSizeX = 15;
    out.PixelSizeY = 15;
    out.Color = 0;
    out.ReportedGainSixteenBit = 1;
    out.MinSuggestedExpTime = 30;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -20;
    out.TempRampRateOne = 700;
    out.TempRampRateTwo = 4000;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Alta_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Alta_Twelve;
    out.PrimaryADLatency = 1;
    out.AlternativeADLatency = 12;
    out.IRPreflashTime = 160;
    out.AdCfg = 8;
    out.DefaultGainLeft = 100;
    out.DefaultOffsetLeft = 100;
    out.DefaultGainRight = 0;
    out.DefaultOffsetRight = 0;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 0;
    out.VideoSubSample = 1;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "FV1";
    out.ClampPatternNormal = "F16HS1";
    out.SkipPatternNormal = "F16HS1";
    out.RoiPatternNormal = "F16HR1";
    out.ClampPatternFast = "H12HC";
    out.SkipPatternFast = "H12HS";
    out.RoiPatternFast = "H12HR";
    out.VerticalPatternVideo= "NoOpV";
    out.ClampPatternVideo = "NoOpH";
    out.SkipPatternVideo = "NoOpH";
    out.RoiPatternVideo = "NoOpH";
}


void camMetaData::getMeta43(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "CCD4710DD";
    out.CameraId = 43;
    out.CameraLine = "Alta";
    out.CameraModel = "47";
    out.InterlineCCD = 0;
    out.SupportsSerialA = 1;
    out.SupportsSerialB = 1;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 1072;
    out.ImagingColumns = 1024;
    out.ClampColumns = 24;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 24;
    out.TotalRows = 1027;
    out.ImagingRows = 1024;
    out.UnderscanRows = 3;
    out.OverscanRows = 0;
    out.VFlushBinning = 1;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 300;
    out.PixelSizeX = 13;
    out.PixelSizeY = 13;
    out.Color = 0;
    out.ReportedGainSixteenBit = 2;
    out.MinSuggestedExpTime = 20;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -20;
    out.TempRampRateOne = 700;
    out.TempRampRateTwo = 4000;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Alta_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Alta_Twelve;
    out.PrimaryADLatency = 1;
    out.AlternativeADLatency = 12;
    out.IRPreflashTime = 160;
    out.AdCfg = 8;
    out.DefaultGainLeft = 400;
    out.DefaultOffsetLeft = 200;
    out.DefaultGainRight = 0;
    out.DefaultOffsetRight = 0;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 0;
    out.VideoSubSample = 1;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "MV1nimo";
    out.ClampPatternNormal = "FM16HS1";
    out.SkipPatternNormal = "FM16HS1";
    out.RoiPatternNormal = "FM16HR3";
    out.ClampPatternFast = "FM12HC";
    out.SkipPatternFast = "FM12HS";
    out.RoiPatternFast = "FM12HR";
    out.VerticalPatternVideo= "NoOpV";
    out.ClampPatternVideo = "NoOpH";
    out.SkipPatternVideo = "NoOpH";
    out.RoiPatternVideo = "NoOpH";
}


void camMetaData::getMeta44(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "KAF8300";
    out.CameraId = 44;
    out.CameraLine = "Alta";
    out.CameraModel = "8300";
    out.InterlineCCD = 0;
    out.SupportsSerialA = 1;
    out.SupportsSerialB = 1;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 3448;
    out.ImagingColumns = 3326;
    out.ClampColumns = 43;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 79;
    out.TotalRows = 2574;
    out.ImagingRows = 2504;
    out.UnderscanRows = 46;
    out.OverscanRows = 24;
    out.VFlushBinning = 1;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 300;
    out.PixelSizeX = 5.4;
    out.PixelSizeY = 5.4;
    out.Color = 0;
    out.ReportedGainSixteenBit = 1.5;
    out.MinSuggestedExpTime = 30;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -20;
    out.TempRampRateOne = 1500;
    out.TempRampRateTwo = 4000;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Alta_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Alta_Twelve;
    out.PrimaryADLatency = 1;
    out.AlternativeADLatency = 12;
    out.IRPreflashTime = 160;
    out.AdCfg = 8;
    out.DefaultGainLeft = 0;
    out.DefaultOffsetLeft = 150;
    out.DefaultGainRight = 0;
    out.DefaultOffsetRight = 0;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 0;
    out.VideoSubSample = 1;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "KV9";
    out.ClampPatternNormal = "K16HS9";
    out.SkipPatternNormal = "K16HS9";
    out.RoiPatternNormal = "K16HR9";
    out.ClampPatternFast = "K12HC9";
    out.SkipPatternFast = "K12HS9";
    out.RoiPatternFast = "K12HR9";
    out.VerticalPatternVideo= "NoOpV";
    out.ClampPatternVideo = "NoOpH";
    out.SkipPatternVideo = "NoOpH";
    out.RoiPatternVideo = "NoOpH";
}


void camMetaData::getMeta60(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "S101401108";
    out.CameraId = 60;
    out.CameraLine = "Alta";
    out.CameraModel = "1108";
    out.InterlineCCD = 0;
    out.SupportsSerialA = 1;
    out.SupportsSerialB = 1;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 2068;
    out.ImagingColumns = 2048;
    out.ClampColumns = 10;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 10;
    out.TotalRows = 256;
    out.ImagingRows = 250;
    out.UnderscanRows = 4;
    out.OverscanRows = 2;
    out.VFlushBinning = 4;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 0;
    out.PixelSizeX = 12;
    out.PixelSizeY = 12;
    out.Color = 0;
    out.ReportedGainSixteenBit = 1;
    out.MinSuggestedExpTime = 30;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -20;
    out.TempRampRateOne = 700;
    out.TempRampRateTwo = 4000;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Alta_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Alta_Twelve;
    out.PrimaryADLatency = 1;
    out.AlternativeADLatency = 12;
    out.IRPreflashTime = 160;
    out.AdCfg = 8;
    out.DefaultGainLeft = 100;
    out.DefaultOffsetLeft = 100;
    out.DefaultGainRight = 0;
    out.DefaultOffsetRight = 0;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 0;
    out.VideoSubSample = 1;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "HV1";
    out.ClampPatternNormal = "H16HS";
    out.SkipPatternNormal = "H16HS";
    out.RoiPatternNormal = "H16HR";
    out.ClampPatternFast = "H12HC";
    out.SkipPatternFast = "H12HS";
    out.RoiPatternFast = "H12HR";
    out.VerticalPatternVideo= "NoOpV";
    out.ClampPatternVideo = "NoOpH";
    out.SkipPatternVideo = "NoOpH";
    out.RoiPatternVideo = "NoOpH";
}


void camMetaData::getMeta11(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "S101401007";
    out.CameraId = 11;
    out.CameraLine = "Alta";
    out.CameraModel = "1007";
    out.InterlineCCD = 0;
    out.SupportsSerialA = 1;
    out.SupportsSerialB = 1;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 1044;
    out.ImagingColumns = 1024;
    out.ClampColumns = 10;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 10;
    out.TotalRows = 128;
    out.ImagingRows = 122;
    out.UnderscanRows = 4;
    out.OverscanRows = 2;
    out.VFlushBinning = 4;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 50;
    out.PixelSizeX = 12;
    out.PixelSizeY = 12;
    out.Color = 0;
    out.ReportedGainSixteenBit = 1.5;
    out.MinSuggestedExpTime = 30;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -20;
    out.TempRampRateOne = 700;
    out.TempRampRateTwo = 4000;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Alta_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Alta_Twelve;
    out.PrimaryADLatency = 1;
    out.AlternativeADLatency = 12;
    out.IRPreflashTime = 160;
    out.AdCfg = 8;
    out.DefaultGainLeft = 100;
    out.DefaultOffsetLeft = 100;
    out.DefaultGainRight = 0;
    out.DefaultOffsetRight = 0;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 0;
    out.VideoSubSample = 1;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "HV1";
    out.ClampPatternNormal = "H16HS";
    out.SkipPatternNormal = "H16HS";
    out.RoiPatternNormal = "H16HR";
    out.ClampPatternFast = "H12HC";
    out.SkipPatternFast = "H12HS";
    out.RoiPatternFast = "H12HR";
    out.VerticalPatternVideo= "NoOpV";
    out.ClampPatternVideo = "NoOpH";
    out.SkipPatternVideo = "NoOpH";
    out.RoiPatternVideo = "NoOpH";
}


void camMetaData::getMeta15(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "S101401009";
    out.CameraId = 15;
    out.CameraLine = "Alta";
    out.CameraModel = "1009";
    out.InterlineCCD = 0;
    out.SupportsSerialA = 1;
    out.SupportsSerialB = 1;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 1044;
    out.ImagingColumns = 1024;
    out.ClampColumns = 10;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 10;
    out.TotalRows = 512;
    out.ImagingRows = 506;
    out.UnderscanRows = 4;
    out.OverscanRows = 2;
    out.VFlushBinning = 4;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 50;
    out.PixelSizeX = 12;
    out.PixelSizeY = 12;
    out.Color = 0;
    out.ReportedGainSixteenBit = 1.5;
    out.MinSuggestedExpTime = 30;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -20;
    out.TempRampRateOne = 700;
    out.TempRampRateTwo = 4000;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Alta_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Alta_Twelve;
    out.PrimaryADLatency = 1;
    out.AlternativeADLatency = 12;
    out.IRPreflashTime = 160;
    out.AdCfg = 8;
    out.DefaultGainLeft = 100;
    out.DefaultOffsetLeft = 100;
    out.DefaultGainRight = 0;
    out.DefaultOffsetRight = 0;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 0;
    out.VideoSubSample = 1;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "HV1";
    out.ClampPatternNormal = "H16HS";
    out.SkipPatternNormal = "H16HS";
    out.RoiPatternNormal = "H16HR";
    out.ClampPatternFast = "H12HC";
    out.SkipPatternFast = "H12HS";
    out.RoiPatternFast = "H12HR";
    out.VerticalPatternVideo= "NoOpV";
    out.ClampPatternVideo = "NoOpH";
    out.SkipPatternVideo = "NoOpH";
    out.RoiPatternVideo = "NoOpH";
}


void camMetaData::getMeta13(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "CCD4240NIMOD9";
    out.CameraId = 13;
    out.CameraLine = "Alta";
    out.CameraModel = "42D9";
    out.InterlineCCD = 0;
    out.SupportsSerialA = 1;
    out.SupportsSerialB = 1;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 2148;
    out.ImagingColumns = 2048;
    out.ClampColumns = 50;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 50;
    out.TotalRows = 2052;
    out.ImagingRows = 2048;
    out.UnderscanRows = 2;
    out.OverscanRows = 2;
    out.VFlushBinning = 1;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 450;
    out.PixelSizeX = 13.5;
    out.PixelSizeY = 13.5;
    out.Color = 0;
    out.ReportedGainSixteenBit = 2;
    out.MinSuggestedExpTime = 30;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -20;
    out.TempRampRateOne = 700;
    out.TempRampRateTwo = 4000;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Alta_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Alta_Twelve;
    out.PrimaryADLatency = 1;
    out.AlternativeADLatency = 12;
    out.IRPreflashTime = 35;
    out.AdCfg = 8;
    out.DefaultGainLeft = 400;
    out.DefaultOffsetLeft = 200;
    out.DefaultGainRight = 0;
    out.DefaultOffsetRight = 0;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 0;
    out.VideoSubSample = 1;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "MV2CN";
    out.ClampPatternNormal = "M16HS1C";
    out.SkipPatternNormal = "M16HS1C";
    out.RoiPatternNormal = "M16HR3C";
    out.ClampPatternFast = "M12HCC";
    out.SkipPatternFast = "M12HSC";
    out.RoiPatternFast = "M12HRC";
    out.VerticalPatternVideo= "NoOpV";
    out.ClampPatternVideo = "NoOpH";
    out.SkipPatternVideo = "NoOpH";
    out.RoiPatternVideo = "NoOpH";
}


void camMetaData::getMeta45(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "KAF09000D9";
    out.CameraId = 45;
    out.CameraLine = "Alta";
    out.CameraModel = "9000D9";
    out.InterlineCCD = 0;
    out.SupportsSerialA = 1;
    out.SupportsSerialB = 1;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 3103;
    out.ImagingColumns = 3056;
    out.ClampColumns = 35;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 12;
    out.TotalRows = 3086;
    out.ImagingRows = 3056;
    out.UnderscanRows = 20;
    out.OverscanRows = 10;
    out.VFlushBinning = 1;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 300;
    out.PixelSizeX = 12;
    out.PixelSizeY = 12;
    out.Color = 0;
    out.ReportedGainSixteenBit = 1.5;
    out.MinSuggestedExpTime = 30;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -20;
    out.TempRampRateOne = 1500;
    out.TempRampRateTwo = 4000;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Alta_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Alta_Twelve;
    out.PrimaryADLatency = 1;
    out.AlternativeADLatency = 12;
    out.IRPreflashTime = 160;
    out.AdCfg = 8;
    out.DefaultGainLeft = 0;
    out.DefaultOffsetLeft = 150;
    out.DefaultGainRight = 0;
    out.DefaultOffsetRight = 0;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 0;
    out.VideoSubSample = 1;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "KV7B";
    out.ClampPatternNormal = "K16HS7";
    out.SkipPatternNormal = "K16HS7";
    out.RoiPatternNormal = "K16HR7";
    out.ClampPatternFast = "K12HC7";
    out.SkipPatternFast = "K12HS7";
    out.RoiPatternFast = "K12HR7";
    out.VerticalPatternVideo= "NoOpV";
    out.ClampPatternVideo = "NoOpH";
    out.SkipPatternVideo = "NoOpH";
    out.RoiPatternVideo = "NoOpH";
}


void camMetaData::getMeta46(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "KAF16801ED9";
    out.CameraId = 46;
    out.CameraLine = "Alta";
    out.CameraModel = "16D9";
    out.InterlineCCD = 0;
    out.SupportsSerialA = 1;
    out.SupportsSerialB = 1;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 4152;
    out.ImagingColumns = 4096;
    out.ClampColumns = 36;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 20;
    out.TotalRows = 4129;
    out.ImagingRows = 4096;
    out.UnderscanRows = 21;
    out.OverscanRows = 11;
    out.VFlushBinning = 1;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 300;
    out.PixelSizeX = 9;
    out.PixelSizeY = 9;
    out.Color = 0;
    out.ReportedGainSixteenBit = 1.5;
    out.MinSuggestedExpTime = 30;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -20;
    out.TempRampRateOne = 1500;
    out.TempRampRateTwo = 4000;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Alta_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Alta_Twelve;
    out.PrimaryADLatency = 1;
    out.AlternativeADLatency = 12;
    out.IRPreflashTime = 160;
    out.AdCfg = 8;
    out.DefaultGainLeft = 100;
    out.DefaultOffsetLeft = 255;
    out.DefaultGainRight = 0;
    out.DefaultOffsetRight = 0;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 0;
    out.VideoSubSample = 1;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "KV4B";
    out.ClampPatternNormal = "K16HC2";
    out.SkipPatternNormal = "K16HS2";
    out.RoiPatternNormal = "K16HR2";
    out.ClampPatternFast = "K12HC2";
    out.SkipPatternFast = "K12HS2";
    out.RoiPatternFast = "K12HR2";
    out.VerticalPatternVideo= "NoOpV";
    out.ClampPatternVideo = "NoOpH";
    out.SkipPatternVideo = "NoOpH";
    out.RoiPatternVideo = "NoOpH";
}


void camMetaData::getMeta47(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "KAF16803D9";
    out.CameraId = 47;
    out.CameraLine = "Alta";
    out.CameraModel = "16MD9";
    out.InterlineCCD = 0;
    out.SupportsSerialA = 1;
    out.SupportsSerialB = 1;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 4152;
    out.ImagingColumns = 4096;
    out.ClampColumns = 36;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 20;
    out.TotalRows = 4129;
    out.ImagingRows = 4096;
    out.UnderscanRows = 21;
    out.OverscanRows = 11;
    out.VFlushBinning = 1;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 300;
    out.PixelSizeX = 9;
    out.PixelSizeY = 9;
    out.Color = 0;
    out.ReportedGainSixteenBit = 1.5;
    out.MinSuggestedExpTime = 30;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -20;
    out.TempRampRateOne = 1500;
    out.TempRampRateTwo = 4000;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Alta_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Alta_Twelve;
    out.PrimaryADLatency = 1;
    out.AlternativeADLatency = 12;
    out.IRPreflashTime = 160;
    out.AdCfg = 8;
    out.DefaultGainLeft = 100;
    out.DefaultOffsetLeft = 255;
    out.DefaultGainRight = 0;
    out.DefaultOffsetRight = 0;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 0;
    out.VideoSubSample = 1;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "KV7B";
    out.ClampPatternNormal = "K16HS7";
    out.SkipPatternNormal = "K16HS7";
    out.RoiPatternNormal = "K16HR7";
    out.ClampPatternFast = "K12HC7";
    out.SkipPatternFast = "K12HS7";
    out.RoiPatternFast = "K12HR7";
    out.VerticalPatternVideo= "NoOpV";
    out.ClampPatternVideo = "NoOpH";
    out.SkipPatternVideo = "NoOpH";
    out.RoiPatternVideo = "NoOpH";
}


void camMetaData::getMeta48(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "F3041D9";
    out.CameraId = 48;
    out.CameraLine = "Alta";
    out.CameraModel = "3041D9";
    out.InterlineCCD = 0;
    out.SupportsSerialA = 1;
    out.SupportsSerialB = 1;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 2080;
    out.ImagingColumns = 2048;
    out.ClampColumns = 16;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 16;
    out.TotalRows = 2112;
    out.ImagingRows = 2048;
    out.UnderscanRows = 32;
    out.OverscanRows = 32;
    out.VFlushBinning = 4;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 50;
    out.PixelSizeX = 15;
    out.PixelSizeY = 15;
    out.Color = 0;
    out.ReportedGainSixteenBit = 1;
    out.MinSuggestedExpTime = 30;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -20;
    out.TempRampRateOne = 700;
    out.TempRampRateTwo = 4000;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Alta_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Alta_Sixteen;
    out.PrimaryADLatency = 1;
    out.AlternativeADLatency = 12;
    out.IRPreflashTime = 160;
    out.AdCfg = 8;
    out.DefaultGainLeft = 100;
    out.DefaultOffsetLeft = 100;
    out.DefaultGainRight = 0;
    out.DefaultOffsetRight = 0;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 0;
    out.VideoSubSample = 1;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "FV1B";
    out.ClampPatternNormal = "F16HS1B";
    out.SkipPatternNormal = "F16HS1B";
    out.RoiPatternNormal = "F16HR1B";
    out.ClampPatternFast = "F16HS1B";
    out.SkipPatternFast = "F16HS1B";
    out.RoiPatternFast = "F16HR1B";
    out.VerticalPatternVideo= "NoOpV";
    out.ClampPatternVideo = "NoOpH";
    out.SkipPatternVideo = "NoOpH";
    out.RoiPatternVideo = "NoOpH";
}


void camMetaData::getMeta49(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "KAF0401ENSD";
    out.CameraId = 49;
    out.CameraLine = "Alta";
    out.CameraModel = "1NSD";
    out.InterlineCCD = 0;
    out.SupportsSerialA = 1;
    out.SupportsSerialB = 1;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 796;
    out.ImagingColumns = 768;
    out.ClampColumns = 14;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 14;
    out.TotalRows = 520;
    out.ImagingRows = 512;
    out.UnderscanRows = 4;
    out.OverscanRows = 4;
    out.VFlushBinning = 1;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 0;
    out.PixelSizeX = 9;
    out.PixelSizeY = 9;
    out.Color = 0;
    out.ReportedGainSixteenBit = 1.5;
    out.MinSuggestedExpTime = 10;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -20;
    out.TempRampRateOne = 700;
    out.TempRampRateTwo = 4000;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Alta_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Alta_Twelve;
    out.PrimaryADLatency = 1;
    out.AlternativeADLatency = 12;
    out.IRPreflashTime = 160;
    out.AdCfg = 8;
    out.DefaultGainLeft = 0;
    out.DefaultOffsetLeft = 100;
    out.DefaultGainRight = 0;
    out.DefaultOffsetRight = 0;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 0;
    out.VideoSubSample = 1;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "KV5ns";
    out.ClampPatternNormal = "K16HS3";
    out.SkipPatternNormal = "K16HS3";
    out.RoiPatternNormal = "K16HR3ns";
    out.ClampPatternFast = "K12HC3";
    out.SkipPatternFast = "K12HS3";
    out.RoiPatternFast = "K12HR3";
    out.VerticalPatternVideo= "NoOpV";
    out.ClampPatternVideo = "NoOpH";
    out.SkipPatternVideo = "NoOpH";
    out.RoiPatternVideo = "NoOpH";
}


void camMetaData::getMeta50(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "KAF8300C";
    out.CameraId = 50;
    out.CameraLine = "Alta";
    out.CameraModel = "8300C";
    out.InterlineCCD = 0;
    out.SupportsSerialA = 1;
    out.SupportsSerialB = 1;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 3448;
    out.ImagingColumns = 3326;
    out.ClampColumns = 43;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 79;
    out.TotalRows = 2574;
    out.ImagingRows = 2504;
    out.UnderscanRows = 46;
    out.OverscanRows = 24;
    out.VFlushBinning = 1;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 300;
    out.PixelSizeX = 5.4;
    out.PixelSizeY = 5.4;
    out.Color = 1;
    out.ReportedGainSixteenBit = 1.5;
    out.MinSuggestedExpTime = 30;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -20;
    out.TempRampRateOne = 1500;
    out.TempRampRateTwo = 4000;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Alta_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Alta_Twelve;
    out.PrimaryADLatency = 1;
    out.AlternativeADLatency = 12;
    out.IRPreflashTime = 160;
    out.AdCfg = 8;
    out.DefaultGainLeft = 0;
    out.DefaultOffsetLeft = 150;
    out.DefaultGainRight = 0;
    out.DefaultOffsetRight = 0;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 0;
    out.VideoSubSample = 1;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "KV9";
    out.ClampPatternNormal = "K16HS9";
    out.SkipPatternNormal = "K16HS9";
    out.RoiPatternNormal = "K16HR9";
    out.ClampPatternFast = "K12HC9";
    out.SkipPatternFast = "K12HS9";
    out.RoiPatternFast = "K12HR9";
    out.VerticalPatternVideo= "NoOpV";
    out.ClampPatternVideo = "NoOpH";
    out.SkipPatternVideo = "NoOpH";
    out.RoiPatternVideo = "NoOpH";
}


void camMetaData::getMeta51(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "CCD4240D9";
    out.CameraId = 51;
    out.CameraLine = "Alta";
    out.CameraModel = "42D9";
    out.InterlineCCD = 0;
    out.SupportsSerialA = 1;
    out.SupportsSerialB = 1;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 2148;
    out.ImagingColumns = 2048;
    out.ClampColumns = 50;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 50;
    out.TotalRows = 2052;
    out.ImagingRows = 2048;
    out.UnderscanRows = 2;
    out.OverscanRows = 2;
    out.VFlushBinning = 1;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 450;
    out.PixelSizeX = 13.5;
    out.PixelSizeY = 13.5;
    out.Color = 0;
    out.ReportedGainSixteenBit = 2;
    out.MinSuggestedExpTime = 30;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -20;
    out.TempRampRateOne = 700;
    out.TempRampRateTwo = 4000;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Alta_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Alta_Twelve;
    out.PrimaryADLatency = 1;
    out.AlternativeADLatency = 12;
    out.IRPreflashTime = 35;
    out.AdCfg = 8;
    out.DefaultGainLeft = 400;
    out.DefaultOffsetLeft = 200;
    out.DefaultGainRight = 0;
    out.DefaultOffsetRight = 0;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 0;
    out.VideoSubSample = 1;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "MV2C";
    out.ClampPatternNormal = "M16HS1C";
    out.SkipPatternNormal = "M16HS1C";
    out.RoiPatternNormal = "M16HR3C";
    out.ClampPatternFast = "M12HCC";
    out.SkipPatternFast = "M12HSC";
    out.RoiPatternFast = "M12HRC";
    out.VerticalPatternVideo= "NoOpV";
    out.ClampPatternVideo = "NoOpH";
    out.SkipPatternVideo = "NoOpH";
    out.RoiPatternVideo = "NoOpH";
}


void camMetaData::getMeta52(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "KAF1001EBD9";
    out.CameraId = 52;
    out.CameraLine = "Alta";
    out.CameraModel = "6D9";
    out.InterlineCCD = 0;
    out.SupportsSerialA = 1;
    out.SupportsSerialB = 1;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 1044;
    out.ImagingColumns = 1024;
    out.ClampColumns = 8;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 12;
    out.TotalRows = 1032;
    out.ImagingRows = 1024;
    out.UnderscanRows = 4;
    out.OverscanRows = 4;
    out.VFlushBinning = 1;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 300;
    out.PixelSizeX = 24;
    out.PixelSizeY = 24;
    out.Color = 0;
    out.ReportedGainSixteenBit = 3;
    out.MinSuggestedExpTime = 30;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -20;
    out.TempRampRateOne = 700;
    out.TempRampRateTwo = 4000;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Alta_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Alta_Twelve;
    out.PrimaryADLatency = 1;
    out.AlternativeADLatency = 12;
    out.IRPreflashTime = 160;
    out.AdCfg = 8;
    out.DefaultGainLeft = 0;
    out.DefaultOffsetLeft = 250;
    out.DefaultGainRight = 0;
    out.DefaultOffsetRight = 0;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 0;
    out.VideoSubSample = 1;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "KV5";
    out.ClampPatternNormal = "K16HS3i";
    out.SkipPatternNormal = "K16HS3i";
    out.RoiPatternNormal = "K16HR3i";
    out.ClampPatternFast = "K12HC3i";
    out.SkipPatternFast = "K12HS3i";
    out.RoiPatternFast = "K12HR3i";
    out.VerticalPatternVideo= "NoOpV";
    out.ClampPatternVideo = "NoOpH";
    out.SkipPatternVideo = "NoOpH";
    out.RoiPatternVideo = "NoOpH";
}


void camMetaData::getMeta53(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "CCD4710D9";
    out.CameraId = 53;
    out.CameraLine = "Alta";
    out.CameraModel = "47D9";
    out.InterlineCCD = 0;
    out.SupportsSerialA = 1;
    out.SupportsSerialB = 1;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 1072;
    out.ImagingColumns = 1024;
    out.ClampColumns = 24;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 24;
    out.TotalRows = 1027;
    out.ImagingRows = 1024;
    out.UnderscanRows = 3;
    out.OverscanRows = 0;
    out.VFlushBinning = 1;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 1;
    out.ShutterCloseDelay = 300;
    out.PixelSizeX = 13;
    out.PixelSizeY = 13;
    out.Color = 0;
    out.ReportedGainSixteenBit = 2;
    out.MinSuggestedExpTime = 30;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -20;
    out.TempRampRateOne = 700;
    out.TempRampRateTwo = 4000;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Alta_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Alta_Twelve;
    out.PrimaryADLatency = 1;
    out.AlternativeADLatency = 12;
    out.IRPreflashTime = 160;
    out.AdCfg = 8;
    out.DefaultGainLeft = 400;
    out.DefaultOffsetLeft = 200;
    out.DefaultGainRight = 0;
    out.DefaultOffsetRight = 0;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 0;
    out.VideoSubSample = 1;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "MV1i";
    out.ClampPatternNormal = "M16HS1i";
    out.SkipPatternNormal = "M16HS1i";
    out.RoiPatternNormal = "M16HR3i";
    out.ClampPatternFast = "M12HCi";
    out.SkipPatternFast = "M12HSi";
    out.RoiPatternFast = "M12HRi";
    out.VerticalPatternVideo= "NoOpV";
    out.ClampPatternVideo = "NoOpH";
    out.SkipPatternVideo = "NoOpH";
    out.RoiPatternVideo = "NoOpH";
}


void camMetaData::getMeta54(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "CCD7700D9";
    out.CameraId = 54;
    out.CameraLine = "Alta";
    out.CameraModel = "77D9";
    out.InterlineCCD = 0;
    out.SupportsSerialA = 1;
    out.SupportsSerialB = 1;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 527;
    out.ImagingColumns = 512;
    out.ClampColumns = 15;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 0;
    out.TotalRows = 512;
    out.ImagingRows = 512;
    out.UnderscanRows = 0;
    out.OverscanRows = 0;
    out.VFlushBinning = 1;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 300;
    out.PixelSizeX = 24;
    out.PixelSizeY = 24;
    out.Color = 0;
    out.ReportedGainSixteenBit = 2;
    out.MinSuggestedExpTime = 30;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -20;
    out.TempRampRateOne = 700;
    out.TempRampRateTwo = 4000;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Alta_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Alta_Twelve;
    out.PrimaryADLatency = 1;
    out.AlternativeADLatency = 12;
    out.IRPreflashTime = 160;
    out.AdCfg = 8;
    out.DefaultGainLeft = 400;
    out.DefaultOffsetLeft = 200;
    out.DefaultGainRight = 0;
    out.DefaultOffsetRight = 0;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 0;
    out.VideoSubSample = 1;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "MV7i";
    out.ClampPatternNormal = "M16HS7i";
    out.SkipPatternNormal = "M16HS7i";
    out.RoiPatternNormal = "M16HR7i";
    out.ClampPatternFast = "M12HC7i";
    out.SkipPatternFast = "M12HS7i";
    out.RoiPatternFast = "M12HR7i";
    out.VerticalPatternVideo= "NoOpV";
    out.ClampPatternVideo = "NoOpH";
    out.SkipPatternVideo = "NoOpH";
    out.RoiPatternVideo = "NoOpH";
}


void camMetaData::getMeta55(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "KAF09000D7D9";
    out.CameraId = 55;
    out.CameraLine = "Alta";
    out.CameraModel = "9000D7D9";
    out.InterlineCCD = 0;
    out.SupportsSerialA = 1;
    out.SupportsSerialB = 1;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 3103;
    out.ImagingColumns = 3056;
    out.ClampColumns = 35;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 12;
    out.TotalRows = 3086;
    out.ImagingRows = 3056;
    out.UnderscanRows = 20;
    out.OverscanRows = 10;
    out.VFlushBinning = 1;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 300;
    out.PixelSizeX = 12;
    out.PixelSizeY = 12;
    out.Color = 0;
    out.ReportedGainSixteenBit = 1.5;
    out.MinSuggestedExpTime = 30;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -20;
    out.TempRampRateOne = 1500;
    out.TempRampRateTwo = 4000;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Alta_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Alta_Twelve;
    out.PrimaryADLatency = 1;
    out.AlternativeADLatency = 12;
    out.IRPreflashTime = 160;
    out.AdCfg = 8;
    out.DefaultGainLeft = 0;
    out.DefaultOffsetLeft = 150;
    out.DefaultGainRight = 0;
    out.DefaultOffsetRight = 0;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 0;
    out.VideoSubSample = 1;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "KV7B";
    out.ClampPatternNormal = "K16HS7";
    out.SkipPatternNormal = "K16HS7";
    out.RoiPatternNormal = "K16HR7";
    out.ClampPatternFast = "K12HC7";
    out.SkipPatternFast = "K12HS7";
    out.RoiPatternFast = "K12HR7";
    out.VerticalPatternVideo= "NoOpV";
    out.ClampPatternVideo = "NoOpH";
    out.SkipPatternVideo = "NoOpH";
    out.RoiPatternVideo = "NoOpH";
}


void camMetaData::getMeta56(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "KAF16801ED7D9";
    out.CameraId = 56;
    out.CameraLine = "Alta";
    out.CameraModel = "16D7D9";
    out.InterlineCCD = 0;
    out.SupportsSerialA = 1;
    out.SupportsSerialB = 1;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 4152;
    out.ImagingColumns = 4096;
    out.ClampColumns = 36;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 20;
    out.TotalRows = 4129;
    out.ImagingRows = 4096;
    out.UnderscanRows = 21;
    out.OverscanRows = 11;
    out.VFlushBinning = 1;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 300;
    out.PixelSizeX = 9;
    out.PixelSizeY = 9;
    out.Color = 0;
    out.ReportedGainSixteenBit = 1.5;
    out.MinSuggestedExpTime = 30;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -20;
    out.TempRampRateOne = 1500;
    out.TempRampRateTwo = 4000;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Alta_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Alta_Twelve;
    out.PrimaryADLatency = 1;
    out.AlternativeADLatency = 12;
    out.IRPreflashTime = 160;
    out.AdCfg = 8;
    out.DefaultGainLeft = 100;
    out.DefaultOffsetLeft = 255;
    out.DefaultGainRight = 0;
    out.DefaultOffsetRight = 0;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 0;
    out.VideoSubSample = 1;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "KV4B";
    out.ClampPatternNormal = "K16HC2";
    out.SkipPatternNormal = "K16HS2";
    out.RoiPatternNormal = "K16HR2";
    out.ClampPatternFast = "K12HC2";
    out.SkipPatternFast = "K12HS2";
    out.RoiPatternFast = "K12HR2";
    out.VerticalPatternVideo= "NoOpV";
    out.ClampPatternVideo = "NoOpH";
    out.SkipPatternVideo = "NoOpH";
    out.RoiPatternVideo = "NoOpH";
}


void camMetaData::getMeta57(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "KAF16803D7D9";
    out.CameraId = 57;
    out.CameraLine = "Alta";
    out.CameraModel = "16MD7D9";
    out.InterlineCCD = 0;
    out.SupportsSerialA = 1;
    out.SupportsSerialB = 1;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 4152;
    out.ImagingColumns = 4096;
    out.ClampColumns = 36;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 20;
    out.TotalRows = 4129;
    out.ImagingRows = 4096;
    out.UnderscanRows = 21;
    out.OverscanRows = 11;
    out.VFlushBinning = 1;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 300;
    out.PixelSizeX = 9;
    out.PixelSizeY = 9;
    out.Color = 0;
    out.ReportedGainSixteenBit = 1.5;
    out.MinSuggestedExpTime = 30;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -20;
    out.TempRampRateOne = 1500;
    out.TempRampRateTwo = 4000;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Alta_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Alta_Twelve;
    out.PrimaryADLatency = 1;
    out.AlternativeADLatency = 12;
    out.IRPreflashTime = 160;
    out.AdCfg = 8;
    out.DefaultGainLeft = 100;
    out.DefaultOffsetLeft = 255;
    out.DefaultGainRight = 0;
    out.DefaultOffsetRight = 0;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 0;
    out.VideoSubSample = 1;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "KV7B";
    out.ClampPatternNormal = "K16HS7";
    out.SkipPatternNormal = "K16HS7";
    out.RoiPatternNormal = "K16HR7";
    out.ClampPatternFast = "K12HC7";
    out.SkipPatternFast = "K12HS7";
    out.RoiPatternFast = "K12HR7";
    out.VerticalPatternVideo= "NoOpV";
    out.ClampPatternVideo = "NoOpH";
    out.SkipPatternVideo = "NoOpH";
    out.RoiPatternVideo = "NoOpH";
}


void camMetaData::getMeta59(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "KAF6302";
    out.CameraId = 59;
    out.CameraLine = "Alta";
    out.CameraModel = "9K6302";
    out.InterlineCCD = 0;
    out.SupportsSerialA = 1;
    out.SupportsSerialB = 1;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 3100;
    out.ImagingColumns = 3073;
    out.ClampColumns = 15;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 12;
    out.TotalRows = 2056;
    out.ImagingRows = 2048;
    out.UnderscanRows = 4;
    out.OverscanRows = 4;
    out.VFlushBinning = 1;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 300;
    out.PixelSizeX = 9;
    out.PixelSizeY = 9;
    out.Color = 0;
    out.ReportedGainSixteenBit = 1.5;
    out.MinSuggestedExpTime = 20;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -20;
    out.TempRampRateOne = 700;
    out.TempRampRateTwo = 4000;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Alta_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Alta_Twelve;
    out.PrimaryADLatency = 1;
    out.AlternativeADLatency = 12;
    out.IRPreflashTime = 160;
    out.AdCfg = 8;
    out.DefaultGainLeft = 0;
    out.DefaultOffsetLeft = 100;
    out.DefaultGainRight = 0;
    out.DefaultOffsetRight = 0;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 0;
    out.VideoSubSample = 1;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "KV5";
    out.ClampPatternNormal = "K16HS3";
    out.SkipPatternNormal = "K16HS3";
    out.RoiPatternNormal = "K16HR31";
    out.ClampPatternFast = "K12HC3";
    out.SkipPatternFast = "K12HS3";
    out.RoiPatternFast = "K12HR3";
    out.VerticalPatternVideo= "NoOpV";
    out.ClampPatternVideo = "NoOpH";
    out.SkipPatternVideo = "NoOpH";
    out.RoiPatternVideo = "NoOpH";
}


void camMetaData::getMeta58(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "KAF09000XD7D9";
    out.CameraId = 58;
    out.CameraLine = "Alta";
    out.CameraModel = "9000XD7D9";
    out.InterlineCCD = 0;
    out.SupportsSerialA = 1;
    out.SupportsSerialB = 1;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 3103;
    out.ImagingColumns = 3056;
    out.ClampColumns = 35;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 12;
    out.TotalRows = 3086;
    out.ImagingRows = 3056;
    out.UnderscanRows = 20;
    out.OverscanRows = 10;
    out.VFlushBinning = 1;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 300;
    out.PixelSizeX = 12;
    out.PixelSizeY = 12;
    out.Color = 0;
    out.ReportedGainSixteenBit = 1.5;
    out.MinSuggestedExpTime = 30;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -20;
    out.TempRampRateOne = 1500;
    out.TempRampRateTwo = 4000;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Alta_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Alta_Twelve;
    out.PrimaryADLatency = 1;
    out.AlternativeADLatency = 12;
    out.IRPreflashTime = 160;
    out.AdCfg = 8;
    out.DefaultGainLeft = 0;
    out.DefaultOffsetLeft = 150;
    out.DefaultGainRight = 0;
    out.DefaultOffsetRight = 0;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 0;
    out.VideoSubSample = 1;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "KV7B";
    out.ClampPatternNormal = "K16HS8";
    out.SkipPatternNormal = "K16HS8";
    out.RoiPatternNormal = "K16HR8";
    out.ClampPatternFast = "K12HC7";
    out.SkipPatternFast = "K12HS7";
    out.RoiPatternFast = "K12HR7";
    out.VerticalPatternVideo= "NoOpV";
    out.ClampPatternVideo = "NoOpH";
    out.SkipPatternVideo = "NoOpH";
    out.RoiPatternVideo = "NoOpH";
}


void camMetaData::getMeta61(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "CCD230_42";
    out.CameraId = 61;
    out.CameraLine = "Alta";
    out.CameraModel = "230";
    out.InterlineCCD = 0;
    out.SupportsSerialA = 1;
    out.SupportsSerialB = 1;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 2148;
    out.ImagingColumns = 2048;
    out.ClampColumns = 50;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 50;
    out.TotalRows = 2064;
    out.ImagingRows = 2048;
    out.UnderscanRows = 8;
    out.OverscanRows = 8;
    out.VFlushBinning = 1;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 300;
    out.PixelSizeX = 15;
    out.PixelSizeY = 15;
    out.Color = 0;
    out.ReportedGainSixteenBit = 2.4;
    out.MinSuggestedExpTime = 30;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -20;
    out.TempRampRateOne = 700;
    out.TempRampRateTwo = 4000;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Alta_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Alta_Twelve;
    out.PrimaryADLatency = 1;
    out.AlternativeADLatency = 12;
    out.IRPreflashTime = 160;
    out.AdCfg = 8;
    out.DefaultGainLeft = 0;
    out.DefaultOffsetLeft = 100;
    out.DefaultGainRight = 0;
    out.DefaultOffsetRight = 0;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 0;
    out.VideoSubSample = 1;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "MV230";
    out.ClampPatternNormal = "M16HS230";
    out.SkipPatternNormal = "M16HS230";
    out.RoiPatternNormal = "M16HR230";
    out.ClampPatternFast = "M16HS230";
    out.SkipPatternFast = "M16HS230";
    out.RoiPatternFast = "M16HR230";
    out.VerticalPatternVideo= "NoOpV";
    out.ClampPatternVideo = "NoOpH";
    out.SkipPatternVideo = "NoOpH";
    out.RoiPatternVideo = "NoOpH";
}


void camMetaData::getMeta62(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "KAF6303EBD9";
    out.CameraId = 62;
    out.CameraLine = "Alta";
    out.CameraModel = "9D9";
    out.InterlineCCD = 0;
    out.SupportsSerialA = 1;
    out.SupportsSerialB = 1;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 3100;
    out.ImagingColumns = 3073;
    out.ClampColumns = 15;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 12;
    out.TotalRows = 2056;
    out.ImagingRows = 2048;
    out.UnderscanRows = 4;
    out.OverscanRows = 4;
    out.VFlushBinning = 1;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 300;
    out.PixelSizeX = 9;
    out.PixelSizeY = 9;
    out.Color = 0;
    out.ReportedGainSixteenBit = 1.5;
    out.MinSuggestedExpTime = 30;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -20;
    out.TempRampRateOne = 700;
    out.TempRampRateTwo = 4000;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Alta_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Alta_Twelve;
    out.PrimaryADLatency = 1;
    out.AlternativeADLatency = 12;
    out.IRPreflashTime = 160;
    out.AdCfg = 8;
    out.DefaultGainLeft = 0;
    out.DefaultOffsetLeft = 100;
    out.DefaultGainRight = 0;
    out.DefaultOffsetRight = 0;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 0;
    out.VideoSubSample = 1;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "KV5";
    out.ClampPatternNormal = "K16HS3i";
    out.SkipPatternNormal = "K16HS3i";
    out.RoiPatternNormal = "K16HR3i";
    out.ClampPatternFast = "K12HC3i";
    out.SkipPatternFast = "K12HS3i";
    out.RoiPatternFast = "K12HR3i";
    out.VerticalPatternVideo= "NoOpV";
    out.ClampPatternVideo = "NoOpH";
    out.SkipPatternVideo = "NoOpH";
    out.RoiPatternVideo = "NoOpH";
}


void camMetaData::getMeta63(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "CCD3011D9";
    out.CameraId = 63;
    out.CameraLine = "Alta";
    out.CameraModel = "30D9";
    out.InterlineCCD = 0;
    out.SupportsSerialA = 1;
    out.SupportsSerialB = 1;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 1040;
    out.ImagingColumns = 1024;
    out.ClampColumns = 8;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 8;
    out.TotalRows = 256;
    out.ImagingRows = 256;
    out.UnderscanRows = 0;
    out.OverscanRows = 0;
    out.VFlushBinning = 1;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 300;
    out.PixelSizeX = 26;
    out.PixelSizeY = 26;
    out.Color = 0;
    out.ReportedGainSixteenBit = 2;
    out.MinSuggestedExpTime = 30;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -20;
    out.TempRampRateOne = 700;
    out.TempRampRateTwo = 4000;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Alta_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Alta_Twelve;
    out.PrimaryADLatency = 1;
    out.AlternativeADLatency = 12;
    out.IRPreflashTime = 160;
    out.AdCfg = 8;
    out.DefaultGainLeft = 400;
    out.DefaultOffsetLeft = 200;
    out.DefaultGainRight = 0;
    out.DefaultOffsetRight = 0;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 0;
    out.VideoSubSample = 1;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "MV2i";
    out.ClampPatternNormal = "M16HS1i";
    out.SkipPatternNormal = "M16HS1i";
    out.RoiPatternNormal = "M16HR5i";
    out.ClampPatternFast = "M12HCi";
    out.SkipPatternFast = "M12HSi";
    out.RoiPatternFast = "M12HRi";
    out.VerticalPatternVideo= "NoOpV";
    out.ClampPatternVideo = "NoOpH";
    out.SkipPatternVideo = "NoOpH";
    out.RoiPatternVideo = "NoOpH";
}


void camMetaData::getMeta25(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "S101401107D9";
    out.CameraId = 25;
    out.CameraLine = "Alta";
    out.CameraModel = "1107D9";
    out.InterlineCCD = 0;
    out.SupportsSerialA = 1;
    out.SupportsSerialB = 1;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 2068;
    out.ImagingColumns = 2048;
    out.ClampColumns = 10;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 10;
    out.TotalRows = 128;
    out.ImagingRows = 122;
    out.UnderscanRows = 4;
    out.OverscanRows = 2;
    out.VFlushBinning = 4;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 300;
    out.PixelSizeX = 12;
    out.PixelSizeY = 12;
    out.Color = 0;
    out.ReportedGainSixteenBit = 1;
    out.MinSuggestedExpTime = 30;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -20;
    out.TempRampRateOne = 700;
    out.TempRampRateTwo = 4000;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Alta_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Alta_Twelve;
    out.PrimaryADLatency = 1;
    out.AlternativeADLatency = 12;
    out.IRPreflashTime = 160;
    out.AdCfg = 8;
    out.DefaultGainLeft = 100;
    out.DefaultOffsetLeft = 100;
    out.DefaultGainRight = 0;
    out.DefaultOffsetRight = 0;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 0;
    out.VideoSubSample = 1;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "HV1";
    out.ClampPatternNormal = "H16HSi";
    out.SkipPatternNormal = "H16HSi";
    out.RoiPatternNormal = "H16HRi";
    out.ClampPatternFast = "H12HCi";
    out.SkipPatternFast = "H12HSi";
    out.RoiPatternFast = "H12HRi";
    out.VerticalPatternVideo= "NoOpV";
    out.ClampPatternVideo = "NoOpH";
    out.SkipPatternVideo = "NoOpH";
    out.RoiPatternVideo = "NoOpH";
}


void camMetaData::getMeta27(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "S101401109D9";
    out.CameraId = 27;
    out.CameraLine = "Alta";
    out.CameraModel = "1109D9";
    out.InterlineCCD = 0;
    out.SupportsSerialA = 1;
    out.SupportsSerialB = 1;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 2068;
    out.ImagingColumns = 2048;
    out.ClampColumns = 10;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 10;
    out.TotalRows = 512;
    out.ImagingRows = 506;
    out.UnderscanRows = 4;
    out.OverscanRows = 2;
    out.VFlushBinning = 4;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 2;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 301;
    out.PixelSizeX = 12;
    out.PixelSizeY = 12;
    out.Color = 0;
    out.ReportedGainSixteenBit = 1;
    out.MinSuggestedExpTime = 30;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -20;
    out.TempRampRateOne = 700;
    out.TempRampRateTwo = 4000;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Alta_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Alta_Twelve;
    out.PrimaryADLatency = 1;
    out.AlternativeADLatency = 12;
    out.IRPreflashTime = 160;
    out.AdCfg = 8;
    out.DefaultGainLeft = 100;
    out.DefaultOffsetLeft = 100;
    out.DefaultGainRight = 0;
    out.DefaultOffsetRight = 0;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 0;
    out.VideoSubSample = 1;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "HV1";
    out.ClampPatternNormal = "H16HSi";
    out.SkipPatternNormal = "H16HSi";
    out.RoiPatternNormal = "H16HRi";
    out.ClampPatternFast = "H12HCi";
    out.SkipPatternFast = "H12HSi";
    out.RoiPatternFast = "H12HRi";
    out.VerticalPatternVideo= "NoOpV";
    out.ClampPatternVideo = "NoOpH";
    out.SkipPatternVideo = "NoOpH";
    out.RoiPatternVideo = "NoOpH";
}


void camMetaData::getMeta76(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "KAI16000CLD9";
    out.CameraId = 76;
    out.CameraLine = "Alta";
    out.CameraModel = "16000CLD9";
    out.InterlineCCD = 1;
    out.SupportsSerialA = 1;
    out.SupportsSerialB = 1;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 4973;
    out.ImagingColumns = 4872;
    out.ClampColumns = 57;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 44;
    out.TotalRows = 3324;
    out.ImagingRows = 3248;
    out.UnderscanRows = 56;
    out.OverscanRows = 20;
    out.VFlushBinning = 8;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 0;
    out.PixelSizeX = 9;
    out.PixelSizeY = 9;
    out.Color = 1;
    out.ReportedGainSixteenBit = 1;
    out.MinSuggestedExpTime = 1.1;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -20;
    out.TempRampRateOne = 700;
    out.TempRampRateTwo = 4000;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Alta_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Alta_Twelve;
    out.PrimaryADLatency = 1;
    out.AlternativeADLatency = 12;
    out.IRPreflashTime = 160;
    out.AdCfg = 8;
    out.DefaultGainLeft = 0;
    out.DefaultOffsetLeft = 100;
    out.DefaultGainRight = 0;
    out.DefaultOffsetRight = 0;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 0;
    out.VideoSubSample = 1;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "KV6B";
    out.ClampPatternNormal = "K16HS6B";
    out.SkipPatternNormal = "K16HS6B";
    out.RoiPatternNormal = "K16HR6B";
    out.ClampPatternFast = "K12HS6B";
    out.SkipPatternFast = "K12HS6B";
    out.RoiPatternFast = "K12HR6B";
    out.VerticalPatternVideo= "NoOpV";
    out.ClampPatternVideo = "NoOpH";
    out.SkipPatternVideo = "NoOpH";
    out.RoiPatternVideo = "NoOpH";
}


void camMetaData::getMeta77(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "KAI16000MLD9";
    out.CameraId = 77;
    out.CameraLine = "Alta";
    out.CameraModel = "16000MLD9";
    out.InterlineCCD = 1;
    out.SupportsSerialA = 1;
    out.SupportsSerialB = 1;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 4973;
    out.ImagingColumns = 4872;
    out.ClampColumns = 57;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 44;
    out.TotalRows = 3324;
    out.ImagingRows = 3248;
    out.UnderscanRows = 56;
    out.OverscanRows = 20;
    out.VFlushBinning = 8;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 0;
    out.PixelSizeX = 9;
    out.PixelSizeY = 9;
    out.Color = 0;
    out.ReportedGainSixteenBit = 1;
    out.MinSuggestedExpTime = 1.1;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -20;
    out.TempRampRateOne = 700;
    out.TempRampRateTwo = 4000;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Alta_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Alta_Twelve;
    out.PrimaryADLatency = 1;
    out.AlternativeADLatency = 12;
    out.IRPreflashTime = 160;
    out.AdCfg = 8;
    out.DefaultGainLeft = 0;
    out.DefaultOffsetLeft = 100;
    out.DefaultGainRight = 0;
    out.DefaultOffsetRight = 0;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 0;
    out.VideoSubSample = 1;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "KV6B";
    out.ClampPatternNormal = "K16HS6B";
    out.SkipPatternNormal = "K16HS6B";
    out.RoiPatternNormal = "K16HR6B";
    out.ClampPatternFast = "K12HS6B";
    out.SkipPatternFast = "K12HS6B";
    out.RoiPatternFast = "K12HR6B";
    out.VerticalPatternVideo= "NoOpV";
    out.ClampPatternVideo = "NoOpH";
    out.SkipPatternVideo = "NoOpH";
    out.RoiPatternVideo = "NoOpH";
}


void camMetaData::getMeta64(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "KAI2020ML";
    out.CameraId = 64;
    out.CameraLine = "Alta";
    out.CameraModel = "2020ML";
    out.InterlineCCD = 1;
    out.SupportsSerialA = 1;
    out.SupportsSerialB = 1;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 1648;
    out.ImagingColumns = 1600;
    out.ClampColumns = 24;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 24;
    out.TotalRows = 1214;
    out.ImagingRows = 1200;
    out.UnderscanRows = 6;
    out.OverscanRows = 8;
    out.VFlushBinning = 1;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 0;
    out.PixelSizeX = 7.4;
    out.PixelSizeY = 7.4;
    out.Color = 0;
    out.ReportedGainSixteenBit = 1;
    out.MinSuggestedExpTime = 1.1;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -20;
    out.TempRampRateOne = 700;
    out.TempRampRateTwo = 4000;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Alta_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Alta_Twelve;
    out.PrimaryADLatency = 1;
    out.AlternativeADLatency = 12;
    out.IRPreflashTime = 160;
    out.AdCfg = 8;
    out.DefaultGainLeft = 0;
    out.DefaultOffsetLeft = 100;
    out.DefaultGainRight = 0;
    out.DefaultOffsetRight = 0;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 0;
    out.VideoSubSample = 1;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "KV3";
    out.ClampPatternNormal = "K16HS5";
    out.SkipPatternNormal = "K16HS5";
    out.RoiPatternNormal = "K16HR5";
    out.ClampPatternFast = "K12HC5";
    out.SkipPatternFast = "K12HS5";
    out.RoiPatternFast = "K12HR5";
    out.VerticalPatternVideo= "NoOpV";
    out.ClampPatternVideo = "NoOpH";
    out.SkipPatternVideo = "NoOpH";
    out.RoiPatternVideo = "NoOpH";
}


void camMetaData::getMeta65(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "KAI2001ML";
    out.CameraId = 65;
    out.CameraLine = "Alta";
    out.CameraModel = "2001ML";
    out.InterlineCCD = 1;
    out.SupportsSerialA = 1;
    out.SupportsSerialB = 1;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 1648;
    out.ImagingColumns = 1600;
    out.ClampColumns = 24;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 24;
    out.TotalRows = 1214;
    out.ImagingRows = 1200;
    out.UnderscanRows = 6;
    out.OverscanRows = 8;
    out.VFlushBinning = 1;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 0;
    out.PixelSizeX = 7.4;
    out.PixelSizeY = 7.4;
    out.Color = 0;
    out.ReportedGainSixteenBit = 1;
    out.MinSuggestedExpTime = 1.1;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -20;
    out.TempRampRateOne = 700;
    out.TempRampRateTwo = 4000;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Alta_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Alta_Twelve;
    out.PrimaryADLatency = 1;
    out.AlternativeADLatency = 12;
    out.IRPreflashTime = 160;
    out.AdCfg = 8;
    out.DefaultGainLeft = 300;
    out.DefaultOffsetLeft = 50;
    out.DefaultGainRight = 0;
    out.DefaultOffsetRight = 0;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 0;
    out.VideoSubSample = 1;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "KV3";
    out.ClampPatternNormal = "K16HS5";
    out.SkipPatternNormal = "K16HS5";
    out.RoiPatternNormal = "K16HR5";
    out.ClampPatternFast = "K12HC5";
    out.SkipPatternFast = "K12HS5";
    out.RoiPatternFast = "K12HR5";
    out.VerticalPatternVideo= "NoOpV";
    out.ClampPatternVideo = "NoOpH";
    out.SkipPatternVideo = "NoOpH";
    out.RoiPatternVideo = "NoOpH";
}


void camMetaData::getMeta66(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "KAI4020ML";
    out.CameraId = 66;
    out.CameraLine = "Alta";
    out.CameraModel = "4020ML";
    out.InterlineCCD = 1;
    out.SupportsSerialA = 1;
    out.SupportsSerialB = 1;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 2136;
    out.ImagingColumns = 2048;
    out.ClampColumns = 44;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 44;
    out.TotalRows = 2072;
    out.ImagingRows = 2048;
    out.UnderscanRows = 16;
    out.OverscanRows = 8;
    out.VFlushBinning = 1;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 0;
    out.PixelSizeX = 7.4;
    out.PixelSizeY = 7.4;
    out.Color = 0;
    out.ReportedGainSixteenBit = 1;
    out.MinSuggestedExpTime = 1.1;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -20;
    out.TempRampRateOne = 700;
    out.TempRampRateTwo = 4000;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Alta_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Alta_Twelve;
    out.PrimaryADLatency = 1;
    out.AlternativeADLatency = 12;
    out.IRPreflashTime = 160;
    out.AdCfg = 8;
    out.DefaultGainLeft = 0;
    out.DefaultOffsetLeft = 100;
    out.DefaultGainRight = 0;
    out.DefaultOffsetRight = 0;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 0;
    out.VideoSubSample = 1;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "KV3";
    out.ClampPatternNormal = "K16HS5";
    out.SkipPatternNormal = "K16HS5";
    out.RoiPatternNormal = "K16HR5";
    out.ClampPatternFast = "K12HC5";
    out.SkipPatternFast = "K12HS5";
    out.RoiPatternFast = "K12HR5";
    out.VerticalPatternVideo= "NoOpV";
    out.ClampPatternVideo = "NoOpH";
    out.SkipPatternVideo = "NoOpH";
    out.RoiPatternVideo = "NoOpH";
}


void camMetaData::getMeta67(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "KAI16000ML";
    out.CameraId = 67;
    out.CameraLine = "Alta";
    out.CameraModel = "16000ML";
    out.InterlineCCD = 1;
    out.SupportsSerialA = 1;
    out.SupportsSerialB = 1;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 4973;
    out.ImagingColumns = 4872;
    out.ClampColumns = 57;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 44;
    out.TotalRows = 3324;
    out.ImagingRows = 3248;
    out.UnderscanRows = 56;
    out.OverscanRows = 20;
    out.VFlushBinning = 8;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 0;
    out.PixelSizeX = 9;
    out.PixelSizeY = 9;
    out.Color = 0;
    out.ReportedGainSixteenBit = 1;
    out.MinSuggestedExpTime = 1.1;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -20;
    out.TempRampRateOne = 700;
    out.TempRampRateTwo = 4000;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Alta_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Alta_Twelve;
    out.PrimaryADLatency = 1;
    out.AlternativeADLatency = 12;
    out.IRPreflashTime = 160;
    out.AdCfg = 8;
    out.DefaultGainLeft = 0;
    out.DefaultOffsetLeft = 100;
    out.DefaultGainRight = 0;
    out.DefaultOffsetRight = 0;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 0;
    out.VideoSubSample = 1;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "KV6";
    out.ClampPatternNormal = "K16HS6";
    out.SkipPatternNormal = "K16HS6";
    out.RoiPatternNormal = "K16HR6";
    out.ClampPatternFast = "K12HS6";
    out.SkipPatternFast = "K12HS6";
    out.RoiPatternFast = "K12HR6";
    out.VerticalPatternVideo= "NoOpV";
    out.ClampPatternVideo = "NoOpH";
    out.SkipPatternVideo = "NoOpH";
    out.RoiPatternVideo = "NoOpH";
}


void camMetaData::getMeta68(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "KAI2020CL";
    out.CameraId = 68;
    out.CameraLine = "Alta";
    out.CameraModel = "2020CL";
    out.InterlineCCD = 1;
    out.SupportsSerialA = 1;
    out.SupportsSerialB = 1;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 1648;
    out.ImagingColumns = 1600;
    out.ClampColumns = 24;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 24;
    out.TotalRows = 1214;
    out.ImagingRows = 1200;
    out.UnderscanRows = 6;
    out.OverscanRows = 8;
    out.VFlushBinning = 1;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 0;
    out.PixelSizeX = 7.4;
    out.PixelSizeY = 7.4;
    out.Color = 1;
    out.ReportedGainSixteenBit = 1;
    out.MinSuggestedExpTime = 1.1;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -20;
    out.TempRampRateOne = 700;
    out.TempRampRateTwo = 4000;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Alta_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Alta_Twelve;
    out.PrimaryADLatency = 1;
    out.AlternativeADLatency = 12;
    out.IRPreflashTime = 160;
    out.AdCfg = 8;
    out.DefaultGainLeft = 0;
    out.DefaultOffsetLeft = 100;
    out.DefaultGainRight = 0;
    out.DefaultOffsetRight = 0;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 0;
    out.VideoSubSample = 1;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "KV3";
    out.ClampPatternNormal = "K16HS5";
    out.SkipPatternNormal = "K16HS5";
    out.RoiPatternNormal = "K16HR5";
    out.ClampPatternFast = "K12HC5";
    out.SkipPatternFast = "K12HS5";
    out.RoiPatternFast = "K12HR5";
    out.VerticalPatternVideo= "NoOpV";
    out.ClampPatternVideo = "NoOpH";
    out.SkipPatternVideo = "NoOpH";
    out.RoiPatternVideo = "NoOpH";
}


void camMetaData::getMeta69(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "KAI4020CL";
    out.CameraId = 69;
    out.CameraLine = "Alta";
    out.CameraModel = "4020CL";
    out.InterlineCCD = 1;
    out.SupportsSerialA = 1;
    out.SupportsSerialB = 1;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 2136;
    out.ImagingColumns = 2048;
    out.ClampColumns = 44;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 44;
    out.TotalRows = 2072;
    out.ImagingRows = 2048;
    out.UnderscanRows = 16;
    out.OverscanRows = 8;
    out.VFlushBinning = 1;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 0;
    out.PixelSizeX = 7.4;
    out.PixelSizeY = 7.4;
    out.Color = 1;
    out.ReportedGainSixteenBit = 1;
    out.MinSuggestedExpTime = 1.1;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -20;
    out.TempRampRateOne = 700;
    out.TempRampRateTwo = 4000;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Alta_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Alta_Twelve;
    out.PrimaryADLatency = 1;
    out.AlternativeADLatency = 12;
    out.IRPreflashTime = 160;
    out.AdCfg = 8;
    out.DefaultGainLeft = 0;
    out.DefaultOffsetLeft = 100;
    out.DefaultGainRight = 0;
    out.DefaultOffsetRight = 0;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 0;
    out.VideoSubSample = 1;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "KV3";
    out.ClampPatternNormal = "K16HS5";
    out.SkipPatternNormal = "K16HS5";
    out.RoiPatternNormal = "K16HR5";
    out.ClampPatternFast = "K12HC5";
    out.SkipPatternFast = "K12HS5";
    out.RoiPatternFast = "K12HR5";
    out.VerticalPatternVideo= "NoOpV";
    out.ClampPatternVideo = "NoOpH";
    out.SkipPatternVideo = "NoOpH";
    out.RoiPatternVideo = "NoOpH";
}


void camMetaData::getMeta70(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "KAI16000CL";
    out.CameraId = 70;
    out.CameraLine = "Alta";
    out.CameraModel = "16000CL";
    out.InterlineCCD = 1;
    out.SupportsSerialA = 1;
    out.SupportsSerialB = 1;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 4973;
    out.ImagingColumns = 4872;
    out.ClampColumns = 57;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 44;
    out.TotalRows = 3324;
    out.ImagingRows = 3248;
    out.UnderscanRows = 56;
    out.OverscanRows = 20;
    out.VFlushBinning = 8;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 0;
    out.PixelSizeX = 9;
    out.PixelSizeY = 9;
    out.Color = 1;
    out.ReportedGainSixteenBit = 1;
    out.MinSuggestedExpTime = 1.1;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -20;
    out.TempRampRateOne = 700;
    out.TempRampRateTwo = 4000;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Alta_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Alta_Twelve;
    out.PrimaryADLatency = 1;
    out.AlternativeADLatency = 12;
    out.IRPreflashTime = 160;
    out.AdCfg = 8;
    out.DefaultGainLeft = 0;
    out.DefaultOffsetLeft = 100;
    out.DefaultGainRight = 0;
    out.DefaultOffsetRight = 0;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 0;
    out.VideoSubSample = 1;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "KV6";
    out.ClampPatternNormal = "K16HS6";
    out.SkipPatternNormal = "K16HS6";
    out.RoiPatternNormal = "K16HR6";
    out.ClampPatternFast = "K12HS6";
    out.SkipPatternFast = "K12HS6";
    out.RoiPatternFast = "K12HR6";
    out.VerticalPatternVideo= "NoOpV";
    out.ClampPatternVideo = "NoOpH";
    out.SkipPatternVideo = "NoOpH";
    out.RoiPatternVideo = "NoOpH";
}


void camMetaData::getMeta71(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "KAI2001CL";
    out.CameraId = 71;
    out.CameraLine = "Alta";
    out.CameraModel = "2001CL";
    out.InterlineCCD = 1;
    out.SupportsSerialA = 1;
    out.SupportsSerialB = 1;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 1648;
    out.ImagingColumns = 1600;
    out.ClampColumns = 24;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 24;
    out.TotalRows = 1214;
    out.ImagingRows = 1200;
    out.UnderscanRows = 6;
    out.OverscanRows = 8;
    out.VFlushBinning = 1;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 0;
    out.PixelSizeX = 7.4;
    out.PixelSizeY = 7.4;
    out.Color = 1;
    out.ReportedGainSixteenBit = 1;
    out.MinSuggestedExpTime = 1.1;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -20;
    out.TempRampRateOne = 700;
    out.TempRampRateTwo = 4000;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Alta_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Alta_Twelve;
    out.PrimaryADLatency = 1;
    out.AlternativeADLatency = 12;
    out.IRPreflashTime = 160;
    out.AdCfg = 8;
    out.DefaultGainLeft = 0;
    out.DefaultOffsetLeft = 100;
    out.DefaultGainRight = 0;
    out.DefaultOffsetRight = 0;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 0;
    out.VideoSubSample = 1;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "KV3";
    out.ClampPatternNormal = "K16HS5";
    out.SkipPatternNormal = "K16HS5";
    out.RoiPatternNormal = "K16HR5";
    out.ClampPatternFast = "K12HC5";
    out.SkipPatternFast = "K12HS5";
    out.RoiPatternFast = "K12HR5";
    out.VerticalPatternVideo= "NoOpV";
    out.ClampPatternVideo = "NoOpH";
    out.SkipPatternVideo = "NoOpH";
    out.RoiPatternVideo = "NoOpH";
}


void camMetaData::getMeta72(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "KAI2020MLB";
    out.CameraId = 72;
    out.CameraLine = "Alta";
    out.CameraModel = "2020ML";
    out.InterlineCCD = 1;
    out.SupportsSerialA = 1;
    out.SupportsSerialB = 1;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 1648;
    out.ImagingColumns = 1600;
    out.ClampColumns = 24;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 24;
    out.TotalRows = 1214;
    out.ImagingRows = 1200;
    out.UnderscanRows = 6;
    out.OverscanRows = 8;
    out.VFlushBinning = 1;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 0;
    out.PixelSizeX = 7.4;
    out.PixelSizeY = 7.4;
    out.Color = 0;
    out.ReportedGainSixteenBit = 1;
    out.MinSuggestedExpTime = 1.1;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -20;
    out.TempRampRateOne = 700;
    out.TempRampRateTwo = 4000;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Alta_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Alta_Twelve;
    out.PrimaryADLatency = 1;
    out.AlternativeADLatency = 12;
    out.IRPreflashTime = 160;
    out.AdCfg = 8;
    out.DefaultGainLeft = 0;
    out.DefaultOffsetLeft = 100;
    out.DefaultGainRight = 0;
    out.DefaultOffsetRight = 0;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 0;
    out.VideoSubSample = 1;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "KV3B";
    out.ClampPatternNormal = "K16HS5B";
    out.SkipPatternNormal = "K16HS5B";
    out.RoiPatternNormal = "K16HR5B";
    out.ClampPatternFast = "K12HC5B";
    out.SkipPatternFast = "K12HS5B";
    out.RoiPatternFast = "K12HR5B";
    out.VerticalPatternVideo= "NoOpV";
    out.ClampPatternVideo = "NoOpH";
    out.SkipPatternVideo = "NoOpH";
    out.RoiPatternVideo = "NoOpH";
}


void camMetaData::getMeta73(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "KAI4020MLB";
    out.CameraId = 73;
    out.CameraLine = "Alta";
    out.CameraModel = "4020ML";
    out.InterlineCCD = 1;
    out.SupportsSerialA = 1;
    out.SupportsSerialB = 1;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 2136;
    out.ImagingColumns = 2048;
    out.ClampColumns = 44;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 44;
    out.TotalRows = 2072;
    out.ImagingRows = 2048;
    out.UnderscanRows = 16;
    out.OverscanRows = 8;
    out.VFlushBinning = 1;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 0;
    out.PixelSizeX = 7.4;
    out.PixelSizeY = 7.4;
    out.Color = 0;
    out.ReportedGainSixteenBit = 1;
    out.MinSuggestedExpTime = 1.1;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -20;
    out.TempRampRateOne = 700;
    out.TempRampRateTwo = 4000;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Alta_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Alta_Twelve;
    out.PrimaryADLatency = 1;
    out.AlternativeADLatency = 12;
    out.IRPreflashTime = 160;
    out.AdCfg = 8;
    out.DefaultGainLeft = 0;
    out.DefaultOffsetLeft = 100;
    out.DefaultGainRight = 0;
    out.DefaultOffsetRight = 0;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 0;
    out.VideoSubSample = 1;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "KV3B";
    out.ClampPatternNormal = "K16HS5B";
    out.SkipPatternNormal = "K16HS5B";
    out.RoiPatternNormal = "K16HR5B";
    out.ClampPatternFast = "K12HC5B";
    out.SkipPatternFast = "K12HS5B";
    out.RoiPatternFast = "K12HR5B";
    out.VerticalPatternVideo= "NoOpV";
    out.ClampPatternVideo = "NoOpH";
    out.SkipPatternVideo = "NoOpH";
    out.RoiPatternVideo = "NoOpH";
}


void camMetaData::getMeta74(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "KAI2020CLB";
    out.CameraId = 74;
    out.CameraLine = "Alta";
    out.CameraModel = "2020CL";
    out.InterlineCCD = 1;
    out.SupportsSerialA = 1;
    out.SupportsSerialB = 1;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 1648;
    out.ImagingColumns = 1600;
    out.ClampColumns = 24;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 24;
    out.TotalRows = 1214;
    out.ImagingRows = 1200;
    out.UnderscanRows = 6;
    out.OverscanRows = 8;
    out.VFlushBinning = 1;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 0;
    out.PixelSizeX = 7.4;
    out.PixelSizeY = 7.4;
    out.Color = 1;
    out.ReportedGainSixteenBit = 1;
    out.MinSuggestedExpTime = 1.1;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -20;
    out.TempRampRateOne = 700;
    out.TempRampRateTwo = 4000;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Alta_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Alta_Twelve;
    out.PrimaryADLatency = 1;
    out.AlternativeADLatency = 12;
    out.IRPreflashTime = 160;
    out.AdCfg = 8;
    out.DefaultGainLeft = 0;
    out.DefaultOffsetLeft = 100;
    out.DefaultGainRight = 0;
    out.DefaultOffsetRight = 0;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 0;
    out.VideoSubSample = 1;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "KV3B";
    out.ClampPatternNormal = "K16HS5B";
    out.SkipPatternNormal = "K16HS5B";
    out.RoiPatternNormal = "K16HR5B";
    out.ClampPatternFast = "K12HC5B";
    out.SkipPatternFast = "K12HS5B";
    out.RoiPatternFast = "K12HR5B";
    out.VerticalPatternVideo= "NoOpV";
    out.ClampPatternVideo = "NoOpH";
    out.SkipPatternVideo = "NoOpH";
    out.RoiPatternVideo = "NoOpH";
}


void camMetaData::getMeta75(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "KAI4020CLB";
    out.CameraId = 75;
    out.CameraLine = "Alta";
    out.CameraModel = "4020CL";
    out.InterlineCCD = 1;
    out.SupportsSerialA = 1;
    out.SupportsSerialB = 1;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 2136;
    out.ImagingColumns = 2048;
    out.ClampColumns = 44;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 44;
    out.TotalRows = 2072;
    out.ImagingRows = 2048;
    out.UnderscanRows = 16;
    out.OverscanRows = 8;
    out.VFlushBinning = 1;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 0;
    out.PixelSizeX = 7.4;
    out.PixelSizeY = 7.4;
    out.Color = 1;
    out.ReportedGainSixteenBit = 1;
    out.MinSuggestedExpTime = 1.1;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -20;
    out.TempRampRateOne = 700;
    out.TempRampRateTwo = 4000;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Alta_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Alta_Twelve;
    out.PrimaryADLatency = 1;
    out.AlternativeADLatency = 12;
    out.IRPreflashTime = 160;
    out.AdCfg = 8;
    out.DefaultGainLeft = 0;
    out.DefaultOffsetLeft = 100;
    out.DefaultGainRight = 0;
    out.DefaultOffsetRight = 0;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 0;
    out.VideoSubSample = 1;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "KV3B";
    out.ClampPatternNormal = "K16HS5B";
    out.SkipPatternNormal = "K16HS5B";
    out.RoiPatternNormal = "K16HR5B";
    out.ClampPatternFast = "K12HC5B";
    out.SkipPatternFast = "K12HS5B";
    out.RoiPatternFast = "K12HR5B";
    out.VerticalPatternVideo= "NoOpV";
    out.ClampPatternVideo = "NoOpH";
    out.SkipPatternVideo = "NoOpH";
    out.RoiPatternVideo = "NoOpH";
}


void camMetaData::getMeta78(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "KAI4020MLD9";
    out.CameraId = 78;
    out.CameraLine = "Alta";
    out.CameraModel = "4020MLD9";
    out.InterlineCCD = 1;
    out.SupportsSerialA = 1;
    out.SupportsSerialB = 1;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 2136;
    out.ImagingColumns = 2048;
    out.ClampColumns = 44;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 44;
    out.TotalRows = 2072;
    out.ImagingRows = 2048;
    out.UnderscanRows = 16;
    out.OverscanRows = 8;
    out.VFlushBinning = 1;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 0;
    out.PixelSizeX = 7.4;
    out.PixelSizeY = 7.4;
    out.Color = 0;
    out.ReportedGainSixteenBit = 1;
    out.MinSuggestedExpTime = 1.1;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -20;
    out.TempRampRateOne = 1500;
    out.TempRampRateTwo = 4000;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Alta_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Alta_Twelve;
    out.PrimaryADLatency = 1;
    out.AlternativeADLatency = 12;
    out.IRPreflashTime = 160;
    out.AdCfg = 8;
    out.DefaultGainLeft = 0;
    out.DefaultOffsetLeft = 100;
    out.DefaultGainRight = 0;
    out.DefaultOffsetRight = 0;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 0;
    out.VideoSubSample = 1;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "KV8B";
    out.ClampPatternNormal = "K16HS10B";
    out.SkipPatternNormal = "K16HS10B";
    out.RoiPatternNormal = "K16HR10B";
    out.ClampPatternFast = "K12HS10B";
    out.SkipPatternFast = "K12HS10B";
    out.RoiPatternFast = "K12HR10B";
    out.VerticalPatternVideo= "NoOpV";
    out.ClampPatternVideo = "NoOpH";
    out.SkipPatternVideo = "NoOpH";
    out.RoiPatternVideo = "NoOpH";
}


void camMetaData::getMeta256(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "ICX205AL";
    out.CameraId = 256;
    out.CameraLine = "Ascent";
    out.CameraModel = "205";
    out.InterlineCCD = 1;
    out.SupportsSerialA = 0;
    out.SupportsSerialB = 0;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 1434;
    out.ImagingColumns = 1360;
    out.ClampColumns = 22;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 20;
    out.TotalRows = 1050;
    out.ImagingRows = 1024;
    out.UnderscanRows = 11;
    out.OverscanRows = 0;
    out.VFlushBinning = 1;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 0;
    out.PixelSizeX = 4.65;
    out.PixelSizeY = 4.65;
    out.Color = 0;
    out.ReportedGainSixteenBit = 0.4;
    out.MinSuggestedExpTime = 0.1;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -20;
    out.TempRampRateOne = 600;
    out.TempRampRateTwo = 1800;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Ascent_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Ascent_Sixteen;
    out.PrimaryADLatency = 4;
    out.AlternativeADLatency = 4;
    out.IRPreflashTime = 160;
    out.AdCfg = 88;
    out.DefaultGainLeft = 45;
    out.DefaultOffsetLeft = 1;
    out.DefaultGainRight = 45;
    out.DefaultOffsetRight = 1;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 1;
    out.VideoSubSample = 3;
    out.AmpCutoffDisable = 1;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "AV6";
    out.ClampPatternNormal = "AS5";
    out.SkipPatternNormal = "AS5";
    out.RoiPatternNormal = "AR5";
    out.ClampPatternFast = "AS5";
    out.SkipPatternFast = "AS5";
    out.RoiPatternFast = "AR5F";
    out.VerticalPatternVideo= "NoOpV";
    out.ClampPatternVideo = "NoOpH";
    out.SkipPatternVideo = "NoOpH";
    out.RoiPatternVideo = "NoOpH";
}


void camMetaData::getMeta257(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "ICX285AL";
    out.CameraId = 257;
    out.CameraLine = "Ascent";
    out.CameraModel = "ASC285M";
    out.InterlineCCD = 1;
    out.SupportsSerialA = 0;
    out.SupportsSerialB = 0;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 1434;
    out.ImagingColumns = 1392;
    out.ClampColumns = 22;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 20;
    out.TotalRows = 1051;
    out.ImagingRows = 1040;
    out.UnderscanRows = 11;
    out.OverscanRows = 0;
    out.VFlushBinning = 1;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 0;
    out.PixelSizeX = 6.45;
    out.PixelSizeY = 6.45;
    out.Color = 0;
    out.ReportedGainSixteenBit = 0.4;
    out.MinSuggestedExpTime = 0.1;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -20;
    out.TempRampRateOne = 600;
    out.TempRampRateTwo = 1800;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Ascent_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Ascent_Sixteen;
    out.PrimaryADLatency = 4;
    out.AlternativeADLatency = 4;
    out.IRPreflashTime = 160;
    out.AdCfg = 88;
    out.DefaultGainLeft = 55;
    out.DefaultOffsetLeft = 1;
    out.DefaultGainRight = 55;
    out.DefaultOffsetRight = 1;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 1;
    out.VideoSubSample = 3;
    out.AmpCutoffDisable = 1;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "AV5";
    out.ClampPatternNormal = "AS5";
    out.SkipPatternNormal = "AS5";
    out.RoiPatternNormal = "AR5";
    out.ClampPatternFast = "AS5";
    out.SkipPatternFast = "AS5";
    out.RoiPatternFast = "AR5F";
    out.VerticalPatternVideo= "AV5V";
    out.ClampPatternVideo = "AS5";
    out.SkipPatternVideo = "AS5";
    out.RoiPatternVideo = "AR5V";
}


void camMetaData::getMeta258(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "KAI0340C";
    out.CameraId = 258;
    out.CameraLine = "Ascent";
    out.CameraModel = "340";
    out.InterlineCCD = 1;
    out.SupportsSerialA = 0;
    out.SupportsSerialB = 0;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 708;
    out.ImagingColumns = 640;
    out.ClampColumns = 40;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 28;
    out.TotalRows = 492;
    out.ImagingRows = 480;
    out.UnderscanRows = 8;
    out.OverscanRows = 4;
    out.VFlushBinning = 10;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 0;
    out.PixelSizeX = 7.4;
    out.PixelSizeY = 7.4;
    out.Color = 0;
    out.ReportedGainSixteenBit = 0.5;
    out.MinSuggestedExpTime = 0.1;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -20;
    out.TempRampRateOne = 600;
    out.TempRampRateTwo = 1800;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Ascent_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Ascent_Sixteen;
    out.PrimaryADLatency = 4;
    out.AlternativeADLatency = 4;
    out.IRPreflashTime = 160;
    out.AdCfg = 88;
    out.DefaultGainLeft = 35;
    out.DefaultOffsetLeft = 1;
    out.DefaultGainRight = 35;
    out.DefaultOffsetRight = 1;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 1;
    out.VideoSubSample = 1;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "AV2";
    out.ClampPatternNormal = "AS2";
    out.SkipPatternNormal = "AS2";
    out.RoiPatternNormal = "AR2a";
    out.ClampPatternFast = "AS2";
    out.SkipPatternFast = "AS2";
    out.RoiPatternFast = "AR2Fa";
    out.VerticalPatternVideo= "AV2";
    out.ClampPatternVideo = "AS2";
    out.SkipPatternVideo = "AS2";
    out.RoiPatternVideo = "AR2F";
}


void camMetaData::getMeta259(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "KAI2020";
    out.CameraId = 259;
    out.CameraLine = "Ascent";
    out.CameraModel = "2000";
    out.InterlineCCD = 1;
    out.SupportsSerialA = 0;
    out.SupportsSerialB = 0;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 1644;
    out.ImagingColumns = 1600;
    out.ClampColumns = 24;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 20;
    out.TotalRows = 1214;
    out.ImagingRows = 1200;
    out.UnderscanRows = 6;
    out.OverscanRows = 8;
    out.VFlushBinning = 1;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 0;
    out.PixelSizeX = 7.4;
    out.PixelSizeY = 7.4;
    out.Color = 0;
    out.ReportedGainSixteenBit = 0.5;
    out.MinSuggestedExpTime = 0.1;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -20;
    out.TempRampRateOne = 600;
    out.TempRampRateTwo = 1800;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Ascent_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Ascent_Sixteen;
    out.PrimaryADLatency = 4;
    out.AlternativeADLatency = 4;
    out.IRPreflashTime = 160;
    out.AdCfg = 88;
    out.DefaultGainLeft = 35;
    out.DefaultOffsetLeft = 1;
    out.DefaultGainRight = 35;
    out.DefaultOffsetRight = 1;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 1;
    out.VideoSubSample = 3;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "AV2";
    out.ClampPatternNormal = "AS2";
    out.SkipPatternNormal = "AS2";
    out.RoiPatternNormal = "AR2";
    out.ClampPatternFast = "AS2";
    out.SkipPatternFast = "AS2";
    out.RoiPatternFast = "AR2F";
    out.VerticalPatternVideo= "AV2V";
    out.ClampPatternVideo = "AS2";
    out.SkipPatternVideo = "AS2";
    out.RoiPatternVideo = "AR2V";
}


void camMetaData::getMeta260(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "KAI4022";
    out.CameraId = 260;
    out.CameraLine = "Ascent";
    out.CameraModel = "4000";
    out.InterlineCCD = 1;
    out.SupportsSerialA = 0;
    out.SupportsSerialB = 0;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 2136;
    out.ImagingColumns = 2048;
    out.ClampColumns = 43;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 45;
    out.TotalRows = 2072;
    out.ImagingRows = 2048;
    out.UnderscanRows = 15;
    out.OverscanRows = 9;
    out.VFlushBinning = 1;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 0;
    out.PixelSizeX = 7.4;
    out.PixelSizeY = 7.4;
    out.Color = 0;
    out.ReportedGainSixteenBit = 0.5;
    out.MinSuggestedExpTime = 0.1;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -20;
    out.TempRampRateOne = 600;
    out.TempRampRateTwo = 1800;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Ascent_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Ascent_Sixteen;
    out.PrimaryADLatency = 4;
    out.AlternativeADLatency = 4;
    out.IRPreflashTime = 160;
    out.AdCfg = 88;
    out.DefaultGainLeft = 35;
    out.DefaultOffsetLeft = 10;
    out.DefaultGainRight = 35;
    out.DefaultOffsetRight = 10;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 1;
    out.VideoSubSample = 5;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "AV2";
    out.ClampPatternNormal = "AS2";
    out.SkipPatternNormal = "AS2";
    out.RoiPatternNormal = "AR2";
    out.ClampPatternFast = "AS2";
    out.SkipPatternFast = "AS2";
    out.RoiPatternFast = "AR2F";
    out.VerticalPatternVideo= "AV2Vb";
    out.ClampPatternVideo = "AS2";
    out.SkipPatternVideo = "AS2";
    out.RoiPatternVideo = "AR2Vb";
}


void camMetaData::getMeta261(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "KAI16000";
    out.CameraId = 261;
    out.CameraLine = "Ascent";
    out.CameraModel = "16000";
    out.InterlineCCD = 1;
    out.SupportsSerialA = 0;
    out.SupportsSerialB = 0;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 4973;
    out.ImagingColumns = 4872;
    out.ClampColumns = 57;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 44;
    out.TotalRows = 3324;
    out.ImagingRows = 3248;
    out.UnderscanRows = 56;
    out.OverscanRows = 20;
    out.VFlushBinning = 1;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 0;
    out.PixelSizeX = 7.4;
    out.PixelSizeY = 7.4;
    out.Color = 0;
    out.ReportedGainSixteenBit = 0.5;
    out.MinSuggestedExpTime = 0.1;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -20;
    out.TempRampRateOne = 600;
    out.TempRampRateTwo = 1800;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Ascent_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Ascent_Sixteen;
    out.PrimaryADLatency = 4;
    out.AlternativeADLatency = 4;
    out.IRPreflashTime = 160;
    out.AdCfg = 88;
    out.DefaultGainLeft = 40;
    out.DefaultOffsetLeft = 1;
    out.DefaultGainRight = 40;
    out.DefaultOffsetRight = 1;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 1;
    out.VideoSubSample = 7;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "AV1";
    out.ClampPatternNormal = "AS2";
    out.SkipPatternNormal = "AS2";
    out.RoiPatternNormal = "AR2";
    out.ClampPatternFast = "AS2";
    out.SkipPatternFast = "AS2";
    out.RoiPatternFast = "AR2F";
    out.VerticalPatternVideo= "NoOpV";
    out.ClampPatternVideo = "NoOpH";
    out.SkipPatternVideo = "NoOpH";
    out.RoiPatternVideo = "NoOpH";
}


void camMetaData::getMeta262(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "KAI01050";
    out.CameraId = 262;
    out.CameraLine = "Ascent";
    out.CameraModel = "1050";
    out.InterlineCCD = 1;
    out.SupportsSerialA = 0;
    out.SupportsSerialB = 0;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 1095;
    out.ImagingColumns = 1024;
    out.ClampColumns = 41;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 30;
    out.TotalRows = 1064;
    out.ImagingRows = 1024;
    out.UnderscanRows = 20;
    out.OverscanRows = 20;
    out.VFlushBinning = 1;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 0;
    out.PixelSizeX = 5.5;
    out.PixelSizeY = 5.5;
    out.Color = 0;
    out.ReportedGainSixteenBit = 0.5;
    out.MinSuggestedExpTime = 0.1;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -20;
    out.TempRampRateOne = 600;
    out.TempRampRateTwo = 1800;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Ascent_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Ascent_Sixteen;
    out.PrimaryADLatency = 4;
    out.AlternativeADLatency = 4;
    out.IRPreflashTime = 160;
    out.AdCfg = 88;
    out.DefaultGainLeft = 55;
    out.DefaultOffsetLeft = 1;
    out.DefaultGainRight = 55;
    out.DefaultOffsetRight = 1;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 1;
    out.VideoSubSample = 3;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "AV4";
    out.ClampPatternNormal = "AS4";
    out.SkipPatternNormal = "AS4";
    out.RoiPatternNormal = "AR4";
    out.ClampPatternFast = "AS4";
    out.SkipPatternFast = "AS4";
    out.RoiPatternFast = "AR4Fb";
    out.VerticalPatternVideo= "AV4V";
    out.ClampPatternVideo = "AS4";
    out.SkipPatternVideo = "AS4";
    out.RoiPatternVideo = "AR4V";
}


void camMetaData::getMeta263(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "KAI02050";
    out.CameraId = 263;
    out.CameraLine = "Ascent";
    out.CameraModel = "2050";
    out.InterlineCCD = 1;
    out.SupportsSerialA = 0;
    out.SupportsSerialB = 0;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 1695;
    out.ImagingColumns = 1600;
    out.ClampColumns = 53;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 42;
    out.TotalRows = 1264;
    out.ImagingRows = 1200;
    out.UnderscanRows = 32;
    out.OverscanRows = 32;
    out.VFlushBinning = 1;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 0;
    out.PixelSizeX = 5.5;
    out.PixelSizeY = 5.5;
    out.Color = 0;
    out.ReportedGainSixteenBit = 0.5;
    out.MinSuggestedExpTime = 0.1;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -20;
    out.TempRampRateOne = 600;
    out.TempRampRateTwo = 1800;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Ascent_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Ascent_Sixteen;
    out.PrimaryADLatency = 4;
    out.AlternativeADLatency = 4;
    out.IRPreflashTime = 160;
    out.AdCfg = 88;
    out.DefaultGainLeft = 55;
    out.DefaultOffsetLeft = 1;
    out.DefaultGainRight = 55;
    out.DefaultOffsetRight = 1;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 1;
    out.VideoSubSample = 3;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "AV4";
    out.ClampPatternNormal = "AS4";
    out.SkipPatternNormal = "AS4";
    out.RoiPatternNormal = "AR4";
    out.ClampPatternFast = "AS4";
    out.SkipPatternFast = "AS4";
    out.RoiPatternFast = "AR4F";
    out.VerticalPatternVideo= "AV4V";
    out.ClampPatternVideo = "AS4";
    out.SkipPatternVideo = "AS4";
    out.RoiPatternVideo = "AR4V";
}


void camMetaData::getMeta264(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "KAI02150";
    out.CameraId = 264;
    out.CameraLine = "Ascent";
    out.CameraModel = "2150";
    out.InterlineCCD = 1;
    out.SupportsSerialA = 0;
    out.SupportsSerialB = 0;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 2015;
    out.ImagingColumns = 1920;
    out.ClampColumns = 53;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 42;
    out.TotalRows = 1144;
    out.ImagingRows = 1080;
    out.UnderscanRows = 32;
    out.OverscanRows = 32;
    out.VFlushBinning = 1;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 0;
    out.PixelSizeX = 5.5;
    out.PixelSizeY = 5.5;
    out.Color = 0;
    out.ReportedGainSixteenBit = 0.5;
    out.MinSuggestedExpTime = 0.1;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -20;
    out.TempRampRateOne = 600;
    out.TempRampRateTwo = 1800;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Ascent_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Ascent_Sixteen;
    out.PrimaryADLatency = 4;
    out.AlternativeADLatency = 4;
    out.IRPreflashTime = 160;
    out.AdCfg = 88;
    out.DefaultGainLeft = 55;
    out.DefaultOffsetLeft = 1;
    out.DefaultGainRight = 55;
    out.DefaultOffsetRight = 1;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 1;
    out.VideoSubSample = 3;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "AV4";
    out.ClampPatternNormal = "AS4";
    out.SkipPatternNormal = "AS4";
    out.RoiPatternNormal = "AR4";
    out.ClampPatternFast = "AS4";
    out.SkipPatternFast = "AS4";
    out.RoiPatternFast = "AR4F";
    out.VerticalPatternVideo= "AV4V";
    out.ClampPatternVideo = "AS4";
    out.SkipPatternVideo = "AS4";
    out.RoiPatternVideo = "AR4V";
}


void camMetaData::getMeta265(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "KAI04050";
    out.CameraId = 265;
    out.CameraLine = "Ascent";
    out.CameraModel = "4050";
    out.InterlineCCD = 1;
    out.SupportsSerialA = 0;
    out.SupportsSerialB = 0;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 2415;
    out.ImagingColumns = 2336;
    out.ClampColumns = 45;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 45;
    out.TotalRows = 1800;
    out.ImagingRows = 1752;
    out.UnderscanRows = 25;
    out.OverscanRows = 25;
    out.VFlushBinning = 1;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 0;
    out.PixelSizeX = 5.5;
    out.PixelSizeY = 5.5;
    out.Color = 0;
    out.ReportedGainSixteenBit = 0.5;
    out.MinSuggestedExpTime = 0.1;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -20;
    out.TempRampRateOne = 600;
    out.TempRampRateTwo = 1800;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Ascent_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Ascent_Sixteen;
    out.PrimaryADLatency = 4;
    out.AlternativeADLatency = 4;
    out.IRPreflashTime = 160;
    out.AdCfg = 88;
    out.DefaultGainLeft = 55;
    out.DefaultOffsetLeft = 25;
    out.DefaultGainRight = 55;
    out.DefaultOffsetRight = 25;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 1;
    out.VideoSubSample = 5;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "AV4";
    out.ClampPatternNormal = "AS4";
    out.SkipPatternNormal = "AS4";
    out.RoiPatternNormal = "AR4";
    out.ClampPatternFast = "AS4";
    out.SkipPatternFast = "AS4";
    out.RoiPatternFast = "AR4F";
    out.VerticalPatternVideo= "AV4Vb";
    out.ClampPatternVideo = "AS4";
    out.SkipPatternVideo = "AS4";
    out.RoiPatternVideo = "AR4Vb";
}


void camMetaData::getMeta266(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "KAI08050";
    out.CameraId = 266;
    out.CameraLine = "Ascent";
    out.CameraModel = "ASC8050";
    out.InterlineCCD = 1;
    out.SupportsSerialA = 0;
    out.SupportsSerialB = 0;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 3375;
    out.ImagingColumns = 3296;
    out.ClampColumns = 45;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 34;
    out.TotalRows = 2520;
    out.ImagingRows = 2472;
    out.UnderscanRows = 24;
    out.OverscanRows = 24;
    out.VFlushBinning = 1;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 0;
    out.PixelSizeX = 5.5;
    out.PixelSizeY = 5.5;
    out.Color = 0;
    out.ReportedGainSixteenBit = 0.5;
    out.MinSuggestedExpTime = 0.1;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -20;
    out.TempRampRateOne = 600;
    out.TempRampRateTwo = 1800;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Ascent_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Ascent_Sixteen;
    out.PrimaryADLatency = 4;
    out.AlternativeADLatency = 4;
    out.IRPreflashTime = 160;
    out.AdCfg = 88;
    out.DefaultGainLeft = 55;
    out.DefaultOffsetLeft = 1;
    out.DefaultGainRight = 55;
    out.DefaultOffsetRight = 1;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 1;
    out.VideoSubSample = 5;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "AV4";
    out.ClampPatternNormal = "AS4";
    out.SkipPatternNormal = "AS4";
    out.RoiPatternNormal = "AR4";
    out.ClampPatternFast = "AS4";
    out.SkipPatternFast = "AS4";
    out.RoiPatternFast = "AR4Fb";
    out.VerticalPatternVideo= "AV4Vb";
    out.ClampPatternVideo = "AS4";
    out.SkipPatternVideo = "AS4";
    out.RoiPatternVideo = "AR4Vb";
}


void camMetaData::getMeta267(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "KAI4022C";
    out.CameraId = 267;
    out.CameraLine = "Ascent";
    out.CameraModel = "ASC4000C";
    out.InterlineCCD = 1;
    out.SupportsSerialA = 0;
    out.SupportsSerialB = 0;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 2136;
    out.ImagingColumns = 2048;
    out.ClampColumns = 43;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 45;
    out.TotalRows = 2072;
    out.ImagingRows = 2048;
    out.UnderscanRows = 15;
    out.OverscanRows = 9;
    out.VFlushBinning = 1;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 0;
    out.PixelSizeX = 7.4;
    out.PixelSizeY = 7.4;
    out.Color = 1;
    out.ReportedGainSixteenBit = 0.5;
    out.MinSuggestedExpTime = 0.1;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -20;
    out.TempRampRateOne = 600;
    out.TempRampRateTwo = 1800;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Ascent_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Ascent_Sixteen;
    out.PrimaryADLatency = 4;
    out.AlternativeADLatency = 4;
    out.IRPreflashTime = 160;
    out.AdCfg = 88;
    out.DefaultGainLeft = 35;
    out.DefaultOffsetLeft = 10;
    out.DefaultGainRight = 35;
    out.DefaultOffsetRight = 10;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 1;
    out.VideoSubSample = 5;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "AV2";
    out.ClampPatternNormal = "AS2";
    out.SkipPatternNormal = "AS2";
    out.RoiPatternNormal = "AR2";
    out.ClampPatternFast = "AS2";
    out.SkipPatternFast = "AS2";
    out.RoiPatternFast = "AR2F";
    out.VerticalPatternVideo= "AV2Vb";
    out.ClampPatternVideo = "AS2";
    out.SkipPatternVideo = "AS2";
    out.RoiPatternVideo = "AR2Vb";
}


void camMetaData::getMeta268(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "KAI08050C";
    out.CameraId = 268;
    out.CameraLine = "Ascent";
    out.CameraModel = "8050C";
    out.InterlineCCD = 1;
    out.SupportsSerialA = 0;
    out.SupportsSerialB = 0;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 3375;
    out.ImagingColumns = 3296;
    out.ClampColumns = 45;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 34;
    out.TotalRows = 2520;
    out.ImagingRows = 2472;
    out.UnderscanRows = 24;
    out.OverscanRows = 24;
    out.VFlushBinning = 1;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 0;
    out.PixelSizeX = 5.5;
    out.PixelSizeY = 5.5;
    out.Color = 1;
    out.ReportedGainSixteenBit = 0.5;
    out.MinSuggestedExpTime = 0.1;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -20;
    out.TempRampRateOne = 600;
    out.TempRampRateTwo = 1800;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Ascent_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Ascent_Sixteen;
    out.PrimaryADLatency = 4;
    out.AlternativeADLatency = 4;
    out.IRPreflashTime = 160;
    out.AdCfg = 88;
    out.DefaultGainLeft = 55;
    out.DefaultOffsetLeft = 1;
    out.DefaultGainRight = 55;
    out.DefaultOffsetRight = 1;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 1;
    out.VideoSubSample = 5;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "AV4";
    out.ClampPatternNormal = "AS4";
    out.SkipPatternNormal = "AS4";
    out.RoiPatternNormal = "AR4";
    out.ClampPatternFast = "AS4";
    out.SkipPatternFast = "AS4";
    out.RoiPatternFast = "AR4Fb";
    out.VerticalPatternVideo= "AV4Vb";
    out.ClampPatternVideo = "AS4";
    out.SkipPatternVideo = "AS4";
    out.RoiPatternVideo = "AR4Vb";
}


void camMetaData::getMeta269(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "KAI2020";
    out.CameraId = 269;
    out.CameraLine = "Ascent";
    out.CameraModel = "2000SL";
    out.InterlineCCD = 1;
    out.SupportsSerialA = 0;
    out.SupportsSerialB = 0;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 1648;
    out.ImagingColumns = 1600;
    out.ClampColumns = 24;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 24;
    out.TotalRows = 1214;
    out.ImagingRows = 1200;
    out.UnderscanRows = 6;
    out.OverscanRows = 8;
    out.VFlushBinning = 1;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 0;
    out.PixelSizeX = 7.4;
    out.PixelSizeY = 7.4;
    out.Color = 0;
    out.ReportedGainSixteenBit = 0.5;
    out.MinSuggestedExpTime = 0.1;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -20;
    out.TempRampRateOne = 600;
    out.TempRampRateTwo = 1800;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Ascent_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Ascent_Sixteen;
    out.PrimaryADLatency = 4;
    out.AlternativeADLatency = 4;
    out.IRPreflashTime = 160;
    out.AdCfg = 88;
    out.DefaultGainLeft = 35;
    out.DefaultOffsetLeft = 1;
    out.DefaultGainRight = 35;
    out.DefaultOffsetRight = 1;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 1;
    out.VideoSubSample = 3;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "AV2S";
    out.ClampPatternNormal = "AS2S";
    out.SkipPatternNormal = "AS2S";
    out.RoiPatternNormal = "AR2S";
    out.ClampPatternFast = "AS2";
    out.SkipPatternFast = "AS2";
    out.RoiPatternFast = "AR2F";
    out.VerticalPatternVideo= "AV2V";
    out.ClampPatternVideo = "AS2";
    out.SkipPatternVideo = "AS2";
    out.RoiPatternVideo = "AR2V";
}


void camMetaData::getMeta270(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "KAI01050C";
    out.CameraId = 270;
    out.CameraLine = "Ascent";
    out.CameraModel = "1050C";
    out.InterlineCCD = 1;
    out.SupportsSerialA = 0;
    out.SupportsSerialB = 0;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 1095;
    out.ImagingColumns = 1024;
    out.ClampColumns = 40;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 31;
    out.TotalRows = 1064;
    out.ImagingRows = 1024;
    out.UnderscanRows = 20;
    out.OverscanRows = 20;
    out.VFlushBinning = 1;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 0;
    out.PixelSizeX = 5.5;
    out.PixelSizeY = 5.5;
    out.Color = 1;
    out.ReportedGainSixteenBit = 0.5;
    out.MinSuggestedExpTime = 0.1;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -20;
    out.TempRampRateOne = 600;
    out.TempRampRateTwo = 1800;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Ascent_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Ascent_Sixteen;
    out.PrimaryADLatency = 4;
    out.AlternativeADLatency = 4;
    out.IRPreflashTime = 160;
    out.AdCfg = 88;
    out.DefaultGainLeft = 55;
    out.DefaultOffsetLeft = 10;
    out.DefaultGainRight = 55;
    out.DefaultOffsetRight = 10;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 1;
    out.VideoSubSample = 3;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "AV4";
    out.ClampPatternNormal = "AS4";
    out.SkipPatternNormal = "AS4";
    out.RoiPatternNormal = "AR4";
    out.ClampPatternFast = "AS4";
    out.SkipPatternFast = "AS4";
    out.RoiPatternFast = "AR4F";
    out.VerticalPatternVideo= "AV4V";
    out.ClampPatternVideo = "AS4";
    out.SkipPatternVideo = "AS4";
    out.RoiPatternVideo = "AR4V";
}


void camMetaData::getMeta271(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "KAI29050";
    out.CameraId = 271;
    out.CameraLine = "Ascent";
    out.CameraModel = "29050";
    out.InterlineCCD = 1;
    out.SupportsSerialA = 0;
    out.SupportsSerialB = 0;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 6644;
    out.ImagingColumns = 6576;
    out.ClampColumns = 34;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 34;
    out.TotalRows = 4452;
    out.ImagingRows = 4384;
    out.UnderscanRows = 34;
    out.OverscanRows = 34;
    out.VFlushBinning = 1;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 0;
    out.PixelSizeX = 5.5;
    out.PixelSizeY = 5.5;
    out.Color = 0;
    out.ReportedGainSixteenBit = 0.5;
    out.MinSuggestedExpTime = 0.1;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -10;
    out.TempRampRateOne = 600;
    out.TempRampRateTwo = 1800;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Ascent_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Ascent_Sixteen;
    out.PrimaryADLatency = 4;
    out.AlternativeADLatency = 4;
    out.IRPreflashTime = 160;
    out.AdCfg = 88;
    out.DefaultGainLeft = 55;
    out.DefaultOffsetLeft = 1;
    out.DefaultGainRight = 55;
    out.DefaultOffsetRight = 1;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 1;
    out.VideoSubSample = 9;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "AV7";
    out.ClampPatternNormal = "AS4";
    out.SkipPatternNormal = "AS4";
    out.RoiPatternNormal = "AR4";
    out.ClampPatternFast = "AS4";
    out.SkipPatternFast = "AS4";
    out.RoiPatternFast = "AR4Fb";
    out.VerticalPatternVideo= "NoOpV";
    out.ClampPatternVideo = "NoOpH";
    out.SkipPatternVideo = "NoOpH";
    out.RoiPatternVideo = "NoOpH";
}


void camMetaData::getMeta272(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "ICX205AK";
    out.CameraId = 272;
    out.CameraLine = "Ascent";
    out.CameraModel = "205C";
    out.InterlineCCD = 1;
    out.SupportsSerialA = 0;
    out.SupportsSerialB = 0;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 1050;
    out.ImagingColumns = 1040;
    out.ClampColumns = 2;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 40;
    out.TotalRows = 1050;
    out.ImagingRows = 1040;
    out.UnderscanRows = 8;
    out.OverscanRows = 2;
    out.VFlushBinning = 1;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 0;
    out.PixelSizeX = 4.65;
    out.PixelSizeY = 4.65;
    out.Color = 1;
    out.ReportedGainSixteenBit = 0.4;
    out.MinSuggestedExpTime = 0.1;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -10;
    out.TempRampRateOne = 600;
    out.TempRampRateTwo = 1800;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Ascent_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Ascent_Sixteen;
    out.PrimaryADLatency = 4;
    out.AlternativeADLatency = 4;
    out.IRPreflashTime = 160;
    out.AdCfg = 88;
    out.DefaultGainLeft = 45;
    out.DefaultOffsetLeft = 1;
    out.DefaultGainRight = 45;
    out.DefaultOffsetRight = 1;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 1;
    out.VideoSubSample = 3;
    out.AmpCutoffDisable = 1;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "AV6";
    out.ClampPatternNormal = "AS5";
    out.SkipPatternNormal = "AS5";
    out.RoiPatternNormal = "AR4";
    out.ClampPatternFast = "AS5";
    out.SkipPatternFast = "AS5";
    out.RoiPatternFast = "AR5F";
    out.VerticalPatternVideo= "AV5V";
    out.ClampPatternVideo = "AS5";
    out.SkipPatternVideo = "AS5";
    out.RoiPatternVideo = "AR5V";
}


void camMetaData::getMeta273(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "ICX285AK";
    out.CameraId = 273;
    out.CameraLine = "Ascent";
    out.CameraModel = "285C";
    out.InterlineCCD = 1;
    out.SupportsSerialA = 0;
    out.SupportsSerialB = 0;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 1434;
    out.ImagingColumns = 1392;
    out.ClampColumns = 22;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 20;
    out.TotalRows = 1051;
    out.ImagingRows = 1040;
    out.UnderscanRows = 11;
    out.OverscanRows = 0;
    out.VFlushBinning = 1;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 0;
    out.PixelSizeX = 6.45;
    out.PixelSizeY = 6.45;
    out.Color = 1;
    out.ReportedGainSixteenBit = 0.4;
    out.MinSuggestedExpTime = 0.1;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -10;
    out.TempRampRateOne = 600;
    out.TempRampRateTwo = 1800;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Ascent_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Ascent_Sixteen;
    out.PrimaryADLatency = 4;
    out.AlternativeADLatency = 4;
    out.IRPreflashTime = 160;
    out.AdCfg = 88;
    out.DefaultGainLeft = 45;
    out.DefaultOffsetLeft = 1;
    out.DefaultGainRight = 45;
    out.DefaultOffsetRight = 1;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 1;
    out.VideoSubSample = 3;
    out.AmpCutoffDisable = 1;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "AV5";
    out.ClampPatternNormal = "AS5";
    out.SkipPatternNormal = "AS5";
    out.RoiPatternNormal = "AR5";
    out.ClampPatternFast = "AS5";
    out.SkipPatternFast = "AS5";
    out.RoiPatternFast = "AR5F";
    out.VerticalPatternVideo= "AV5V";
    out.ClampPatternVideo = "AS5";
    out.SkipPatternVideo = "AS5";
    out.RoiPatternVideo = "AR5V";
}


void camMetaData::getMeta274(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "KAI0340C";
    out.CameraId = 274;
    out.CameraLine = "Ascent";
    out.CameraModel = "340C";
    out.InterlineCCD = 1;
    out.SupportsSerialA = 0;
    out.SupportsSerialB = 0;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 708;
    out.ImagingColumns = 640;
    out.ClampColumns = 40;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 28;
    out.TotalRows = 492;
    out.ImagingRows = 480;
    out.UnderscanRows = 8;
    out.OverscanRows = 4;
    out.VFlushBinning = 1;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 0;
    out.PixelSizeX = 7.4;
    out.PixelSizeY = 7.4;
    out.Color = 1;
    out.ReportedGainSixteenBit = 0.5;
    out.MinSuggestedExpTime = 0.1;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -10;
    out.TempRampRateOne = 600;
    out.TempRampRateTwo = 1800;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Ascent_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Ascent_Sixteen;
    out.PrimaryADLatency = 4;
    out.AlternativeADLatency = 4;
    out.IRPreflashTime = 160;
    out.AdCfg = 88;
    out.DefaultGainLeft = 35;
    out.DefaultOffsetLeft = 1;
    out.DefaultGainRight = 35;
    out.DefaultOffsetRight = 1;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 1;
    out.VideoSubSample = 1;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "AV2";
    out.ClampPatternNormal = "AS2";
    out.SkipPatternNormal = "AS2";
    out.RoiPatternNormal = "AR2";
    out.ClampPatternFast = "AS2";
    out.SkipPatternFast = "AS2";
    out.RoiPatternFast = "AR2F";
    out.VerticalPatternVideo= "AV2";
    out.ClampPatternVideo = "AS2";
    out.SkipPatternVideo = "AS2";
    out.RoiPatternVideo = "AR2F";
}


void camMetaData::getMeta275(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "KAI2020C";
    out.CameraId = 275;
    out.CameraLine = "Ascent";
    out.CameraModel = "2000C";
    out.InterlineCCD = 1;
    out.SupportsSerialA = 0;
    out.SupportsSerialB = 0;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 1648;
    out.ImagingColumns = 1600;
    out.ClampColumns = 24;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 24;
    out.TotalRows = 1214;
    out.ImagingRows = 1200;
    out.UnderscanRows = 6;
    out.OverscanRows = 8;
    out.VFlushBinning = 1;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 0;
    out.PixelSizeX = 7.4;
    out.PixelSizeY = 7.4;
    out.Color = 1;
    out.ReportedGainSixteenBit = 0.5;
    out.MinSuggestedExpTime = 0.1;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -10;
    out.TempRampRateOne = 600;
    out.TempRampRateTwo = 1800;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Ascent_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Ascent_Sixteen;
    out.PrimaryADLatency = 4;
    out.AlternativeADLatency = 4;
    out.IRPreflashTime = 160;
    out.AdCfg = 88;
    out.DefaultGainLeft = 35;
    out.DefaultOffsetLeft = 1;
    out.DefaultGainRight = 35;
    out.DefaultOffsetRight = 1;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 1;
    out.VideoSubSample = 3;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "AV2";
    out.ClampPatternNormal = "AS2";
    out.SkipPatternNormal = "AS2";
    out.RoiPatternNormal = "AR2";
    out.ClampPatternFast = "AS2";
    out.SkipPatternFast = "AS2";
    out.RoiPatternFast = "AR2F";
    out.VerticalPatternVideo= "AV2V";
    out.ClampPatternVideo = "AS2";
    out.SkipPatternVideo = "AS2";
    out.RoiPatternVideo = "AR2V";
}


void camMetaData::getMeta276(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "KAI16000C";
    out.CameraId = 276;
    out.CameraLine = "Ascent";
    out.CameraModel = "16000C";
    out.InterlineCCD = 1;
    out.SupportsSerialA = 0;
    out.SupportsSerialB = 0;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 4973;
    out.ImagingColumns = 4872;
    out.ClampColumns = 57;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 44;
    out.TotalRows = 3324;
    out.ImagingRows = 3248;
    out.UnderscanRows = 56;
    out.OverscanRows = 20;
    out.VFlushBinning = 1;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 0;
    out.PixelSizeX = 7.4;
    out.PixelSizeY = 7.4;
    out.Color = 1;
    out.ReportedGainSixteenBit = 0.5;
    out.MinSuggestedExpTime = 0.1;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -10;
    out.TempRampRateOne = 600;
    out.TempRampRateTwo = 1800;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Ascent_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Ascent_Sixteen;
    out.PrimaryADLatency = 4;
    out.AlternativeADLatency = 4;
    out.IRPreflashTime = 160;
    out.AdCfg = 88;
    out.DefaultGainLeft = 40;
    out.DefaultOffsetLeft = 1;
    out.DefaultGainRight = 40;
    out.DefaultOffsetRight = 1;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 1;
    out.VideoSubSample = 7;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "AV1";
    out.ClampPatternNormal = "AS2";
    out.SkipPatternNormal = "AS2";
    out.RoiPatternNormal = "AR2";
    out.ClampPatternFast = "AS2";
    out.SkipPatternFast = "AS2";
    out.RoiPatternFast = "AR2F";
    out.VerticalPatternVideo= "NoOpV";
    out.ClampPatternVideo = "NoOpH";
    out.SkipPatternVideo = "NoOpH";
    out.RoiPatternVideo = "NoOpH";
}


void camMetaData::getMeta277(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "KAI02050C";
    out.CameraId = 277;
    out.CameraLine = "Ascent";
    out.CameraModel = "2050C";
    out.InterlineCCD = 1;
    out.SupportsSerialA = 0;
    out.SupportsSerialB = 0;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 1695;
    out.ImagingColumns = 1600;
    out.ClampColumns = 53;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 42;
    out.TotalRows = 1264;
    out.ImagingRows = 1200;
    out.UnderscanRows = 32;
    out.OverscanRows = 32;
    out.VFlushBinning = 1;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 0;
    out.PixelSizeX = 5.5;
    out.PixelSizeY = 5.5;
    out.Color = 1;
    out.ReportedGainSixteenBit = 0.5;
    out.MinSuggestedExpTime = 0.1;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -10;
    out.TempRampRateOne = 600;
    out.TempRampRateTwo = 1800;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Ascent_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Ascent_Sixteen;
    out.PrimaryADLatency = 4;
    out.AlternativeADLatency = 4;
    out.IRPreflashTime = 160;
    out.AdCfg = 88;
    out.DefaultGainLeft = 55;
    out.DefaultOffsetLeft = 1;
    out.DefaultGainRight = 55;
    out.DefaultOffsetRight = 1;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 1;
    out.VideoSubSample = 3;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "AV4";
    out.ClampPatternNormal = "AS4";
    out.SkipPatternNormal = "AS4";
    out.RoiPatternNormal = "AR4";
    out.ClampPatternFast = "AS4";
    out.SkipPatternFast = "AS4";
    out.RoiPatternFast = "AR4F";
    out.VerticalPatternVideo= "AV4V";
    out.ClampPatternVideo = "AS4";
    out.SkipPatternVideo = "AS4";
    out.RoiPatternVideo = "AR4V";
}


void camMetaData::getMeta278(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "KAI02150C";
    out.CameraId = 278;
    out.CameraLine = "Ascent";
    out.CameraModel = "2150C";
    out.InterlineCCD = 1;
    out.SupportsSerialA = 0;
    out.SupportsSerialB = 0;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 2015;
    out.ImagingColumns = 1920;
    out.ClampColumns = 53;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 42;
    out.TotalRows = 1144;
    out.ImagingRows = 1080;
    out.UnderscanRows = 32;
    out.OverscanRows = 32;
    out.VFlushBinning = 1;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 0;
    out.PixelSizeX = 5.5;
    out.PixelSizeY = 5.5;
    out.Color = 1;
    out.ReportedGainSixteenBit = 0.5;
    out.MinSuggestedExpTime = 0.1;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -10;
    out.TempRampRateOne = 600;
    out.TempRampRateTwo = 1800;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Ascent_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Ascent_Sixteen;
    out.PrimaryADLatency = 4;
    out.AlternativeADLatency = 4;
    out.IRPreflashTime = 160;
    out.AdCfg = 88;
    out.DefaultGainLeft = 55;
    out.DefaultOffsetLeft = 1;
    out.DefaultGainRight = 55;
    out.DefaultOffsetRight = 1;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 1;
    out.VideoSubSample = 3;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "AV4";
    out.ClampPatternNormal = "AS4";
    out.SkipPatternNormal = "AS4";
    out.RoiPatternNormal = "AR4";
    out.ClampPatternFast = "AS4";
    out.SkipPatternFast = "AS4";
    out.RoiPatternFast = "AR4F";
    out.VerticalPatternVideo= "AV4V";
    out.ClampPatternVideo = "AS4";
    out.SkipPatternVideo = "AS4";
    out.RoiPatternVideo = "AR4V";
}


void camMetaData::getMeta279(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "KAI04050C";
    out.CameraId = 279;
    out.CameraLine = "Ascent";
    out.CameraModel = "4050C";
    out.InterlineCCD = 1;
    out.SupportsSerialA = 0;
    out.SupportsSerialB = 0;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 2415;
    out.ImagingColumns = 2336;
    out.ClampColumns = 45;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 45;
    out.TotalRows = 1800;
    out.ImagingRows = 1752;
    out.UnderscanRows = 25;
    out.OverscanRows = 25;
    out.VFlushBinning = 1;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 0;
    out.PixelSizeX = 5.5;
    out.PixelSizeY = 5.5;
    out.Color = 1;
    out.ReportedGainSixteenBit = 0.5;
    out.MinSuggestedExpTime = 0.1;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -10;
    out.TempRampRateOne = 600;
    out.TempRampRateTwo = 1800;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Ascent_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Ascent_Sixteen;
    out.PrimaryADLatency = 4;
    out.AlternativeADLatency = 4;
    out.IRPreflashTime = 160;
    out.AdCfg = 88;
    out.DefaultGainLeft = 55;
    out.DefaultOffsetLeft = 1;
    out.DefaultGainRight = 55;
    out.DefaultOffsetRight = 1;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 1;
    out.VideoSubSample = 5;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "AV4";
    out.ClampPatternNormal = "AS4";
    out.SkipPatternNormal = "AS4";
    out.RoiPatternNormal = "AR4";
    out.ClampPatternFast = "AS4";
    out.SkipPatternFast = "AS4";
    out.RoiPatternFast = "AR4F";
    out.VerticalPatternVideo= "AV4Vb";
    out.ClampPatternVideo = "AS4";
    out.SkipPatternVideo = "AS4";
    out.RoiPatternVideo = "AR4Vb";
}


void camMetaData::getMeta280(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "KAI29050C";
    out.CameraId = 280;
    out.CameraLine = "Ascent";
    out.CameraModel = "29050C";
    out.InterlineCCD = 1;
    out.SupportsSerialA = 0;
    out.SupportsSerialB = 0;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 6644;
    out.ImagingColumns = 6576;
    out.ClampColumns = 34;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 34;
    out.TotalRows = 4452;
    out.ImagingRows = 4384;
    out.UnderscanRows = 34;
    out.OverscanRows = 34;
    out.VFlushBinning = 1;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 0;
    out.PixelSizeX = 5.5;
    out.PixelSizeY = 5.5;
    out.Color = 1;
    out.ReportedGainSixteenBit = 0.5;
    out.MinSuggestedExpTime = 0.1;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -10;
    out.TempRampRateOne = 600;
    out.TempRampRateTwo = 1800;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Ascent_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Ascent_Sixteen;
    out.PrimaryADLatency = 4;
    out.AlternativeADLatency = 4;
    out.IRPreflashTime = 160;
    out.AdCfg = 88;
    out.DefaultGainLeft = 55;
    out.DefaultOffsetLeft = 1;
    out.DefaultGainRight = 55;
    out.DefaultOffsetRight = 1;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 1;
    out.VideoSubSample = 9;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "AV7";
    out.ClampPatternNormal = "AS4";
    out.SkipPatternNormal = "AS4";
    out.RoiPatternNormal = "AR4";
    out.ClampPatternFast = "AS4";
    out.SkipPatternFast = "AS4";
    out.RoiPatternFast = "AR4Fb";
    out.VerticalPatternVideo= "NoOpV";
    out.ClampPatternVideo = "NoOpH";
    out.SkipPatternVideo = "NoOpH";
    out.RoiPatternVideo = "NoOpH";
}


void camMetaData::getMeta384(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "KAF09000";
    out.CameraId = 384;
    out.CameraLine = "AltaF";
    out.CameraModel = "9000D7";
    out.InterlineCCD = 0;
    out.SupportsSerialA = 0;
    out.SupportsSerialB = 0;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 3103;
    out.ImagingColumns = 3056;
    out.ClampColumns = 35;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 12;
    out.TotalRows = 3086;
    out.ImagingRows = 3056;
    out.UnderscanRows = 20;
    out.OverscanRows = 10;
    out.VFlushBinning = 1;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 450;
    out.PixelSizeX = 12;
    out.PixelSizeY = 12;
    out.Color = 0;
    out.ReportedGainSixteenBit = 1.5;
    out.MinSuggestedExpTime = 30;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -20;
    out.TempRampRateOne = 2200;
    out.TempRampRateTwo = 4000;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Ascent_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Ascent_Sixteen;
    out.PrimaryADLatency = 4;
    out.AlternativeADLatency = 4;
    out.IRPreflashTime = 160;
    out.AdCfg = 216;
    out.DefaultGainLeft = 35;
    out.DefaultOffsetLeft = 35;
    out.DefaultGainRight = 35;
    out.DefaultOffsetRight = 35;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 1;
    out.VideoSubSample = 3;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "FKV1";
    out.ClampPatternNormal = "FKHS1A";
    out.SkipPatternNormal = "FKHS1A";
    out.RoiPatternNormal = "FKHR1A";
    out.ClampPatternFast = "FKHS1B";
    out.SkipPatternFast = "FKHS1B";
    out.RoiPatternFast = "FKHR1B";
    out.VerticalPatternVideo= "NoOpV";
    out.ClampPatternVideo = "NoOpH";
    out.SkipPatternVideo = "NoOpH";
    out.RoiPatternVideo = "NoOpH";
}


void camMetaData::getMeta386(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "KAF16803";
    out.CameraId = 386;
    out.CameraLine = "AltaF";
    out.CameraModel = "16MD7";
    out.InterlineCCD = 0;
    out.SupportsSerialA = 0;
    out.SupportsSerialB = 0;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 4145;
    out.ImagingColumns = 4095;
    out.ClampColumns = 36;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 14;
    out.TotalRows = 4128;
    out.ImagingRows = 4095;
    out.UnderscanRows = 21;
    out.OverscanRows = 12;
    out.VFlushBinning = 1;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 450;
    out.PixelSizeX = 9;
    out.PixelSizeY = 9;
    out.Color = 0;
    out.ReportedGainSixteenBit = 1.5;
    out.MinSuggestedExpTime = 30;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -20;
    out.TempRampRateOne = 2200;
    out.TempRampRateTwo = 4000;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Ascent_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Ascent_Sixteen;
    out.PrimaryADLatency = 4;
    out.AlternativeADLatency = 4;
    out.IRPreflashTime = 160;
    out.AdCfg = 216;
    out.DefaultGainLeft = 40;
    out.DefaultOffsetLeft = 20;
    out.DefaultGainRight = 40;
    out.DefaultOffsetRight = 20;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 1;
    out.VideoSubSample = 3;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "FKV1";
    out.ClampPatternNormal = "FKHS1A";
    out.SkipPatternNormal = "FKHS1A";
    out.RoiPatternNormal = "FKHR1A";
    out.ClampPatternFast = "FKHS1B";
    out.SkipPatternFast = "FKHS1B";
    out.RoiPatternFast = "FKHR1B";
    out.VerticalPatternVideo= "NoOpV";
    out.ClampPatternVideo = "NoOpH";
    out.SkipPatternVideo = "NoOpH";
    out.RoiPatternVideo = "NoOpH";
}


void camMetaData::getMeta387(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "KAF6303";
    out.CameraId = 387;
    out.CameraLine = "AltaF";
    out.CameraModel = "9D2";
    out.InterlineCCD = 0;
    out.SupportsSerialA = 0;
    out.SupportsSerialB = 0;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 3100;
    out.ImagingColumns = 3072;
    out.ClampColumns = 16;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 12;
    out.TotalRows = 2056;
    out.ImagingRows = 2048;
    out.UnderscanRows = 4;
    out.OverscanRows = 4;
    out.VFlushBinning = 1;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 450;
    out.PixelSizeX = 9;
    out.PixelSizeY = 9;
    out.Color = 0;
    out.ReportedGainSixteenBit = 1.5;
    out.MinSuggestedExpTime = 30;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -20;
    out.TempRampRateOne = 2000;
    out.TempRampRateTwo = 4000;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Ascent_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Ascent_Sixteen;
    out.PrimaryADLatency = 4;
    out.AlternativeADLatency = 4;
    out.IRPreflashTime = 160;
    out.AdCfg = 88;
    out.DefaultGainLeft = 37;
    out.DefaultOffsetLeft = 300;
    out.DefaultGainRight = 37;
    out.DefaultOffsetRight = 300;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 1;
    out.VideoSubSample = 3;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "FKV2";
    out.ClampPatternNormal = "FKHS2";
    out.SkipPatternNormal = "FKHS2";
    out.RoiPatternNormal = "FKHR2A";
    out.ClampPatternFast = "FKHS2";
    out.SkipPatternFast = "FKHS2";
    out.RoiPatternFast = "FKHR2B";
    out.VerticalPatternVideo= "NoOpV";
    out.ClampPatternVideo = "NoOpH";
    out.SkipPatternVideo = "NoOpH";
    out.RoiPatternVideo = "NoOpH";
}


void camMetaData::getMeta427(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "KAF39000";
    out.CameraId = 427;
    out.CameraLine = "AltaF";
    out.CameraModel = "39000D10";
    out.InterlineCCD = 0;
    out.SupportsSerialA = 0;
    out.SupportsSerialB = 0;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 7344;
    out.ImagingColumns = 7216;
    out.ClampColumns = 64;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 64;
    out.TotalRows = 5494;
    out.ImagingRows = 5412;
    out.UnderscanRows = 38;
    out.OverscanRows = 44;
    out.VFlushBinning = 1;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 450;
    out.PixelSizeX = 6.8;
    out.PixelSizeY = 6.8;
    out.Color = 0;
    out.ReportedGainSixteenBit = 1.5;
    out.MinSuggestedExpTime = 100;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -20;
    out.TempRampRateOne = 2000;
    out.TempRampRateTwo = 4000;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Ascent_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Ascent_Sixteen;
    out.PrimaryADLatency = 4;
    out.AlternativeADLatency = 4;
    out.IRPreflashTime = 160;
    out.AdCfg = 216;
    out.DefaultGainLeft = 20;
    out.DefaultOffsetLeft = 1;
    out.DefaultGainRight = 20;
    out.DefaultOffsetRight = 1;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 1;
    out.VideoSubSample = 3;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "FKV1";
    out.ClampPatternNormal = "FKHS1A";
    out.SkipPatternNormal = "FKHS1A";
    out.RoiPatternNormal = "FKHR1A";
    out.ClampPatternFast = "FKHS1B";
    out.SkipPatternFast = "FKHS1B";
    out.RoiPatternFast = "FKHR1B";
    out.VerticalPatternVideo= "NoOpV";
    out.ClampPatternVideo = "NoOpH";
    out.SkipPatternVideo = "NoOpH";
    out.RoiPatternVideo = "NoOpH";
}


void camMetaData::getMeta511(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "CCD203-82";
    out.CameraId = 511;
    out.CameraLine = "HiC";
    out.CameraModel = "203";
    out.InterlineCCD = 0;
    out.SupportsSerialA = 0;
    out.SupportsSerialB = 0;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 4196;
    out.ImagingColumns = 4096;
    out.ClampColumns = 50;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 50;
    out.TotalRows = 4136;
    out.ImagingRows = 4136;
    out.UnderscanRows = 0;
    out.OverscanRows = 0;
    out.VFlushBinning = 1;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 450;
    out.PixelSizeX = 12;
    out.PixelSizeY = 12;
    out.Color = 0;
    out.ReportedGainSixteenBit = 2.7;
    out.MinSuggestedExpTime = 30;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -20;
    out.TempRampRateOne = 2200;
    out.TempRampRateTwo = 4000;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Ascent_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Ascent_Sixteen;
    out.PrimaryADLatency = 2;
    out.AlternativeADLatency = 2;
    out.IRPreflashTime = 160;
    out.AdCfg = 88;
    out.DefaultGainLeft = 46;
    out.DefaultOffsetLeft = 50;
    out.DefaultGainRight = 46;
    out.DefaultOffsetRight = 50;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 1;
    out.VideoSubSample = 3;
    out.AmpCutoffDisable = 1;
    out.NumAdOutputs = 4;
    out.VerticalPattern = "FEV1";
    out.ClampPatternNormal = "FEHS1A";
    out.SkipPatternNormal = "FEHS1A";
    out.RoiPatternNormal = "FEHR1AQ";
    out.ClampPatternFast = "FEHS1B";
    out.SkipPatternFast = "FEHS1B";
    out.RoiPatternFast = "FEHR1BQ";
    out.VerticalPatternVideo= "NoOpV";
    out.ClampPatternVideo = "NoOpH";
    out.SkipPatternVideo = "NoOpH";
    out.RoiPatternVideo = "NoOpH";
}


void camMetaData::getMeta281(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "KAI16000";
    out.CameraId = 281;
    out.CameraLine = "AltaF";
    out.CameraModel = "16000";
    out.InterlineCCD = 1;
    out.SupportsSerialA = 0;
    out.SupportsSerialB = 0;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 4973;
    out.ImagingColumns = 4872;
    out.ClampColumns = 57;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 44;
    out.TotalRows = 3324;
    out.ImagingRows = 3248;
    out.UnderscanRows = 56;
    out.OverscanRows = 20;
    out.VFlushBinning = 1;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 0;
    out.PixelSizeX = 7.4;
    out.PixelSizeY = 7.4;
    out.Color = 0;
    out.ReportedGainSixteenBit = 0.5;
    out.MinSuggestedExpTime = 0.1;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -20;
    out.TempRampRateOne = 600;
    out.TempRampRateTwo = 1800;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Ascent_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Ascent_Sixteen;
    out.PrimaryADLatency = 4;
    out.AlternativeADLatency = 4;
    out.IRPreflashTime = 160;
    out.AdCfg = 88;
    out.DefaultGainLeft = 40;
    out.DefaultOffsetLeft = 1;
    out.DefaultGainRight = 40;
    out.DefaultOffsetRight = 1;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 1;
    out.VideoSubSample = 7;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "AV1";
    out.ClampPatternNormal = "AS2";
    out.SkipPatternNormal = "AS2";
    out.RoiPatternNormal = "FR2";
    out.ClampPatternFast = "AS2";
    out.SkipPatternFast = "AS2";
    out.RoiPatternFast = "FR2F";
    out.VerticalPatternVideo= "NoOpV";
    out.ClampPatternVideo = "NoOpH";
    out.SkipPatternVideo = "NoOpH";
    out.RoiPatternVideo = "NoOpH";
}


void camMetaData::getMeta412(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "KAF4320E";
    out.CameraId = 412;
    out.CameraLine = "AltaF";
    out.CameraModel = "4320";
    out.InterlineCCD = 0;
    out.SupportsSerialA = 0;
    out.SupportsSerialB = 0;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 2102;
    out.ImagingColumns = 2084;
    out.ClampColumns = 9;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 9;
    out.TotalRows = 2094;
    out.ImagingRows = 2086;
    out.UnderscanRows = 4;
    out.OverscanRows = 4;
    out.VFlushBinning = 1;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 0;
    out.PixelSizeX = 24;
    out.PixelSizeY = 24;
    out.Color = 0;
    out.ReportedGainSixteenBit = 5.5;
    out.MinSuggestedExpTime = 1;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -20;
    out.TempRampRateOne = 2200;
    out.TempRampRateTwo = 4000;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Ascent_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Ascent_Sixteen;
    out.PrimaryADLatency = 2;
    out.AlternativeADLatency = 2;
    out.IRPreflashTime = 160;
    out.AdCfg = 216;
    out.DefaultGainLeft = 0;
    out.DefaultOffsetLeft = 0;
    out.DefaultGainRight = 0;
    out.DefaultOffsetRight = 0;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 1;
    out.VideoSubSample = 7;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 4;
    out.VerticalPattern = "FKV4";
    out.ClampPatternNormal = "FKHS4";
    out.SkipPatternNormal = "FKHS4";
    out.RoiPatternNormal = "FKHR4AQ";
    out.ClampPatternFast = "FKHS4";
    out.SkipPatternFast = "FKHS4";
    out.RoiPatternFast = "FKHR4BQ";
    out.VerticalPatternVideo= "NoOpV";
    out.ClampPatternVideo = "NoOpH";
    out.SkipPatternVideo = "NoOpH";
    out.RoiPatternVideo = "NoOpH";
}


void camMetaData::getMeta403(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "KAF3200ME";
    out.CameraId = 403;
    out.CameraLine = "AltaF";
    out.CameraModel = "32D1";
    out.InterlineCCD = 0;
    out.SupportsSerialA = 0;
    out.SupportsSerialB = 0;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 2267;
    out.ImagingColumns = 2184;
    out.ClampColumns = 46;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 37;
    out.TotalRows = 1510;
    out.ImagingRows = 1472;
    out.UnderscanRows = 34;
    out.OverscanRows = 4;
    out.VFlushBinning = 1;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 100;
    out.PixelSizeX = 6.8;
    out.PixelSizeY = 6.8;
    out.Color = 0;
    out.ReportedGainSixteenBit = 0.8;
    out.MinSuggestedExpTime = 10;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -20;
    out.TempRampRateOne = 2200;
    out.TempRampRateTwo = 4000;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Ascent_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Ascent_Sixteen;
    out.PrimaryADLatency = 4;
    out.AlternativeADLatency = 4;
    out.IRPreflashTime = 160;
    out.AdCfg = 88;
    out.DefaultGainLeft = 34;
    out.DefaultOffsetLeft = 0;
    out.DefaultGainRight = 34;
    out.DefaultOffsetRight = 0;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 1;
    out.VideoSubSample = 3;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "FKV3";
    out.ClampPatternNormal = "FKHS3";
    out.SkipPatternNormal = "FKHS3";
    out.RoiPatternNormal = "FKHR3A";
    out.ClampPatternFast = "FKHS3";
    out.SkipPatternFast = "FKHS3";
    out.RoiPatternFast = "FKHR3B";
    out.VerticalPatternVideo= "NoOpV";
    out.ClampPatternVideo = "NoOpH";
    out.SkipPatternVideo = "NoOpH";
    out.RoiPatternVideo = "NoOpH";
}


void camMetaData::getMeta388(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "KAF16801";
    out.CameraId = 388;
    out.CameraLine = "AltaF";
    out.CameraModel = "16D7";
    out.InterlineCCD = 0;
    out.SupportsSerialA = 0;
    out.SupportsSerialB = 0;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 4145;
    out.ImagingColumns = 4096;
    out.ClampColumns = 36;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 13;
    out.TotalRows = 4128;
    out.ImagingRows = 4096;
    out.UnderscanRows = 21;
    out.OverscanRows = 11;
    out.VFlushBinning = 1;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 450;
    out.PixelSizeX = 9;
    out.PixelSizeY = 9;
    out.Color = 0;
    out.ReportedGainSixteenBit = 1.5;
    out.MinSuggestedExpTime = 30;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -20;
    out.TempRampRateOne = 2200;
    out.TempRampRateTwo = 4000;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Ascent_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Ascent_Sixteen;
    out.PrimaryADLatency = 4;
    out.AlternativeADLatency = 4;
    out.IRPreflashTime = 160;
    out.AdCfg = 88;
    out.DefaultGainLeft = 27;
    out.DefaultOffsetLeft = 0;
    out.DefaultGainRight = 27;
    out.DefaultOffsetRight = 0;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 1;
    out.VideoSubSample = 3;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "FKV5";
    out.ClampPatternNormal = "FKHS5";
    out.SkipPatternNormal = "FKHS5";
    out.RoiPatternNormal = "FKHR5A";
    out.ClampPatternFast = "FKHS5";
    out.SkipPatternFast = "FKHS5";
    out.RoiPatternFast = "FKHR5B";
    out.VerticalPatternVideo= "NoOpV";
    out.ClampPatternVideo = "NoOpH";
    out.SkipPatternVideo = "NoOpH";
    out.RoiPatternVideo = "NoOpH";
}


void camMetaData::getMeta389(CamCfg::APN_CAMERA_METADATA & out)
{
    out.Sensor = "KAF4301E";
    out.CameraId = 389;
    out.CameraLine = "AltaF";
    out.CameraModel = "4301";
    out.InterlineCCD = 0;
    out.SupportsSerialA = 0;
    out.SupportsSerialB = 0;
    out.SensorTypeCCD = 1;
    out.TotalColumns = 2102;
    out.ImagingColumns = 2084;
    out.ClampColumns = 8;
    out.PreRoiSkipColumns = 0;
    out.PostRoiSkipColumns = 0;
    out.OverscanColumns = 10;
    out.TotalRows = 2092;
    out.ImagingRows = 2084;
    out.UnderscanRows = 4;
    out.OverscanRows = 4;
    out.VFlushBinning = 1;
    out.EnableSingleRowOffset = 0;
    out.RowOffsetBinning = 1;
    out.HFlushDisable = 0;
    out.ShutterCloseDelay = 450;
    out.PixelSizeX = 24;
    out.PixelSizeY = 24;
    out.Color = 0;
    out.ReportedGainSixteenBit = 3;
    out.MinSuggestedExpTime = 333;
    out.CoolingSupported = 1;
    out.RegulatedCoolingSupported = 1;
    out.TempSetPoint = -20;
    out.TempRampRateOne = 2200;
    out.TempRampRateTwo = 4000;
    out.TempBackoffPoint = 2;
    out.PrimaryADType =  CamCfg::ApnAdType_Ascent_Sixteen;
    out.AlternativeADType = CamCfg::ApnAdType_Ascent_Sixteen;
    out.PrimaryADLatency = 4;
    out.AlternativeADLatency = 4;
    out.IRPreflashTime = 160;
    out.AdCfg = 216;
    out.DefaultGainLeft = 33;
    out.DefaultOffsetLeft = 0;
    out.DefaultGainRight = 33;
    out.DefaultOffsetRight = 0;
    out.DefaultRVoltage = 1000;
    out.DefaultDataReduction = 1;
    out.VideoSubSample = 3;
    out.AmpCutoffDisable = 0;
    out.NumAdOutputs = 1;
    out.VerticalPattern = "FKV6";
    out.ClampPatternNormal = "FKHS6";
    out.SkipPatternNormal = "FKHS6";
    out.RoiPatternNormal = "FKHR6A";
    out.ClampPatternFast = "FKHS6";
    out.SkipPatternFast = "FKHS6";
    out.RoiPatternFast = "FKHR6B";
    out.VerticalPatternVideo= "NoOpV";
    out.ClampPatternVideo = "NoOpH";
    out.SkipPatternVideo = "NoOpH";
    out.RoiPatternVideo = "NoOpH";
}

